(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   1038328,      16716]
NotebookOptionsPosition[   1019797,      16395]
NotebookOutlinePosition[   1038111,      16707]
CellTagsIndexPosition[   1038068,      16704]
WindowFrame->Normal
ContainsDynamic->True *)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<Optica`Optica`\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.405341626376052*^9, 3.405341632980596*^9}}],

Cell[CellGroupData[{

Cell["+++++++++++++++++++++++++++++++++", "Print",
 CellChangeTimes->{3.406913349975807*^9, 3.4069135088603363`*^9, 
  3.4069146921545887`*^9, 3.406914840392132*^9, 3.406914983618017*^9, 
  3.4069878351702642`*^9, 3.40699660841365*^9, 3.407166868208579*^9}],

Cell[TextData[{
 "\"Optica 3.0 was loaded in 25 s and needs 11871 kilobytes of memory on top \
of 9048 kilobytes already used\"\n\n\n(* \n",
 StyleBox["\nA GRIN lens is a lens whose material refractive index varies \
continuously as a function of spatial coordinates in the medium.By gradually \
varying the index of refraction within the lens material,\nlight rays can be \
smoothly and continuously redirected. The material in the block has a graded \
index of refraction given by the profile.  Change the index to see how the \
light bends in the block.\n\nDrag the red locator buttons in the graphic to \
move the light source, block  and index center. To rotate the light source,  \
pull out the blue locator button with the yellow arrow and drag. \n", 
  "Subsubtitle"],
 "\n*)"
}], "Print",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{
  3.406913349975807*^9, 3.4069135088603363`*^9, 3.4069146921545887`*^9, 
   3.406914840392132*^9, 3.406914983618017*^9, 3.4069878351702642`*^9, 
   3.40699660841365*^9, 3.407166898033671*^9, {3.4202393920998287`*^9, 
   3.42023955570676*^9}, {3.42023959515129*^9, 3.4202396516170187`*^9}},
 FormatType->"TextForm"]
}, Open  ]]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"grinrod", " ", "=", " ", 
   RowBox[{"GRINLens", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"10", ",", "10"}], "}"}], ",", "10", ",", " ", 
     RowBox[{"SymbolicRefractiveModels", "->", 
      RowBox[{"{", 
       RowBox[{"DefaultGRINIndex", "->", 
        RowBox[{"(", 
         RowBox[{"baseIndex", "\[InvisibleSpace]", "-", 
          RowBox[{"factorX", " ", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"RSx", "-", "xpos"}], ")"}], "^", "2"}]}], "-", 
          RowBox[{"factorY", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"RSy", "-", "ypos"}], ")"}], "^", "2"}]}]}], ")"}]}], 
       "}"}]}], ",", " ", 
     RowBox[{"SymbolicValues", "->", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"baseIndex", "\[Rule]", "2.5"}], ",", 
        RowBox[{"factorX", "->", ".001"}], ",", 
        RowBox[{"factorY", "\[Rule]", ".001"}], ",", 
        RowBox[{"xpos", "\[Rule]", "1"}], ",", 
        RowBox[{"ypos", "\[Rule]", "0"}]}], "}"}]}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ManipulateSystem", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Move", "[", 
      RowBox[{
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Move", "[", 
          RowBox[{
           RowBox[{"SingleRay", "[", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"width", "*", "wn"}], ",", 
               RowBox[{"4", "*", "wn"}]}], "}"}]}], "}"}]}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"wn", ",", 
           RowBox[{"-", ".5"}], ",", ".5", ",", ".1"}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"x", ",", "10"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"y", ",", "1"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"th", ",", "0"}], "}"}]}], "]"}], ",", 
     RowBox[{"Move", "[", 
      RowBox[{"grinrod", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"glx", ",", "15"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"gly", ",", "0"}], "}"}]}], "}"}]}], "]"}], ",", " ", 
     RowBox[{"Boundary", "[", 
      RowBox[{"40", ",", "30"}], "]"}]}], "}"}], ",", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"DynamicFrame", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"PlotType", "->", "TopView"}], ",", 
         RowBox[{"PrependGraphics", "\[Rule]", 
          RowBox[{"Hold", "[", 
           RowBox[{"Graphics", "[", 
            RowBox[{"Dynamic", "[", 
             RowBox[{"GeometricTransformation", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"ContourPlot", "[", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"baseIndex", "\[InvisibleSpace]", "-", 
                    RowBox[{"factorX", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"rsx", "-", "xpos"}], ")"}], "^", "2"}]}], "-", 
                    RowBox[{"factorY", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"rsy", "-", "ypos"}], ")"}], "^", "2"}]}]}], 
                   ")"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"rsx", ",", 
                    RowBox[{"-", "5"}], ",", "5"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"rsy", ",", 
                    RowBox[{"-", "5"}], ",", "5"}], "}"}]}], "]"}], "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"glx", "+", "5"}], ",", "gly"}], "}"}]}], "}"}]}], 
              "]"}], "]"}], "]"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"AppendGraphics", "\[Rule]", 
          RowBox[{"Hold", "[", 
           RowBox[{"Graphics", "[", 
            RowBox[{"GeometricTransformation", "[", 
             RowBox[{
              RowBox[{"Locator", "[", 
               RowBox[{
                RowBox[{"Dynamic", "[", 
                 RowBox[{"{", 
                  RowBox[{"xpos", ",", "ypos"}], "}"}], "]"}], ",", 
                RowBox[{"Graphics", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"Lighter", "[", "Red", "]"}], ",", 
                    RowBox[{"Disk", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", ".8"}], "]"}]}], 
                   "}"}], ",", 
                  RowBox[{"ImageSize", "\[Rule]", "10"}]}], "]"}]}], "]"}], 
              ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"1", ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "1"}], "}"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"glx", "+", "5"}], ",", "gly"}], "}"}]}], "}"}]}], 
             "]"}], "]"}], "]"}]}], ",", 
         RowBox[{
         "PlotLabel", "\[Rule]", 
          "\"\<Graded Refraction Through A Transparent Cubical Block\>\""}]}],
         "}"}], "]"}], ",", 
      RowBox[{"Dynamic", "[", 
       RowBox[{"Plot3D", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"baseIndex", "\[InvisibleSpace]", "-", 
           RowBox[{"factorX", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"rsx", "-", "xpos"}], ")"}], "^", "2"}]}], "-", 
           RowBox[{"factorY", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"rsy", "-", "ypos"}], ")"}], "^", "2"}]}]}], ")"}], ",",
          
         RowBox[{"{", 
          RowBox[{"rsx", ",", 
           RowBox[{"-", "5"}], ",", "5"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"rsy", ",", 
           RowBox[{"-", "5"}], ",", "5"}], "}"}], ",", 
         RowBox[{"PlotLabel", "\[Rule]", "\"\<Graded Index Profile\>\""}], 
         ",", 
         RowBox[{"ImageSize", "\[Rule]", "400"}]}], "]"}], "]"}]}], "}"}], 
    "]"}], ",", "\[IndentingNewLine]", "\t", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "factorX", ",", ".001", ",", 
       "\"\<Horizontal Quadratic Index Factor\>\""}], "}"}], ",", "0", ",", 
     ".1"}], "}"}], ",", "\[IndentingNewLine]", "\t", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "factorY", ",", ".001", ",", 
       "\"\<Vertical Quadratic Index Factor\>\""}], "}"}], ",", "0", ",", 
     ".1"}], "}"}], ",", "\[IndentingNewLine]", "\t", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "baseIndex", ",", "2.5", ",", "\"\<Refractive Index Constant\>\""}], 
      "}"}], ",", "2.5", ",", "10"}], "}"}], ",", "\[IndentingNewLine]", "\t",
    
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"width", ",", "0", ",", "\"\<Beam Width\>\""}], "}"}], ",", "0",
      ",", "10"}], "}"}], ",", "\[IndentingNewLine]", "\t", 
   RowBox[{"SliderLabelReplacements", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
      "\"\<baseIndex\>\"", "->", "\"\<Refractive Index Constant\>\""}], ",", 
      RowBox[{
      "\"\<factorX\>\"", "->", "\"\<Horizontal Index Quadratic Factor\>\""}], 
      ",", 
      RowBox[{
      "\"\<factorY\>\"", "->", "\"\<Vertical Index Quadratic Factor\>\""}]}], 
     "}"}]}], ",", "\[IndentingNewLine]", "\t", 
   RowBox[{"Deployed", "\[Rule]", "False"}], ",", 
   RowBox[{"OutputType", "\[Rule]", "Notebook"}]}], "\[IndentingNewLine]", 
  "]"}]}], "Input",
 CellChangeTimes->{{3.4053417742725353`*^9, 3.405341792540154*^9}, {
   3.4053463566028013`*^9, 3.405346378279293*^9}, {3.405346697618993*^9, 
   3.405346703883503*^9}, {3.4069108687095327`*^9, 3.406910870780875*^9}, 
   3.4069114697916107`*^9, {3.406911753543605*^9, 3.406911814743287*^9}, {
   3.406911882542654*^9, 3.406911903904608*^9}, {3.4069119592524652`*^9, 
   3.406911989432384*^9}, {3.406912033225143*^9, 3.4069120569178047`*^9}, 
   3.406912090203266*^9, {3.4069122289957523`*^9, 3.406912256267599*^9}, {
   3.406913806161322*^9, 3.40691381328782*^9}, {3.406917948166432*^9, 
   3.4069180401654673`*^9}, {3.4069180726649446`*^9, 3.406918151251679*^9}, {
   3.406988019061302*^9, 3.4069881121434507`*^9}, {3.406988143937645*^9, 
   3.406988218515383*^9}, {3.406988756512539*^9, 3.406988773933805*^9}, {
   3.406989284491337*^9, 3.406989288096874*^9}, {3.406989727341879*^9, 
   3.40698975795918*^9}, {3.406989867227813*^9, 3.406989879506075*^9}, {
   3.406989912741622*^9, 3.406989934880189*^9}, {3.406990234459065*^9, 
   3.406990261736046*^9}, {3.4069904584899597`*^9, 3.406990480970245*^9}, {
   3.4069913218706617`*^9, 3.4069913494464617`*^9}, {3.4069913797985373`*^9, 
   3.4069913956190357`*^9}, {3.406991456553591*^9, 3.4069914568333073`*^9}, {
   3.40699157202575*^9, 3.4069915829980373`*^9}, {3.406991895753954*^9, 
   3.406991906893901*^9}, {3.406991949255857*^9, 3.4069919583094263`*^9}, {
   3.406992089822815*^9, 3.4069921062126637`*^9}, {3.406992321631269*^9, 
   3.406992382139974*^9}, {3.406992412163657*^9, 3.406992552107685*^9}, {
   3.4069926128316097`*^9, 3.4069927160134068`*^9}, {3.406992747207572*^9, 
   3.4069927605952168`*^9}, {3.406992810733446*^9, 3.4069928383469467`*^9}, {
   3.406992880085477*^9, 3.4069928905447702`*^9}, {3.4069935586122217`*^9, 
   3.406993577814116*^9}, {3.4069938854631577`*^9, 3.406993892629092*^9}, {
   3.406994089755745*^9, 3.406994090197856*^9}, {3.406994162338841*^9, 
   3.406994163179317*^9}, {3.406994225084341*^9, 3.406994354211874*^9}, {
   3.4069944255414257`*^9, 3.406994491382201*^9}, 3.4069957117324667`*^9, {
   3.406995763122085*^9, 3.4069958210701427`*^9}, {3.406995880219554*^9, 
   3.4069959063772697`*^9}, {3.406997352825301*^9, 3.406997422281435*^9}, {
   3.406997519515855*^9, 3.4069975219139423`*^9}, {3.406997733384486*^9, 
   3.4069978172903757`*^9}, {3.4069980534811172`*^9, 3.406998061028359*^9}, {
   3.406998143036298*^9, 3.406998152148641*^9}, {3.406998241703651*^9, 
   3.406998315008664*^9}, {3.406998379820301*^9, 3.4069983983306017`*^9}, {
   3.4069984441692467`*^9, 3.40699847195744*^9}, {3.406999267661252*^9, 
   3.406999280161031*^9}, {3.407082779196828*^9, 3.407082826669323*^9}, {
   3.407082868532461*^9, 3.4070828949742527`*^9}, {3.407083217969633*^9, 
   3.40708322128373*^9}, {3.4070872128472*^9, 3.407087255605279*^9}, {
   3.407087292308566*^9, 3.407087321075358*^9}, {3.407087398159644*^9, 
   3.407087423202196*^9}, {3.407087456492384*^9, 3.4070875872994423`*^9}, {
   3.407087629213592*^9, 3.4070876749202747`*^9}, 3.4071669536050997`*^9, {
   3.4071669866694393`*^9, 3.407167042680902*^9}, {3.4071673055764427`*^9, 
   3.4071673171962643`*^9}, {3.407167370157082*^9, 3.407167389750434*^9}}],

Cell[CellGroupData[{

Cell["\<\
Manipulate[
 Column[
  {Row[{Show[{Graphics[Dynamic[GeometricTransformation[ContourPlot[baseIndex \
- factorX*(rsx - xpos)^2 - factorY*(rsy - ypos)^2, {rsx, -5, 5}, 
            {rsy, -5, 5}][[1]], {{{1, 0}, {0, 1}}, {glx + 5, gly}}]]], 
       Graphics[{{Opacity[0.8], \
GeometricTransformation[staticpolygons11458120071219151445727591, \
Dynamic[{{{1, 0}, {0, 1}}, {glx, gly}}]], 
          staticpolygons12458120071219151445731868, Opacity[1], \
RGBColor[0.038747429704798886, 0.9161617552424038, 0.039847212269181365], 
          AbsoluteThickness[Medium], Line[Dynamic[({#1[[{1, 2}]], #1[[{4, \
5}]]} & ) /@ Select[raytracefunction1458120071219151445741744[th, width, x, 
               y, glx, gly, baseIndex, factorX, factorY, xpos, ypos], #1[[1]] \
> -9.87654321*^8 & ]]], Arrowheads[Large], Thickness[Large], 
          Dashing[{Small, Small}], RGBColor[1, 1, 0], \
Arrow[Dynamic[If[laststartposth != {x, y} || lastth =!= th, laststartposth = \
{x, y}; lastth = 
                th; {xth, yth} = laststartposth + radiusth*{Cos[th*Degree], \
Sin[th*Degree]}]; {laststartposth, {xth, yth}}, 
            ({laststartposth, {xth, yth}} = #1) & ]], \
Tooltip[Locator[Dynamic[If[{xth, yth} != lastlocposth || lastth != th, 
               lastlocposth = {xth, yth}; lastth = th; {xth, yth} = \
laststartposth + radiusth*{Cos[th*Degree], Sin[th*Degree]}]; {xth, yth}, 
             ({xth, yth} = #1; xoffth = xth - x; yoffth = yth - y; radiusth = \
Sqrt[xoffth^2 + yoffth^2]; th = Chop[ArcTan[xoffth, yoffth]/Degree]; {
                xth, yth}) & ], Graphics[{RGBColor[1/3, 1/3, 1], Disk[{0, 0}, \
0.5]}, ImageSize -> 10]], Dynamic[StringJoin[\"th = \", ToString[th]]]], 
          Tooltip[Locator[Dynamic[{x, y}, ({x, y} = Chop[#1]) & ], \
Graphics[{RGBColor[1, 1/3, 1/3], Disk[{0, 0}, 0.8]}, ImageSize -> 10]], 
           Dynamic[StringJoin[\"{x, y} = \", ToString[Chop[{x, y}]]]]], \
Tooltip[Locator[Dynamic[{glx, gly}, ({glx, gly} = Chop[#1]) & ], 
            Graphics[{RGBColor[1, 1/3, 1/3], Disk[{0, 0}, 0.8]}, ImageSize -> \
10]], Dynamic[StringJoin[\"{glx, gly} = \", 
             ToString[Chop[{glx, gly}]]]]]}}], \
Graphics[GeometricTransformation[Locator[Dynamic[{xpos, ypos}], 
          Graphics[{Lighter[Red], Disk[{0, 0}, 0.8]}, ImageSize -> 10]], \
{{{1, 0}, {0, 1}}, {glx + 5, gly}}]]}, 
      {PlotLabel -> \"Graded Refraction Through A Transparent Cubical \
Block\", ImageSize -> 800, AspectRatio -> Automatic}], Null, 
     Dynamic[Plot3D[baseIndex - factorX*(rsx - xpos)^2 - factorY*(rsy - \
ypos)^2, {rsx, -5, 5}, {rsy, -5, 5}, PlotLabel -> \"Graded Index Profile\", 
       ImageSize -> 400]]}], Tooltip[Row[{Style[\"\", Italic, 10], \
Hyperlink[Style[\"<< Crafted with Optica\[Trademark] >>\", Italic, 10], 
       \"http://www.opticasoftware.com\"], Style[\"\", Italic, 10]}], \"Click \
here to visit www.opticasoftware.com\"]}, Center], 
 {{th, 0.}, {-180., 180.}, ControlType -> None}, {{width, 4.}, {0, 10}, \
ControlType -> None}, {{x, 10.}, {0.1, 20}, ControlType -> None}, 
 {{y, 1.}, {0.1, 1.5}, ControlType -> None}, {{glx, 15.}, {0.15, 30}, \
ControlType -> None}, {{gly, 0.}, {-10, 10}, ControlType -> None}, 
 {{baseIndex, 2.5}, {2.5, 10}, ControlType -> None}, {{factorX, 0.001}, {0, \
0.1}, ControlType -> None}, 
 {{factorY, 0.001}, {0, 0.1}, ControlType -> None}, {{xpos, 1.}, {0.1, 1.5}, \
ControlType -> None}, {{ypos, 0.}, {-10, 10}, ControlType -> None}, 
 Style[Grid[{{\"Horizontal Quadratic Index Factor\", \
Manipulator[Dynamic[factorX], {0, 0.1}], Dynamic[factorX]}}]], 
 Style[Grid[{{\"Vertical Quadratic Index Factor\", \
Manipulator[Dynamic[factorY], {0, 0.1}], Dynamic[factorY]}}]], 
 Style[Grid[{{\"Refractive Index Constant\", Manipulator[Dynamic[baseIndex], \
{2.5, 10}], Dynamic[baseIndex]}}]], 
 Style[Grid[{{\"Beam Width\", Manipulator[Dynamic[width], {0, 10}], \
Dynamic[width]}}]], {{xth, 11.}, ControlType -> None}, 
 {{yth, 1.}, ControlType -> None}, {{radiusth, 1.}, ControlType -> None}, \
{{xoffth, 1.}, ControlType -> None}, {{yoffth, 0.}, ControlType -> None}, 
 {{laststartposth, {10., 1.}}, ControlType -> None}, {{lastlocposth, {11., \
1.}}, ControlType -> None}, {{lastth, 0}, ControlType -> None}, 
 {{staticpolygons11458120071219151445727591, {GrayLevel[0], \
AbsoluteThickness[0.5], 
    Line[{{{0., -5.}, {0., -4.166666666666667}, {0., -3.3333333333333335}, \
{0., -2.5}, {0., -1.666666666666667}, {0., -0.8333333333333339}, {0., 0.}, 
       {0., 0.833333333333333}, {0., 1.666666666666666}, {0., \
2.499999999999999}, {0., 3.333333333333332}, {0., 4.166666666666666}, {0., \
5.}, 
       {0., 5.}, {0., 4.166666666666667}, {0., 3.3333333333333335}, {0., \
2.5}, {0., 1.666666666666667}, {0., 0.8333333333333339}, {0., 0.}, 
       {0., -0.833333333333333}, {0., -1.666666666666666}, {0., \
-2.499999999999999}, {0., -3.333333333333332}, {0., -4.166666666666666}, {0., \
-5.}, 
       {0., -5.}}, {{10., -5.}, {10., -4.166666666666667}, {10., \
-3.3333333333333335}, {10., -2.5}, {10., -1.666666666666667}, 
       {10., -0.8333333333333339}, {10., 0.}, {10., 0.833333333333333}, {10., \
1.666666666666666}, {10., 2.499999999999999}, {10., 3.333333333333332}, 
       {10., 4.166666666666666}, {10., 5.}, {10., 5.}, {10., \
4.166666666666667}, {10., 3.3333333333333335}, {10., 2.5}, {10., \
1.666666666666667}, 
       {10., 0.8333333333333339}, {10., 0.}, {10., -0.833333333333333}, {10., \
-1.666666666666666}, {10., -2.499999999999999}, 
       {10., -3.333333333333332}, {10., -4.166666666666666}, {10., -5.}, \
{10., -5.}}, {{5., -5.}, {5., -4.166666666666667}, 
       {5., -3.3333333333333335}, {5., -2.5}, {5., -1.666666666666667}, {5., \
-0.8333333333333339}, {5., 0.}, {5., 0.833333333333333}, 
       {5., 1.666666666666666}, {5., 2.499999999999999}, {5., \
3.333333333333332}, {5., 4.166666666666666}, {5., 5.}, {5., 5.}, 
       {5., 4.166666666666667}, {5., 3.3333333333333335}, {5., 2.5}, {5., \
1.666666666666667}, {5., 0.8333333333333339}, {5., 0.}, 
       {5., -0.833333333333333}, {5., -1.666666666666666}, {5., \
-2.499999999999999}, {5., -3.333333333333332}, {5., -4.166666666666666}, {5., \
-5.}, 
       {5., -5.}}, {{10., 0.}, {9.166666666666668, 0.}, {8.333333333333334, \
0.}, {7.5, 0.}, {6.666666666666667, 0.}, {5.833333333333334, 0.}, 
       {5., 0.}, {4.166666666666667, 0.}, {3.333333333333334, 0.}, \
{2.500000000000001, 0.}, {1.6666666666666679, 0.}, {0.8333333333333339, 0.}, 
       {0., 0.}, {0., 0.}, {0.833333333333333, 0.}, {1.6666666666666665, 0.}, \
{2.5, 0.}, {3.333333333333333, 0.}, {4.166666666666666, 0.}, {5., 0.}, 
       {5.833333333333333, 0.}, {6.666666666666666, 0.}, {7.499999999999999, \
0.}, {8.333333333333332, 0.}, {9.166666666666666, 0.}, {10., 0.}, 
       {10., 0.}}, {{5., 5.}, {5., 4.166666666666667}, {5., \
3.3333333333333335}, {5., 2.5}, {5., 1.666666666666667}, {5., \
0.8333333333333339}, 
       {5., 0.}, {5., -0.833333333333333}, {5., -1.666666666666666}, {5., \
-2.499999999999999}, {5., -3.333333333333332}, {5., -4.166666666666666}, 
       {5., -5.}, {5., -5.}, {5., -4.166666666666667}, {5., \
-3.3333333333333335}, {5., -2.5}, {5., -1.666666666666667}, {5., \
-0.8333333333333339}, 
       {5., 0.}, {5., 0.833333333333333}, {5., 1.666666666666666}, {5., \
2.499999999999999}, {5., 3.333333333333332}, {5., 4.166666666666666}, 
       {5., 5.}, {5., 5.}}, {{10., 0.}, {9.166666666666668, 0.}, \
{8.333333333333334, 0.}, {7.5, 0.}, {6.666666666666667, 0.}, 
       {5.833333333333334, 0.}, {5., 0.}, {4.166666666666667, 0.}, \
{3.333333333333334, 0.}, {2.500000000000001, 0.}, {1.6666666666666679, 0.}, 
       {0.8333333333333339, 0.}, {0., 0.}, {0., 0.}, {0.833333333333333, 0.}, \
{1.6666666666666665, 0.}, {2.5, 0.}, {3.333333333333333, 0.}, 
       {4.166666666666666, 0.}, {5., 0.}, {5.833333333333333, 0.}, \
{6.666666666666666, 0.}, {7.499999999999999, 0.}, {8.333333333333332, 0.}, 
       {9.166666666666666, 0.}, {10., 0.}, {10., 0.}}, {{0., 5.}, \
{0.833333333333333, 5.}, {1.6666666666666665, 5.}, {2.5, 5.}, 
       {3.333333333333333, 5.}, {4.166666666666666, 5.}, {5., 5.}, \
{5.833333333333333, 5.}, {6.666666666666666, 5.}, {7.499999999999999, 5.}, 
       {8.333333333333332, 5.}, {9.166666666666666, 5.}, {10., 5.}, {10., \
5.}, {9.166666666666668, 5.}, {8.333333333333334, 5.}, {7.5, 5.}, 
       {6.666666666666667, 5.}, {5.833333333333334, 5.}, {5., 5.}, \
{4.166666666666667, 5.}, {3.333333333333334, 5.}, {2.500000000000001, 5.}, 
       {1.6666666666666679, 5.}, {0.8333333333333339, 5.}, {0., 5.}, {0., \
5.}}, {{10., -5.}, {9.166666666666668, -5.}, {8.333333333333334, -5.}, 
       {7.5, -5.}, {6.666666666666667, -5.}, {5.833333333333334, -5.}, {5., \
-5.}, {4.166666666666667, -5.}, {3.333333333333334, -5.}, 
       {2.500000000000001, -5.}, {1.6666666666666679, -5.}, \
{0.8333333333333339, -5.}, {0., -5.}, {0., -5.}, {0.833333333333333, -5.}, 
       {1.6666666666666665, -5.}, {2.5, -5.}, {3.333333333333333, -5.}, \
{4.166666666666666, -5.}, {5., -5.}, {5.833333333333333, -5.}, 
       {6.666666666666666, -5.}, {7.499999999999999, -5.}, \
{8.333333333333332, -5.}, {9.166666666666666, -5.}, {10., -5.}, {10., \
-5.}}}]}}, 
  ControlType -> None}, {{staticpolygons12458120071219151445731868, \
{GrayLevel[0], AbsoluteThickness[0.5], 
    Line[{{{40., 15.}, {40., -15.}, {40., -15.}, {40., 15.}, {40., 15.}}, \
{{40., -15.}, {0., -15.}, {0., -15.}, {40., -15.}, {40., -15.}}, 
      {{0., -15.}, {0., 15.}, {0., 15.}, {0., -15.}, {0., -15.}}, {{0., 15.}, \
{40., 15.}, {40., 15.}, {0., 15.}, {0., 15.}}, 
      {{40., -15.}, {40., 15.}, {0., 15.}, {0., -15.}, {40., -15.}}, {{40., \
15.}, {40., -15.}, {0., -15.}, {0., 15.}, {40., 15.}}}]}}, 
  ControlType -> None}, Initialization :> \
(raytracefunction1458120071219151445741744 = 
   Compile[{{th, _Real}, {width, _Real}, {x, _Real}, {y, _Real}, {glx, \
_Real}, {gly, _Real}, {baseIndex, _Real}, {factorX, _Real}, {factorY, _Real}, \

     {xpos, _Real}, {ypos, _Real}}, Module[{activeregion, Aelement, \
allcreatedamplitudes, allcreatedrays, allowzeroraylength, alternateindex, 
      amplitude, axismagnitude, axismatrix, Belement, Celement, clonedata, \
clonegenerationnumber, cloneinput, clonenumber, cloneposition, 
      clonereportedrays, clonerotation, clonescale, clonescalevector, \
clonesorthistogram, clonetraceinput, clonetraceoutput, closestdistances, 
      closestposition, closestpositions, closestraylength, completedray, \
componentnumber, cosangle, crossmatrix, deflecteddummyrayspresent, 
      deflectedlocalrays, deflectedrays, deflectedrayspresent, dummymatrix, \
dummymatrixlist, dummyvector, frontid, generationlimit, generationnumber, 
      holeintersections, holeQ, holeQlist, hor, index, index1, index2, \
indexpoints, inrays, integratedrefractiveindex, intensity, intensityscale, 
      intersectionnumber, intersections, intersectionslist, \
intersectionspresent, listofpositions, listoftilts, localdummyoutrayspresent, \
localindex, 
      localopticallength, localoutrays, localoutrayspresent, localpos, \
localraylength, localrotation, localtilt, localtranslation, magnitude, 
      maxclonegenerationnumber, maximumposition, minimumraylength, \
minresonateraylength, n12, newcomponentnumber, newdeflectedrays, newdistance, \

      newpos, newsurfaceid, newsurfacenumber, newtilt, Nfinal, Ninitial, \
ninteger, nonintersectingrays, normalizedpolarization, oldgenerationnumber, 
      opticallength, opticallengths, originalopticallength, originalray, \
originalraytilt, originalrotation, originalsurfnorm, outrays, 
      parallelamplitude, PAxis, perpendicularamplitude, phaseshift, pol1, \
pol2, pol3, previoustilt, propagate, propagatedrays, r1, r2, r3, r4, r5, 
      r6, r7, r8, r9, ray1, ray2, ray3, LocRayL, rayslot, raysreported, \
raytiltx, raytiltz, reporteddummyrayspresent, reportedlocalrays, 
      reportedrays, reportedrayspresent, resonateintersections, \
resonatenumber, resonateraylength, rex, rey, rez, rotationaxis, rsx, LocRSx, 
      rSxOffset, rsy, LocRSy, rsz, LocRSz, RTx, LocRTy, LocRTz, rx, rxhlp, \
ry, ryhlp, rz, rzhlp, LocSCx, LocSCy, Sfinal, sid, sinangle, Sinitial, 
      sno1, sno2, sno3, sno4, surfaceid, surfacenumber, \
surfacerotationmatrix, surfacetranslationvector, surfnorm, surfrot, \
surftrans, symr1, symr2, 
      symr3, symr4, symr5, symr6, symr7, symr8, symr9, tempclonedata, \
terminatedeflection, thresholdintensity, tiltmagnitude, transmatrix, LocTV1, 
      LocTV10, LocTV2, LocTV3, LocTV4, LocTV5, LocTV6, LocTV7, LocTV8, \
LocTV9, u, unfilteredintersections, unit, uu, ver, wavelength, XAxis, xunit, 
      YAxis, yunit, ZAxis, zunit}, activeregion = 1.; Aelement = {0., 0., \
0.}; allcreatedamplitudes = {{0. + 0.*I, 0. + 0.*I, 0. + 0.*I}}; 
      allcreatedrays = {{1.}}; allowzeroraylength = True; alternateindex = \
1.; amplitude = {1. + 0.*I, 0. + 0.*I, 0. + 0.*I}; axismagnitude = 1.; 
      axismatrix = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}; Belement = \
{0., 0., 0.}; Celement = {0., 0., 0.}; clonedata = {{1.}}; 
      clonegenerationnumber = 1.; cloneinput = {1.}; clonenumber = 1; \
cloneposition = {0., 0., 0.}; clonereportedrays = {{1.}}; 
      clonerotation = {{1.}}; clonescale = 1.; clonescalevector = {1.}; \
clonesorthistogram = {1}; clonetraceinput = {{1.}}; 
      clonetraceoutput = {{1.}}; closestdistances = {1.}; closestposition = \
0; closestpositions = {0}; closestraylength = 1.; completedray = {1.}; 
      componentnumber = -1.; cosangle = 1.; crossmatrix = {{1., 0., 0.}, {0., \
1., 0.}, {0., 0., 1.}}; deflecteddummyrayspresent = False; 
      deflectedlocalrays = {{1.}}; deflectedrays = {{1.}}; \
deflectedrayspresent = False; dummymatrix = {{1.}}; dummymatrixlist = \
{{{1.}}}; 
      dummyvector = {1.}; frontid = 1.; generationlimit = 200.; \
generationnumber = 1.; holeintersections = {{-1., 0., 0.}}; holeQ = False; 
      holeQlist = {0}; hor = 1. + 0.*I; index = 1.; index1 = 1.; index2 = 1.; \
indexpoints = {1.}; inrays = {{1.}}; integratedrefractiveindex = 0.; 
      intensity = 1.; intensityscale = 1.; intersectionnumber = 1.; \
intersections = {{-1., 0., 0.}}; intersectionslist = {{{-1., 0., 0.}}}; 
      intersectionspresent = False; listofpositions = {{1.}}; listoftilts = \
{{1.}}; localdummyoutrayspresent = False; localindex = 1.; 
      localopticallength = 0.; localoutrays = {{1.}}; localoutrayspresent = \
False; localpos = {0., 0., 0.}; localraylength = 0.; 
      localrotation = {{1.}}; localtilt = {1., 0., 0.}; localtranslation = \
{1., 0., 0.}; magnitude = 1.; maxclonegenerationnumber = 1.; 
      maximumposition = 1; minimumraylength = 0.0001; minresonateraylength = \
1.; n12 = 1.; newcomponentnumber = -1.; newdeflectedrays = {{1.}}; 
      newdistance = 1.; newpos = {0., 0., 0.}; newsurfaceid = -1.; \
newsurfacenumber = -1.; newtilt = {1., 0., 0.}; Nfinal = 0.; Ninitial = 0.; 
      ninteger = 1; nonintersectingrays = {{1.}}; normalizedpolarization = \
{1., 1.}; oldgenerationnumber = 1.; opticallength = 1.; 
      opticallengths = {1.}; originalray = {1.}; originalraytilt = {1.}; \
originalrotation = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}; 
      originalsurfnorm = {{1.}}; outrays = {{1.}}; parallelamplitude = 1. + \
0.*I; PAxis = {1., 0., 0.}; perpendicularamplitude = 1. + 0.*I; 
      phaseshift = 0.; pol1 = 1.; pol2 = 1.; pol3 = 1.; previoustilt = {1., \
0., 0.}; propagate = True; propagatedrays = {{1.}}; r1 = 1.; r2 = 1.; 
      r3 = 1.; r4 = 1.; r5 = 1.; r6 = 1.; r7 = 1.; r8 = 1.; r9 = 1.; ray1 = \
1.; ray2 = 1.; ray3 = 1.; LocRayL = 1.; rayslot = 1.; 
      raysreported = False; raytiltx = 1.; raytiltz = 1.; \
reporteddummyrayspresent = False; reportedlocalrays = {{1.}}; reportedrays = \
{{1.}}; 
      reportedrayspresent = False; resonateintersections = {{-1., 0., 0.}}; \
resonatenumber = 0; resonateraylength = 1.; rex = 1.; rey = 1.; rez = 1.; 
      rsx = 1.; LocRSx = 1.; rSxOffset = 1.; rsy = 1.; LocRSy = 1.; rsz = 1.; \
LocRSz = 1.; RTx = 1.; LocRTy = 1.; LocRTz = 1.; rx = 1.; rxhlp = 1.; 
      ry = 1.; ryhlp = 1.; rz = 1.; rzhlp = 1.; LocSCx = 1.; LocSCy = 1.; \
Sfinal = 0.; sid = 1.; sinangle = 1.; Sinitial = 0.; sno1 = 1.; sno2 = 1.; 
      sno3 = 1.; sno4 = 1.; surfaceid = -1.; surfacenumber = -1.; \
surfacerotationmatrix = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}; 
      surfacetranslationvector = {0., 0., 0.}; surfnorm = {{1.}}; surfrot = \
{{1.}}; surftrans = {1., 0., 0.}; symr1 = 1.; symr2 = 1.; symr3 = 1.; 
      symr4 = 1.; symr5 = 1.; symr6 = 1.; symr7 = 1.; symr8 = 1.; symr9 = 1.; \
tempclonedata = {{1.}}; terminatedeflection = False; 
      thresholdintensity = 1.; tiltmagnitude = 1.; transmatrix = {{{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}}}; LocTV1 = 1.; LocTV10 = 1.; 
      LocTV2 = 1.; LocTV3 = 1.; LocTV4 = 1.; LocTV5 = 1.; LocTV6 = 1.; LocTV7 \
= 1.; LocTV8 = 1.; LocTV9 = 1.; 
      u = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}; unfilteredintersections \
= {{-1., 0., 0.}}; unit = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}; 
      uu = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}; ver = 0. + 0.*I; \
wavelength = 1.; XAxis = {1., 0., 0.}; xunit = 1.; YAxis = {1., 0., 0.}; 
      yunit = 1.; ZAxis = {1., 0., 0.}; zunit = 1.; propagatedrays = \
Join[{symr1, symr2, symr3, symr4, symr5, symr6, symr7, symr8, symr9} = 
          {Cos[Degree*th], Sin[Degree*th], 0, -Sin[Degree*th], \
Cos[Degree*th], 0, 0, 0, 1}; 
         (({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, intensity, intensityscale, ray1, index, opticallength, 
              phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
              intersectionnumber, pol1, pol2, pol3} = #1; {LocTV1, LocTV2, \
LocTV3} = {rsx*symr1 + rsy*symr4 + rsz*symr7 + x + 0.5*width*
                Sin[Degree*th], rsx*symr2 + rsy*symr5 + rsz*symr8 + y - \
0.5*width*Cos[Degree*th], rsx*symr3 + rsy*symr6 + rsz*symr9}; 
            {rsx, rsy, rsz} = {LocTV1, LocTV2, LocTV3}; {LocTV1, LocTV2, \
LocTV3} = {rex*symr1 + rey*symr4 + rez*symr7 + x + 0.5*width*Sin[Degree*th], 
              rex*symr2 + rey*symr5 + rez*symr8 + y - \
0.5*width*Cos[Degree*th], rex*symr3 + rey*symr6 + rez*symr9}; 
            {rex, rey, rez} = {LocTV1, LocTV2, LocTV3}; {LocTV1, LocTV2, \
LocTV3} = {r1*symr1 + r2*symr4 + r3*symr7, r1*symr2 + r2*symr5 + r3*symr8, 
              r1*symr3 + r2*symr6 + r3*symr9}; {LocTV4, LocTV5, LocTV6} = \
{r4*symr1 + r5*symr4 + r6*symr7, r4*symr2 + r5*symr5 + r6*symr8, 
              r4*symr3 + r5*symr6 + r6*symr9}; {LocTV7, LocTV8, LocTV9} = \
{r7*symr1 + r8*symr4 + r9*symr7, r7*symr2 + r8*symr5 + r9*symr8, 
              r7*symr3 + r8*symr6 + r9*symr9}; {{r1, r2, r3}, {r4, r5, r6}, \
{r7, r8, r9}} = {{LocTV1, LocTV2, LocTV3}, {LocTV4, LocTV5, LocTV6}, 
              {LocTV7, LocTV8, LocTV9}}; {rsx, rsy, rsz, rex, rey, rez, r1, \
r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, 
             ray1, index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
             rayslot, generationnumber, intersectionnumber, pol1, pol2, \
pol3}) & ) /@ {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., 
            0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 0., 0., \
0., 273039., 273039., 1., 1., 0., 0., 1., 0., 0., 0., 1., 0.}}, 
        {symr1, symr2, symr3, symr4, symr5, symr6, symr7, symr8, symr9} = \
{Cos[Degree*th], Sin[Degree*th], 0, -Sin[Degree*th], Cos[Degree*th], 0, 0, 
           0, 1}; (({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
              opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
              oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = \
#1; {LocTV1, LocTV2, LocTV3} = 
             {rsx*symr1 + rsy*symr4 + rsz*symr7 + x + \
0.4*width*Sin[Degree*th], rsx*symr2 + rsy*symr5 + rsz*symr8 + y - \
0.4*width*Cos[Degree*th], 
              rsx*symr3 + rsy*symr6 + rsz*symr9}; {rsx, rsy, rsz} = {LocTV1, \
LocTV2, LocTV3}; {LocTV1, LocTV2, LocTV3} = 
             {rex*symr1 + rey*symr4 + rez*symr7 + x + \
0.4*width*Sin[Degree*th], rex*symr2 + rey*symr5 + rez*symr8 + y - \
0.4*width*Cos[Degree*th], 
              rex*symr3 + rey*symr6 + rez*symr9}; {rex, rey, rez} = {LocTV1, \
LocTV2, LocTV3}; {LocTV1, LocTV2, LocTV3} = 
             {r1*symr1 + r2*symr4 + r3*symr7, r1*symr2 + r2*symr5 + r3*symr8, \
r1*symr3 + r2*symr6 + r3*symr9}; {LocTV4, LocTV5, LocTV6} = 
             {r4*symr1 + r5*symr4 + r6*symr7, r4*symr2 + r5*symr5 + r6*symr8, \
r4*symr3 + r5*symr6 + r6*symr9}; {LocTV7, LocTV8, LocTV9} = 
             {r7*symr1 + r8*symr4 + r9*symr7, r7*symr2 + r8*symr5 + r9*symr8, \
r7*symr3 + r8*symr6 + r9*symr9}; 
            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = {{LocTV1, LocTV2, \
LocTV3}, {LocTV4, LocTV5, LocTV6}, {LocTV7, LocTV8, LocTV9}}; 
            {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, \
r9, wavelength, intensity, intensityscale, ray1, index, opticallength, 
             phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
             intersectionnumber, pol1, pol2, pol3}) & ) /@ {{0., 0., 0., 0., \
0., 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., 0.532, 100., 1., 0., 
            1.00026945145708, 0., 0., 0., 0., 0., 0., 0., 273042., 273042., \
1., 1., 0., 0., 1., 0., 0., 0., 1., 0.}}, 
        {symr1, symr2, symr3, symr4, symr5, symr6, symr7, symr8, symr9} = \
{Cos[Degree*th], Sin[Degree*th], 0, -Sin[Degree*th], Cos[Degree*th], 0, 0, 
           0, 1}; (({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
              opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
              oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = \
#1; {LocTV1, LocTV2, LocTV3} = 
             {rsx*symr1 + rsy*symr4 + rsz*symr7 + x + \
0.3*width*Sin[Degree*th], rsx*symr2 + rsy*symr5 + rsz*symr8 + y - \
0.3*width*Cos[Degree*th], 
              rsx*symr3 + rsy*symr6 + rsz*symr9}; {rsx, rsy, rsz} = {LocTV1, \
LocTV2, LocTV3}; {LocTV1, LocTV2, LocTV3} = 
             {rex*symr1 + rey*symr4 + rez*symr7 + x + \
0.3*width*Sin[Degree*th], rex*symr2 + rey*symr5 + rez*symr8 + y - \
0.3*width*Cos[Degree*th], 
              rex*symr3 + rey*symr6 + rez*symr9}; {rex, rey, rez} = {LocTV1, \
LocTV2, LocTV3}; {LocTV1, LocTV2, LocTV3} = 
             {r1*symr1 + r2*symr4 + r3*symr7, r1*symr2 + r2*symr5 + r3*symr8, \
r1*symr3 + r2*symr6 + r3*symr9}; {LocTV4, LocTV5, LocTV6} = 
             {r4*symr1 + r5*symr4 + r6*symr7, r4*symr2 + r5*symr5 + r6*symr8, \
r4*symr3 + r5*symr6 + r6*symr9}; {LocTV7, LocTV8, LocTV9} = 
             {r7*symr1 + r8*symr4 + r9*symr7, r7*symr2 + r8*symr5 + r9*symr8, \
r7*symr3 + r8*symr6 + r9*symr9}; 
            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = {{LocTV1, LocTV2, \
LocTV3}, {LocTV4, LocTV5, LocTV6}, {LocTV7, LocTV8, LocTV9}}; 
            {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, \
r9, wavelength, intensity, intensityscale, ray1, index, opticallength, 
             phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
             intersectionnumber, pol1, pol2, pol3}) & ) /@ {{0., 0., 0., 0., \
0., 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., 0.532, 100., 1., 0., 
            1.00026945145708, 0., 0., 0., 0., 0., 0., 0., 273045., 273045., \
1., 1., 0., 0., 1., 0., 0., 0., 1., 0.}}, 
        {symr1, symr2, symr3, symr4, symr5, symr6, symr7, symr8, symr9} = \
{Cos[Degree*th], Sin[Degree*th], 0, -Sin[Degree*th], Cos[Degree*th], 0, 0, 
           0, 1}; (({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
              opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
              oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = \
#1; {LocTV1, LocTV2, LocTV3} = 
             {rsx*symr1 + rsy*symr4 + rsz*symr7 + x + \
0.19999999999999998*width*Sin[Degree*th], rsx*symr2 + rsy*symr5 + rsz*symr8 + \
y - 
               0.19999999999999998*width*Cos[Degree*th], rsx*symr3 + \
rsy*symr6 + rsz*symr9}; {rsx, rsy, rsz} = {LocTV1, LocTV2, LocTV3}; 
            {LocTV1, LocTV2, LocTV3} = {rex*symr1 + rey*symr4 + rez*symr7 + x \
+ 0.19999999999999998*width*Sin[Degree*th], 
              rex*symr2 + rey*symr5 + rez*symr8 + y - \
0.19999999999999998*width*Cos[Degree*th], rex*symr3 + rey*symr6 + rez*symr9}; \

            {rex, rey, rez} = {LocTV1, LocTV2, LocTV3}; {LocTV1, LocTV2, \
LocTV3} = {r1*symr1 + r2*symr4 + r3*symr7, r1*symr2 + r2*symr5 + r3*symr8, 
              r1*symr3 + r2*symr6 + r3*symr9}; {LocTV4, LocTV5, LocTV6} = \
{r4*symr1 + r5*symr4 + r6*symr7, r4*symr2 + r5*symr5 + r6*symr8, 
              r4*symr3 + r5*symr6 + r6*symr9}; {LocTV7, LocTV8, LocTV9} = \
{r7*symr1 + r8*symr4 + r9*symr7, r7*symr2 + r8*symr5 + r9*symr8, 
              r7*symr3 + r8*symr6 + r9*symr9}; {{r1, r2, r3}, {r4, r5, r6}, \
{r7, r8, r9}} = {{LocTV1, LocTV2, LocTV3}, {LocTV4, LocTV5, LocTV6}, 
              {LocTV7, LocTV8, LocTV9}}; {rsx, rsy, rsz, rex, rey, rez, r1, \
r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, 
             ray1, index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
             rayslot, generationnumber, intersectionnumber, pol1, pol2, \
pol3}) & ) /@ {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., 
            0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 0., 0., \
0., 273048., 273048., 1., 1., 0., 0., 1., 0., 0., 0., 1., 0.}}, 
        {symr1, symr2, symr3, symr4, symr5, symr6, symr7, symr8, symr9} = \
{Cos[Degree*th], Sin[Degree*th], 0, -Sin[Degree*th], Cos[Degree*th], 0, 0, 
           0, 1}; (({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
              opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
              oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = \
#1; {LocTV1, LocTV2, LocTV3} = 
             {rsx*symr1 + rsy*symr4 + rsz*symr7 + x + \
0.09999999999999998*width*Sin[Degree*th], rsx*symr2 + rsy*symr5 + rsz*symr8 + \
y - 
               0.09999999999999998*width*Cos[Degree*th], rsx*symr3 + \
rsy*symr6 + rsz*symr9}; {rsx, rsy, rsz} = {LocTV1, LocTV2, LocTV3}; 
            {LocTV1, LocTV2, LocTV3} = {rex*symr1 + rey*symr4 + rez*symr7 + x \
+ 0.09999999999999998*width*Sin[Degree*th], 
              rex*symr2 + rey*symr5 + rez*symr8 + y - \
0.09999999999999998*width*Cos[Degree*th], rex*symr3 + rey*symr6 + rez*symr9}; \

            {rex, rey, rez} = {LocTV1, LocTV2, LocTV3}; {LocTV1, LocTV2, \
LocTV3} = {r1*symr1 + r2*symr4 + r3*symr7, r1*symr2 + r2*symr5 + r3*symr8, 
              r1*symr3 + r2*symr6 + r3*symr9}; {LocTV4, LocTV5, LocTV6} = \
{r4*symr1 + r5*symr4 + r6*symr7, r4*symr2 + r5*symr5 + r6*symr8, 
              r4*symr3 + r5*symr6 + r6*symr9}; {LocTV7, LocTV8, LocTV9} = \
{r7*symr1 + r8*symr4 + r9*symr7, r7*symr2 + r8*symr5 + r9*symr8, 
              r7*symr3 + r8*symr6 + r9*symr9}; {{r1, r2, r3}, {r4, r5, r6}, \
{r7, r8, r9}} = {{LocTV1, LocTV2, LocTV3}, {LocTV4, LocTV5, LocTV6}, 
              {LocTV7, LocTV8, LocTV9}}; {rsx, rsy, rsz, rex, rey, rez, r1, \
r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, 
             ray1, index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
             rayslot, generationnumber, intersectionnumber, pol1, pol2, \
pol3}) & ) /@ {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., 
            0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 0., 0., \
0., 273051., 273051., 1., 1., 0., 0., 1., 0., 0., 0., 1., 0.}}, 
        {symr1, symr2, symr3, symr4, symr5, symr6, symr7, symr8, symr9} = \
{Cos[Degree*th], Sin[Degree*th], 0, -Sin[Degree*th], Cos[Degree*th], 0, 0, 
           0, 1}; (({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
              opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
              oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = \
#1; {LocTV1, LocTV2, LocTV3} = {rsx*symr1 + rsy*symr4 + rsz*symr7 + x, 
              rsx*symr2 + rsy*symr5 + rsz*symr8 + y, rsx*symr3 + rsy*symr6 + \
rsz*symr9}; {rsx, rsy, rsz} = {LocTV1, LocTV2, LocTV3}; 
            {LocTV1, LocTV2, LocTV3} = {rex*symr1 + rey*symr4 + rez*symr7 + \
x, rex*symr2 + rey*symr5 + rez*symr8 + y, rex*symr3 + rey*symr6 + rez*
                symr9}; {rex, rey, rez} = {LocTV1, LocTV2, LocTV3}; {LocTV1, \
LocTV2, LocTV3} = {r1*symr1 + r2*symr4 + r3*symr7, 
              r1*symr2 + r2*symr5 + r3*symr8, r1*symr3 + r2*symr6 + \
r3*symr9}; {LocTV4, LocTV5, LocTV6} = {r4*symr1 + r5*symr4 + r6*symr7, 
              r4*symr2 + r5*symr5 + r6*symr8, r4*symr3 + r5*symr6 + \
r6*symr9}; {LocTV7, LocTV8, LocTV9} = {r7*symr1 + r8*symr4 + r9*symr7, 
              r7*symr2 + r8*symr5 + r9*symr8, r7*symr3 + r8*symr6 + \
r9*symr9}; {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = 
             {{LocTV1, LocTV2, LocTV3}, {LocTV4, LocTV5, LocTV6}, {LocTV7, \
LocTV8, LocTV9}}; {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, 
             r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
             ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}) & ) /@ 
          {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., \
0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 0., 0., 0., 273054., 
            273054., 1., 1., 0., 0., 1., 0., 0., 0., 1., 0.}}, {symr1, symr2, \
symr3, symr4, symr5, symr6, symr7, symr8, symr9} = 
          {Cos[Degree*th], Sin[Degree*th], 0, -Sin[Degree*th], \
Cos[Degree*th], 0, 0, 0, 1}; 
         (({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, intensity, intensityscale, ray1, index, opticallength, 
              phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
              intersectionnumber, pol1, pol2, pol3} = #1; {LocTV1, LocTV2, \
LocTV3} = {rsx*symr1 + rsy*symr4 + rsz*symr7 + x - 0.10000000000000003*
                width*Sin[Degree*th], rsx*symr2 + rsy*symr5 + rsz*symr8 + y + \
0.10000000000000003*width*Cos[Degree*th], 
              rsx*symr3 + rsy*symr6 + rsz*symr9}; {rsx, rsy, rsz} = {LocTV1, \
LocTV2, LocTV3}; {LocTV1, LocTV2, LocTV3} = 
             {rex*symr1 + rey*symr4 + rez*symr7 + x - \
0.10000000000000003*width*Sin[Degree*th], rex*symr2 + rey*symr5 + rez*symr8 + \
y + 
               0.10000000000000003*width*Cos[Degree*th], rex*symr3 + \
rey*symr6 + rez*symr9}; {rex, rey, rez} = {LocTV1, LocTV2, LocTV3}; 
            {LocTV1, LocTV2, LocTV3} = {r1*symr1 + r2*symr4 + r3*symr7, \
r1*symr2 + r2*symr5 + r3*symr8, r1*symr3 + r2*symr6 + r3*symr9}; 
            {LocTV4, LocTV5, LocTV6} = {r4*symr1 + r5*symr4 + r6*symr7, \
r4*symr2 + r5*symr5 + r6*symr8, r4*symr3 + r5*symr6 + r6*symr9}; 
            {LocTV7, LocTV8, LocTV9} = {r7*symr1 + r8*symr4 + r9*symr7, \
r7*symr2 + r8*symr5 + r9*symr8, r7*symr3 + r8*symr6 + r9*symr9}; 
            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = {{LocTV1, LocTV2, \
LocTV3}, {LocTV4, LocTV5, LocTV6}, {LocTV7, LocTV8, LocTV9}}; 
            {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, \
r9, wavelength, intensity, intensityscale, ray1, index, opticallength, 
             phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
             intersectionnumber, pol1, pol2, pol3}) & ) /@ {{0., 0., 0., 0., \
0., 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., 0.532, 100., 1., 0., 
            1.00026945145708, 0., 0., 0., 0., 0., 0., 0., 273057., 273057., \
1., 1., 0., 0., 1., 0., 0., 0., 1., 0.}}, 
        {symr1, symr2, symr3, symr4, symr5, symr6, symr7, symr8, symr9} = \
{Cos[Degree*th], Sin[Degree*th], 0, -Sin[Degree*th], Cos[Degree*th], 0, 0, 
           0, 1}; (({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
              opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
              oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = \
#1; {LocTV1, LocTV2, LocTV3} = 
             {rsx*symr1 + rsy*symr4 + rsz*symr7 + x - \
0.20000000000000004*width*Sin[Degree*th], rsx*symr2 + rsy*symr5 + rsz*symr8 + \
y + 
               0.20000000000000004*width*Cos[Degree*th], rsx*symr3 + \
rsy*symr6 + rsz*symr9}; {rsx, rsy, rsz} = {LocTV1, LocTV2, LocTV3}; 
            {LocTV1, LocTV2, LocTV3} = {rex*symr1 + rey*symr4 + rez*symr7 + x \
- 0.20000000000000004*width*Sin[Degree*th], 
              rex*symr2 + rey*symr5 + rez*symr8 + y + \
0.20000000000000004*width*Cos[Degree*th], rex*symr3 + rey*symr6 + rez*symr9}; \

            {rex, rey, rez} = {LocTV1, LocTV2, LocTV3}; {LocTV1, LocTV2, \
LocTV3} = {r1*symr1 + r2*symr4 + r3*symr7, r1*symr2 + r2*symr5 + r3*symr8, 
              r1*symr3 + r2*symr6 + r3*symr9}; {LocTV4, LocTV5, LocTV6} = \
{r4*symr1 + r5*symr4 + r6*symr7, r4*symr2 + r5*symr5 + r6*symr8, 
              r4*symr3 + r5*symr6 + r6*symr9}; {LocTV7, LocTV8, LocTV9} = \
{r7*symr1 + r8*symr4 + r9*symr7, r7*symr2 + r8*symr5 + r9*symr8, 
              r7*symr3 + r8*symr6 + r9*symr9}; {{r1, r2, r3}, {r4, r5, r6}, \
{r7, r8, r9}} = {{LocTV1, LocTV2, LocTV3}, {LocTV4, LocTV5, LocTV6}, 
              {LocTV7, LocTV8, LocTV9}}; {rsx, rsy, rsz, rex, rey, rez, r1, \
r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, 
             ray1, index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
             rayslot, generationnumber, intersectionnumber, pol1, pol2, \
pol3}) & ) /@ {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., 
            0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 0., 0., \
0., 273060., 273060., 1., 1., 0., 0., 1., 0., 0., 0., 1., 0.}}, 
        {symr1, symr2, symr3, symr4, symr5, symr6, symr7, symr8, symr9} = \
{Cos[Degree*th], Sin[Degree*th], 0, -Sin[Degree*th], Cos[Degree*th], 0, 0, 
           0, 1}; (({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
              opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
              oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = \
#1; {LocTV1, LocTV2, LocTV3} = 
             {rsx*symr1 + rsy*symr4 + rsz*symr7 + x - \
0.30000000000000004*width*Sin[Degree*th], rsx*symr2 + rsy*symr5 + rsz*symr8 + \
y + 
               0.30000000000000004*width*Cos[Degree*th], rsx*symr3 + \
rsy*symr6 + rsz*symr9}; {rsx, rsy, rsz} = {LocTV1, LocTV2, LocTV3}; 
            {LocTV1, LocTV2, LocTV3} = {rex*symr1 + rey*symr4 + rez*symr7 + x \
- 0.30000000000000004*width*Sin[Degree*th], 
              rex*symr2 + rey*symr5 + rez*symr8 + y + \
0.30000000000000004*width*Cos[Degree*th], rex*symr3 + rey*symr6 + rez*symr9}; \

            {rex, rey, rez} = {LocTV1, LocTV2, LocTV3}; {LocTV1, LocTV2, \
LocTV3} = {r1*symr1 + r2*symr4 + r3*symr7, r1*symr2 + r2*symr5 + r3*symr8, 
              r1*symr3 + r2*symr6 + r3*symr9}; {LocTV4, LocTV5, LocTV6} = \
{r4*symr1 + r5*symr4 + r6*symr7, r4*symr2 + r5*symr5 + r6*symr8, 
              r4*symr3 + r5*symr6 + r6*symr9}; {LocTV7, LocTV8, LocTV9} = \
{r7*symr1 + r8*symr4 + r9*symr7, r7*symr2 + r8*symr5 + r9*symr8, 
              r7*symr3 + r8*symr6 + r9*symr9}; {{r1, r2, r3}, {r4, r5, r6}, \
{r7, r8, r9}} = {{LocTV1, LocTV2, LocTV3}, {LocTV4, LocTV5, LocTV6}, 
              {LocTV7, LocTV8, LocTV9}}; {rsx, rsy, rsz, rex, rey, rez, r1, \
r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, 
             ray1, index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
             rayslot, generationnumber, intersectionnumber, pol1, pol2, \
pol3}) & ) /@ {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., 
            0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 0., 0., \
0., 273063., 273063., 1., 1., 0., 0., 1., 0., 0., 0., 1., 0.}}, 
        {symr1, symr2, symr3, symr4, symr5, symr6, symr7, symr8, symr9} = \
{Cos[Degree*th], Sin[Degree*th], 0, -Sin[Degree*th], Cos[Degree*th], 0, 0, 
           0, 1}; (({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
              opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
              oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = \
#1; {LocTV1, LocTV2, LocTV3} = 
             {rsx*symr1 + rsy*symr4 + rsz*symr7 + x - \
0.4*width*Sin[Degree*th], rsx*symr2 + rsy*symr5 + rsz*symr8 + y + \
0.4*width*Cos[Degree*th], 
              rsx*symr3 + rsy*symr6 + rsz*symr9}; {rsx, rsy, rsz} = {LocTV1, \
LocTV2, LocTV3}; {LocTV1, LocTV2, LocTV3} = 
             {rex*symr1 + rey*symr4 + rez*symr7 + x - \
0.4*width*Sin[Degree*th], rex*symr2 + rey*symr5 + rez*symr8 + y + \
0.4*width*Cos[Degree*th], 
              rex*symr3 + rey*symr6 + rez*symr9}; {rex, rey, rez} = {LocTV1, \
LocTV2, LocTV3}; {LocTV1, LocTV2, LocTV3} = 
             {r1*symr1 + r2*symr4 + r3*symr7, r1*symr2 + r2*symr5 + r3*symr8, \
r1*symr3 + r2*symr6 + r3*symr9}; {LocTV4, LocTV5, LocTV6} = 
             {r4*symr1 + r5*symr4 + r6*symr7, r4*symr2 + r5*symr5 + r6*symr8, \
r4*symr3 + r5*symr6 + r6*symr9}; {LocTV7, LocTV8, LocTV9} = 
             {r7*symr1 + r8*symr4 + r9*symr7, r7*symr2 + r8*symr5 + r9*symr8, \
r7*symr3 + r8*symr6 + r9*symr9}; 
            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = {{LocTV1, LocTV2, \
LocTV3}, {LocTV4, LocTV5, LocTV6}, {LocTV7, LocTV8, LocTV9}}; 
            {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, \
r9, wavelength, intensity, intensityscale, ray1, index, opticallength, 
             phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
             intersectionnumber, pol1, pol2, pol3}) & ) /@ {{0., 0., 0., 0., \
0., 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., 0.532, 100., 1., 0., 
            1.00026945145708, 0., 0., 0., 0., 0., 0., 0., 273066., 273066., \
1., 1., 0., 0., 1., 0., 0., 0., 1., 0.}}, 
        {symr1, symr2, symr3, symr4, symr5, symr6, symr7, symr8, symr9} = \
{Cos[Degree*th], Sin[Degree*th], 0, -Sin[Degree*th], Cos[Degree*th], 0, 0, 
           0, 1}; (({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
              opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
              oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = \
#1; {LocTV1, LocTV2, LocTV3} = 
             {rsx*symr1 + rsy*symr4 + rsz*symr7 + x - \
0.5*width*Sin[Degree*th], rsx*symr2 + rsy*symr5 + rsz*symr8 + y + \
0.5*width*Cos[Degree*th], 
              rsx*symr3 + rsy*symr6 + rsz*symr9}; {rsx, rsy, rsz} = {LocTV1, \
LocTV2, LocTV3}; {LocTV1, LocTV2, LocTV3} = 
             {rex*symr1 + rey*symr4 + rez*symr7 + x - \
0.5*width*Sin[Degree*th], rex*symr2 + rey*symr5 + rez*symr8 + y + \
0.5*width*Cos[Degree*th], 
              rex*symr3 + rey*symr6 + rez*symr9}; {rex, rey, rez} = {LocTV1, \
LocTV2, LocTV3}; {LocTV1, LocTV2, LocTV3} = 
             {r1*symr1 + r2*symr4 + r3*symr7, r1*symr2 + r2*symr5 + r3*symr8, \
r1*symr3 + r2*symr6 + r3*symr9}; {LocTV4, LocTV5, LocTV6} = 
             {r4*symr1 + r5*symr4 + r6*symr7, r4*symr2 + r5*symr5 + r6*symr8, \
r4*symr3 + r5*symr6 + r6*symr9}; {LocTV7, LocTV8, LocTV9} = 
             {r7*symr1 + r8*symr4 + r9*symr7, r7*symr2 + r8*symr5 + r9*symr8, \
r7*symr3 + r8*symr6 + r9*symr9}; 
            {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = {{LocTV1, LocTV2, \
LocTV3}, {LocTV4, LocTV5, LocTV6}, {LocTV7, LocTV8, LocTV9}}; 
            {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, \
r9, wavelength, intensity, intensityscale, ray1, index, opticallength, 
             phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
             intersectionnumber, pol1, pol2, pol3}) & ) /@ {{0., 0., 0., 0., \
0., 0., 1., 0., 0., 0., 1., 0., 0., 0., 1., 0.532, 100., 1., 0., 
            1.00026945145708, 0., 0., 0., 0., 0., 0., 0., 273069., 273069., \
1., 1., 0., 0., 1., 0., 0., 0., 1., 0.}}]; 
      propagatedrays = (({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, \
r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
            opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
            oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; \
componentnumber = 1.; frontid = 1.; 
          {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, intensity, intensityscale, ray1, index, opticallength, 
           phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
           intersectionnumber, pol1, pol2, pol3}) & ) /@ propagatedrays; \
thresholdintensity = 1.; generationlimit = 200.; 
      reportedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
         opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
         generationnumber, intersectionnumber, pol1, pol2, pol3}}; \
generationnumber = 0.; (inrays = propagatedrays; 
       outrays = {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 
          1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}; deflectedrayspresent = \
True; reportedrayspresent = False; propagate = True; 
       While[deflectedrayspresent && propagate, generationnumber += 1.; \
(deflecteddummyrayspresent = False; deflectedrayspresent = False; 
          reportedrayspresent = False; reporteddummyrayspresent = True; \
localdummyoutrayspresent = False; localoutrayspresent = False; 
          {deflectedlocalrays, localoutrays, reportedlocalrays} = \
(Flatten[#1, 1] & ) /@ 
            Transpose[(({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, \
r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                  opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
                  oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} \
= #1; If[intensity > thresholdintensity && generationnumber < 
                   generationlimit, (resonatenumber = 0; resonateraylength = \
9.87654321*^8; resonateintersections = {{-1., 0., 0.}}; 
                   MapIndexed[If[#1[[1,1]] > -1. && #1[[1,1]] < \
resonateraylength, resonateraylength = #1[[1,1]]; resonateintersections = #1; \

                       resonatenumber = First[#2], resonatenumber] & , \
intersectionslist = {{{-1., 0., 0.}}}; holeQlist = {0}; 
                     ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                        opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                        rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; index1 = index; xunit = r1; yunit = r2; zunit = r3; 
                      xunit = Chop[xunit]; yunit = Chop[yunit]; zunit = \
Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^2^(-1); 
                      xunit = xunit/magnitude; yunit = yunit/magnitude; zunit \
= zunit/magnitude; rx = rex - 1.*Re[glx]; ry = rey - 1.*Re[gly]; 
                      rz = rez; rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; \
terminatedeflection = False; intersections = {{-1., 0., 0.}}; 
                      intersections = If[Chop[xunit] != 0, \
{(If[N[Chop[#1[[1]]]] >= 0. && (#1[[2]] <= 5. && #1[[2]] >= -5. && #1[[3]] >= \
-5. && 
                              #1[[3]] <= 5.), {#1[[1]], #1[[2]], #1[[3]]}, \
{-1., 0., 0.}] & )[{-(rx/xunit), ry - (rx*yunit)/xunit, 
                           rz - (rx*zunit)/xunit}]}, {{-1., 0., 0.}}]; \
AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                      If[ !(Chop[surfaceid - 272713.] == 0. || N[Chop[ray1]] \
< 0.0001) || generationnumber == 1., minresonateraylength = 0., 
                       minresonateraylength = 0.0001]; Block[{LocRayL, \
LocSCx, LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                         Union[Select[intersections, ({LocRayL, LocSCx, \
LocSCy} = #1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || 
                              N[Chop[LocRayL]] >= minresonateraylength) & ]]; \
intersections = dummymatrix]; unfilteredintersections = intersections; 
                      If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]; 
                      AppendTo[intersectionslist, intersections]; If[holeQ, \
AppendTo[holeQlist, 1], AppendTo[holeQlist, 0]]; 
                      {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                        opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                        rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; index1 = index; xunit = r1; yunit = r2; zunit = r3; 
                      xunit = Chop[xunit]; yunit = Chop[yunit]; zunit = \
Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^2^(-1); 
                      xunit = xunit/magnitude; yunit = yunit/magnitude; zunit \
= zunit/magnitude; rx = -10. + rex - 1.*Re[glx]; ry = rey - 1.*Re[gly]; 
                      rz = rez; rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; \
terminatedeflection = False; intersections = {{-1., 0., 0.}}; 
                      intersections = If[Chop[xunit] != 0, \
{(If[N[Chop[#1[[1]]]] >= 0. && (#1[[2]] <= 5. && #1[[2]] >= -5. && #1[[3]] >= \
-5. && 
                              #1[[3]] <= 5.), {#1[[1]], #1[[2]], #1[[3]]}, \
{-1., 0., 0.}] & )[{-(rx/xunit), ry - (rx*yunit)/xunit, 
                           rz - (rx*zunit)/xunit}]}, {{-1., 0., 0.}}]; \
AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                      If[ !(Chop[surfaceid - 272778.] == 0. || N[Chop[ray1]] \
< 0.0001) || generationnumber == 1., minresonateraylength = 0., 
                       minresonateraylength = 0.0001]; Block[{LocRayL, \
LocSCx, LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                         Union[Select[intersections, ({LocRayL, LocSCx, \
LocSCy} = #1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || 
                              N[Chop[LocRayL]] >= minresonateraylength) & ]]; \
intersections = dummymatrix]; unfilteredintersections = intersections; 
                      If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]; 
                      AppendTo[intersectionslist, intersections]; If[holeQ, \
AppendTo[holeQlist, 1], AppendTo[holeQlist, 0]]; 
                      {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                        opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                        rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; index1 = index; xunit = r3; yunit = r2; 
                      zunit = -1.*r1; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                        2^(-1); xunit = xunit/magnitude; yunit = \
yunit/magnitude; zunit = zunit/magnitude; rx = -5. + rez; ry = rey - \
1.*Re[gly]; 
                      rz = -1.*(-5. + rex - 1.*Re[glx]); rx = Chop[rx]; ry = \
Chop[ry]; rz = Chop[rz]; terminatedeflection = False; intersections = 
                       {{-1., 0., 0.}}; intersections = If[Chop[xunit] != 0, \
{(If[N[Chop[#1[[1]]]] >= 0. && (#1[[2]] <= 5. && #1[[2]] >= -5. && 
                              #1[[3]] >= -5. && #1[[3]] <= 5.), {#1[[1]], \
#1[[2]], #1[[3]]}, {-1., 0., 0.}] & )[{-(rx/xunit), ry - (rx*yunit)/xunit, 
                           rz - (rx*zunit)/xunit}]}, {{-1., 0., 0.}}]; \
AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                      If[ !(Chop[surfaceid - 272521.] == 0. || N[Chop[ray1]] \
< 0.0001) || generationnumber == 1., minresonateraylength = 0., 
                       minresonateraylength = 0.0001]; Block[{LocRayL, \
LocSCx, LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                         Union[Select[intersections, ({LocRayL, LocSCx, \
LocSCy} = #1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || 
                              N[Chop[LocRayL]] >= minresonateraylength) & ]]; \
intersections = dummymatrix]; unfilteredintersections = intersections; 
                      If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]; 
                      AppendTo[intersectionslist, intersections]; If[holeQ, \
AppendTo[holeQlist, 1], AppendTo[holeQlist, 0]]; 
                      {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                        opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                        rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; index1 = index; xunit = -1.*r3; yunit = -1.*r2; 
                      zunit = -1.*r1; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                        2^(-1); xunit = xunit/magnitude; yunit = \
yunit/magnitude; zunit = zunit/magnitude; rx = -1.*(5. + rez); 
                      ry = -1.*(rey - 1.*Re[gly]); rz = -1.*(-5. + rex - \
1.*Re[glx]); rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; 
                      terminatedeflection = False; intersections = {{-1., 0., \
0.}}; intersections = If[Chop[xunit] != 0, 
                        {(If[N[Chop[#1[[1]]]] >= 0. && (#1[[2]] <= 5. && \
#1[[2]] >= -5. && #1[[3]] >= -5. && #1[[3]] <= 5.), {#1[[1]], #1[[2]], 
                             #1[[3]]}, {-1., 0., 0.}] & )[{-(rx/xunit), ry - \
(rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, {{-1., 0., 0.}}]; 
                      AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; \
If[ !(Chop[surfaceid - 272551.] == 0. || N[Chop[ray1]] < 0.0001) || 
                        generationnumber == 1., minresonateraylength = 0., \
minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, LocSCy}, 
                       LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = \
Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = #1; 
                             {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
N[Chop[LocRayL]] >= minresonateraylength) & ]]; intersections = 
                         dummymatrix]; unfilteredintersections = \
intersections; If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; 
                        intersections = dummymatrix; 1., 1.]; \
AppendTo[intersectionslist, intersections]; If[holeQ, AppendTo[holeQlist, 1], \

                       AppendTo[holeQlist, 0]]; {rsx, rsy, rsz, rex, rey, \
rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                        intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                        sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; index1 = index; 
                      xunit = -1.*r2; yunit = r1; zunit = r3; xunit = \
Chop[xunit]; yunit = Chop[yunit]; zunit = Chop[zunit]; magnitude = 
                       (xunit^2 + yunit^2 + zunit^2)^2^(-1); xunit = \
xunit/magnitude; yunit = yunit/magnitude; zunit = zunit/magnitude; 
                      rx = -1.*(-5. + rey - 1.*Re[gly]); ry = -5. + rex - \
1.*Re[glx]; rz = rez; rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; 
                      terminatedeflection = False; intersections = {{-1., 0., \
0.}}; intersections = If[Chop[xunit] != 0, 
                        {(If[N[Chop[#1[[1]]]] >= 0. && (#1[[2]] <= 5. && \
#1[[2]] >= -5. && #1[[3]] >= -5. && #1[[3]] <= 5.), {#1[[1]], #1[[2]], 
                             #1[[3]]}, {-1., 0., 0.}] & )[{-(rx/xunit), ry - \
(rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, {{-1., 0., 0.}}]; 
                      AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; \
If[ !(Chop[surfaceid - 272617.] == 0. || N[Chop[ray1]] < 0.0001) || 
                        generationnumber == 1., minresonateraylength = 0., \
minresonateraylength = 0.0001]; Block[{LocRayL, LocSCx, LocSCy}, 
                       LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = \
Union[Select[intersections, ({LocRayL, LocSCx, LocSCy} = #1; 
                             {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || \
N[Chop[LocRayL]] >= minresonateraylength) & ]]; intersections = 
                         dummymatrix]; unfilteredintersections = \
intersections; If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; 
                        intersections = dummymatrix; 1., 1.]; \
AppendTo[intersectionslist, intersections]; If[holeQ, AppendTo[holeQlist, 1], \

                       AppendTo[holeQlist, 0]]; {rsx, rsy, rsz, rex, rey, \
rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                        intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                        sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; index1 = index; xunit = r2; 
                      yunit = -1.*r1; zunit = r3; xunit = Chop[xunit]; yunit \
= Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + 
                         zunit^2)^2^(-1); xunit = xunit/magnitude; yunit = \
yunit/magnitude; zunit = zunit/magnitude; rx = 5. + rey - 1.*Re[gly]; 
                      ry = -1.*(-5. + rex - 1.*Re[glx]); rz = rez; rx = \
Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = False; 
                      intersections = {{-1., 0., 0.}}; intersections = \
If[Chop[xunit] != 0, {(If[N[Chop[#1[[1]]]] >= 0. && (#1[[2]] <= 5. && 
                              #1[[2]] >= -5. && #1[[3]] >= -5. && #1[[3]] <= \
5.), {#1[[1]], #1[[2]], #1[[3]]}, {-1., 0., 0.}] & )[{-(rx/xunit), 
                           ry - (rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, \
{{-1., 0., 0.}}]; AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                      If[ !(Chop[surfaceid - 272683.] == 0. || N[Chop[ray1]] \
< 0.0001) || generationnumber == 1., minresonateraylength = 0., 
                       minresonateraylength = 0.0001]; Block[{LocRayL, \
LocSCx, LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                         Union[Select[intersections, ({LocRayL, LocSCx, \
LocSCy} = #1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || 
                              N[Chop[LocRayL]] >= minresonateraylength) & ]]; \
intersections = dummymatrix]; unfilteredintersections = intersections; 
                      If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]; 
                      AppendTo[intersectionslist, intersections]; If[holeQ, \
AppendTo[holeQlist, 1], AppendTo[holeQlist, 0]]); holeQlist = 
                      Drop[holeQlist, 1]; Drop[intersectionslist, 1]]); \
Which[resonatenumber == 1, {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, \

                      r6, r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, oldgenerationnumber, intersectionnumber, pol1, pol2, 
                      pol3} = #1; index1 = index; xunit = r1; yunit = r2; \
zunit = r3; xunit = Chop[xunit]; yunit = Chop[yunit]; zunit = Chop[zunit]; 
                    magnitude = (xunit^2 + yunit^2 + zunit^2)^2^(-1); xunit = \
xunit/magnitude; yunit = yunit/magnitude; zunit = zunit/magnitude; 
                    rx = rex - 1.*Re[glx]; ry = rey - 1.*Re[gly]; rz = rez; \
rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = False; 
                    intersections = {{-1., 0., 0.}}; intersections = \
resonateintersections; holeQ = holeQlist[[resonatenumber]] == 1; 
                    {newcomponentnumber, newsurfacenumber, newsurfaceid} = \
{1., 1., 272713.}; {componentnumber, surfacenumber, surfaceid} = 
                     {1., 1., 272713.}; {ray1, ray2, ray3} = \
intersections[[1]]; rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \

                    ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = \
rxhlp + Re[glx]; rey = ryhlp + Re[gly]; rez = rzhlp; rex = Chop[rex]; 
                    rey = Chop[rey]; rez = Chop[rez]; intersectionnumber = \
intersectionnumber + 1.; opticallength = opticallength + ray1*index1; 
                    completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, \
r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                      index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                      rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; reportedrayspresent = True; intersectionspresent = True; 
                    deflectedrayspresent = True; localdummyoutrayspresent = \
True; (surfnorm = 1.*Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}]; 
                     dummymatrix = (#1 & ) /@ surfnorm; surfnorm = \
(#1/Sqrt[#1 . #1] & ) /@ dummymatrix; surfacerotationmatrix = {{1., 0, 0}, 
                       {0, 1., 0}, {0, 0, 1.}}; surfacetranslationvector = \
{Re[glx], Re[gly], 0.}; activeregion = 1.; completedray = 
                      {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                       opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                       rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; componentnumber = newcomponentnumber; surfacenumber = 
                      newsurfacenumber; surfaceid = newsurfaceid; originalray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                       wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                       ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                     ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, \
r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                     If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                     If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis \
= XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                        ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                     YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, \
r2, r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                      PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                      normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                     amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                         Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                     surftrans = surfacetranslationvector; surfrot = \
surfacerotationmatrix; Which[surfaceid == 272713, localtranslation = {0, 0, \
0}; 
                       localrotation = {{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}, \
surfaceid == 272778, localtranslation = {10., 0., 0.}; localrotation = 
                        {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, surfaceid \
== 272521, localtranslation = {5., 0., 5.}; localrotation = 
                        {{0., 0., 1.}, {0., 1., 0.}, {-1., 0., 0.}}, \
surfaceid == 272551, localtranslation = {5., 0., -5.}; localrotation = 
                        {{0., 0., -1.}, {0., -1., 0.}, {-1., 0., 0.}}, \
surfaceid == 272617, localtranslation = {5., 5., 0.}; localrotation = 
                        {{0., -1., 0.}, {1., 0., 0.}, {0., 0., 1.}}, True, \
localtranslation = {5., -5., 0.}; localrotation = {{0., 1., 0.}, 
                         {-1., 0., 0.}, {0., 0., 1.}}]; localpos = surfrot . \
({rex, rey, rez} - surftrans); localtilt = surfrot . {r1, r2, r3}; 
                     localpos = localpos . localrotation + localtranslation; \
localtilt = localtilt . localrotation; {LocRSx, LocRSy, LocRSz} = 
                      localpos; {RTx, LocRTy, LocRTz} = localtilt; \
allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, \
r8, 
                        r9, wavelength, intensity, intensityscale, ray1, \
index, opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                        ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}}; 
                     originalrotation = Partition[Take[originalray, {7, 15}], \
3]; previoustilt = originalrotation[[1]]; transmatrix = 
                      MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, \
r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                           index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, 
                           sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; rotationaxis = \
Cross[previoustilt, 
                           {r1, r2, r3}]; axismagnitude = Sqrt[rotationaxis . \
rotationaxis]; If[Chop[axismagnitude] != 0., rotationaxis = 
                            rotationaxis/axismagnitude; axismatrix = \
(#1*rotationaxis & ) /@ rotationaxis; crossmatrix = {{0., -rotationaxis[[3]], \

                              rotationaxis[[2]]}, {rotationaxis[[3]], 0., \
-rotationaxis[[1]]}, {-rotationaxis[[2]], rotationaxis[[1]], 0.}}; 
                           cosangle = previoustilt . {r1, r2, r3}; If[1. - \
cosangle < 2.220446049250313*^-16, cosangle = 1.]; sinangle = 
                            1 - cosangle^2; If[sinangle < \
2.220446049250313*^-16, sinangle = 0., sinangle = Sqrt[sinangle]]; axismatrix \
+ 
                            ({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}} - \
axismatrix)*cosangle + crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, 
                            {r7, r8, r9}} = If[Sign[previoustilt . {r1, r2, \
r3}] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, 
                             {0., -1., 0.}, {0., 0., 1.}}]]) & , \
allcreatedrays]; allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, \
r1, r2, 
                           r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, 
                           componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                           intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                             originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                           1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                             {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; \
{{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                         If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                             amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                               0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                             dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                             {pol1, pol2, pol3} = dummyvector]; 1., 1.]; \
{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                          wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                          ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                       allcreatedrays]; (originalray = First[allcreatedrays]; \
completedray = originalray); deflectedrays = allcreatedrays; 
                     newdeflectedrays = {originalray}; Scan[({rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                          intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, 
                          sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        (ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, \
r2, r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                         If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                         If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], \
XAxis = XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                            ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                         YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = \
ZAxis*{r1, r2, r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                          PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                          normalizedpolarization/Sqrt[normalizedpolarization \
. normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                         amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                             Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                         If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = baseIndex - factorX*(LocRSx - xpos)^2 - 
                             factorY*(LocRSy - ypos)^2; index1 = index; \
If[Abs[index2 - index1] < 0.01, alternateindex = Sqrt[1.0005281111748805 - 
                                2.364805676582992*^-10*wavelength^2 + \
2.9781670902982902*^-6/wavelength^2 + 2.6004099469477187*^-8/wavelength^4 + 
                                3.7787839314048715*^-10/wavelength^6 + \
2.830549017940716*^-12/wavelength^8]; If[Abs[alternateindex - index1] > 
                               Abs[index2 - index1], index1 = index2; index2 \
= alternateindex, index1 = alternateindex], index1 = 
                             Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                               2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]], \

                          index2 = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                              2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]; 
                           index1 = index; If[Abs[index2 - index1] < 0.01, \
alternateindex = baseIndex - factorX*(LocRSx - xpos)^2 - factorY*
                                (LocRSy - ypos)^2; If[Abs[alternateindex - \
index1] > Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                              index1 = alternateindex], index1 = baseIndex - \
factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - ypos)^2]]; 
                         n12 = index1/index2; index = index2; If[1 - \
n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + ZAxis*
                              (-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                            phaseshift = phaseshift + 0.5, 1.]; index2 = \
index1; index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                               {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                            dummyvector; 1.]; allcreatedrays = {{rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                            intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, 
                            sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}}; 
                         originalrotation = Partition[Take[originalray, {7, \
15}], 3]; previoustilt = originalrotation[[1]]; transmatrix = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; rotationaxis = 
                              Cross[previoustilt, {r1, r2, r3}]; \
axismagnitude = Sqrt[rotationaxis . rotationaxis]; If[Chop[axismagnitude] != \
0., 
                              rotationaxis = rotationaxis/axismagnitude; \
axismatrix = (#1*rotationaxis & ) /@ rotationaxis; crossmatrix = 
                                {{0., -rotationaxis[[3]], rotationaxis[[2]]}, \
{rotationaxis[[3]], 0., -rotationaxis[[1]]}, {-rotationaxis[[2]], 
                                  rotationaxis[[1]], 0.}}; cosangle = \
previoustilt . {r1, r2, r3}; If[1. - cosangle < 2.220446049250313*^-16, 
                                cosangle = 1.]; sinangle = 1 - cosangle^2; \
If[sinangle < 2.220446049250313*^-16, sinangle = 0., sinangle = 
                                 Sqrt[sinangle]]; axismatrix + ({{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}} - axismatrix)*cosangle + crossmatrix*
                                 sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, \
r8, r9}} = If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., 0., 0.}, 
                                 {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, \
{0., -1., 0.}, {0., 0., 1.}}]]) & , allcreatedrays]; allcreatedrays = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; {{r1, r2, r3}, {r4, r5, r6}, 
                               {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ \
originalrotation][transmatrix[[First[#2]]]]; tiltmagnitude = 
                              {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; 
                               {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; 
                               {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
dummymatrix; 1., 1.]; If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, 
                              amplitude = allcreatedamplitudes[[First[#2]]]; \
hor = {r4, r5, r6} . amplitude; ver = {r7, r8, r9} . amplitude; 
                               If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, \
pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = {pol1, pol2, pol3}/
                                   Sqrt[{pol1, pol2, pol3} . {pol1, pol2, \
pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = ReplacePart[
                                   {pol1, pol2, pol3}, (If[ver == 0., 0., \
Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; {pol1, pol2, pol3} = 
                                  dummyvector]; 1., 1.]; {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                              intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                              frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                           allcreatedrays]); newdeflectedrays = \
Join[newdeflectedrays, allcreatedrays]) & , deflectedrays]; allcreatedrays = 
                      Drop[newdeflectedrays, 1]; deflectedrays = \
allcreatedrays; newdeflectedrays = {originalray}; 
                     Scan[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, \
r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; (ZAxis = First[surfnorm]*Sign[First[surfnorm] . 
                             {r1, r2, r3}]; raytiltz = ZAxis . {r1, r2, r3}; \
raytiltx = 1 - raytiltz^2; If[raytiltx < 2.220446049250313*^-16, 
                          raytiltx = 0., raytiltx = Sqrt[raytiltx]]; XAxis = \
{r1, r2, r3} - ZAxis*raytiltz; If[Abs[raytiltx] < 1.*^-7, 
                          XAxis = surfnorm[[2]], XAxis = XAxis/raytiltx]; \
YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + ZAxis[[2]]*XAxis[[3]], 
                           ZAxis[[3]]*XAxis[[1]] - ZAxis[[1]]*XAxis[[3]], \
-(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; YAxis = 
                          YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = PAxis/
                           Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                          normalizedpolarization/Sqrt[normalizedpolarization \
. normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                         amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                             Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                         surftrans = surfacetranslationvector; surfrot = \
surfacerotationmatrix; Which[surfaceid == 272713, localtranslation = 
                            {0, 0, 0}; localrotation = {{1, 0, 0}, {0, 1, 0}, \
{0, 0, 1}}, surfaceid == 272778, localtranslation = {10., 0., 0.}; 
                           localrotation = {{1., 0., 0.}, {0., 1., 0.}, {0., \
0., 1.}}, surfaceid == 272521, localtranslation = {5., 0., 5.}; 
                           localrotation = {{0., 0., 1.}, {0., 1., 0.}, {-1., \
0., 0.}}, surfaceid == 272551, localtranslation = {5., 0., -5.}; 
                           localrotation = {{0., 0., -1.}, {0., -1., 0.}, \
{-1., 0., 0.}}, surfaceid == 272617, localtranslation = {5., 5., 0.}; 
                           localrotation = {{0., -1., 0.}, {1., 0., 0.}, {0., \
0., 1.}}, True, localtranslation = {5., -5., 0.}; localrotation = 
                            {{0., 1., 0.}, {-1., 0., 0.}, {0., 0., 1.}}]; \
localopticallength = 0.; localraylength = 0.; integratedrefractiveindex = 
                          0.; localpos = surfrot . ({rex, rey, rez} - \
surftrans); localtilt = surfrot . {r1, r2, r3}; If[activeregion*localtilt[[
                             1]] > 0, {LocRSx, LocRSy, LocRSz} = localpos; \
localpos = localpos . localrotation + localtranslation; localtilt = 
                            localtilt . localrotation; {LocRSx, LocRSy, \
LocRSz} = localpos; localindex = index; localindex = baseIndex - 
                             factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - \
ypos)^2; listofpositions = {{LocRSx, LocRSy, LocRSz}}; listoftilts = 
                            {{RTx, LocRTy, LocRTz}}; indexpoints = \
{localindex}; opticallengths = {opticallength}; {RTx, LocRTy, LocRTz} = \
localtilt; 
                           localtilt = localindex*localtilt; Ninitial = \
localindex^2; Sinitial = 0.1^2*{-2*baseIndex*factorX*LocRSx + 2*factorX^2*
                                 LocRSx^3 + 2*factorX*factorY*LocRSx*LocRSy^2 \
+ 2*baseIndex*factorX*xpos - 6*factorX^2*LocRSx^2*xpos - 2*factorX*
                                 factorY*LocRSy^2*xpos + \
6*factorX^2*LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 
                                4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*LocRSx*ypos^2 - 2*factorX*factorY*xpos*ypos^2, 
                               -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*
                                 LocRSy*xpos + \
2*factorX*factorY*LocRSy*xpos^2 + 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 
                                6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*
                                 ypos^2 - 2*factorY^2*ypos^3, 0} . localtilt; \
rSxOffset = 0.; While[(Plus[10.]) - (LocRSx - rSxOffset) >= 
                              -0.01*0.1 && Plus[LocRSx - rSxOffset] >= \
-0.01*0.1 && (0.99999*LocRSy <= 5. && 0.99999*LocRSy >= -5. && 
                              0.99999*LocRSz >= -5. && 0.99999*LocRSz <= 5.), \
localraylength = (localraylength + Sqrt[#1 . #1] & )[localpos - 
                                {LocRSx, LocRSy, LocRSz}]; localpos = \
{LocRSx, LocRSy, LocRSz}; AppendTo[listofpositions, {LocRSx, LocRSy, \
LocRSz}]; 
                             AppendTo[listoftilts, {RTx, LocRTy, LocRTz}]; \
localindex = baseIndex - factorX*(LocRSx - xpos)^2 - factorY*
                                (LocRSy - ypos)^2; AppendTo[indexpoints, \
localindex]; opticallengths = Append[opticallengths, Last[opticallengths] + 
                                localindex*0.1]; integratedrefractiveindex = \
integratedrefractiveindex + localindex^2; localtilt = localindex*
                               {RTx, LocRTy, LocRTz}; Aelement = \
0.1*{-2*baseIndex*factorX*LocRSx + 2*factorX^2*LocRSx^3 + \
2*factorX*factorY*LocRSx*
                                  LocRSy^2 + 2*baseIndex*factorX*xpos - \
6*factorX^2*LocRSx^2*xpos - 2*factorX*factorY*LocRSy^2*xpos + 6*factorX^2*
                                  LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 4*factorX*factorY*LocRSy*xpos*ypos + 
                                 2*factorX*factorY*LocRSx*ypos^2 - \
2*factorX*factorY*xpos*ypos^2, -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*
                                  LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*LocRSy*xpos + 2*factorX*factorY*LocRSy*xpos^2 + 
                                 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*
                                  xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*ypos^2 - 2*factorY^2*ypos^3, 0}; {LocRSx, LocRSy, 
                               LocRSz} = localpos + (0.1*localtilt)/2. + \
(0.1*Aelement)/8.; Belement = 0.1*{-2*baseIndex*factorX*LocRSx + 
                                 2*factorX^2*LocRSx^3 + \
2*factorX*factorY*LocRSx*LocRSy^2 + 2*baseIndex*factorX*xpos - \
6*factorX^2*LocRSx^2*xpos - 
                                 2*factorX*factorY*LocRSy^2*xpos + \
6*factorX^2*LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*
                                  ypos + 4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*LocRSx*ypos^2 - 2*factorX*factorY*xpos*ypos^2, 
                                -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*
                                  LocRSy*xpos + \
2*factorX*factorY*LocRSy*xpos^2 + 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 
                                 6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*
                                  ypos^2 - 2*factorY^2*ypos^3, 0}; {LocRSx, \
LocRSy, LocRSz} = localpos + 0.1*localtilt + (0.1*Belement)/2; 
                             Celement = 0.1*{-2*baseIndex*factorX*LocRSx + \
2*factorX^2*LocRSx^3 + 2*factorX*factorY*LocRSx*LocRSy^2 + 2*baseIndex*
                                  factorX*xpos - 6*factorX^2*LocRSx^2*xpos - \
2*factorX*factorY*LocRSy^2*xpos + 6*factorX^2*LocRSx*xpos^2 - 
                                 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*
                                  LocRSx*ypos^2 - \
2*factorX*factorY*xpos*ypos^2, -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 
                                 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*LocRSy*xpos + 2*factorX*factorY*LocRSy*xpos^2 + \
2*baseIndex*factorY*
                                  ypos - 2*factorX*factorY*LocRSx^2*ypos - \
6*factorY^2*LocRSy^2*ypos + 4*factorX*factorY*LocRSx*xpos*ypos - 
                                 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*ypos^2 - 2*factorY^2*ypos^3, 0}; newpos = localpos + 
                               0.1*(localtilt + (Aelement + 2*Belement)/6); \
newtilt = localtilt + (Aelement + 4.*Aelement + Celement)/6.; 
                             newtilt = newtilt/Sqrt[newtilt . newtilt]; \
{LocRSx, LocRSy, LocRSz} = newpos; {RTx, LocRTy, LocRTz} = newtilt; 1.]; 
                           integratedrefractiveindex = \
integratedrefractiveindex - localindex^2; {LocRSx, LocRSy, LocRSz} = \
localpos; 
                           Sfinal = 0.1*Aelement . localtilt; Nfinal = \
localindex^2; localtilt = localtilt/Sqrt[localtilt . localtilt]; 
                           {RTx, LocRTy, LocRTz} = localtilt; \
localopticallength = 0.1*integratedrefractiveindex - (Sfinal - Sinitial)/6 + 
                             (0.1*(Nfinal - Ninitial))/2; opticallength = \
opticallength + localopticallength; ray1 = localraylength; localpos = 
                            localrotation . (localpos - localtranslation); \
{rex, rey, rez} = localpos . surfrot + surftrans; localtilt = 
                            localrotation . localtilt; {r1, r2, r3} = \
localtilt . surfrot; {rsx, rsy, rsz} = {rex, rey, rez}; index = baseIndex - 
                             factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - \
ypos)^2; allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, 
                              r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                              surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                              intersectionnumber, pol1, pol2, pol3}}; \
listofpositions = (localrotation . (#1 - localtranslation) & ) /@ 
                             listofpositions; listofpositions = (#1 . surfrot \
+ surftrans & ) /@ listofpositions; listoftilts = 
                            (#1/Sqrt[#1 . #1] & ) /@ listoftilts; listoftilts \
= (#1 . surfrot & ) /@ listoftilts; If[reportedrayspresent && 
                             Length[indexpoints] > 1, reportedrays = \
Join[reportedrays, Table[{rsx, rsy, rsz} = listofpositions[[ninteger]]; 
                                 {rex, rey, rez} = listofpositions[[ninteger \
+ 1]]; {r1, r2, r3} = listoftilts[[ninteger]]; ray1 = 0.1; index = 
                                  indexpoints[[ninteger]]; opticallength = \
opticallengths[[ninteger]]; {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, 
                                  r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                                  surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                                  intersectionnumber, pol1, pol2, pol3}, \
{ninteger, 1, Length[indexpoints] - 1}]]; 1., 1.]; allcreatedrays, 
                          allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, \
r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, 
                             ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                             sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}]; originalrotation = Partition[
                           Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                           ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                               opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, 
                               sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; rotationaxis = \
Cross[previoustilt, 
                               {r1, r2, r3}]; axismagnitude = \
Sqrt[rotationaxis . rotationaxis]; If[Chop[axismagnitude] != 0., rotationaxis \
= 
                                rotationaxis/axismagnitude; axismatrix = \
(#1*rotationaxis & ) /@ rotationaxis; crossmatrix = {{0., -rotationaxis[[
                                    3]], rotationaxis[[2]]}, \
{rotationaxis[[3]], 0., -rotationaxis[[1]]}, {-rotationaxis[[2]], \
rotationaxis[[1]], 
                                  0.}}; cosangle = previoustilt . {r1, r2, \
r3}; If[1. - cosangle < 2.220446049250313*^-16, cosangle = 1.]; 
                               sinangle = 1 - cosangle^2; If[sinangle < \
2.220446049250313*^-16, sinangle = 0., sinangle = Sqrt[sinangle]]; 
                               axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, \
{0., 0., 1.}} - axismatrix)*cosangle + crossmatrix*sinangle, 
                              {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., 0., 0.}, {0., 1., 0.}, 
                                 {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., \
0.}, {0., 0., 1.}}]]) & , allcreatedrays]; allcreatedrays = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; {{r1, r2, r3}, {r4, r5, r6}, 
                               {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ \
originalrotation][transmatrix[[First[#2]]]]; tiltmagnitude = 
                              {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; 
                               {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; 
                               {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
dummymatrix; 1., 1.]; If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, 
                              amplitude = allcreatedamplitudes[[First[#2]]]; \
hor = {r4, r5, r6} . amplitude; ver = {r7, r8, r9} . amplitude; 
                               If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, \
pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = {pol1, pol2, pol3}/
                                   Sqrt[{pol1, pol2, pol3} . {pol1, pol2, \
pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = ReplacePart[
                                   {pol1, pol2, pol3}, (If[ver == 0., 0., \
Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; {pol1, pol2, pol3} = 
                                  dummyvector]; 1., 1.]; {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                              intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                              frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                           allcreatedrays]); newdeflectedrays = \
Join[newdeflectedrays, allcreatedrays]) & , deflectedrays]; allcreatedrays = 
                      Drop[newdeflectedrays, 1]; deflectedrays = \
allcreatedrays; deflectedrays = MapIndexed[ReplacePart[#1, First[#2], 34] & , \

                       allcreatedrays]; allcreatedrays = deflectedrays); \
{allcreatedrays, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                       1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., \
-1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}, 
                     {completedray}}, resonatenumber == 2, {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; index1 = index; xunit = r1; 
                    yunit = r2; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                      2^(-1); xunit = xunit/magnitude; yunit = \
yunit/magnitude; zunit = zunit/magnitude; rx = -10. + rex - 1.*Re[glx]; 
                    ry = rey - 1.*Re[gly]; rz = rez; rx = Chop[rx]; ry = \
Chop[ry]; rz = Chop[rz]; terminatedeflection = False; intersections = 
                     {{-1., 0., 0.}}; intersections = resonateintersections; \
holeQ = holeQlist[[resonatenumber]] == 1; {newcomponentnumber, 
                      newsurfacenumber, newsurfaceid} = {1., 2., 272778.}; \
{componentnumber, surfacenumber, surfaceid} = {1., 2., 272778.}; 
                    {ray1, ray2, ray3} = intersections[[1]]; rsx = rex; rsy = \
rey; rsz = rez; rxhlp = rx + ray1*xunit; ryhlp = ry + ray1*yunit; 
                    rzhlp = rz + ray1*zunit; rex = 10. + rxhlp + Re[glx]; rey \
= ryhlp + Re[gly]; rez = rzhlp; rex = Chop[rex]; rey = Chop[rey]; 
                    rez = Chop[rez]; intersectionnumber = intersectionnumber \
+ 1.; opticallength = opticallength + ray1*index1; completedray = 
                     {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                      opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                      rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; reportedrayspresent = True; intersectionspresent = True; 
                    deflectedrayspresent = True; localdummyoutrayspresent = \
True; (surfnorm = 1.*Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}]; 
                     dummymatrix = (#1 & ) /@ surfnorm; surfnorm = \
(#1/Sqrt[#1 . #1] & ) /@ dummymatrix; surfacerotationmatrix = {{1., 0, 0}, 
                       {0, 1., 0}, {0, 0, 1.}}; surfacetranslationvector = \
{10. + Re[glx], Re[gly], 0.}; activeregion = -1.; completedray = 
                      {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                       opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                       rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; componentnumber = newcomponentnumber; surfacenumber = 
                      newsurfacenumber; surfaceid = newsurfaceid; originalray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                       wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                       ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                     ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, r2, \
r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                     If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                     If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], XAxis \
= XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                        ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                     YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, \
r2, r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                      PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                      normalizedpolarization/Sqrt[normalizedpolarization . \
normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                     amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                         Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                     surftrans = surfacetranslationvector; surfrot = \
surfacerotationmatrix; Which[surfaceid == 272713, localtranslation = {0, 0, \
0}; 
                       localrotation = {{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}, \
surfaceid == 272778, localtranslation = {10., 0., 0.}; localrotation = 
                        {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, surfaceid \
== 272521, localtranslation = {5., 0., 5.}; localrotation = 
                        {{0., 0., 1.}, {0., 1., 0.}, {-1., 0., 0.}}, \
surfaceid == 272551, localtranslation = {5., 0., -5.}; localrotation = 
                        {{0., 0., -1.}, {0., -1., 0.}, {-1., 0., 0.}}, \
surfaceid == 272617, localtranslation = {5., 5., 0.}; localrotation = 
                        {{0., -1., 0.}, {1., 0., 0.}, {0., 0., 1.}}, True, \
localtranslation = {5., -5., 0.}; localrotation = {{0., 1., 0.}, 
                         {-1., 0., 0.}, {0., 0., 1.}}]; localpos = surfrot . \
({rex, rey, rez} - surftrans); localtilt = surfrot . {r1, r2, r3}; 
                     localpos = localpos . localrotation + localtranslation; \
localtilt = localtilt . localrotation; {LocRSx, LocRSy, LocRSz} = 
                      localpos; {RTx, LocRTy, LocRTz} = localtilt; \
allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, \
r8, 
                        r9, wavelength, intensity, intensityscale, ray1, \
index, opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                        ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}}; 
                     originalrotation = Partition[Take[originalray, {7, 15}], \
3]; previoustilt = originalrotation[[1]]; transmatrix = 
                      MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, \
r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                           index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, 
                           sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; rotationaxis = \
Cross[previoustilt, 
                           {r1, r2, r3}]; axismagnitude = Sqrt[rotationaxis . \
rotationaxis]; If[Chop[axismagnitude] != 0., rotationaxis = 
                            rotationaxis/axismagnitude; axismatrix = \
(#1*rotationaxis & ) /@ rotationaxis; crossmatrix = {{0., -rotationaxis[[3]], \

                              rotationaxis[[2]]}, {rotationaxis[[3]], 0., \
-rotationaxis[[1]]}, {-rotationaxis[[2]], rotationaxis[[1]], 0.}}; 
                           cosangle = previoustilt . {r1, r2, r3}; If[1. - \
cosangle < 2.220446049250313*^-16, cosangle = 1.]; sinangle = 
                            1 - cosangle^2; If[sinangle < \
2.220446049250313*^-16, sinangle = 0., sinangle = Sqrt[sinangle]]; axismatrix \
+ 
                            ({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}} - \
axismatrix)*cosangle + crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, 
                            {r7, r8, r9}} = If[Sign[previoustilt . {r1, r2, \
r3}] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, 
                             {0., -1., 0.}, {0., 0., 1.}}]]) & , \
allcreatedrays]; allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, \
r1, r2, 
                           r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, 
                           componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                           intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                             originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                           1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                             {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; \
{{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                         If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                             amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                               0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                             dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                             {pol1, pol2, pol3} = dummyvector]; 1., 1.]; \
{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                          wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                          ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                       allcreatedrays]; (originalray = First[allcreatedrays]; \
completedray = originalray); deflectedrays = allcreatedrays; 
                     newdeflectedrays = {originalray}; Scan[({rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                          intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, 
                          sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        (ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, \
r2, r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                         If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                         If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], \
XAxis = XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                            ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                         YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = \
ZAxis*{r1, r2, r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                          PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                          normalizedpolarization/Sqrt[normalizedpolarization \
. normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                         amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                             Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                         If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = baseIndex - factorX*(LocRSx - xpos)^2 - 
                             factorY*(LocRSy - ypos)^2; index1 = index; \
If[Abs[index2 - index1] < 0.01, alternateindex = Sqrt[1.0005281111748805 - 
                                2.364805676582992*^-10*wavelength^2 + \
2.9781670902982902*^-6/wavelength^2 + 2.6004099469477187*^-8/wavelength^4 + 
                                3.7787839314048715*^-10/wavelength^6 + \
2.830549017940716*^-12/wavelength^8]; If[Abs[alternateindex - index1] > 
                               Abs[index2 - index1], index1 = index2; index2 \
= alternateindex, index1 = alternateindex], index1 = 
                             Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                               2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]], \

                          index2 = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                              2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]; 
                           index1 = index; If[Abs[index2 - index1] < 0.01, \
alternateindex = baseIndex - factorX*(LocRSx - xpos)^2 - factorY*
                                (LocRSy - ypos)^2; If[Abs[alternateindex - \
index1] > Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                              index1 = alternateindex], index1 = baseIndex - \
factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - ypos)^2]]; 
                         n12 = index1/index2; index = index2; If[1 - \
n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + ZAxis*
                              (-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                            phaseshift = phaseshift + 0.5, 1.]; index2 = \
index1; index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                               {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                            dummyvector; 1.]; allcreatedrays = {{rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                            intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, 
                            sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}}; 
                         originalrotation = Partition[Take[originalray, {7, \
15}], 3]; previoustilt = originalrotation[[1]]; transmatrix = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; rotationaxis = 
                              Cross[previoustilt, {r1, r2, r3}]; \
axismagnitude = Sqrt[rotationaxis . rotationaxis]; If[Chop[axismagnitude] != \
0., 
                              rotationaxis = rotationaxis/axismagnitude; \
axismatrix = (#1*rotationaxis & ) /@ rotationaxis; crossmatrix = 
                                {{0., -rotationaxis[[3]], rotationaxis[[2]]}, \
{rotationaxis[[3]], 0., -rotationaxis[[1]]}, {-rotationaxis[[2]], 
                                  rotationaxis[[1]], 0.}}; cosangle = \
previoustilt . {r1, r2, r3}; If[1. - cosangle < 2.220446049250313*^-16, 
                                cosangle = 1.]; sinangle = 1 - cosangle^2; \
If[sinangle < 2.220446049250313*^-16, sinangle = 0., sinangle = 
                                 Sqrt[sinangle]]; axismatrix + ({{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}} - axismatrix)*cosangle + crossmatrix*
                                 sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, \
r8, r9}} = If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., 0., 0.}, 
                                 {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, \
{0., -1., 0.}, {0., 0., 1.}}]]) & , allcreatedrays]; allcreatedrays = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; {{r1, r2, r3}, {r4, r5, r6}, 
                               {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ \
originalrotation][transmatrix[[First[#2]]]]; tiltmagnitude = 
                              {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; 
                               {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; 
                               {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
dummymatrix; 1., 1.]; If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, 
                              amplitude = allcreatedamplitudes[[First[#2]]]; \
hor = {r4, r5, r6} . amplitude; ver = {r7, r8, r9} . amplitude; 
                               If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, \
pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = {pol1, pol2, pol3}/
                                   Sqrt[{pol1, pol2, pol3} . {pol1, pol2, \
pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = ReplacePart[
                                   {pol1, pol2, pol3}, (If[ver == 0., 0., \
Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; {pol1, pol2, pol3} = 
                                  dummyvector]; 1., 1.]; {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                              intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                              frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                           allcreatedrays]); newdeflectedrays = \
Join[newdeflectedrays, allcreatedrays]) & , deflectedrays]; allcreatedrays = 
                      Drop[newdeflectedrays, 1]; deflectedrays = \
allcreatedrays; newdeflectedrays = {originalray}; 
                     Scan[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, \
r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; (ZAxis = First[surfnorm]*Sign[First[surfnorm] . 
                             {r1, r2, r3}]; raytiltz = ZAxis . {r1, r2, r3}; \
raytiltx = 1 - raytiltz^2; If[raytiltx < 2.220446049250313*^-16, 
                          raytiltx = 0., raytiltx = Sqrt[raytiltx]]; XAxis = \
{r1, r2, r3} - ZAxis*raytiltz; If[Abs[raytiltx] < 1.*^-7, 
                          XAxis = surfnorm[[2]], XAxis = XAxis/raytiltx]; \
YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + ZAxis[[2]]*XAxis[[3]], 
                           ZAxis[[3]]*XAxis[[1]] - ZAxis[[1]]*XAxis[[3]], \
-(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; YAxis = 
                          YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = PAxis/
                           Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                          normalizedpolarization/Sqrt[normalizedpolarization \
. normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                         amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                             Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                         surftrans = surfacetranslationvector; surfrot = \
surfacerotationmatrix; Which[surfaceid == 272713, localtranslation = 
                            {0, 0, 0}; localrotation = {{1, 0, 0}, {0, 1, 0}, \
{0, 0, 1}}, surfaceid == 272778, localtranslation = {10., 0., 0.}; 
                           localrotation = {{1., 0., 0.}, {0., 1., 0.}, {0., \
0., 1.}}, surfaceid == 272521, localtranslation = {5., 0., 5.}; 
                           localrotation = {{0., 0., 1.}, {0., 1., 0.}, {-1., \
0., 0.}}, surfaceid == 272551, localtranslation = {5., 0., -5.}; 
                           localrotation = {{0., 0., -1.}, {0., -1., 0.}, \
{-1., 0., 0.}}, surfaceid == 272617, localtranslation = {5., 5., 0.}; 
                           localrotation = {{0., -1., 0.}, {1., 0., 0.}, {0., \
0., 1.}}, True, localtranslation = {5., -5., 0.}; localrotation = 
                            {{0., 1., 0.}, {-1., 0., 0.}, {0., 0., 1.}}]; \
localopticallength = 0.; localraylength = 0.; integratedrefractiveindex = 
                          0.; localpos = surfrot . ({rex, rey, rez} - \
surftrans); localtilt = surfrot . {r1, r2, r3}; If[activeregion*localtilt[[
                             1]] > 0, {LocRSx, LocRSy, LocRSz} = localpos; \
localpos = localpos . localrotation + localtranslation; localtilt = 
                            localtilt . localrotation; {LocRSx, LocRSy, \
LocRSz} = localpos; localindex = index; localindex = baseIndex - 
                             factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - \
ypos)^2; listofpositions = {{LocRSx, LocRSy, LocRSz}}; listoftilts = 
                            {{RTx, LocRTy, LocRTz}}; indexpoints = \
{localindex}; opticallengths = {opticallength}; {RTx, LocRTy, LocRTz} = \
localtilt; 
                           localtilt = localindex*localtilt; Ninitial = \
localindex^2; Sinitial = 0.1^2*{-2*baseIndex*factorX*LocRSx + 2*factorX^2*
                                 LocRSx^3 + 2*factorX*factorY*LocRSx*LocRSy^2 \
+ 2*baseIndex*factorX*xpos - 6*factorX^2*LocRSx^2*xpos - 2*factorX*
                                 factorY*LocRSy^2*xpos + \
6*factorX^2*LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 
                                4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*LocRSx*ypos^2 - 2*factorX*factorY*xpos*ypos^2, 
                               -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*
                                 LocRSy*xpos + \
2*factorX*factorY*LocRSy*xpos^2 + 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 
                                6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*
                                 ypos^2 - 2*factorY^2*ypos^3, 0} . localtilt; \
rSxOffset = 0.; While[(Plus[10.]) - (LocRSx - rSxOffset) >= 
                              -0.01*0.1 && Plus[LocRSx - rSxOffset] >= \
-0.01*0.1 && (0.99999*LocRSy <= 5. && 0.99999*LocRSy >= -5. && 
                              0.99999*LocRSz >= -5. && 0.99999*LocRSz <= 5.), \
localraylength = (localraylength + Sqrt[#1 . #1] & )[localpos - 
                                {LocRSx, LocRSy, LocRSz}]; localpos = \
{LocRSx, LocRSy, LocRSz}; AppendTo[listofpositions, {LocRSx, LocRSy, \
LocRSz}]; 
                             AppendTo[listoftilts, {RTx, LocRTy, LocRTz}]; \
localindex = baseIndex - factorX*(LocRSx - xpos)^2 - factorY*
                                (LocRSy - ypos)^2; AppendTo[indexpoints, \
localindex]; opticallengths = Append[opticallengths, Last[opticallengths] + 
                                localindex*0.1]; integratedrefractiveindex = \
integratedrefractiveindex + localindex^2; localtilt = localindex*
                               {RTx, LocRTy, LocRTz}; Aelement = \
0.1*{-2*baseIndex*factorX*LocRSx + 2*factorX^2*LocRSx^3 + \
2*factorX*factorY*LocRSx*
                                  LocRSy^2 + 2*baseIndex*factorX*xpos - \
6*factorX^2*LocRSx^2*xpos - 2*factorX*factorY*LocRSy^2*xpos + 6*factorX^2*
                                  LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 4*factorX*factorY*LocRSy*xpos*ypos + 
                                 2*factorX*factorY*LocRSx*ypos^2 - \
2*factorX*factorY*xpos*ypos^2, -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*
                                  LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*LocRSy*xpos + 2*factorX*factorY*LocRSy*xpos^2 + 
                                 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*
                                  xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*ypos^2 - 2*factorY^2*ypos^3, 0}; {LocRSx, LocRSy, 
                               LocRSz} = localpos + (0.1*localtilt)/2. + \
(0.1*Aelement)/8.; Belement = 0.1*{-2*baseIndex*factorX*LocRSx + 
                                 2*factorX^2*LocRSx^3 + \
2*factorX*factorY*LocRSx*LocRSy^2 + 2*baseIndex*factorX*xpos - \
6*factorX^2*LocRSx^2*xpos - 
                                 2*factorX*factorY*LocRSy^2*xpos + \
6*factorX^2*LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*
                                  ypos + 4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*LocRSx*ypos^2 - 2*factorX*factorY*xpos*ypos^2, 
                                -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*
                                  LocRSy*xpos + \
2*factorX*factorY*LocRSy*xpos^2 + 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 
                                 6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*
                                  ypos^2 - 2*factorY^2*ypos^3, 0}; {LocRSx, \
LocRSy, LocRSz} = localpos + 0.1*localtilt + (0.1*Belement)/2; 
                             Celement = 0.1*{-2*baseIndex*factorX*LocRSx + \
2*factorX^2*LocRSx^3 + 2*factorX*factorY*LocRSx*LocRSy^2 + 2*baseIndex*
                                  factorX*xpos - 6*factorX^2*LocRSx^2*xpos - \
2*factorX*factorY*LocRSy^2*xpos + 6*factorX^2*LocRSx*xpos^2 - 
                                 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*
                                  LocRSx*ypos^2 - \
2*factorX*factorY*xpos*ypos^2, -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 
                                 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*LocRSy*xpos + 2*factorX*factorY*LocRSy*xpos^2 + \
2*baseIndex*factorY*
                                  ypos - 2*factorX*factorY*LocRSx^2*ypos - \
6*factorY^2*LocRSy^2*ypos + 4*factorX*factorY*LocRSx*xpos*ypos - 
                                 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*ypos^2 - 2*factorY^2*ypos^3, 0}; newpos = localpos + 
                               0.1*(localtilt + (Aelement + 2*Belement)/6); \
newtilt = localtilt + (Aelement + 4.*Aelement + Celement)/6.; 
                             newtilt = newtilt/Sqrt[newtilt . newtilt]; \
{LocRSx, LocRSy, LocRSz} = newpos; {RTx, LocRTy, LocRTz} = newtilt; 1.]; 
                           integratedrefractiveindex = \
integratedrefractiveindex - localindex^2; {LocRSx, LocRSy, LocRSz} = \
localpos; 
                           Sfinal = 0.1*Aelement . localtilt; Nfinal = \
localindex^2; localtilt = localtilt/Sqrt[localtilt . localtilt]; 
                           {RTx, LocRTy, LocRTz} = localtilt; \
localopticallength = 0.1*integratedrefractiveindex - (Sfinal - Sinitial)/6 + 
                             (0.1*(Nfinal - Ninitial))/2; opticallength = \
opticallength + localopticallength; ray1 = localraylength; localpos = 
                            localrotation . (localpos - localtranslation); \
{rex, rey, rez} = localpos . surfrot + surftrans; localtilt = 
                            localrotation . localtilt; {r1, r2, r3} = \
localtilt . surfrot; {rsx, rsy, rsz} = {rex, rey, rez}; index = baseIndex - 
                             factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - \
ypos)^2; allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, 
                              r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                              surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                              intersectionnumber, pol1, pol2, pol3}}; \
listofpositions = (localrotation . (#1 - localtranslation) & ) /@ 
                             listofpositions; listofpositions = (#1 . surfrot \
+ surftrans & ) /@ listofpositions; listoftilts = 
                            (#1/Sqrt[#1 . #1] & ) /@ listoftilts; listoftilts \
= (#1 . surfrot & ) /@ listoftilts; If[reportedrayspresent && 
                             Length[indexpoints] > 1, reportedrays = \
Join[reportedrays, Table[{rsx, rsy, rsz} = listofpositions[[ninteger]]; 
                                 {rex, rey, rez} = listofpositions[[ninteger \
+ 1]]; {r1, r2, r3} = listoftilts[[ninteger]]; ray1 = 0.1; index = 
                                  indexpoints[[ninteger]]; opticallength = \
opticallengths[[ninteger]]; {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, 
                                  r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                                  surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                                  intersectionnumber, pol1, pol2, pol3}, \
{ninteger, 1, Length[indexpoints] - 1}]]; 1., 1.]; allcreatedrays, 
                          allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, \
r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, 
                             ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                             sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}]; originalrotation = Partition[
                           Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                           ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                               opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, 
                               sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; rotationaxis = \
Cross[previoustilt, 
                               {r1, r2, r3}]; axismagnitude = \
Sqrt[rotationaxis . rotationaxis]; If[Chop[axismagnitude] != 0., rotationaxis \
= 
                                rotationaxis/axismagnitude; axismatrix = \
(#1*rotationaxis & ) /@ rotationaxis; crossmatrix = {{0., -rotationaxis[[
                                    3]], rotationaxis[[2]]}, \
{rotationaxis[[3]], 0., -rotationaxis[[1]]}, {-rotationaxis[[2]], \
rotationaxis[[1]], 
                                  0.}}; cosangle = previoustilt . {r1, r2, \
r3}; If[1. - cosangle < 2.220446049250313*^-16, cosangle = 1.]; 
                               sinangle = 1 - cosangle^2; If[sinangle < \
2.220446049250313*^-16, sinangle = 0., sinangle = Sqrt[sinangle]]; 
                               axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, \
{0., 0., 1.}} - axismatrix)*cosangle + crossmatrix*sinangle, 
                              {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., 0., 0.}, {0., 1., 0.}, 
                                 {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., \
0.}, {0., 0., 1.}}]]) & , allcreatedrays]; allcreatedrays = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; {{r1, r2, r3}, {r4, r5, r6}, 
                               {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ \
originalrotation][transmatrix[[First[#2]]]]; tiltmagnitude = 
                              {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; 
                               {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; 
                               {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
dummymatrix; 1., 1.]; If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, 
                              amplitude = allcreatedamplitudes[[First[#2]]]; \
hor = {r4, r5, r6} . amplitude; ver = {r7, r8, r9} . amplitude; 
                               If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, \
pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = {pol1, pol2, pol3}/
                                   Sqrt[{pol1, pol2, pol3} . {pol1, pol2, \
pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = ReplacePart[
                                   {pol1, pol2, pol3}, (If[ver == 0., 0., \
Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; {pol1, pol2, pol3} = 
                                  dummyvector]; 1., 1.]; {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                              intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                              frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                           allcreatedrays]); newdeflectedrays = \
Join[newdeflectedrays, allcreatedrays]) & , deflectedrays]; allcreatedrays = 
                      Drop[newdeflectedrays, 1]; deflectedrays = \
allcreatedrays; deflectedrays = MapIndexed[ReplacePart[#1, First[#2], 34] & , \

                       allcreatedrays]; allcreatedrays = deflectedrays); \
{allcreatedrays, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                       1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., \
-1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}, 
                     {completedray}}, resonatenumber == 3, {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; index1 = index; xunit = r3; 
                    yunit = r2; zunit = -1.*r1; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = 
                     (xunit^2 + yunit^2 + zunit^2)^2^(-1); xunit = \
xunit/magnitude; yunit = yunit/magnitude; zunit = zunit/magnitude; rx = -5. + \
rez; 
                    ry = rey - 1.*Re[gly]; rz = -1.*(-5. + rex - 1.*Re[glx]); \
rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = 
                     False; intersections = {{-1., 0., 0.}}; intersections = \
resonateintersections; holeQ = holeQlist[[resonatenumber]] == 1; 
                    {newcomponentnumber, newsurfacenumber, newsurfaceid} = \
{1., 3., 272521.}; {componentnumber, surfacenumber, surfaceid} = 
                     {1., 3., 272521.}; {ray1, ray2, ray3} = \
intersections[[1]]; rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \

                    ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = \
5. - 1.*rzhlp + Re[glx]; rey = ryhlp + Re[gly]; rez = 5. + rxhlp; 
                    rex = Chop[rex]; rey = Chop[rey]; rez = Chop[rez]; \
intersectionnumber = intersectionnumber + 1.; opticallength = 
                     opticallength + ray1*index1; completedray = {rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                      intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                      frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}; reportedrayspresent \
= True; 
                    intersectionspresent = True; deflectedrayspresent = True; \
localdummyoutrayspresent = True; (surfnorm = 
                      1.*Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}]; \
dummymatrix = ({{0., 0., -1.}, {0., 1., 0.}, {1., 0., 0.}} . #1 & ) /@ 
                       surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ \
dummymatrix; surfacerotationmatrix = {{0, 0, 1.}, {0, 1., 0}, {-1., 0, 0}}; 
                     surfacetranslationvector = {5. + Re[glx], Re[gly], 5.}; \
activeregion = 1.; completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, 
                       r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                       surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, 
                       pol1, pol2, pol3}; componentnumber = \
newcomponentnumber; surfacenumber = newsurfacenumber; surfaceid = \
newsurfaceid; 
                     originalray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, \
r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                       index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                       rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; ZAxis = First[surfnorm]*Sign[First[surfnorm] . 
                         {r1, r2, r3}]; raytiltz = ZAxis . {r1, r2, r3}; \
raytiltx = 1 - raytiltz^2; If[raytiltx < 2.220446049250313*^-16, 
                      raytiltx = 0., raytiltx = Sqrt[raytiltx]]; XAxis = {r1, \
r2, r3} - ZAxis*raytiltz; If[Abs[raytiltx] < 1.*^-7, 
                      XAxis = surfnorm[[2]], XAxis = XAxis/raytiltx]; YAxis = \
{-(ZAxis[[3]]*XAxis[[2]]) + ZAxis[[2]]*XAxis[[3]], 
                       ZAxis[[3]]*XAxis[[1]] - ZAxis[[1]]*XAxis[[3]], \
-(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; YAxis = 
                      YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, r3} . \
XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = PAxis/Sqrt[PAxis . PAxis]; 
                     normalizedpolarization = {pol1, pol2, pol3}[[{1, 2}]]; \
normalizedpolarization = normalizedpolarization/
                       Sqrt[normalizedpolarization . normalizedpolarization]; \
allcreatedamplitudes = {{I*0., I*0., I*0.}}; amplitude = 
                      Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, \
r6} + normalizedpolarization[[2]]*{r7, r8, r9}*
                         Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                     surftrans = surfacetranslationvector; surfrot = \
surfacerotationmatrix; Which[surfaceid == 272713, localtranslation = {0, 0, \
0}; 
                       localrotation = {{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}, \
surfaceid == 272778, localtranslation = {10., 0., 0.}; localrotation = 
                        {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, surfaceid \
== 272521, localtranslation = {5., 0., 5.}; localrotation = 
                        {{0., 0., 1.}, {0., 1., 0.}, {-1., 0., 0.}}, \
surfaceid == 272551, localtranslation = {5., 0., -5.}; localrotation = 
                        {{0., 0., -1.}, {0., -1., 0.}, {-1., 0., 0.}}, \
surfaceid == 272617, localtranslation = {5., 5., 0.}; localrotation = 
                        {{0., -1., 0.}, {1., 0., 0.}, {0., 0., 1.}}, True, \
localtranslation = {5., -5., 0.}; localrotation = {{0., 1., 0.}, 
                         {-1., 0., 0.}, {0., 0., 1.}}]; localpos = surfrot . \
({rex, rey, rez} - surftrans); localtilt = surfrot . {r1, r2, r3}; 
                     localpos = localpos . localrotation + localtranslation; \
localtilt = localtilt . localrotation; {LocRSx, LocRSy, LocRSz} = 
                      localpos; {RTx, LocRTy, LocRTz} = localtilt; \
allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, \
r8, 
                        r9, wavelength, intensity, intensityscale, ray1, \
index, opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                        ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}}; 
                     originalrotation = Partition[Take[originalray, {7, 15}], \
3]; previoustilt = originalrotation[[1]]; transmatrix = 
                      MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, \
r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                           index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, 
                           sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; rotationaxis = \
Cross[previoustilt, 
                           {r1, r2, r3}]; axismagnitude = Sqrt[rotationaxis . \
rotationaxis]; If[Chop[axismagnitude] != 0., rotationaxis = 
                            rotationaxis/axismagnitude; axismatrix = \
(#1*rotationaxis & ) /@ rotationaxis; crossmatrix = {{0., -rotationaxis[[3]], \

                              rotationaxis[[2]]}, {rotationaxis[[3]], 0., \
-rotationaxis[[1]]}, {-rotationaxis[[2]], rotationaxis[[1]], 0.}}; 
                           cosangle = previoustilt . {r1, r2, r3}; If[1. - \
cosangle < 2.220446049250313*^-16, cosangle = 1.]; sinangle = 
                            1 - cosangle^2; If[sinangle < \
2.220446049250313*^-16, sinangle = 0., sinangle = Sqrt[sinangle]]; axismatrix \
+ 
                            ({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}} - \
axismatrix)*cosangle + crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, 
                            {r7, r8, r9}} = If[Sign[previoustilt . {r1, r2, \
r3}] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, 
                             {0., -1., 0.}, {0., 0., 1.}}]]) & , \
allcreatedrays]; allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, \
r1, r2, 
                           r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, 
                           componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                           intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                             originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                           1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                             {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; \
{{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                         If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                             amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                               0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                             dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                             {pol1, pol2, pol3} = dummyvector]; 1., 1.]; \
{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                          wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                          ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                       allcreatedrays]; (originalray = First[allcreatedrays]; \
completedray = originalray); deflectedrays = allcreatedrays; 
                     newdeflectedrays = {originalray}; Scan[({rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                          intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, 
                          sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        (ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, \
r2, r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                         If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                         If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], \
XAxis = XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                            ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                         YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = \
ZAxis*{r1, r2, r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                          PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                          normalizedpolarization/Sqrt[normalizedpolarization \
. normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                         amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                             Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                         If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = baseIndex - factorX*(LocRSx - xpos)^2 - 
                             factorY*(LocRSy - ypos)^2; index1 = index; \
If[Abs[index2 - index1] < 0.01, alternateindex = Sqrt[1.0005281111748805 - 
                                2.364805676582992*^-10*wavelength^2 + \
2.9781670902982902*^-6/wavelength^2 + 2.6004099469477187*^-8/wavelength^4 + 
                                3.7787839314048715*^-10/wavelength^6 + \
2.830549017940716*^-12/wavelength^8]; If[Abs[alternateindex - index1] > 
                               Abs[index2 - index1], index1 = index2; index2 \
= alternateindex, index1 = alternateindex], index1 = 
                             Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                               2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]], \

                          index2 = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                              2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]; 
                           index1 = index; If[Abs[index2 - index1] < 0.01, \
alternateindex = baseIndex - factorX*(LocRSx - xpos)^2 - factorY*
                                (LocRSy - ypos)^2; If[Abs[alternateindex - \
index1] > Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                              index1 = alternateindex], index1 = baseIndex - \
factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - ypos)^2]]; 
                         n12 = index1/index2; index = index2; If[1 - \
n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + ZAxis*
                              (-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                            phaseshift = phaseshift + 0.5, 1.]; index2 = \
index1; index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                               {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                            dummyvector; 1.]; allcreatedrays = {{rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                            intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, 
                            sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}}; 
                         originalrotation = Partition[Take[originalray, {7, \
15}], 3]; previoustilt = originalrotation[[1]]; transmatrix = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; rotationaxis = 
                              Cross[previoustilt, {r1, r2, r3}]; \
axismagnitude = Sqrt[rotationaxis . rotationaxis]; If[Chop[axismagnitude] != \
0., 
                              rotationaxis = rotationaxis/axismagnitude; \
axismatrix = (#1*rotationaxis & ) /@ rotationaxis; crossmatrix = 
                                {{0., -rotationaxis[[3]], rotationaxis[[2]]}, \
{rotationaxis[[3]], 0., -rotationaxis[[1]]}, {-rotationaxis[[2]], 
                                  rotationaxis[[1]], 0.}}; cosangle = \
previoustilt . {r1, r2, r3}; If[1. - cosangle < 2.220446049250313*^-16, 
                                cosangle = 1.]; sinangle = 1 - cosangle^2; \
If[sinangle < 2.220446049250313*^-16, sinangle = 0., sinangle = 
                                 Sqrt[sinangle]]; axismatrix + ({{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}} - axismatrix)*cosangle + crossmatrix*
                                 sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, \
r8, r9}} = If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., 0., 0.}, 
                                 {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, \
{0., -1., 0.}, {0., 0., 1.}}]]) & , allcreatedrays]; allcreatedrays = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; {{r1, r2, r3}, {r4, r5, r6}, 
                               {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ \
originalrotation][transmatrix[[First[#2]]]]; tiltmagnitude = 
                              {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; 
                               {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; 
                               {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
dummymatrix; 1., 1.]; If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, 
                              amplitude = allcreatedamplitudes[[First[#2]]]; \
hor = {r4, r5, r6} . amplitude; ver = {r7, r8, r9} . amplitude; 
                               If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, \
pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = {pol1, pol2, pol3}/
                                   Sqrt[{pol1, pol2, pol3} . {pol1, pol2, \
pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = ReplacePart[
                                   {pol1, pol2, pol3}, (If[ver == 0., 0., \
Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; {pol1, pol2, pol3} = 
                                  dummyvector]; 1., 1.]; {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                              intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                              frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                           allcreatedrays]); newdeflectedrays = \
Join[newdeflectedrays, allcreatedrays]) & , deflectedrays]; allcreatedrays = 
                      Drop[newdeflectedrays, 1]; deflectedrays = \
allcreatedrays; newdeflectedrays = {originalray}; 
                     Scan[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, \
r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; (ZAxis = First[surfnorm]*Sign[First[surfnorm] . 
                             {r1, r2, r3}]; raytiltz = ZAxis . {r1, r2, r3}; \
raytiltx = 1 - raytiltz^2; If[raytiltx < 2.220446049250313*^-16, 
                          raytiltx = 0., raytiltx = Sqrt[raytiltx]]; XAxis = \
{r1, r2, r3} - ZAxis*raytiltz; If[Abs[raytiltx] < 1.*^-7, 
                          XAxis = surfnorm[[2]], XAxis = XAxis/raytiltx]; \
YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + ZAxis[[2]]*XAxis[[3]], 
                           ZAxis[[3]]*XAxis[[1]] - ZAxis[[1]]*XAxis[[3]], \
-(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; YAxis = 
                          YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = PAxis/
                           Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                          normalizedpolarization/Sqrt[normalizedpolarization \
. normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                         amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                             Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                         surftrans = surfacetranslationvector; surfrot = \
surfacerotationmatrix; Which[surfaceid == 272713, localtranslation = 
                            {0, 0, 0}; localrotation = {{1, 0, 0}, {0, 1, 0}, \
{0, 0, 1}}, surfaceid == 272778, localtranslation = {10., 0., 0.}; 
                           localrotation = {{1., 0., 0.}, {0., 1., 0.}, {0., \
0., 1.}}, surfaceid == 272521, localtranslation = {5., 0., 5.}; 
                           localrotation = {{0., 0., 1.}, {0., 1., 0.}, {-1., \
0., 0.}}, surfaceid == 272551, localtranslation = {5., 0., -5.}; 
                           localrotation = {{0., 0., -1.}, {0., -1., 0.}, \
{-1., 0., 0.}}, surfaceid == 272617, localtranslation = {5., 5., 0.}; 
                           localrotation = {{0., -1., 0.}, {1., 0., 0.}, {0., \
0., 1.}}, True, localtranslation = {5., -5., 0.}; localrotation = 
                            {{0., 1., 0.}, {-1., 0., 0.}, {0., 0., 1.}}]; \
localopticallength = 0.; localraylength = 0.; integratedrefractiveindex = 
                          0.; localpos = surfrot . ({rex, rey, rez} - \
surftrans); localtilt = surfrot . {r1, r2, r3}; If[activeregion*localtilt[[
                             1]] > 0, {LocRSx, LocRSy, LocRSz} = localpos; \
localpos = localpos . localrotation + localtranslation; localtilt = 
                            localtilt . localrotation; {LocRSx, LocRSy, \
LocRSz} = localpos; localindex = index; localindex = baseIndex - 
                             factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - \
ypos)^2; listofpositions = {{LocRSx, LocRSy, LocRSz}}; listoftilts = 
                            {{RTx, LocRTy, LocRTz}}; indexpoints = \
{localindex}; opticallengths = {opticallength}; {RTx, LocRTy, LocRTz} = \
localtilt; 
                           localtilt = localindex*localtilt; Ninitial = \
localindex^2; Sinitial = 0.1^2*{-2*baseIndex*factorX*LocRSx + 2*factorX^2*
                                 LocRSx^3 + 2*factorX*factorY*LocRSx*LocRSy^2 \
+ 2*baseIndex*factorX*xpos - 6*factorX^2*LocRSx^2*xpos - 2*factorX*
                                 factorY*LocRSy^2*xpos + \
6*factorX^2*LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 
                                4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*LocRSx*ypos^2 - 2*factorX*factorY*xpos*ypos^2, 
                               -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*
                                 LocRSy*xpos + \
2*factorX*factorY*LocRSy*xpos^2 + 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 
                                6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*
                                 ypos^2 - 2*factorY^2*ypos^3, 0} . localtilt; \
rSxOffset = 0.; While[(Plus[10.]) - (LocRSx - rSxOffset) >= 
                              -0.01*0.1 && Plus[LocRSx - rSxOffset] >= \
-0.01*0.1 && (0.99999*LocRSy <= 5. && 0.99999*LocRSy >= -5. && 
                              0.99999*LocRSz >= -5. && 0.99999*LocRSz <= 5.), \
localraylength = (localraylength + Sqrt[#1 . #1] & )[localpos - 
                                {LocRSx, LocRSy, LocRSz}]; localpos = \
{LocRSx, LocRSy, LocRSz}; AppendTo[listofpositions, {LocRSx, LocRSy, \
LocRSz}]; 
                             AppendTo[listoftilts, {RTx, LocRTy, LocRTz}]; \
localindex = baseIndex - factorX*(LocRSx - xpos)^2 - factorY*
                                (LocRSy - ypos)^2; AppendTo[indexpoints, \
localindex]; opticallengths = Append[opticallengths, Last[opticallengths] + 
                                localindex*0.1]; integratedrefractiveindex = \
integratedrefractiveindex + localindex^2; localtilt = localindex*
                               {RTx, LocRTy, LocRTz}; Aelement = \
0.1*{-2*baseIndex*factorX*LocRSx + 2*factorX^2*LocRSx^3 + \
2*factorX*factorY*LocRSx*
                                  LocRSy^2 + 2*baseIndex*factorX*xpos - \
6*factorX^2*LocRSx^2*xpos - 2*factorX*factorY*LocRSy^2*xpos + 6*factorX^2*
                                  LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 4*factorX*factorY*LocRSy*xpos*ypos + 
                                 2*factorX*factorY*LocRSx*ypos^2 - \
2*factorX*factorY*xpos*ypos^2, -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*
                                  LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*LocRSy*xpos + 2*factorX*factorY*LocRSy*xpos^2 + 
                                 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*
                                  xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*ypos^2 - 2*factorY^2*ypos^3, 0}; {LocRSx, LocRSy, 
                               LocRSz} = localpos + (0.1*localtilt)/2. + \
(0.1*Aelement)/8.; Belement = 0.1*{-2*baseIndex*factorX*LocRSx + 
                                 2*factorX^2*LocRSx^3 + \
2*factorX*factorY*LocRSx*LocRSy^2 + 2*baseIndex*factorX*xpos - \
6*factorX^2*LocRSx^2*xpos - 
                                 2*factorX*factorY*LocRSy^2*xpos + \
6*factorX^2*LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*
                                  ypos + 4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*LocRSx*ypos^2 - 2*factorX*factorY*xpos*ypos^2, 
                                -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*
                                  LocRSy*xpos + \
2*factorX*factorY*LocRSy*xpos^2 + 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 
                                 6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*
                                  ypos^2 - 2*factorY^2*ypos^3, 0}; {LocRSx, \
LocRSy, LocRSz} = localpos + 0.1*localtilt + (0.1*Belement)/2; 
                             Celement = 0.1*{-2*baseIndex*factorX*LocRSx + \
2*factorX^2*LocRSx^3 + 2*factorX*factorY*LocRSx*LocRSy^2 + 2*baseIndex*
                                  factorX*xpos - 6*factorX^2*LocRSx^2*xpos - \
2*factorX*factorY*LocRSy^2*xpos + 6*factorX^2*LocRSx*xpos^2 - 
                                 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*
                                  LocRSx*ypos^2 - \
2*factorX*factorY*xpos*ypos^2, -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 
                                 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*LocRSy*xpos + 2*factorX*factorY*LocRSy*xpos^2 + \
2*baseIndex*factorY*
                                  ypos - 2*factorX*factorY*LocRSx^2*ypos - \
6*factorY^2*LocRSy^2*ypos + 4*factorX*factorY*LocRSx*xpos*ypos - 
                                 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*ypos^2 - 2*factorY^2*ypos^3, 0}; newpos = localpos + 
                               0.1*(localtilt + (Aelement + 2*Belement)/6); \
newtilt = localtilt + (Aelement + 4.*Aelement + Celement)/6.; 
                             newtilt = newtilt/Sqrt[newtilt . newtilt]; \
{LocRSx, LocRSy, LocRSz} = newpos; {RTx, LocRTy, LocRTz} = newtilt; 1.]; 
                           integratedrefractiveindex = \
integratedrefractiveindex - localindex^2; {LocRSx, LocRSy, LocRSz} = \
localpos; 
                           Sfinal = 0.1*Aelement . localtilt; Nfinal = \
localindex^2; localtilt = localtilt/Sqrt[localtilt . localtilt]; 
                           {RTx, LocRTy, LocRTz} = localtilt; \
localopticallength = 0.1*integratedrefractiveindex - (Sfinal - Sinitial)/6 + 
                             (0.1*(Nfinal - Ninitial))/2; opticallength = \
opticallength + localopticallength; ray1 = localraylength; localpos = 
                            localrotation . (localpos - localtranslation); \
{rex, rey, rez} = localpos . surfrot + surftrans; localtilt = 
                            localrotation . localtilt; {r1, r2, r3} = \
localtilt . surfrot; {rsx, rsy, rsz} = {rex, rey, rez}; index = baseIndex - 
                             factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - \
ypos)^2; allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, 
                              r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                              surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                              intersectionnumber, pol1, pol2, pol3}}; \
listofpositions = (localrotation . (#1 - localtranslation) & ) /@ 
                             listofpositions; listofpositions = (#1 . surfrot \
+ surftrans & ) /@ listofpositions; listoftilts = 
                            (#1/Sqrt[#1 . #1] & ) /@ listoftilts; listoftilts \
= (#1 . surfrot & ) /@ listoftilts; If[reportedrayspresent && 
                             Length[indexpoints] > 1, reportedrays = \
Join[reportedrays, Table[{rsx, rsy, rsz} = listofpositions[[ninteger]]; 
                                 {rex, rey, rez} = listofpositions[[ninteger \
+ 1]]; {r1, r2, r3} = listoftilts[[ninteger]]; ray1 = 0.1; index = 
                                  indexpoints[[ninteger]]; opticallength = \
opticallengths[[ninteger]]; {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, 
                                  r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                                  surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                                  intersectionnumber, pol1, pol2, pol3}, \
{ninteger, 1, Length[indexpoints] - 1}]]; 1., 1.]; allcreatedrays, 
                          allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, \
r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, 
                             ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                             sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}]; originalrotation = Partition[
                           Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                           ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                               opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, 
                               sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; rotationaxis = \
Cross[previoustilt, 
                               {r1, r2, r3}]; axismagnitude = \
Sqrt[rotationaxis . rotationaxis]; If[Chop[axismagnitude] != 0., rotationaxis \
= 
                                rotationaxis/axismagnitude; axismatrix = \
(#1*rotationaxis & ) /@ rotationaxis; crossmatrix = {{0., -rotationaxis[[
                                    3]], rotationaxis[[2]]}, \
{rotationaxis[[3]], 0., -rotationaxis[[1]]}, {-rotationaxis[[2]], \
rotationaxis[[1]], 
                                  0.}}; cosangle = previoustilt . {r1, r2, \
r3}; If[1. - cosangle < 2.220446049250313*^-16, cosangle = 1.]; 
                               sinangle = 1 - cosangle^2; If[sinangle < \
2.220446049250313*^-16, sinangle = 0., sinangle = Sqrt[sinangle]]; 
                               axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, \
{0., 0., 1.}} - axismatrix)*cosangle + crossmatrix*sinangle, 
                              {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., 0., 0.}, {0., 1., 0.}, 
                                 {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., \
0.}, {0., 0., 1.}}]]) & , allcreatedrays]; allcreatedrays = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; {{r1, r2, r3}, {r4, r5, r6}, 
                               {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ \
originalrotation][transmatrix[[First[#2]]]]; tiltmagnitude = 
                              {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; 
                               {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; 
                               {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
dummymatrix; 1., 1.]; If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, 
                              amplitude = allcreatedamplitudes[[First[#2]]]; \
hor = {r4, r5, r6} . amplitude; ver = {r7, r8, r9} . amplitude; 
                               If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, \
pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = {pol1, pol2, pol3}/
                                   Sqrt[{pol1, pol2, pol3} . {pol1, pol2, \
pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = ReplacePart[
                                   {pol1, pol2, pol3}, (If[ver == 0., 0., \
Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; {pol1, pol2, pol3} = 
                                  dummyvector]; 1., 1.]; {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                              intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                              frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                           allcreatedrays]); newdeflectedrays = \
Join[newdeflectedrays, allcreatedrays]) & , deflectedrays]; allcreatedrays = 
                      Drop[newdeflectedrays, 1]; deflectedrays = \
allcreatedrays; deflectedrays = MapIndexed[ReplacePart[#1, First[#2], 34] & , \

                       allcreatedrays]; allcreatedrays = deflectedrays); \
{allcreatedrays, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                       1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., \
-1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}, 
                     {completedray}}, resonatenumber == 4, {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; index1 = index; 
                    xunit = -1.*r3; yunit = -1.*r2; zunit = -1.*r1; xunit = \
Chop[xunit]; yunit = Chop[yunit]; zunit = Chop[zunit]; 
                    magnitude = (xunit^2 + yunit^2 + zunit^2)^2^(-1); xunit = \
xunit/magnitude; yunit = yunit/magnitude; zunit = zunit/magnitude; 
                    rx = -1.*(5. + rez); ry = -1.*(rey - 1.*Re[gly]); rz = \
-1.*(-5. + rex - 1.*Re[glx]); rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; 
                    terminatedeflection = False; intersections = {{-1., 0., \
0.}}; intersections = resonateintersections; 
                    holeQ = holeQlist[[resonatenumber]] == 1; \
{newcomponentnumber, newsurfacenumber, newsurfaceid} = {1., 4., 272551.}; 
                    {componentnumber, surfacenumber, surfaceid} = {1., 4., \
272551.}; {ray1, ray2, ray3} = intersections[[1]]; rsx = rex; rsy = rey; 
                    rsz = rez; rxhlp = rx + ray1*xunit; ryhlp = ry + \
ray1*yunit; rzhlp = rz + ray1*zunit; rex = 5. - 1.*rzhlp + Re[glx]; 
                    rey = -1.*ryhlp + Re[gly]; rez = -5. - 1.*rxhlp; rex = \
Chop[rex]; rey = Chop[rey]; rez = Chop[rez]; intersectionnumber = 
                     intersectionnumber + 1.; opticallength = opticallength + \
ray1*index1; completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, 
                      r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                      surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, 
                      pol1, pol2, pol3}; reportedrayspresent = True; \
intersectionspresent = True; deflectedrayspresent = True; 
                    localdummyoutrayspresent = True; (surfnorm = 1.*Re[{{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = 
                      ({{0., 0., -1.}, {0., -1., 0.}, {-1., 0., 0.}} . #1 & ) \
/@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ dummymatrix; 
                     surfacerotationmatrix = {{0, 0, -1.}, {0, -1., 0}, {-1., \
0, 0}}; surfacetranslationvector = {5. + Re[glx], Re[gly], -5.}; 
                     activeregion = 1.; completedray = {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                       intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                       sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; componentnumber = 
                      newcomponentnumber; surfacenumber = newsurfacenumber; \
surfaceid = newsurfaceid; originalray = {rsx, rsy, rsz, rex, rey, rez, 
                       r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}; ZAxis = \
First[surfnorm]*Sign[First[surfnorm] . {r1, r2, r3}]; raytiltz = 
                      ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; \
If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., raytiltx = 
                       Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - \
ZAxis*raytiltz; If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], 
                      XAxis = XAxis/raytiltx]; YAxis = \
{-(ZAxis[[3]]*XAxis[[2]]) + ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*
                         XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + \
ZAxis[[1]]*XAxis[[2]]}; YAxis = YAxis/Sqrt[YAxis . YAxis]; 
                     PAxis = ZAxis*{r1, r2, r3} . XAxis - XAxis*{r1, r2, r3} \
. ZAxis; PAxis = PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = 
                      {pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = \
normalizedpolarization/Sqrt[normalizedpolarization . 
                         normalizedpolarization]; allcreatedamplitudes = \
{{I*0., I*0., I*0.}}; amplitude = Sqrt[intensity]*
                       (normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*Exp[I*pol3*0.017453292519943295]); 
                     perpendicularamplitude = amplitude . YAxis; \
parallelamplitude = amplitude . PAxis; surftrans = surfacetranslationvector; 
                     surfrot = surfacerotationmatrix; Which[surfaceid == \
272713, localtranslation = {0, 0, 0}; localrotation = {{1, 0, 0}, {0, 1, 0}, 
                         {0, 0, 1}}, surfaceid == 272778, localtranslation = \
{10., 0., 0.}; localrotation = {{1., 0., 0.}, {0., 1., 0.}, 
                         {0., 0., 1.}}, surfaceid == 272521, localtranslation \
= {5., 0., 5.}; localrotation = {{0., 0., 1.}, {0., 1., 0.}, 
                         {-1., 0., 0.}}, surfaceid == 272551, \
localtranslation = {5., 0., -5.}; localrotation = {{0., 0., -1.}, {0., -1., \
0.}, 
                         {-1., 0., 0.}}, surfaceid == 272617, \
localtranslation = {5., 5., 0.}; localrotation = {{0., -1., 0.}, {1., 0., \
0.}, 
                         {0., 0., 1.}}, True, localtranslation = {5., -5., \
0.}; localrotation = {{0., 1., 0.}, {-1., 0., 0.}, {0., 0., 1.}}]; 
                     localpos = surfrot . ({rex, rey, rez} - surftrans); \
localtilt = surfrot . {r1, r2, r3}; localpos = localpos . localrotation + 
                       localtranslation; localtilt = localtilt . \
localrotation; {LocRSx, LocRSy, LocRSz} = localpos; {RTx, LocRTy, LocRTz} = 
                      localtilt; allcreatedrays = {{rsx, rsy, rsz, rex, rey, \
rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                        intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                        sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; originalrotation = 
                      Partition[Take[originalray, {7, 15}], 3]; previoustilt \
= originalrotation[[1]]; transmatrix = MapIndexed[
                       ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, \
r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                           opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                           rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; rotationaxis = Cross[previoustilt, 
                           {r1, r2, r3}]; axismagnitude = Sqrt[rotationaxis . \
rotationaxis]; If[Chop[axismagnitude] != 0., rotationaxis = 
                            rotationaxis/axismagnitude; axismatrix = \
(#1*rotationaxis & ) /@ rotationaxis; crossmatrix = {{0., -rotationaxis[[3]], \

                              rotationaxis[[2]]}, {rotationaxis[[3]], 0., \
-rotationaxis[[1]]}, {-rotationaxis[[2]], rotationaxis[[1]], 0.}}; 
                           cosangle = previoustilt . {r1, r2, r3}; If[1. - \
cosangle < 2.220446049250313*^-16, cosangle = 1.]; sinangle = 
                            1 - cosangle^2; If[sinangle < \
2.220446049250313*^-16, sinangle = 0., sinangle = Sqrt[sinangle]]; axismatrix \
+ 
                            ({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}} - \
axismatrix)*cosangle + crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, 
                            {r7, r8, r9}} = If[Sign[previoustilt . {r1, r2, \
r3}] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, 
                             {0., -1., 0.}, {0., 0., 1.}}]]) & , \
allcreatedrays]; allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, \
r1, r2, 
                           r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, 
                           componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                           intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                             originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                           1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                             {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; \
{{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                         If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                             amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                               0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                             dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                             {pol1, pol2, pol3} = dummyvector]; 1., 1.]; \
{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                          wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                          ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                       allcreatedrays]; (originalray = First[allcreatedrays]; \
completedray = originalray); deflectedrays = allcreatedrays; 
                     newdeflectedrays = {originalray}; Scan[({rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                          intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, 
                          sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        (ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, \
r2, r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                         If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                         If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], \
XAxis = XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                            ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                         YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = \
ZAxis*{r1, r2, r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                          PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                          normalizedpolarization/Sqrt[normalizedpolarization \
. normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                         amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                             Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                         If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = baseIndex - factorX*(LocRSx - xpos)^2 - 
                             factorY*(LocRSy - ypos)^2; index1 = index; \
If[Abs[index2 - index1] < 0.01, alternateindex = Sqrt[1.0005281111748805 - 
                                2.364805676582992*^-10*wavelength^2 + \
2.9781670902982902*^-6/wavelength^2 + 2.6004099469477187*^-8/wavelength^4 + 
                                3.7787839314048715*^-10/wavelength^6 + \
2.830549017940716*^-12/wavelength^8]; If[Abs[alternateindex - index1] > 
                               Abs[index2 - index1], index1 = index2; index2 \
= alternateindex, index1 = alternateindex], index1 = 
                             Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                               2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]], \

                          index2 = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                              2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]; 
                           index1 = index; If[Abs[index2 - index1] < 0.01, \
alternateindex = baseIndex - factorX*(LocRSx - xpos)^2 - factorY*
                                (LocRSy - ypos)^2; If[Abs[alternateindex - \
index1] > Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                              index1 = alternateindex], index1 = baseIndex - \
factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - ypos)^2]]; 
                         n12 = index1/index2; index = index2; If[1 - \
n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + ZAxis*
                              (-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                            phaseshift = phaseshift + 0.5, 1.]; index2 = \
index1; index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                               {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                            dummyvector; 1.]; allcreatedrays = {{rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                            intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, 
                            sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}}; 
                         originalrotation = Partition[Take[originalray, {7, \
15}], 3]; previoustilt = originalrotation[[1]]; transmatrix = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; rotationaxis = 
                              Cross[previoustilt, {r1, r2, r3}]; \
axismagnitude = Sqrt[rotationaxis . rotationaxis]; If[Chop[axismagnitude] != \
0., 
                              rotationaxis = rotationaxis/axismagnitude; \
axismatrix = (#1*rotationaxis & ) /@ rotationaxis; crossmatrix = 
                                {{0., -rotationaxis[[3]], rotationaxis[[2]]}, \
{rotationaxis[[3]], 0., -rotationaxis[[1]]}, {-rotationaxis[[2]], 
                                  rotationaxis[[1]], 0.}}; cosangle = \
previoustilt . {r1, r2, r3}; If[1. - cosangle < 2.220446049250313*^-16, 
                                cosangle = 1.]; sinangle = 1 - cosangle^2; \
If[sinangle < 2.220446049250313*^-16, sinangle = 0., sinangle = 
                                 Sqrt[sinangle]]; axismatrix + ({{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}} - axismatrix)*cosangle + crossmatrix*
                                 sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, \
r8, r9}} = If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., 0., 0.}, 
                                 {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, \
{0., -1., 0.}, {0., 0., 1.}}]]) & , allcreatedrays]; allcreatedrays = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; {{r1, r2, r3}, {r4, r5, r6}, 
                               {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ \
originalrotation][transmatrix[[First[#2]]]]; tiltmagnitude = 
                              {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; 
                               {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; 
                               {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
dummymatrix; 1., 1.]; If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, 
                              amplitude = allcreatedamplitudes[[First[#2]]]; \
hor = {r4, r5, r6} . amplitude; ver = {r7, r8, r9} . amplitude; 
                               If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, \
pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = {pol1, pol2, pol3}/
                                   Sqrt[{pol1, pol2, pol3} . {pol1, pol2, \
pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = ReplacePart[
                                   {pol1, pol2, pol3}, (If[ver == 0., 0., \
Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; {pol1, pol2, pol3} = 
                                  dummyvector]; 1., 1.]; {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                              intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                              frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                           allcreatedrays]); newdeflectedrays = \
Join[newdeflectedrays, allcreatedrays]) & , deflectedrays]; allcreatedrays = 
                      Drop[newdeflectedrays, 1]; deflectedrays = \
allcreatedrays; newdeflectedrays = {originalray}; 
                     Scan[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, \
r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; (ZAxis = First[surfnorm]*Sign[First[surfnorm] . 
                             {r1, r2, r3}]; raytiltz = ZAxis . {r1, r2, r3}; \
raytiltx = 1 - raytiltz^2; If[raytiltx < 2.220446049250313*^-16, 
                          raytiltx = 0., raytiltx = Sqrt[raytiltx]]; XAxis = \
{r1, r2, r3} - ZAxis*raytiltz; If[Abs[raytiltx] < 1.*^-7, 
                          XAxis = surfnorm[[2]], XAxis = XAxis/raytiltx]; \
YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + ZAxis[[2]]*XAxis[[3]], 
                           ZAxis[[3]]*XAxis[[1]] - ZAxis[[1]]*XAxis[[3]], \
-(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; YAxis = 
                          YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = PAxis/
                           Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                          normalizedpolarization/Sqrt[normalizedpolarization \
. normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                         amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                             Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                         surftrans = surfacetranslationvector; surfrot = \
surfacerotationmatrix; Which[surfaceid == 272713, localtranslation = 
                            {0, 0, 0}; localrotation = {{1, 0, 0}, {0, 1, 0}, \
{0, 0, 1}}, surfaceid == 272778, localtranslation = {10., 0., 0.}; 
                           localrotation = {{1., 0., 0.}, {0., 1., 0.}, {0., \
0., 1.}}, surfaceid == 272521, localtranslation = {5., 0., 5.}; 
                           localrotation = {{0., 0., 1.}, {0., 1., 0.}, {-1., \
0., 0.}}, surfaceid == 272551, localtranslation = {5., 0., -5.}; 
                           localrotation = {{0., 0., -1.}, {0., -1., 0.}, \
{-1., 0., 0.}}, surfaceid == 272617, localtranslation = {5., 5., 0.}; 
                           localrotation = {{0., -1., 0.}, {1., 0., 0.}, {0., \
0., 1.}}, True, localtranslation = {5., -5., 0.}; localrotation = 
                            {{0., 1., 0.}, {-1., 0., 0.}, {0., 0., 1.}}]; \
localopticallength = 0.; localraylength = 0.; integratedrefractiveindex = 
                          0.; localpos = surfrot . ({rex, rey, rez} - \
surftrans); localtilt = surfrot . {r1, r2, r3}; If[activeregion*localtilt[[
                             1]] > 0, {LocRSx, LocRSy, LocRSz} = localpos; \
localpos = localpos . localrotation + localtranslation; localtilt = 
                            localtilt . localrotation; {LocRSx, LocRSy, \
LocRSz} = localpos; localindex = index; localindex = baseIndex - 
                             factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - \
ypos)^2; listofpositions = {{LocRSx, LocRSy, LocRSz}}; listoftilts = 
                            {{RTx, LocRTy, LocRTz}}; indexpoints = \
{localindex}; opticallengths = {opticallength}; {RTx, LocRTy, LocRTz} = \
localtilt; 
                           localtilt = localindex*localtilt; Ninitial = \
localindex^2; Sinitial = 0.1^2*{-2*baseIndex*factorX*LocRSx + 2*factorX^2*
                                 LocRSx^3 + 2*factorX*factorY*LocRSx*LocRSy^2 \
+ 2*baseIndex*factorX*xpos - 6*factorX^2*LocRSx^2*xpos - 2*factorX*
                                 factorY*LocRSy^2*xpos + \
6*factorX^2*LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 
                                4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*LocRSx*ypos^2 - 2*factorX*factorY*xpos*ypos^2, 
                               -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*
                                 LocRSy*xpos + \
2*factorX*factorY*LocRSy*xpos^2 + 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 
                                6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*
                                 ypos^2 - 2*factorY^2*ypos^3, 0} . localtilt; \
rSxOffset = 0.; While[(Plus[10.]) - (LocRSx - rSxOffset) >= 
                              -0.01*0.1 && Plus[LocRSx - rSxOffset] >= \
-0.01*0.1 && (0.99999*LocRSy <= 5. && 0.99999*LocRSy >= -5. && 
                              0.99999*LocRSz >= -5. && 0.99999*LocRSz <= 5.), \
localraylength = (localraylength + Sqrt[#1 . #1] & )[localpos - 
                                {LocRSx, LocRSy, LocRSz}]; localpos = \
{LocRSx, LocRSy, LocRSz}; AppendTo[listofpositions, {LocRSx, LocRSy, \
LocRSz}]; 
                             AppendTo[listoftilts, {RTx, LocRTy, LocRTz}]; \
localindex = baseIndex - factorX*(LocRSx - xpos)^2 - factorY*
                                (LocRSy - ypos)^2; AppendTo[indexpoints, \
localindex]; opticallengths = Append[opticallengths, Last[opticallengths] + 
                                localindex*0.1]; integratedrefractiveindex = \
integratedrefractiveindex + localindex^2; localtilt = localindex*
                               {RTx, LocRTy, LocRTz}; Aelement = \
0.1*{-2*baseIndex*factorX*LocRSx + 2*factorX^2*LocRSx^3 + \
2*factorX*factorY*LocRSx*
                                  LocRSy^2 + 2*baseIndex*factorX*xpos - \
6*factorX^2*LocRSx^2*xpos - 2*factorX*factorY*LocRSy^2*xpos + 6*factorX^2*
                                  LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 4*factorX*factorY*LocRSy*xpos*ypos + 
                                 2*factorX*factorY*LocRSx*ypos^2 - \
2*factorX*factorY*xpos*ypos^2, -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*
                                  LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*LocRSy*xpos + 2*factorX*factorY*LocRSy*xpos^2 + 
                                 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*
                                  xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*ypos^2 - 2*factorY^2*ypos^3, 0}; {LocRSx, LocRSy, 
                               LocRSz} = localpos + (0.1*localtilt)/2. + \
(0.1*Aelement)/8.; Belement = 0.1*{-2*baseIndex*factorX*LocRSx + 
                                 2*factorX^2*LocRSx^3 + \
2*factorX*factorY*LocRSx*LocRSy^2 + 2*baseIndex*factorX*xpos - \
6*factorX^2*LocRSx^2*xpos - 
                                 2*factorX*factorY*LocRSy^2*xpos + \
6*factorX^2*LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*
                                  ypos + 4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*LocRSx*ypos^2 - 2*factorX*factorY*xpos*ypos^2, 
                                -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*
                                  LocRSy*xpos + \
2*factorX*factorY*LocRSy*xpos^2 + 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 
                                 6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*
                                  ypos^2 - 2*factorY^2*ypos^3, 0}; {LocRSx, \
LocRSy, LocRSz} = localpos + 0.1*localtilt + (0.1*Belement)/2; 
                             Celement = 0.1*{-2*baseIndex*factorX*LocRSx + \
2*factorX^2*LocRSx^3 + 2*factorX*factorY*LocRSx*LocRSy^2 + 2*baseIndex*
                                  factorX*xpos - 6*factorX^2*LocRSx^2*xpos - \
2*factorX*factorY*LocRSy^2*xpos + 6*factorX^2*LocRSx*xpos^2 - 
                                 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*
                                  LocRSx*ypos^2 - \
2*factorX*factorY*xpos*ypos^2, -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 
                                 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*LocRSy*xpos + 2*factorX*factorY*LocRSy*xpos^2 + \
2*baseIndex*factorY*
                                  ypos - 2*factorX*factorY*LocRSx^2*ypos - \
6*factorY^2*LocRSy^2*ypos + 4*factorX*factorY*LocRSx*xpos*ypos - 
                                 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*ypos^2 - 2*factorY^2*ypos^3, 0}; newpos = localpos + 
                               0.1*(localtilt + (Aelement + 2*Belement)/6); \
newtilt = localtilt + (Aelement + 4.*Aelement + Celement)/6.; 
                             newtilt = newtilt/Sqrt[newtilt . newtilt]; \
{LocRSx, LocRSy, LocRSz} = newpos; {RTx, LocRTy, LocRTz} = newtilt; 1.]; 
                           integratedrefractiveindex = \
integratedrefractiveindex - localindex^2; {LocRSx, LocRSy, LocRSz} = \
localpos; 
                           Sfinal = 0.1*Aelement . localtilt; Nfinal = \
localindex^2; localtilt = localtilt/Sqrt[localtilt . localtilt]; 
                           {RTx, LocRTy, LocRTz} = localtilt; \
localopticallength = 0.1*integratedrefractiveindex - (Sfinal - Sinitial)/6 + 
                             (0.1*(Nfinal - Ninitial))/2; opticallength = \
opticallength + localopticallength; ray1 = localraylength; localpos = 
                            localrotation . (localpos - localtranslation); \
{rex, rey, rez} = localpos . surfrot + surftrans; localtilt = 
                            localrotation . localtilt; {r1, r2, r3} = \
localtilt . surfrot; {rsx, rsy, rsz} = {rex, rey, rez}; index = baseIndex - 
                             factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - \
ypos)^2; allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, 
                              r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                              surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                              intersectionnumber, pol1, pol2, pol3}}; \
listofpositions = (localrotation . (#1 - localtranslation) & ) /@ 
                             listofpositions; listofpositions = (#1 . surfrot \
+ surftrans & ) /@ listofpositions; listoftilts = 
                            (#1/Sqrt[#1 . #1] & ) /@ listoftilts; listoftilts \
= (#1 . surfrot & ) /@ listoftilts; If[reportedrayspresent && 
                             Length[indexpoints] > 1, reportedrays = \
Join[reportedrays, Table[{rsx, rsy, rsz} = listofpositions[[ninteger]]; 
                                 {rex, rey, rez} = listofpositions[[ninteger \
+ 1]]; {r1, r2, r3} = listoftilts[[ninteger]]; ray1 = 0.1; index = 
                                  indexpoints[[ninteger]]; opticallength = \
opticallengths[[ninteger]]; {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, 
                                  r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                                  surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                                  intersectionnumber, pol1, pol2, pol3}, \
{ninteger, 1, Length[indexpoints] - 1}]]; 1., 1.]; allcreatedrays, 
                          allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, \
r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, 
                             ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                             sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}]; originalrotation = Partition[
                           Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                           ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                               opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, 
                               sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; rotationaxis = \
Cross[previoustilt, 
                               {r1, r2, r3}]; axismagnitude = \
Sqrt[rotationaxis . rotationaxis]; If[Chop[axismagnitude] != 0., rotationaxis \
= 
                                rotationaxis/axismagnitude; axismatrix = \
(#1*rotationaxis & ) /@ rotationaxis; crossmatrix = {{0., -rotationaxis[[
                                    3]], rotationaxis[[2]]}, \
{rotationaxis[[3]], 0., -rotationaxis[[1]]}, {-rotationaxis[[2]], \
rotationaxis[[1]], 
                                  0.}}; cosangle = previoustilt . {r1, r2, \
r3}; If[1. - cosangle < 2.220446049250313*^-16, cosangle = 1.]; 
                               sinangle = 1 - cosangle^2; If[sinangle < \
2.220446049250313*^-16, sinangle = 0., sinangle = Sqrt[sinangle]]; 
                               axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, \
{0., 0., 1.}} - axismatrix)*cosangle + crossmatrix*sinangle, 
                              {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., 0., 0.}, {0., 1., 0.}, 
                                 {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., \
0.}, {0., 0., 1.}}]]) & , allcreatedrays]; allcreatedrays = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; {{r1, r2, r3}, {r4, r5, r6}, 
                               {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ \
originalrotation][transmatrix[[First[#2]]]]; tiltmagnitude = 
                              {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; 
                               {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; 
                               {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
dummymatrix; 1., 1.]; If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, 
                              amplitude = allcreatedamplitudes[[First[#2]]]; \
hor = {r4, r5, r6} . amplitude; ver = {r7, r8, r9} . amplitude; 
                               If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, \
pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = {pol1, pol2, pol3}/
                                   Sqrt[{pol1, pol2, pol3} . {pol1, pol2, \
pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = ReplacePart[
                                   {pol1, pol2, pol3}, (If[ver == 0., 0., \
Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; {pol1, pol2, pol3} = 
                                  dummyvector]; 1., 1.]; {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                              intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                              frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                           allcreatedrays]); newdeflectedrays = \
Join[newdeflectedrays, allcreatedrays]) & , deflectedrays]; allcreatedrays = 
                      Drop[newdeflectedrays, 1]; deflectedrays = \
allcreatedrays; deflectedrays = MapIndexed[ReplacePart[#1, First[#2], 34] & , \

                       allcreatedrays]; allcreatedrays = deflectedrays); \
{allcreatedrays, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                       1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., \
-1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}, 
                     {completedray}}, resonatenumber == 5, {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; index1 = index; 
                    xunit = -1.*r2; yunit = r1; zunit = r3; xunit = \
Chop[xunit]; yunit = Chop[yunit]; zunit = Chop[zunit]; magnitude = 
                     (xunit^2 + yunit^2 + zunit^2)^2^(-1); xunit = \
xunit/magnitude; yunit = yunit/magnitude; zunit = zunit/magnitude; 
                    rx = -1.*(-5. + rey - 1.*Re[gly]); ry = -5. + rex - \
1.*Re[glx]; rz = rez; rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; 
                    terminatedeflection = False; intersections = {{-1., 0., \
0.}}; intersections = resonateintersections; 
                    holeQ = holeQlist[[resonatenumber]] == 1; \
{newcomponentnumber, newsurfacenumber, newsurfaceid} = {1., 5., 272617.}; 
                    {componentnumber, surfacenumber, surfaceid} = {1., 5., \
272617.}; {ray1, ray2, ray3} = intersections[[1]]; rsx = rex; rsy = rey; 
                    rsz = rez; rxhlp = rx + ray1*xunit; ryhlp = ry + \
ray1*yunit; rzhlp = rz + ray1*zunit; rex = 5. + ryhlp + Re[glx]; 
                    rey = 5. - 1.*rxhlp + Re[gly]; rez = rzhlp; rex = \
Chop[rex]; rey = Chop[rey]; rez = Chop[rez]; intersectionnumber = 
                     intersectionnumber + 1.; opticallength = opticallength + \
ray1*index1; completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, 
                      r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                      surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, 
                      pol1, pol2, pol3}; reportedrayspresent = True; \
intersectionspresent = True; deflectedrayspresent = True; 
                    localdummyoutrayspresent = True; (surfnorm = 1.*Re[{{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = 
                      ({{0., 1., 0.}, {-1., 0., 0.}, {0., 0., 1.}} . #1 & ) \
/@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ dummymatrix; 
                     surfacerotationmatrix = {{0, -1., 0}, {1., 0, 0}, {0, 0, \
1.}}; surfacetranslationvector = {5. + Re[glx], 5. + Re[gly], 0.}; 
                     activeregion = 1.; completedray = {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                       intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                       sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; componentnumber = 
                      newcomponentnumber; surfacenumber = newsurfacenumber; \
surfaceid = newsurfaceid; originalray = {rsx, rsy, rsz, rex, rey, rez, 
                       r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}; ZAxis = \
First[surfnorm]*Sign[First[surfnorm] . {r1, r2, r3}]; raytiltz = 
                      ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; \
If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., raytiltx = 
                       Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - \
ZAxis*raytiltz; If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], 
                      XAxis = XAxis/raytiltx]; YAxis = \
{-(ZAxis[[3]]*XAxis[[2]]) + ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*
                         XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + \
ZAxis[[1]]*XAxis[[2]]}; YAxis = YAxis/Sqrt[YAxis . YAxis]; 
                     PAxis = ZAxis*{r1, r2, r3} . XAxis - XAxis*{r1, r2, r3} \
. ZAxis; PAxis = PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = 
                      {pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = \
normalizedpolarization/Sqrt[normalizedpolarization . 
                         normalizedpolarization]; allcreatedamplitudes = \
{{I*0., I*0., I*0.}}; amplitude = Sqrt[intensity]*
                       (normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*Exp[I*pol3*0.017453292519943295]); 
                     perpendicularamplitude = amplitude . YAxis; \
parallelamplitude = amplitude . PAxis; surftrans = surfacetranslationvector; 
                     surfrot = surfacerotationmatrix; Which[surfaceid == \
272713, localtranslation = {0, 0, 0}; localrotation = {{1, 0, 0}, {0, 1, 0}, 
                         {0, 0, 1}}, surfaceid == 272778, localtranslation = \
{10., 0., 0.}; localrotation = {{1., 0., 0.}, {0., 1., 0.}, 
                         {0., 0., 1.}}, surfaceid == 272521, localtranslation \
= {5., 0., 5.}; localrotation = {{0., 0., 1.}, {0., 1., 0.}, 
                         {-1., 0., 0.}}, surfaceid == 272551, \
localtranslation = {5., 0., -5.}; localrotation = {{0., 0., -1.}, {0., -1., \
0.}, 
                         {-1., 0., 0.}}, surfaceid == 272617, \
localtranslation = {5., 5., 0.}; localrotation = {{0., -1., 0.}, {1., 0., \
0.}, 
                         {0., 0., 1.}}, True, localtranslation = {5., -5., \
0.}; localrotation = {{0., 1., 0.}, {-1., 0., 0.}, {0., 0., 1.}}]; 
                     localpos = surfrot . ({rex, rey, rez} - surftrans); \
localtilt = surfrot . {r1, r2, r3}; localpos = localpos . localrotation + 
                       localtranslation; localtilt = localtilt . \
localrotation; {LocRSx, LocRSy, LocRSz} = localpos; {RTx, LocRTy, LocRTz} = 
                      localtilt; allcreatedrays = {{rsx, rsy, rsz, rex, rey, \
rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                        intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                        sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; originalrotation = 
                      Partition[Take[originalray, {7, 15}], 3]; previoustilt \
= originalrotation[[1]]; transmatrix = MapIndexed[
                       ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, \
r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                           opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                           rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; rotationaxis = Cross[previoustilt, 
                           {r1, r2, r3}]; axismagnitude = Sqrt[rotationaxis . \
rotationaxis]; If[Chop[axismagnitude] != 0., rotationaxis = 
                            rotationaxis/axismagnitude; axismatrix = \
(#1*rotationaxis & ) /@ rotationaxis; crossmatrix = {{0., -rotationaxis[[3]], \

                              rotationaxis[[2]]}, {rotationaxis[[3]], 0., \
-rotationaxis[[1]]}, {-rotationaxis[[2]], rotationaxis[[1]], 0.}}; 
                           cosangle = previoustilt . {r1, r2, r3}; If[1. - \
cosangle < 2.220446049250313*^-16, cosangle = 1.]; sinangle = 
                            1 - cosangle^2; If[sinangle < \
2.220446049250313*^-16, sinangle = 0., sinangle = Sqrt[sinangle]]; axismatrix \
+ 
                            ({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}} - \
axismatrix)*cosangle + crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, 
                            {r7, r8, r9}} = If[Sign[previoustilt . {r1, r2, \
r3}] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, 
                             {0., -1., 0.}, {0., 0., 1.}}]]) & , \
allcreatedrays]; allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, \
r1, r2, 
                           r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, 
                           componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                           intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                             originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                           1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                             {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; \
{{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                         If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                             amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                               0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                             dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                             {pol1, pol2, pol3} = dummyvector]; 1., 1.]; \
{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                          wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                          ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                       allcreatedrays]; (originalray = First[allcreatedrays]; \
completedray = originalray); deflectedrays = allcreatedrays; 
                     newdeflectedrays = {originalray}; Scan[({rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                          intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, 
                          sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        (ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, \
r2, r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                         If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                         If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], \
XAxis = XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                            ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                         YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = \
ZAxis*{r1, r2, r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                          PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                          normalizedpolarization/Sqrt[normalizedpolarization \
. normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                         amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                             Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                         If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = baseIndex - factorX*(LocRSx - xpos)^2 - 
                             factorY*(LocRSy - ypos)^2; index1 = index; \
If[Abs[index2 - index1] < 0.01, alternateindex = Sqrt[1.0005281111748805 - 
                                2.364805676582992*^-10*wavelength^2 + \
2.9781670902982902*^-6/wavelength^2 + 2.6004099469477187*^-8/wavelength^4 + 
                                3.7787839314048715*^-10/wavelength^6 + \
2.830549017940716*^-12/wavelength^8]; If[Abs[alternateindex - index1] > 
                               Abs[index2 - index1], index1 = index2; index2 \
= alternateindex, index1 = alternateindex], index1 = 
                             Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                               2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]], \

                          index2 = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                              2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]; 
                           index1 = index; If[Abs[index2 - index1] < 0.01, \
alternateindex = baseIndex - factorX*(LocRSx - xpos)^2 - factorY*
                                (LocRSy - ypos)^2; If[Abs[alternateindex - \
index1] > Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                              index1 = alternateindex], index1 = baseIndex - \
factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - ypos)^2]]; 
                         n12 = index1/index2; index = index2; If[1 - \
n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + ZAxis*
                              (-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                            phaseshift = phaseshift + 0.5, 1.]; index2 = \
index1; index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                               {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                            dummyvector; 1.]; allcreatedrays = {{rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                            intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, 
                            sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}}; 
                         originalrotation = Partition[Take[originalray, {7, \
15}], 3]; previoustilt = originalrotation[[1]]; transmatrix = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; rotationaxis = 
                              Cross[previoustilt, {r1, r2, r3}]; \
axismagnitude = Sqrt[rotationaxis . rotationaxis]; If[Chop[axismagnitude] != \
0., 
                              rotationaxis = rotationaxis/axismagnitude; \
axismatrix = (#1*rotationaxis & ) /@ rotationaxis; crossmatrix = 
                                {{0., -rotationaxis[[3]], rotationaxis[[2]]}, \
{rotationaxis[[3]], 0., -rotationaxis[[1]]}, {-rotationaxis[[2]], 
                                  rotationaxis[[1]], 0.}}; cosangle = \
previoustilt . {r1, r2, r3}; If[1. - cosangle < 2.220446049250313*^-16, 
                                cosangle = 1.]; sinangle = 1 - cosangle^2; \
If[sinangle < 2.220446049250313*^-16, sinangle = 0., sinangle = 
                                 Sqrt[sinangle]]; axismatrix + ({{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}} - axismatrix)*cosangle + crossmatrix*
                                 sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, \
r8, r9}} = If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., 0., 0.}, 
                                 {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, \
{0., -1., 0.}, {0., 0., 1.}}]]) & , allcreatedrays]; allcreatedrays = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; {{r1, r2, r3}, {r4, r5, r6}, 
                               {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ \
originalrotation][transmatrix[[First[#2]]]]; tiltmagnitude = 
                              {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; 
                               {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; 
                               {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
dummymatrix; 1., 1.]; If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, 
                              amplitude = allcreatedamplitudes[[First[#2]]]; \
hor = {r4, r5, r6} . amplitude; ver = {r7, r8, r9} . amplitude; 
                               If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, \
pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = {pol1, pol2, pol3}/
                                   Sqrt[{pol1, pol2, pol3} . {pol1, pol2, \
pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = ReplacePart[
                                   {pol1, pol2, pol3}, (If[ver == 0., 0., \
Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; {pol1, pol2, pol3} = 
                                  dummyvector]; 1., 1.]; {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                              intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                              frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                           allcreatedrays]); newdeflectedrays = \
Join[newdeflectedrays, allcreatedrays]) & , deflectedrays]; allcreatedrays = 
                      Drop[newdeflectedrays, 1]; deflectedrays = \
allcreatedrays; newdeflectedrays = {originalray}; 
                     Scan[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, \
r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; (ZAxis = First[surfnorm]*Sign[First[surfnorm] . 
                             {r1, r2, r3}]; raytiltz = ZAxis . {r1, r2, r3}; \
raytiltx = 1 - raytiltz^2; If[raytiltx < 2.220446049250313*^-16, 
                          raytiltx = 0., raytiltx = Sqrt[raytiltx]]; XAxis = \
{r1, r2, r3} - ZAxis*raytiltz; If[Abs[raytiltx] < 1.*^-7, 
                          XAxis = surfnorm[[2]], XAxis = XAxis/raytiltx]; \
YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + ZAxis[[2]]*XAxis[[3]], 
                           ZAxis[[3]]*XAxis[[1]] - ZAxis[[1]]*XAxis[[3]], \
-(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; YAxis = 
                          YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = PAxis/
                           Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                          normalizedpolarization/Sqrt[normalizedpolarization \
. normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                         amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                             Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                         surftrans = surfacetranslationvector; surfrot = \
surfacerotationmatrix; Which[surfaceid == 272713, localtranslation = 
                            {0, 0, 0}; localrotation = {{1, 0, 0}, {0, 1, 0}, \
{0, 0, 1}}, surfaceid == 272778, localtranslation = {10., 0., 0.}; 
                           localrotation = {{1., 0., 0.}, {0., 1., 0.}, {0., \
0., 1.}}, surfaceid == 272521, localtranslation = {5., 0., 5.}; 
                           localrotation = {{0., 0., 1.}, {0., 1., 0.}, {-1., \
0., 0.}}, surfaceid == 272551, localtranslation = {5., 0., -5.}; 
                           localrotation = {{0., 0., -1.}, {0., -1., 0.}, \
{-1., 0., 0.}}, surfaceid == 272617, localtranslation = {5., 5., 0.}; 
                           localrotation = {{0., -1., 0.}, {1., 0., 0.}, {0., \
0., 1.}}, True, localtranslation = {5., -5., 0.}; localrotation = 
                            {{0., 1., 0.}, {-1., 0., 0.}, {0., 0., 1.}}]; \
localopticallength = 0.; localraylength = 0.; integratedrefractiveindex = 
                          0.; localpos = surfrot . ({rex, rey, rez} - \
surftrans); localtilt = surfrot . {r1, r2, r3}; If[activeregion*localtilt[[
                             1]] > 0, {LocRSx, LocRSy, LocRSz} = localpos; \
localpos = localpos . localrotation + localtranslation; localtilt = 
                            localtilt . localrotation; {LocRSx, LocRSy, \
LocRSz} = localpos; localindex = index; localindex = baseIndex - 
                             factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - \
ypos)^2; listofpositions = {{LocRSx, LocRSy, LocRSz}}; listoftilts = 
                            {{RTx, LocRTy, LocRTz}}; indexpoints = \
{localindex}; opticallengths = {opticallength}; {RTx, LocRTy, LocRTz} = \
localtilt; 
                           localtilt = localindex*localtilt; Ninitial = \
localindex^2; Sinitial = 0.1^2*{-2*baseIndex*factorX*LocRSx + 2*factorX^2*
                                 LocRSx^3 + 2*factorX*factorY*LocRSx*LocRSy^2 \
+ 2*baseIndex*factorX*xpos - 6*factorX^2*LocRSx^2*xpos - 2*factorX*
                                 factorY*LocRSy^2*xpos + \
6*factorX^2*LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 
                                4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*LocRSx*ypos^2 - 2*factorX*factorY*xpos*ypos^2, 
                               -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*
                                 LocRSy*xpos + \
2*factorX*factorY*LocRSy*xpos^2 + 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 
                                6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*
                                 ypos^2 - 2*factorY^2*ypos^3, 0} . localtilt; \
rSxOffset = 0.; While[(Plus[10.]) - (LocRSx - rSxOffset) >= 
                              -0.01*0.1 && Plus[LocRSx - rSxOffset] >= \
-0.01*0.1 && (0.99999*LocRSy <= 5. && 0.99999*LocRSy >= -5. && 
                              0.99999*LocRSz >= -5. && 0.99999*LocRSz <= 5.), \
localraylength = (localraylength + Sqrt[#1 . #1] & )[localpos - 
                                {LocRSx, LocRSy, LocRSz}]; localpos = \
{LocRSx, LocRSy, LocRSz}; AppendTo[listofpositions, {LocRSx, LocRSy, \
LocRSz}]; 
                             AppendTo[listoftilts, {RTx, LocRTy, LocRTz}]; \
localindex = baseIndex - factorX*(LocRSx - xpos)^2 - factorY*
                                (LocRSy - ypos)^2; AppendTo[indexpoints, \
localindex]; opticallengths = Append[opticallengths, Last[opticallengths] + 
                                localindex*0.1]; integratedrefractiveindex = \
integratedrefractiveindex + localindex^2; localtilt = localindex*
                               {RTx, LocRTy, LocRTz}; Aelement = \
0.1*{-2*baseIndex*factorX*LocRSx + 2*factorX^2*LocRSx^3 + \
2*factorX*factorY*LocRSx*
                                  LocRSy^2 + 2*baseIndex*factorX*xpos - \
6*factorX^2*LocRSx^2*xpos - 2*factorX*factorY*LocRSy^2*xpos + 6*factorX^2*
                                  LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 4*factorX*factorY*LocRSy*xpos*ypos + 
                                 2*factorX*factorY*LocRSx*ypos^2 - \
2*factorX*factorY*xpos*ypos^2, -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*
                                  LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*LocRSy*xpos + 2*factorX*factorY*LocRSy*xpos^2 + 
                                 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*
                                  xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*ypos^2 - 2*factorY^2*ypos^3, 0}; {LocRSx, LocRSy, 
                               LocRSz} = localpos + (0.1*localtilt)/2. + \
(0.1*Aelement)/8.; Belement = 0.1*{-2*baseIndex*factorX*LocRSx + 
                                 2*factorX^2*LocRSx^3 + \
2*factorX*factorY*LocRSx*LocRSy^2 + 2*baseIndex*factorX*xpos - \
6*factorX^2*LocRSx^2*xpos - 
                                 2*factorX*factorY*LocRSy^2*xpos + \
6*factorX^2*LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*
                                  ypos + 4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*LocRSx*ypos^2 - 2*factorX*factorY*xpos*ypos^2, 
                                -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*
                                  LocRSy*xpos + \
2*factorX*factorY*LocRSy*xpos^2 + 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 
                                 6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*
                                  ypos^2 - 2*factorY^2*ypos^3, 0}; {LocRSx, \
LocRSy, LocRSz} = localpos + 0.1*localtilt + (0.1*Belement)/2; 
                             Celement = 0.1*{-2*baseIndex*factorX*LocRSx + \
2*factorX^2*LocRSx^3 + 2*factorX*factorY*LocRSx*LocRSy^2 + 2*baseIndex*
                                  factorX*xpos - 6*factorX^2*LocRSx^2*xpos - \
2*factorX*factorY*LocRSy^2*xpos + 6*factorX^2*LocRSx*xpos^2 - 
                                 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*
                                  LocRSx*ypos^2 - \
2*factorX*factorY*xpos*ypos^2, -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 
                                 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*LocRSy*xpos + 2*factorX*factorY*LocRSy*xpos^2 + \
2*baseIndex*factorY*
                                  ypos - 2*factorX*factorY*LocRSx^2*ypos - \
6*factorY^2*LocRSy^2*ypos + 4*factorX*factorY*LocRSx*xpos*ypos - 
                                 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*ypos^2 - 2*factorY^2*ypos^3, 0}; newpos = localpos + 
                               0.1*(localtilt + (Aelement + 2*Belement)/6); \
newtilt = localtilt + (Aelement + 4.*Aelement + Celement)/6.; 
                             newtilt = newtilt/Sqrt[newtilt . newtilt]; \
{LocRSx, LocRSy, LocRSz} = newpos; {RTx, LocRTy, LocRTz} = newtilt; 1.]; 
                           integratedrefractiveindex = \
integratedrefractiveindex - localindex^2; {LocRSx, LocRSy, LocRSz} = \
localpos; 
                           Sfinal = 0.1*Aelement . localtilt; Nfinal = \
localindex^2; localtilt = localtilt/Sqrt[localtilt . localtilt]; 
                           {RTx, LocRTy, LocRTz} = localtilt; \
localopticallength = 0.1*integratedrefractiveindex - (Sfinal - Sinitial)/6 + 
                             (0.1*(Nfinal - Ninitial))/2; opticallength = \
opticallength + localopticallength; ray1 = localraylength; localpos = 
                            localrotation . (localpos - localtranslation); \
{rex, rey, rez} = localpos . surfrot + surftrans; localtilt = 
                            localrotation . localtilt; {r1, r2, r3} = \
localtilt . surfrot; {rsx, rsy, rsz} = {rex, rey, rez}; index = baseIndex - 
                             factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - \
ypos)^2; allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, 
                              r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                              surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                              intersectionnumber, pol1, pol2, pol3}}; \
listofpositions = (localrotation . (#1 - localtranslation) & ) /@ 
                             listofpositions; listofpositions = (#1 . surfrot \
+ surftrans & ) /@ listofpositions; listoftilts = 
                            (#1/Sqrt[#1 . #1] & ) /@ listoftilts; listoftilts \
= (#1 . surfrot & ) /@ listoftilts; If[reportedrayspresent && 
                             Length[indexpoints] > 1, reportedrays = \
Join[reportedrays, Table[{rsx, rsy, rsz} = listofpositions[[ninteger]]; 
                                 {rex, rey, rez} = listofpositions[[ninteger \
+ 1]]; {r1, r2, r3} = listoftilts[[ninteger]]; ray1 = 0.1; index = 
                                  indexpoints[[ninteger]]; opticallength = \
opticallengths[[ninteger]]; {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, 
                                  r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                                  surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                                  intersectionnumber, pol1, pol2, pol3}, \
{ninteger, 1, Length[indexpoints] - 1}]]; 1., 1.]; allcreatedrays, 
                          allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, \
r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, 
                             ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                             sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}]; originalrotation = Partition[
                           Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                           ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                               opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, 
                               sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; rotationaxis = \
Cross[previoustilt, 
                               {r1, r2, r3}]; axismagnitude = \
Sqrt[rotationaxis . rotationaxis]; If[Chop[axismagnitude] != 0., rotationaxis \
= 
                                rotationaxis/axismagnitude; axismatrix = \
(#1*rotationaxis & ) /@ rotationaxis; crossmatrix = {{0., -rotationaxis[[
                                    3]], rotationaxis[[2]]}, \
{rotationaxis[[3]], 0., -rotationaxis[[1]]}, {-rotationaxis[[2]], \
rotationaxis[[1]], 
                                  0.}}; cosangle = previoustilt . {r1, r2, \
r3}; If[1. - cosangle < 2.220446049250313*^-16, cosangle = 1.]; 
                               sinangle = 1 - cosangle^2; If[sinangle < \
2.220446049250313*^-16, sinangle = 0., sinangle = Sqrt[sinangle]]; 
                               axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, \
{0., 0., 1.}} - axismatrix)*cosangle + crossmatrix*sinangle, 
                              {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., 0., 0.}, {0., 1., 0.}, 
                                 {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., \
0.}, {0., 0., 1.}}]]) & , allcreatedrays]; allcreatedrays = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; {{r1, r2, r3}, {r4, r5, r6}, 
                               {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ \
originalrotation][transmatrix[[First[#2]]]]; tiltmagnitude = 
                              {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; 
                               {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; 
                               {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
dummymatrix; 1., 1.]; If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, 
                              amplitude = allcreatedamplitudes[[First[#2]]]; \
hor = {r4, r5, r6} . amplitude; ver = {r7, r8, r9} . amplitude; 
                               If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, \
pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = {pol1, pol2, pol3}/
                                   Sqrt[{pol1, pol2, pol3} . {pol1, pol2, \
pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = ReplacePart[
                                   {pol1, pol2, pol3}, (If[ver == 0., 0., \
Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; {pol1, pol2, pol3} = 
                                  dummyvector]; 1., 1.]; {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                              intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                              frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                           allcreatedrays]); newdeflectedrays = \
Join[newdeflectedrays, allcreatedrays]) & , deflectedrays]; allcreatedrays = 
                      Drop[newdeflectedrays, 1]; deflectedrays = \
allcreatedrays; deflectedrays = MapIndexed[ReplacePart[#1, First[#2], 34] & , \

                       allcreatedrays]; allcreatedrays = deflectedrays); \
{allcreatedrays, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                       1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., \
-1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}, 
                     {completedray}}, resonatenumber == 6, {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                      intensityscale, ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, 
                      sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; index1 = index; xunit = r2; 
                    yunit = -1.*r1; zunit = r3; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = 
                     (xunit^2 + yunit^2 + zunit^2)^2^(-1); xunit = \
xunit/magnitude; yunit = yunit/magnitude; zunit = zunit/magnitude; 
                    rx = 5. + rey - 1.*Re[gly]; ry = -1.*(-5. + rex - \
1.*Re[glx]); rz = rez; rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; 
                    terminatedeflection = False; intersections = {{-1., 0., \
0.}}; intersections = resonateintersections; 
                    holeQ = holeQlist[[resonatenumber]] == 1; \
{newcomponentnumber, newsurfacenumber, newsurfaceid} = {1., 6., 272683.}; 
                    {componentnumber, surfacenumber, surfaceid} = {1., 6., \
272683.}; {ray1, ray2, ray3} = intersections[[1]]; rsx = rex; rsy = rey; 
                    rsz = rez; rxhlp = rx + ray1*xunit; ryhlp = ry + \
ray1*yunit; rzhlp = rz + ray1*zunit; rex = 5. - 1.*ryhlp + Re[glx]; 
                    rey = -5. + rxhlp + Re[gly]; rez = rzhlp; rex = \
Chop[rex]; rey = Chop[rey]; rez = Chop[rez]; intersectionnumber = 
                     intersectionnumber + 1.; opticallength = opticallength + \
ray1*index1; completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, 
                      r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                      surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, 
                      pol1, pol2, pol3}; reportedrayspresent = True; \
intersectionspresent = True; deflectedrayspresent = True; 
                    localdummyoutrayspresent = True; (surfnorm = 1.*Re[{{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = 
                      ({{0., -1., 0.}, {1., 0., 0.}, {0., 0., 1.}} . #1 & ) \
/@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ dummymatrix; 
                     surfacerotationmatrix = {{0, 1., 0}, {-1., 0, 0}, {0, 0, \
1.}}; surfacetranslationvector = {5. + Re[glx], -5. + Re[gly], 0.}; 
                     activeregion = 1.; completedray = {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                       intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                       sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; componentnumber = 
                      newcomponentnumber; surfacenumber = newsurfacenumber; \
surfaceid = newsurfaceid; originalray = {rsx, rsy, rsz, rex, rey, rez, 
                       r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}; ZAxis = \
First[surfnorm]*Sign[First[surfnorm] . {r1, r2, r3}]; raytiltz = 
                      ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; \
If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., raytiltx = 
                       Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - \
ZAxis*raytiltz; If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], 
                      XAxis = XAxis/raytiltx]; YAxis = \
{-(ZAxis[[3]]*XAxis[[2]]) + ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*
                         XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + \
ZAxis[[1]]*XAxis[[2]]}; YAxis = YAxis/Sqrt[YAxis . YAxis]; 
                     PAxis = ZAxis*{r1, r2, r3} . XAxis - XAxis*{r1, r2, r3} \
. ZAxis; PAxis = PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = 
                      {pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = \
normalizedpolarization/Sqrt[normalizedpolarization . 
                         normalizedpolarization]; allcreatedamplitudes = \
{{I*0., I*0., I*0.}}; amplitude = Sqrt[intensity]*
                       (normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*Exp[I*pol3*0.017453292519943295]); 
                     perpendicularamplitude = amplitude . YAxis; \
parallelamplitude = amplitude . PAxis; surftrans = surfacetranslationvector; 
                     surfrot = surfacerotationmatrix; Which[surfaceid == \
272713, localtranslation = {0, 0, 0}; localrotation = {{1, 0, 0}, {0, 1, 0}, 
                         {0, 0, 1}}, surfaceid == 272778, localtranslation = \
{10., 0., 0.}; localrotation = {{1., 0., 0.}, {0., 1., 0.}, 
                         {0., 0., 1.}}, surfaceid == 272521, localtranslation \
= {5., 0., 5.}; localrotation = {{0., 0., 1.}, {0., 1., 0.}, 
                         {-1., 0., 0.}}, surfaceid == 272551, \
localtranslation = {5., 0., -5.}; localrotation = {{0., 0., -1.}, {0., -1., \
0.}, 
                         {-1., 0., 0.}}, surfaceid == 272617, \
localtranslation = {5., 5., 0.}; localrotation = {{0., -1., 0.}, {1., 0., \
0.}, 
                         {0., 0., 1.}}, True, localtranslation = {5., -5., \
0.}; localrotation = {{0., 1., 0.}, {-1., 0., 0.}, {0., 0., 1.}}]; 
                     localpos = surfrot . ({rex, rey, rez} - surftrans); \
localtilt = surfrot . {r1, r2, r3}; localpos = localpos . localrotation + 
                       localtranslation; localtilt = localtilt . \
localrotation; {LocRSx, LocRSy, LocRSz} = localpos; {RTx, LocRTy, LocRTz} = 
                      localtilt; allcreatedrays = {{rsx, rsy, rsz, rex, rey, \
rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                        intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                        sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}; originalrotation = 
                      Partition[Take[originalray, {7, 15}], 3]; previoustilt \
= originalrotation[[1]]; transmatrix = MapIndexed[
                       ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, \
r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                           opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                           rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; rotationaxis = Cross[previoustilt, 
                           {r1, r2, r3}]; axismagnitude = Sqrt[rotationaxis . \
rotationaxis]; If[Chop[axismagnitude] != 0., rotationaxis = 
                            rotationaxis/axismagnitude; axismatrix = \
(#1*rotationaxis & ) /@ rotationaxis; crossmatrix = {{0., -rotationaxis[[3]], \

                              rotationaxis[[2]]}, {rotationaxis[[3]], 0., \
-rotationaxis[[1]]}, {-rotationaxis[[2]], rotationaxis[[1]], 0.}}; 
                           cosangle = previoustilt . {r1, r2, r3}; If[1. - \
cosangle < 2.220446049250313*^-16, cosangle = 1.]; sinangle = 
                            1 - cosangle^2; If[sinangle < \
2.220446049250313*^-16, sinangle = 0., sinangle = Sqrt[sinangle]]; axismatrix \
+ 
                            ({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}} - \
axismatrix)*cosangle + crossmatrix*sinangle, {{r1, r2, r3}, {r4, r5, r6}, 
                            {r7, r8, r9}} = If[Sign[previoustilt . {r1, r2, \
r3}] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, 
                             {0., -1., 0.}, {0., 0., 1.}}]]) & , \
allcreatedrays]; allcreatedrays = MapIndexed[({rsx, rsy, rsz, rex, rey, rez, \
r1, r2, 
                           r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, 
                           componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, oldgenerationnumber, 
                           intersectionnumber, pol1, pol2, pol3} = #1; {{r1, \
r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ 
                             originalrotation][transmatrix[[First[#2]]]]; \
tiltmagnitude = {r1, r2, r3} . {r1, r2, r3}; If[Abs[tiltmagnitude - 1.] > 
                           1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ 
                             {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; \
{{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = dummymatrix; 1., 1.]; 
                         If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, \
amplitude = allcreatedamplitudes[[First[#2]]]; hor = {r4, r5, r6} . 
                             amplitude; ver = {r7, r8, r9} . amplitude; \
If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, pol2, pol3} = {Abs[hor], Abs[ver], 
                               0.}; dummyvector = {pol1, pol2, \
pol3}/Sqrt[{pol1, pol2, pol3} . {pol1, pol2, pol3}]; {pol1, pol2, pol3} = \
dummyvector; 
                             dummyvector = ReplacePart[{pol1, pol2, pol3}, \
(If[ver == 0., 0., Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; 
                             {pol1, pol2, pol3} = dummyvector]; 1., 1.]; \
{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                          wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                          ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                       allcreatedrays]; (originalray = First[allcreatedrays]; \
completedray = originalray); deflectedrays = allcreatedrays; 
                     newdeflectedrays = {originalray}; Scan[({rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                          intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, 
                          sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                        (ZAxis = First[surfnorm]*Sign[First[surfnorm] . {r1, \
r2, r3}]; raytiltz = ZAxis . {r1, r2, r3}; raytiltx = 1 - raytiltz^2; 
                         If[raytiltx < 2.220446049250313*^-16, raytiltx = 0., \
raytiltx = Sqrt[raytiltx]]; XAxis = {r1, r2, r3} - ZAxis*raytiltz; 
                         If[Abs[raytiltx] < 1.*^-7, XAxis = surfnorm[[2]], \
XAxis = XAxis/raytiltx]; YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + 
                            ZAxis[[2]]*XAxis[[3]], ZAxis[[3]]*XAxis[[1]] - \
ZAxis[[1]]*XAxis[[3]], -(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; 
                         YAxis = YAxis/Sqrt[YAxis . YAxis]; PAxis = \
ZAxis*{r1, r2, r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = 
                          PAxis/Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                          normalizedpolarization/Sqrt[normalizedpolarization \
. normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                         amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                             Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                         If[activeregion*(surfacerotationmatrix . {r1, r2, \
r3})[[1]] > 0, index2 = baseIndex - factorX*(LocRSx - xpos)^2 - 
                             factorY*(LocRSy - ypos)^2; index1 = index; \
If[Abs[index2 - index1] < 0.01, alternateindex = Sqrt[1.0005281111748805 - 
                                2.364805676582992*^-10*wavelength^2 + \
2.9781670902982902*^-6/wavelength^2 + 2.6004099469477187*^-8/wavelength^4 + 
                                3.7787839314048715*^-10/wavelength^6 + \
2.830549017940716*^-12/wavelength^8]; If[Abs[alternateindex - index1] > 
                               Abs[index2 - index1], index1 = index2; index2 \
= alternateindex, index1 = alternateindex], index1 = 
                             Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                               2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]], \

                          index2 = Sqrt[1.0005281111748805 - \
2.364805676582992*^-10*wavelength^2 + 2.9781670902982902*^-6/wavelength^2 + 
                              2.6004099469477187*^-8/wavelength^4 + \
3.7787839314048715*^-10/wavelength^6 + 2.830549017940716*^-12/wavelength^8]; 
                           index1 = index; If[Abs[index2 - index1] < 0.01, \
alternateindex = baseIndex - factorX*(LocRSx - xpos)^2 - factorY*
                                (LocRSy - ypos)^2; If[Abs[alternateindex - \
index1] > Abs[index2 - index1], index1 = index2; index2 = alternateindex, 
                              index1 = alternateindex], index1 = baseIndex - \
factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - ypos)^2]]; 
                         n12 = index1/index2; index = index2; If[1 - \
n12^2*raytiltx^2 >= 0., dummyvector = n12*{r1, r2, r3} + ZAxis*
                              (-(n12*raytiltz) + Sqrt[1 - n12^2*raytiltx^2]); \
{r1, r2, r3} = dummyvector; 1., If[{r1, r2, r3} . surfnorm[[1]] > 0, 
                            phaseshift = phaseshift + 0.5, 1.]; index2 = \
index1; index = index1; dummyvector = {r1, r2, r3} - 2*ZAxis*ZAxis . 
                               {r1, r2, r3}; {r1, r2, r3} = dummyvector; \
dummyvector = {pol1, pol2, pol3} + {0, 0, -180}; {pol1, pol2, pol3} = 
                            dummyvector; 1.]; allcreatedrays = {{rsx, rsy, \
rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                            intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, \
ray3, 
                            sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}}; 
                         originalrotation = Partition[Take[originalray, {7, \
15}], 3]; previoustilt = originalrotation[[1]]; transmatrix = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; rotationaxis = 
                              Cross[previoustilt, {r1, r2, r3}]; \
axismagnitude = Sqrt[rotationaxis . rotationaxis]; If[Chop[axismagnitude] != \
0., 
                              rotationaxis = rotationaxis/axismagnitude; \
axismatrix = (#1*rotationaxis & ) /@ rotationaxis; crossmatrix = 
                                {{0., -rotationaxis[[3]], rotationaxis[[2]]}, \
{rotationaxis[[3]], 0., -rotationaxis[[1]]}, {-rotationaxis[[2]], 
                                  rotationaxis[[1]], 0.}}; cosangle = \
previoustilt . {r1, r2, r3}; If[1. - cosangle < 2.220446049250313*^-16, 
                                cosangle = 1.]; sinangle = 1 - cosangle^2; \
If[sinangle < 2.220446049250313*^-16, sinangle = 0., sinangle = 
                                 Sqrt[sinangle]]; axismatrix + ({{1., 0., \
0.}, {0., 1., 0.}, {0., 0., 1.}} - axismatrix)*cosangle + crossmatrix*
                                 sinangle, {{r1, r2, r3}, {r4, r5, r6}, {r7, \
r8, r9}} = If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., 0., 0.}, 
                                 {0., 1., 0.}, {0., 0., 1.}}, {{-1., 0., 0.}, \
{0., -1., 0.}, {0., 0., 1.}}]]) & , allcreatedrays]; allcreatedrays = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; {{r1, r2, r3}, {r4, r5, r6}, 
                               {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ \
originalrotation][transmatrix[[First[#2]]]]; tiltmagnitude = 
                              {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; 
                               {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; 
                               {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
dummymatrix; 1., 1.]; If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, 
                              amplitude = allcreatedamplitudes[[First[#2]]]; \
hor = {r4, r5, r6} . amplitude; ver = {r7, r8, r9} . amplitude; 
                               If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, \
pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = {pol1, pol2, pol3}/
                                   Sqrt[{pol1, pol2, pol3} . {pol1, pol2, \
pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = ReplacePart[
                                   {pol1, pol2, pol3}, (If[ver == 0., 0., \
Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; {pol1, pol2, pol3} = 
                                  dummyvector]; 1., 1.]; {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                              intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                              frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                           allcreatedrays]); newdeflectedrays = \
Join[newdeflectedrays, allcreatedrays]) & , deflectedrays]; allcreatedrays = 
                      Drop[newdeflectedrays, 1]; deflectedrays = \
allcreatedrays; newdeflectedrays = {originalray}; 
                     Scan[({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, \
r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                          opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                          rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; (ZAxis = First[surfnorm]*Sign[First[surfnorm] . 
                             {r1, r2, r3}]; raytiltz = ZAxis . {r1, r2, r3}; \
raytiltx = 1 - raytiltz^2; If[raytiltx < 2.220446049250313*^-16, 
                          raytiltx = 0., raytiltx = Sqrt[raytiltx]]; XAxis = \
{r1, r2, r3} - ZAxis*raytiltz; If[Abs[raytiltx] < 1.*^-7, 
                          XAxis = surfnorm[[2]], XAxis = XAxis/raytiltx]; \
YAxis = {-(ZAxis[[3]]*XAxis[[2]]) + ZAxis[[2]]*XAxis[[3]], 
                           ZAxis[[3]]*XAxis[[1]] - ZAxis[[1]]*XAxis[[3]], \
-(ZAxis[[2]]*XAxis[[1]]) + ZAxis[[1]]*XAxis[[2]]}; YAxis = 
                          YAxis/Sqrt[YAxis . YAxis]; PAxis = ZAxis*{r1, r2, \
r3} . XAxis - XAxis*{r1, r2, r3} . ZAxis; PAxis = PAxis/
                           Sqrt[PAxis . PAxis]; normalizedpolarization = \
{pol1, pol2, pol3}[[{1, 2}]]; normalizedpolarization = 
                          normalizedpolarization/Sqrt[normalizedpolarization \
. normalizedpolarization]; allcreatedamplitudes = {{I*0., I*0., I*0.}}; 
                         amplitude = \
Sqrt[intensity]*(normalizedpolarization[[1]]*{r4, r5, r6} + \
normalizedpolarization[[2]]*{r7, r8, r9}*
                             Exp[I*pol3*0.017453292519943295]); \
perpendicularamplitude = amplitude . YAxis; parallelamplitude = amplitude . \
PAxis; 
                         surftrans = surfacetranslationvector; surfrot = \
surfacerotationmatrix; Which[surfaceid == 272713, localtranslation = 
                            {0, 0, 0}; localrotation = {{1, 0, 0}, {0, 1, 0}, \
{0, 0, 1}}, surfaceid == 272778, localtranslation = {10., 0., 0.}; 
                           localrotation = {{1., 0., 0.}, {0., 1., 0.}, {0., \
0., 1.}}, surfaceid == 272521, localtranslation = {5., 0., 5.}; 
                           localrotation = {{0., 0., 1.}, {0., 1., 0.}, {-1., \
0., 0.}}, surfaceid == 272551, localtranslation = {5., 0., -5.}; 
                           localrotation = {{0., 0., -1.}, {0., -1., 0.}, \
{-1., 0., 0.}}, surfaceid == 272617, localtranslation = {5., 5., 0.}; 
                           localrotation = {{0., -1., 0.}, {1., 0., 0.}, {0., \
0., 1.}}, True, localtranslation = {5., -5., 0.}; localrotation = 
                            {{0., 1., 0.}, {-1., 0., 0.}, {0., 0., 1.}}]; \
localopticallength = 0.; localraylength = 0.; integratedrefractiveindex = 
                          0.; localpos = surfrot . ({rex, rey, rez} - \
surftrans); localtilt = surfrot . {r1, r2, r3}; If[activeregion*localtilt[[
                             1]] > 0, {LocRSx, LocRSy, LocRSz} = localpos; \
localpos = localpos . localrotation + localtranslation; localtilt = 
                            localtilt . localrotation; {LocRSx, LocRSy, \
LocRSz} = localpos; localindex = index; localindex = baseIndex - 
                             factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - \
ypos)^2; listofpositions = {{LocRSx, LocRSy, LocRSz}}; listoftilts = 
                            {{RTx, LocRTy, LocRTz}}; indexpoints = \
{localindex}; opticallengths = {opticallength}; {RTx, LocRTy, LocRTz} = \
localtilt; 
                           localtilt = localindex*localtilt; Ninitial = \
localindex^2; Sinitial = 0.1^2*{-2*baseIndex*factorX*LocRSx + 2*factorX^2*
                                 LocRSx^3 + 2*factorX*factorY*LocRSx*LocRSy^2 \
+ 2*baseIndex*factorX*xpos - 6*factorX^2*LocRSx^2*xpos - 2*factorX*
                                 factorY*LocRSy^2*xpos + \
6*factorX^2*LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 
                                4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*LocRSx*ypos^2 - 2*factorX*factorY*xpos*ypos^2, 
                               -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*
                                 LocRSy*xpos + \
2*factorX*factorY*LocRSy*xpos^2 + 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 
                                6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*
                                 ypos^2 - 2*factorY^2*ypos^3, 0} . localtilt; \
rSxOffset = 0.; While[(Plus[10.]) - (LocRSx - rSxOffset) >= 
                              -0.01*0.1 && Plus[LocRSx - rSxOffset] >= \
-0.01*0.1 && (0.99999*LocRSy <= 5. && 0.99999*LocRSy >= -5. && 
                              0.99999*LocRSz >= -5. && 0.99999*LocRSz <= 5.), \
localraylength = (localraylength + Sqrt[#1 . #1] & )[localpos - 
                                {LocRSx, LocRSy, LocRSz}]; localpos = \
{LocRSx, LocRSy, LocRSz}; AppendTo[listofpositions, {LocRSx, LocRSy, \
LocRSz}]; 
                             AppendTo[listoftilts, {RTx, LocRTy, LocRTz}]; \
localindex = baseIndex - factorX*(LocRSx - xpos)^2 - factorY*
                                (LocRSy - ypos)^2; AppendTo[indexpoints, \
localindex]; opticallengths = Append[opticallengths, Last[opticallengths] + 
                                localindex*0.1]; integratedrefractiveindex = \
integratedrefractiveindex + localindex^2; localtilt = localindex*
                               {RTx, LocRTy, LocRTz}; Aelement = \
0.1*{-2*baseIndex*factorX*LocRSx + 2*factorX^2*LocRSx^3 + \
2*factorX*factorY*LocRSx*
                                  LocRSy^2 + 2*baseIndex*factorX*xpos - \
6*factorX^2*LocRSx^2*xpos - 2*factorX*factorY*LocRSy^2*xpos + 6*factorX^2*
                                  LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 4*factorX*factorY*LocRSy*xpos*ypos + 
                                 2*factorX*factorY*LocRSx*ypos^2 - \
2*factorX*factorY*xpos*ypos^2, -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*
                                  LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*LocRSy*xpos + 2*factorX*factorY*LocRSy*xpos^2 + 
                                 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*
                                  xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*ypos^2 - 2*factorY^2*ypos^3, 0}; {LocRSx, LocRSy, 
                               LocRSz} = localpos + (0.1*localtilt)/2. + \
(0.1*Aelement)/8.; Belement = 0.1*{-2*baseIndex*factorX*LocRSx + 
                                 2*factorX^2*LocRSx^3 + \
2*factorX*factorY*LocRSx*LocRSy^2 + 2*baseIndex*factorX*xpos - \
6*factorX^2*LocRSx^2*xpos - 
                                 2*factorX*factorY*LocRSy^2*xpos + \
6*factorX^2*LocRSx*xpos^2 - 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*
                                  ypos + 4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*LocRSx*ypos^2 - 2*factorX*factorY*xpos*ypos^2, 
                                -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*
                                  LocRSy*xpos + \
2*factorX*factorY*LocRSy*xpos^2 + 2*baseIndex*factorY*ypos - \
2*factorX*factorY*LocRSx^2*ypos - 
                                 6*factorY^2*LocRSy^2*ypos + \
4*factorX*factorY*LocRSx*xpos*ypos - 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*
                                  ypos^2 - 2*factorY^2*ypos^3, 0}; {LocRSx, \
LocRSy, LocRSz} = localpos + 0.1*localtilt + (0.1*Belement)/2; 
                             Celement = 0.1*{-2*baseIndex*factorX*LocRSx + \
2*factorX^2*LocRSx^3 + 2*factorX*factorY*LocRSx*LocRSy^2 + 2*baseIndex*
                                  factorX*xpos - 6*factorX^2*LocRSx^2*xpos - \
2*factorX*factorY*LocRSy^2*xpos + 6*factorX^2*LocRSx*xpos^2 - 
                                 2*factorX^2*xpos^3 - \
4*factorX*factorY*LocRSx*LocRSy*ypos + 4*factorX*factorY*LocRSy*xpos*ypos + \
2*factorX*factorY*
                                  LocRSx*ypos^2 - \
2*factorX*factorY*xpos*ypos^2, -2*baseIndex*factorY*LocRSy + \
2*factorX*factorY*LocRSx^2*LocRSy + 
                                 2*factorY^2*LocRSy^3 - \
4*factorX*factorY*LocRSx*LocRSy*xpos + 2*factorX*factorY*LocRSy*xpos^2 + \
2*baseIndex*factorY*
                                  ypos - 2*factorX*factorY*LocRSx^2*ypos - \
6*factorY^2*LocRSy^2*ypos + 4*factorX*factorY*LocRSx*xpos*ypos - 
                                 2*factorX*factorY*xpos^2*ypos + \
6*factorY^2*LocRSy*ypos^2 - 2*factorY^2*ypos^3, 0}; newpos = localpos + 
                               0.1*(localtilt + (Aelement + 2*Belement)/6); \
newtilt = localtilt + (Aelement + 4.*Aelement + Celement)/6.; 
                             newtilt = newtilt/Sqrt[newtilt . newtilt]; \
{LocRSx, LocRSy, LocRSz} = newpos; {RTx, LocRTy, LocRTz} = newtilt; 1.]; 
                           integratedrefractiveindex = \
integratedrefractiveindex - localindex^2; {LocRSx, LocRSy, LocRSz} = \
localpos; 
                           Sfinal = 0.1*Aelement . localtilt; Nfinal = \
localindex^2; localtilt = localtilt/Sqrt[localtilt . localtilt]; 
                           {RTx, LocRTy, LocRTz} = localtilt; \
localopticallength = 0.1*integratedrefractiveindex - (Sfinal - Sinitial)/6 + 
                             (0.1*(Nfinal - Ninitial))/2; opticallength = \
opticallength + localopticallength; ray1 = localraylength; localpos = 
                            localrotation . (localpos - localtranslation); \
{rex, rey, rez} = localpos . surfrot + surftrans; localtilt = 
                            localrotation . localtilt; {r1, r2, r3} = \
localtilt . surfrot; {rsx, rsy, rsz} = {rex, rey, rez}; index = baseIndex - 
                             factorX*(LocRSx - xpos)^2 - factorY*(LocRSy - \
ypos)^2; allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, 
                              r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                              surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                              intersectionnumber, pol1, pol2, pol3}}; \
listofpositions = (localrotation . (#1 - localtranslation) & ) /@ 
                             listofpositions; listofpositions = (#1 . surfrot \
+ surftrans & ) /@ listofpositions; listoftilts = 
                            (#1/Sqrt[#1 . #1] & ) /@ listoftilts; listoftilts \
= (#1 . surfrot & ) /@ listoftilts; If[reportedrayspresent && 
                             Length[indexpoints] > 1, reportedrays = \
Join[reportedrays, Table[{rsx, rsy, rsz} = listofpositions[[ninteger]]; 
                                 {rex, rey, rez} = listofpositions[[ninteger \
+ 1]]; {r1, r2, r3} = listoftilts[[ninteger]]; ray1 = 0.1; index = 
                                  indexpoints[[ninteger]]; opticallength = \
opticallengths[[ninteger]]; {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, 
                                  r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                                  surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                                  intersectionnumber, pol1, pol2, pol3}, \
{ninteger, 1, Length[indexpoints] - 1}]]; 1., 1.]; allcreatedrays, 
                          allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, \
r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, 
                             ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                             sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}]; originalrotation = Partition[
                           Take[originalray, {7, 15}], 3]; previoustilt = \
originalrotation[[1]]; transmatrix = MapIndexed[
                           ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, \
r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                               opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, 
                               sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; rotationaxis = \
Cross[previoustilt, 
                               {r1, r2, r3}]; axismagnitude = \
Sqrt[rotationaxis . rotationaxis]; If[Chop[axismagnitude] != 0., rotationaxis \
= 
                                rotationaxis/axismagnitude; axismatrix = \
(#1*rotationaxis & ) /@ rotationaxis; crossmatrix = {{0., -rotationaxis[[
                                    3]], rotationaxis[[2]]}, \
{rotationaxis[[3]], 0., -rotationaxis[[1]]}, {-rotationaxis[[2]], \
rotationaxis[[1]], 
                                  0.}}; cosangle = previoustilt . {r1, r2, \
r3}; If[1. - cosangle < 2.220446049250313*^-16, cosangle = 1.]; 
                               sinangle = 1 - cosangle^2; If[sinangle < \
2.220446049250313*^-16, sinangle = 0., sinangle = Sqrt[sinangle]]; 
                               axismatrix + ({{1., 0., 0.}, {0., 1., 0.}, \
{0., 0., 1.}} - axismatrix)*cosangle + crossmatrix*sinangle, 
                              {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
If[Sign[previoustilt . {r1, r2, r3}] === 1, {{1., 0., 0.}, {0., 1., 0.}, 
                                 {0., 0., 1.}}, {{-1., 0., 0.}, {0., -1., \
0.}, {0., 0., 1.}}]]) & , allcreatedrays]; allcreatedrays = 
                          MapIndexed[({rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                               index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                               sno3, sno4, rayslot, oldgenerationnumber, \
intersectionnumber, pol1, pol2, pol3} = #1; {{r1, r2, r3}, {r4, r5, r6}, 
                               {r7, r8, r9}} = Function[mm, (mm . #1 & ) /@ \
originalrotation][transmatrix[[First[#2]]]]; tiltmagnitude = 
                              {r1, r2, r3} . {r1, r2, r3}; \
If[Abs[tiltmagnitude - 1.] > 1.*^-6, dummyvector = {r1, r2, \
r3}/Sqrt[tiltmagnitude]; 
                               {r1, r2, r3} = dummyvector; dummymatrix = \
(#1/Sqrt[#1 . #1] & ) /@ {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}}; 
                               {{r1, r2, r3}, {r4, r5, r6}, {r7, r8, r9}} = \
dummymatrix; 1., 1.]; If[allcreatedamplitudes != {{I*0., I*0., I*0.}}, 
                              amplitude = allcreatedamplitudes[[First[#2]]]; \
hor = {r4, r5, r6} . amplitude; ver = {r7, r8, r9} . amplitude; 
                               If[Abs[hor] > 0. || Abs[ver] > 0., {pol1, \
pol2, pol3} = {Abs[hor], Abs[ver], 0.}; dummyvector = {pol1, pol2, pol3}/
                                   Sqrt[{pol1, pol2, pol3} . {pol1, pol2, \
pol3}]; {pol1, pol2, pol3} = dummyvector; dummyvector = ReplacePart[
                                   {pol1, pol2, pol3}, (If[ver == 0., 0., \
Arg[ver]] - If[hor == 0., 0., Arg[hor]])/Degree, 3]; {pol1, pol2, pol3} = 
                                  dummyvector]; 1., 1.]; {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                              intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                              frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}) & , 
                           allcreatedrays]); newdeflectedrays = \
Join[newdeflectedrays, allcreatedrays]) & , deflectedrays]; allcreatedrays = 
                      Drop[newdeflectedrays, 1]; deflectedrays = \
allcreatedrays; deflectedrays = MapIndexed[ReplacePart[#1, First[#2], 34] & , \

                       allcreatedrays]; allcreatedrays = deflectedrays); \
{allcreatedrays, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                       1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., \
-1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}, 
                     {completedray}}, True, deflecteddummyrayspresent = True; \
reporteddummyrayspresent = True; localoutrayspresent = True; 
                    {{{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 
                       1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}, {{rsx, \
rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                       intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                       frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}}, {{1., 1., 1., 1., \
1., 1., 
                       1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
-9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 
                       1., 1., 1., 1., 1.}}}], deflecteddummyrayspresent = \
True; reporteddummyrayspresent = True; localdummyoutrayspresent = True; 
                  {{{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}, {{1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 
                     1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1.}}, {{1., 1., 1., 1., 1., 1., 1., 1., 
                     1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., \
1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                     1., 1., 1.}}}]) & ) /@ inrays]; If[deflectedrayspresent \
&& deflecteddummyrayspresent, 
           deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & \
]*1., 1.]; If[localoutrayspresent, 
           If[localdummyoutrayspresent, localoutrays = Select[localoutrays, \
#1[[23]] > 0. & ]; 1., 1.]; outrays = Join[outrays, localoutrays]; 1., 
           1.]; If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
         If[reportedrayspresent, raysreported = True; reportedrays = \
Join[reportedrays, {{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8}}, reportedlocalrays]; 1., 1.]; inrays = deflectedlocalrays; 
         propagate = generationnumber < generationlimit]; propagatedrays = \
If[Length[outrays] > 1, Drop[outrays, 1], outrays]; 
       If[generationnumber >= generationlimit && deflectedrayspresent, \
propagatedrays = Join[propagatedrays, deflectedlocalrays]; 1., 1.]); 
      (inrays = propagatedrays; outrays = {{1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., 
          -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}; \
deflectedrayspresent = True; reportedrayspresent = False; 
       propagate = True; While[deflectedrayspresent && propagate, \
generationnumber += 1.; (deflecteddummyrayspresent = False; 
          deflectedrayspresent = False; reportedrayspresent = False; \
reporteddummyrayspresent = True; localdummyoutrayspresent = False; 
          localoutrayspresent = False; {deflectedlocalrays, localoutrays, \
reportedlocalrays} = (Flatten[#1, 1] & ) /@ 
            Transpose[(({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, \
r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                  opticallength, phaseshift, componentnumber, surfacenumber, \
surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, 
                  oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} \
= #1; If[intensity > thresholdintensity && generationnumber < 
                   generationlimit, (resonatenumber = 0; resonateraylength = \
9.87654321*^8; resonateintersections = {{-1., 0., 0.}}; 
                   MapIndexed[If[#1[[1,1]] > -1. && #1[[1,1]] < \
resonateraylength, resonateraylength = #1[[1,1]]; resonateintersections = #1; \

                       resonatenumber = First[#2], resonatenumber] & , \
intersectionslist = {{{-1., 0., 0.}}}; holeQlist = {0}; 
                     ({rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                        opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                        rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; index1 = index; xunit = -1.*r1; yunit = -1.*r2; 
                      zunit = r3; xunit = Chop[xunit]; yunit = Chop[yunit]; \
zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^2^(-1); 
                      xunit = xunit/magnitude; yunit = yunit/magnitude; zunit \
= zunit/magnitude; rx = -1.*(-40. + rex); ry = -1.*rey; rz = rez; 
                      rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; \
terminatedeflection = False; intersections = {{-1., 0., 0.}}; intersections = \

                       If[Chop[xunit] != 0, {(If[N[Chop[#1[[1]]]] >= 0. && \
(#1[[2]] <= 15. && #1[[2]] >= -15. && #1[[3]] >= -15. && #1[[3]] <= 15.), 
                            {#1[[1]], #1[[2]], #1[[3]]}, {-1., 0., 0.}] & \
)[{-(rx/xunit), ry - (rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, 
                        {{-1., 0., 0.}}]; AppendTo[intersections, {-1., 0., \
0.}]; holeQ = False; If[ !(Chop[surfaceid - 273031.] == 0. || 
                          N[Chop[ray1]] < 0.0001) || generationnumber == 1., \
minresonateraylength = 0., minresonateraylength = 0.0001]; 
                      Block[{LocRayL, LocSCx, LocSCy}, LocRayL = 1.; LocSCx = \
1.; LocSCy = 1.; dummymatrix = Union[Select[intersections, 
                           ({LocRayL, LocSCx, LocSCy} = #1; {LocRayL, LocSCx, \
LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                               minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                      If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]; 
                      AppendTo[intersectionslist, intersections]; If[holeQ, \
AppendTo[holeQlist, 1], AppendTo[holeQlist, 0]]; 
                      {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                        opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                        rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; index1 = index; xunit = r2; yunit = -1.*r1; 
                      zunit = r3; xunit = Chop[xunit]; yunit = Chop[yunit]; \
zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^2^(-1); 
                      xunit = xunit/magnitude; yunit = yunit/magnitude; zunit \
= zunit/magnitude; rx = 15. + rey; ry = -1.*(-20. + rex); rz = rez; 
                      rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; \
terminatedeflection = False; intersections = {{-1., 0., 0.}}; intersections = \

                       If[Chop[xunit] != 0, {(If[N[Chop[#1[[1]]]] >= 0. && \
(#1[[2]] <= 20. && #1[[2]] >= -20. && #1[[3]] >= -15. && #1[[3]] <= 15.), 
                            {#1[[1]], #1[[2]], #1[[3]]}, {-1., 0., 0.}] & \
)[{-(rx/xunit), ry - (rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, 
                        {{-1., 0., 0.}}]; AppendTo[intersections, {-1., 0., \
0.}]; holeQ = False; If[ !(Chop[surfaceid - 273032.] == 0. || 
                          N[Chop[ray1]] < 0.0001) || generationnumber == 1., \
minresonateraylength = 0., minresonateraylength = 0.0001]; 
                      Block[{LocRayL, LocSCx, LocSCy}, LocRayL = 1.; LocSCx = \
1.; LocSCy = 1.; dummymatrix = Union[Select[intersections, 
                           ({LocRayL, LocSCx, LocSCy} = #1; {LocRayL, LocSCx, \
LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                               minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                      If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]; 
                      AppendTo[intersectionslist, intersections]; If[holeQ, \
AppendTo[holeQlist, 1], AppendTo[holeQlist, 0]]; 
                      {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                        opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                        rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; index1 = index; xunit = r1; yunit = r2; zunit = r3; 
                      xunit = Chop[xunit]; yunit = Chop[yunit]; zunit = \
Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^2^(-1); 
                      xunit = xunit/magnitude; yunit = yunit/magnitude; zunit \
= zunit/magnitude; rx = rex; ry = rey; rz = rez; rx = Chop[rx]; 
                      ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = \
False; intersections = {{-1., 0., 0.}}; intersections = 
                       If[Chop[xunit] != 0, {(If[N[Chop[#1[[1]]]] >= 0. && \
(#1[[2]] <= 15. && #1[[2]] >= -15. && #1[[3]] >= -15. && #1[[3]] <= 15.), 
                            {#1[[1]], #1[[2]], #1[[3]]}, {-1., 0., 0.}] & \
)[{-(rx/xunit), ry - (rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, 
                        {{-1., 0., 0.}}]; AppendTo[intersections, {-1., 0., \
0.}]; holeQ = False; If[ !(Chop[surfaceid - 273033.] == 0. || 
                          N[Chop[ray1]] < 0.0001) || generationnumber == 1., \
minresonateraylength = 0., minresonateraylength = 0.0001]; 
                      Block[{LocRayL, LocSCx, LocSCy}, LocRayL = 1.; LocSCx = \
1.; LocSCy = 1.; dummymatrix = Union[Select[intersections, 
                           ({LocRayL, LocSCx, LocSCy} = #1; {LocRayL, LocSCx, \
LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                               minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                      If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]; 
                      AppendTo[intersectionslist, intersections]; If[holeQ, \
AppendTo[holeQlist, 1], AppendTo[holeQlist, 0]]; 
                      {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                        opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                        rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; index1 = index; xunit = -1.*r2; yunit = r1; 
                      zunit = r3; xunit = Chop[xunit]; yunit = Chop[yunit]; \
zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^2^(-1); 
                      xunit = xunit/magnitude; yunit = yunit/magnitude; zunit \
= zunit/magnitude; rx = -1.*(-15. + rey); ry = -20. + rex; rz = rez; 
                      rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; \
terminatedeflection = False; intersections = {{-1., 0., 0.}}; intersections = \

                       If[Chop[xunit] != 0, {(If[N[Chop[#1[[1]]]] >= 0. && \
(#1[[2]] <= 20. && #1[[2]] >= -20. && #1[[3]] >= -15. && #1[[3]] <= 15.), 
                            {#1[[1]], #1[[2]], #1[[3]]}, {-1., 0., 0.}] & \
)[{-(rx/xunit), ry - (rx*yunit)/xunit, rz - (rx*zunit)/xunit}]}, 
                        {{-1., 0., 0.}}]; AppendTo[intersections, {-1., 0., \
0.}]; holeQ = False; If[ !(Chop[surfaceid - 273034.] == 0. || 
                          N[Chop[ray1]] < 0.0001) || generationnumber == 1., \
minresonateraylength = 0., minresonateraylength = 0.0001]; 
                      Block[{LocRayL, LocSCx, LocSCy}, LocRayL = 1.; LocSCx = \
1.; LocSCy = 1.; dummymatrix = Union[Select[intersections, 
                           ({LocRayL, LocSCx, LocSCy} = #1; {LocRayL, LocSCx, \
LocSCy} == {-1., 0., 0.} || N[Chop[LocRayL]] >= 
                               minresonateraylength) & ]]; intersections = \
dummymatrix]; unfilteredintersections = intersections; 
                      If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]; 
                      AppendTo[intersectionslist, intersections]; If[holeQ, \
AppendTo[holeQlist, 1], AppendTo[holeQlist, 0]]; 
                      {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                        opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                        rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; index1 = index; xunit = r3; yunit = r2; 
                      zunit = -1.*r1; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                        2^(-1); xunit = xunit/magnitude; yunit = \
yunit/magnitude; zunit = zunit/magnitude; rx = 15. + rez; ry = rey; 
                      rz = -1.*(-20. + rex); rx = Chop[rx]; ry = Chop[ry]; rz \
= Chop[rz]; terminatedeflection = False; intersections = 
                       {{-1., 0., 0.}}; intersections = If[Chop[xunit] != 0, \
{(If[N[Chop[#1[[1]]]] >= 0. && (#1[[2]] <= 15. && #1[[2]] >= -15. && 
                              #1[[3]] >= -20. && #1[[3]] <= 20.), {#1[[1]], \
#1[[2]], #1[[3]]}, {-1., 0., 0.}] & )[{-(rx/xunit), ry - (rx*yunit)/
                             xunit, rz - (rx*zunit)/xunit}]}, {{-1., 0., \
0.}}]; AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                      If[ !(Chop[surfaceid - 273035.] == 0. || N[Chop[ray1]] \
< 0.0001) || generationnumber == 1., minresonateraylength = 0., 
                       minresonateraylength = 0.0001]; Block[{LocRayL, \
LocSCx, LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                         Union[Select[intersections, ({LocRayL, LocSCx, \
LocSCy} = #1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || 
                              N[Chop[LocRayL]] >= minresonateraylength) & ]]; \
intersections = dummymatrix]; unfilteredintersections = intersections; 
                      If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]; 
                      AppendTo[intersectionslist, intersections]; If[holeQ, \
AppendTo[holeQlist, 1], AppendTo[holeQlist, 0]]; 
                      {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                        opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                        rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; index1 = index; xunit = -1.*r3; yunit = -1.*r2; 
                      zunit = -1.*r1; xunit = Chop[xunit]; yunit = \
Chop[yunit]; zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^
                        2^(-1); xunit = xunit/magnitude; yunit = \
yunit/magnitude; zunit = zunit/magnitude; rx = -1.*(-15. + rez); ry = \
-1.*rey; 
                      rz = -1.*(-20. + rex); rx = Chop[rx]; ry = Chop[ry]; rz \
= Chop[rz]; terminatedeflection = False; intersections = 
                       {{-1., 0., 0.}}; intersections = If[Chop[xunit] != 0, \
{(If[N[Chop[#1[[1]]]] >= 0. && (#1[[2]] <= 15. && #1[[2]] >= -15. && 
                              #1[[3]] >= -20. && #1[[3]] <= 20.), {#1[[1]], \
#1[[2]], #1[[3]]}, {-1., 0., 0.}] & )[{-(rx/xunit), ry - (rx*yunit)/
                             xunit, rz - (rx*zunit)/xunit}]}, {{-1., 0., \
0.}}]; AppendTo[intersections, {-1., 0., 0.}]; holeQ = False; 
                      If[ !(Chop[surfaceid - 273036.] == 0. || N[Chop[ray1]] \
< 0.0001) || generationnumber == 1., minresonateraylength = 0., 
                       minresonateraylength = 0.0001]; Block[{LocRayL, \
LocSCx, LocSCy}, LocRayL = 1.; LocSCx = 1.; LocSCy = 1.; dummymatrix = 
                         Union[Select[intersections, ({LocRayL, LocSCx, \
LocSCy} = #1; {LocRayL, LocSCx, LocSCy} == {-1., 0., 0.} || 
                              N[Chop[LocRayL]] >= minresonateraylength) & ]]; \
intersections = dummymatrix]; unfilteredintersections = intersections; 
                      If[Length[intersections] > 1, dummymatrix = \
Take[intersections, {2}]; intersections = dummymatrix; 1., 1.]; 
                      AppendTo[intersectionslist, intersections]; If[holeQ, \
AppendTo[holeQlist, 1], AppendTo[holeQlist, 0]]); holeQlist = 
                      Drop[holeQlist, 1]; Drop[intersectionslist, 1]]); \
Which[resonatenumber == 1, {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, \

                      r6, r7, r8, r9, wavelength, intensity, intensityscale, \
ray1, index, opticallength, phaseshift, componentnumber, surfacenumber, 
                      surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, \
sno4, rayslot, oldgenerationnumber, intersectionnumber, pol1, pol2, 
                      pol3} = #1; index1 = index; xunit = -1.*r1; yunit = \
-1.*r2; zunit = r3; xunit = Chop[xunit]; yunit = Chop[yunit]; 
                    zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + \
zunit^2)^2^(-1); xunit = xunit/magnitude; yunit = yunit/magnitude; 
                    zunit = zunit/magnitude; rx = -1.*(-40. + rex); ry = \
-1.*rey; rz = rez; rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; 
                    terminatedeflection = False; intersections = {{-1., 0., \
0.}}; intersections = resonateintersections; 
                    holeQ = holeQlist[[resonatenumber]] == 1; \
{newcomponentnumber, newsurfacenumber, newsurfaceid} = {2., 1., 273031.}; 
                    {componentnumber, surfacenumber, surfaceid} = {2., 1., \
273031.}; {ray1, ray2, ray3} = intersections[[1]]; rsx = rex; rsy = rey; 
                    rsz = rez; rxhlp = rx + ray1*xunit; ryhlp = ry + \
ray1*yunit; rzhlp = rz + ray1*zunit; rex = 40. - 1.*rxhlp; rey = -1.*ryhlp; 
                    rez = rzhlp; rex = Chop[rex]; rey = Chop[rey]; rez = \
Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                    opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                      wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                      ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    reportedrayspresent = True; intersectionspresent = True; \
deflectedrayspresent = True; localdummyoutrayspresent = True; 
                    (surfnorm = 1.*Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., \
1.}}]; dummymatrix = ({{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 1.}} . 
                         #1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) \
/@ dummymatrix; surfacerotationmatrix = {{-1., 0, 0}, {0, -1., 0}, 
                       {0, 0, 1.}}; surfacetranslationvector = {40., 0, 0}; \
activeregion = 0.; completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, 
                       r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                       surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, 
                       pol1, pol2, pol3}; componentnumber = \
newcomponentnumber; surfacenumber = newsurfacenumber; surfaceid = \
newsurfaceid; 
                     originalray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, \
r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                       index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                       rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; intensity = 0.; allcreatedrays = {{rsx, rsy, rsz, rex, rey, 
                        rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                        componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                        intersectionnumber, pol1, pol2, pol3}}); \
{allcreatedrays, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 
                       -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}, {completedray}}, 
                   resonatenumber == 2, {rsx, rsy, rsz, rex, rey, rez, r1, \
r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, 
                      ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, 
                      sno4, rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; index1 = index; xunit = r2; yunit = -1.*r1; 
                    zunit = r3; xunit = Chop[xunit]; yunit = Chop[yunit]; \
zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^2^(-1); 
                    xunit = xunit/magnitude; yunit = yunit/magnitude; zunit = \
zunit/magnitude; rx = 15. + rey; ry = -1.*(-20. + rex); rz = rez; 
                    rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; \
terminatedeflection = False; intersections = {{-1., 0., 0.}}; intersections = \

                     resonateintersections; holeQ = \
holeQlist[[resonatenumber]] == 1; {newcomponentnumber, newsurfacenumber, \
newsurfaceid} = 
                     {2., 2., 273032.}; {componentnumber, surfacenumber, \
surfaceid} = {2., 2., 273032.}; {ray1, ray2, ray3} = intersections[[1]]; 
                    rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = 20. - 1.*ryhlp; 
                    rey = -15. + rxhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 1.; 
                    opticallength = opticallength + ray1*index1; completedray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                      wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                      ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    reportedrayspresent = True; intersectionspresent = True; \
deflectedrayspresent = True; localdummyoutrayspresent = True; 
                    (surfnorm = 1.*Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., \
1.}}]; dummymatrix = ({{0., -1., 0.}, {1., 0., 0.}, {0., 0., 1.}} . 
                         #1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) \
/@ dummymatrix; surfacerotationmatrix = {{0, 1., 0}, {-1., 0, 0}, 
                       {0, 0, 1.}}; surfacetranslationvector = {20., -15., \
0}; activeregion = 0.; completedray = {rsx, rsy, rsz, rex, rey, rez, r1, 
                       r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}; componentnumber \
= newcomponentnumber; surfacenumber = newsurfacenumber; 
                     surfaceid = newsurfaceid; originalray = {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                       intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                       frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}; intensity = 0.; 
                     allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, 
                        ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                        sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}); {allcreatedrays, {{1., 1., 1., 1., \
1., 1., 
                       1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
-9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 
                       1., 1., 1., 1., 1.}}, {completedray}}, resonatenumber \
== 3, {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                      wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                      ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                    index1 = index; xunit = r1; yunit = r2; zunit = r3; xunit \
= Chop[xunit]; yunit = Chop[yunit]; zunit = Chop[zunit]; 
                    magnitude = (xunit^2 + yunit^2 + zunit^2)^2^(-1); xunit = \
xunit/magnitude; yunit = yunit/magnitude; zunit = zunit/magnitude; 
                    rx = rex; ry = rey; rz = rez; rx = Chop[rx]; ry = \
Chop[ry]; rz = Chop[rz]; terminatedeflection = False; intersections = 
                     {{-1., 0., 0.}}; intersections = resonateintersections; \
holeQ = holeQlist[[resonatenumber]] == 1; {newcomponentnumber, 
                      newsurfacenumber, newsurfaceid} = {2., 3., 273033.}; \
{componentnumber, surfacenumber, surfaceid} = {2., 3., 273033.}; 
                    {ray1, ray2, ray3} = intersections[[1]]; rsx = rex; rsy = \
rey; rsz = rez; rxhlp = rx + ray1*xunit; ryhlp = ry + ray1*yunit; 
                    rzhlp = rz + ray1*zunit; rex = rxhlp; rey = ryhlp; rez = \
rzhlp; rex = Chop[rex]; rey = Chop[rey]; rez = Chop[rez]; 
                    intersectionnumber = intersectionnumber + 1.; \
opticallength = opticallength + ray1*index1; completedray = {rsx, rsy, rsz, \
rex, 
                      rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, 
                      componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                      intersectionnumber, pol1, pol2, pol3}; \
reportedrayspresent = True; intersectionspresent = True; deflectedrayspresent \
= True; 
                    localdummyoutrayspresent = True; (surfnorm = 1.*Re[{{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = 
                      (#1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) \
/@ dummymatrix; surfacerotationmatrix = {{1, 0, 0}, {0, 1, 0}, 
                       {0, 0, 1}}; surfacetranslationvector = {0, 0, 0}; \
activeregion = 0.; completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, 
                       r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                       surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, 
                       pol1, pol2, pol3}; componentnumber = \
newcomponentnumber; surfacenumber = newsurfacenumber; surfaceid = \
newsurfaceid; 
                     originalray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, \
r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                       index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                       rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; intensity = 0.; allcreatedrays = {{rsx, rsy, rsz, rex, rey, 
                        rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                        componentnumber, surfacenumber, surfaceid, ray2, \
ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                        intersectionnumber, pol1, pol2, pol3}}); \
{allcreatedrays, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 
                       -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}, {completedray}}, 
                   resonatenumber == 4, {rsx, rsy, rsz, rex, rey, rez, r1, \
r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, 
                      ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, sno3, 
                      sno4, rayslot, oldgenerationnumber, intersectionnumber, \
pol1, pol2, pol3} = #1; index1 = index; xunit = -1.*r2; yunit = r1; 
                    zunit = r3; xunit = Chop[xunit]; yunit = Chop[yunit]; \
zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^2^(-1); 
                    xunit = xunit/magnitude; yunit = yunit/magnitude; zunit = \
zunit/magnitude; rx = -1.*(-15. + rey); ry = -20. + rex; rz = rez; 
                    rx = Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; \
terminatedeflection = False; intersections = {{-1., 0., 0.}}; intersections = \

                     resonateintersections; holeQ = \
holeQlist[[resonatenumber]] == 1; {newcomponentnumber, newsurfacenumber, \
newsurfaceid} = 
                     {2., 4., 273034.}; {componentnumber, surfacenumber, \
surfaceid} = {2., 4., 273034.}; {ray1, ray2, ray3} = intersections[[1]]; 
                    rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \
ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = 20. + ryhlp; 
                    rey = 15. - 1.*rxhlp; rez = rzhlp; rex = Chop[rex]; rey = \
Chop[rey]; rez = Chop[rez]; intersectionnumber = intersectionnumber + 
                      1.; opticallength = opticallength + ray1*index1; \
completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, \

                      r9, wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                      ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                    reportedrayspresent = True; intersectionspresent = True; \
deflectedrayspresent = True; localdummyoutrayspresent = True; 
                    (surfnorm = 1.*Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., \
1.}}]; dummymatrix = ({{0., 1., 0.}, {-1., 0., 0.}, {0., 0., 1.}} . 
                         #1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) \
/@ dummymatrix; surfacerotationmatrix = {{0, -1., 0}, {1., 0, 0}, 
                       {0, 0, 1.}}; surfacetranslationvector = {20., 15., 0}; \
activeregion = 0.; completedray = {rsx, rsy, rsz, rex, rey, rez, r1, 
                       r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}; componentnumber \
= newcomponentnumber; surfacenumber = newsurfacenumber; 
                     surfaceid = newsurfaceid; originalray = {rsx, rsy, rsz, \
rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, 
                       intensity, intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, 
                       frontid, sno1, sno2, sno3, sno4, rayslot, \
generationnumber, intersectionnumber, pol1, pol2, pol3}; intensity = 0.; 
                     allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, 
                        ray1, index, opticallength, phaseshift, \
componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, \
sno2, 
                        sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}); {allcreatedrays, {{1., 1., 1., 1., \
1., 1., 
                       1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
-9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 
                       1., 1., 1., 1., 1.}}, {completedray}}, resonatenumber \
== 5, {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                      wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, ray2, 
                      ray3, sid, frontid, sno1, sno2, sno3, sno4, rayslot, \
oldgenerationnumber, intersectionnumber, pol1, pol2, pol3} = #1; 
                    index1 = index; xunit = r3; yunit = r2; zunit = -1.*r1; \
xunit = Chop[xunit]; yunit = Chop[yunit]; zunit = Chop[zunit]; 
                    magnitude = (xunit^2 + yunit^2 + zunit^2)^2^(-1); xunit = \
xunit/magnitude; yunit = yunit/magnitude; zunit = zunit/magnitude; 
                    rx = 15. + rez; ry = rey; rz = -1.*(-20. + rex); rx = \
Chop[rx]; ry = Chop[ry]; rz = Chop[rz]; terminatedeflection = False; 
                    intersections = {{-1., 0., 0.}}; intersections = \
resonateintersections; holeQ = holeQlist[[resonatenumber]] == 1; 
                    {newcomponentnumber, newsurfacenumber, newsurfaceid} = \
{2., 5., 273035.}; {componentnumber, surfacenumber, surfaceid} = 
                     {2., 5., 273035.}; {ray1, ray2, ray3} = \
intersections[[1]]; rsx = rex; rsy = rey; rsz = rez; rxhlp = rx + ray1*xunit; \

                    ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; rex = \
20. - 1.*rzhlp; rey = ryhlp; rez = -15. + rxhlp; rex = Chop[rex]; 
                    rey = Chop[rey]; rez = Chop[rez]; intersectionnumber = \
intersectionnumber + 1.; opticallength = opticallength + ray1*index1; 
                    completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, \
r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                      index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                      rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; reportedrayspresent = True; intersectionspresent = True; 
                    deflectedrayspresent = True; localdummyoutrayspresent = \
True; (surfnorm = 1.*Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 1.}}]; 
                     dummymatrix = ({{0., 0., -1.}, {0., 1., 0.}, {1., 0., \
0.}} . #1 & ) /@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ 
                       dummymatrix; surfacerotationmatrix = {{0, 0, 1.}, {0, \
1., 0}, {-1., 0, 0}}; surfacetranslationvector = {20., 0, -15.}; 
                     activeregion = 0.; completedray = {rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                       intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                       sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}; componentnumber = 
                      newcomponentnumber; surfacenumber = newsurfacenumber; \
surfaceid = newsurfaceid; originalray = {rsx, rsy, rsz, rex, rey, rez, 
                       r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, \
intensity, intensityscale, ray1, index, opticallength, phaseshift, 
                       componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                       intersectionnumber, pol1, pol2, pol3}; intensity = 0.; \
allcreatedrays = {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, 
                        r6, r7, r8, r9, wavelength, intensity, \
intensityscale, ray1, index, opticallength, phaseshift, componentnumber, 
                        surfacenumber, surfaceid, ray2, ray3, sid, frontid, \
sno1, sno2, sno3, sno4, rayslot, generationnumber, intersectionnumber, 
                        pol1, pol2, pol3}}); {allcreatedrays, {{1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 
                       1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1.}}, {completedray}}, resonatenumber == 6, 
                   {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, \
r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                      opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                      rayslot, oldgenerationnumber, intersectionnumber, pol1, \
pol2, pol3} = #1; index1 = index; xunit = -1.*r3; yunit = -1.*r2; 
                    zunit = -1.*r1; xunit = Chop[xunit]; yunit = Chop[yunit]; \
zunit = Chop[zunit]; magnitude = (xunit^2 + yunit^2 + zunit^2)^2^(-1); 
                    xunit = xunit/magnitude; yunit = yunit/magnitude; zunit = \
zunit/magnitude; rx = -1.*(-15. + rez); ry = -1.*rey; 
                    rz = -1.*(-20. + rex); rx = Chop[rx]; ry = Chop[ry]; rz = \
Chop[rz]; terminatedeflection = False; intersections = {{-1., 0., 0.}}; 
                    intersections = resonateintersections; holeQ = \
holeQlist[[resonatenumber]] == 1; {newcomponentnumber, newsurfacenumber, 
                      newsurfaceid} = {2., 6., 273036.}; {componentnumber, \
surfacenumber, surfaceid} = {2., 6., 273036.}; {ray1, ray2, ray3} = 
                     intersections[[1]]; rsx = rex; rsy = rey; rsz = rez; \
rxhlp = rx + ray1*xunit; ryhlp = ry + ray1*yunit; rzhlp = rz + ray1*zunit; 
                    rex = 20. - 1.*rzhlp; rey = -1.*ryhlp; rez = 15. - \
1.*rxhlp; rex = Chop[rex]; rey = Chop[rey]; rez = Chop[rez]; 
                    intersectionnumber = intersectionnumber + 1.; \
opticallength = opticallength + ray1*index1; completedray = {rsx, rsy, rsz, \
rex, 
                      rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, \
wavelength, intensity, intensityscale, ray1, index, opticallength, \
phaseshift, 
                      componentnumber, surfacenumber, surfaceid, ray2, ray3, \
sid, frontid, sno1, sno2, sno3, sno4, rayslot, generationnumber, 
                      intersectionnumber, pol1, pol2, pol3}; \
reportedrayspresent = True; intersectionspresent = True; deflectedrayspresent \
= True; 
                    localdummyoutrayspresent = True; (surfnorm = 1.*Re[{{1., \
0., 0.}, {0., 1., 0.}, {0., 0., 1.}}]; dummymatrix = 
                      ({{0., 0., -1.}, {0., -1., 0.}, {-1., 0., 0.}} . #1 & ) \
/@ surfnorm; surfnorm = (#1/Sqrt[#1 . #1] & ) /@ dummymatrix; 
                     surfacerotationmatrix = {{0, 0, -1.}, {0, -1., 0}, {-1., \
0, 0}}; surfacetranslationvector = {20., 0, 15.}; activeregion = 0.; 
                     completedray = {rsx, rsy, rsz, rex, rey, rez, r1, r2, \
r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, intensityscale, ray1, 
                       index, opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                       rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}; componentnumber = newcomponentnumber; surfacenumber = 
                      newsurfacenumber; surfaceid = newsurfaceid; originalray \
= {rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, 
                       wavelength, intensity, intensityscale, ray1, index, \
opticallength, phaseshift, componentnumber, surfacenumber, surfaceid, 
                       ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, \
rayslot, generationnumber, intersectionnumber, pol1, pol2, pol3}; 
                     intensity = 0.; allcreatedrays = {{rsx, rsy, rsz, rex, \
rey, rez, r1, r2, r3, r4, r5, r6, r7, r8, r9, wavelength, intensity, 
                        intensityscale, ray1, index, opticallength, \
phaseshift, componentnumber, surfacenumber, surfaceid, ray2, ray3, sid, \
frontid, 
                        sno1, sno2, sno3, sno4, rayslot, generationnumber, \
intersectionnumber, pol1, pol2, pol3}}); {allcreatedrays, 
                     {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 
                       1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}, \
{completedray}}, True, deflecteddummyrayspresent = True; 
                    reporteddummyrayspresent = True; localoutrayspresent = \
True; {{{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                       -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}, 
                     {{rsx, rsy, rsz, rex, rey, rez, r1, r2, r3, r4, r5, r6, \
r7, r8, r9, wavelength, intensity, intensityscale, ray1, index, 
                       opticallength, phaseshift, componentnumber, \
surfacenumber, surfaceid, ray2, ray3, sid, frontid, sno1, sno2, sno3, sno4, 
                       rayslot, generationnumber, intersectionnumber, pol1, \
pol2, pol3}}, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                       1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., \
-1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}}], 
                 deflecteddummyrayspresent = True; reporteddummyrayspresent = \
True; localdummyoutrayspresent = True; 
                  {{{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., \
1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.}}, {{1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 
                     1., 1., 1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., \
1., 1., 1., 1., 1., 1., 1., 1., 1.}}, {{1., 1., 1., 1., 1., 1., 1., 1., 
                     1., 1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., \
1., 1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                     1., 1., 1.}}}]) & ) /@ inrays]; If[deflectedrayspresent \
&& deflecteddummyrayspresent, 
           deflectedlocalrays = Select[deflectedlocalrays, #1[[23]] > 0. & \
]*1., 1.]; If[localoutrayspresent, 
           If[localdummyoutrayspresent, localoutrays = Select[localoutrays, \
#1[[23]] > 0. & ]; 1., 1.]; outrays = Join[outrays, localoutrays]; 1., 
           1.]; If[reportedrayspresent && reporteddummyrayspresent, \
reportedlocalrays = Select[reportedlocalrays, #1[[23]] > 0. & ]; 1., 1.]); 
         If[reportedrayspresent, raysreported = True; reportedrays = \
Join[reportedrays, {{-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, 
               -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8}}, reportedlocalrays]; 1., 1.]; inrays = deflectedlocalrays; 
         propagate = generationnumber < generationlimit]; propagatedrays = \
If[Length[outrays] > 1, Drop[outrays, 1], outrays]; 
       If[generationnumber >= generationlimit && deflectedrayspresent, \
propagatedrays = Join[propagatedrays, deflectedlocalrays]; 1., 1.]); 
      If[Length[reportedrays] > 2, reportedrays = Drop[reportedrays, 2], \
reportedrays]; 
      ({#1[[1]], #1[[2]], #1[[3]], #1[[4]], #1[[5]], #1[[6]]} & ) /@ \
reportedrays]]), Deployed -> False, 
 AutorunSequencing -> {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11}, \
SynchronousInitialization -> True, SynchronousUpdating -> True]\
\>", "Input"],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`baseIndex$$ = 2.5, $CellContext`factorX$$ = 
    0.029, $CellContext`factorY$$ = 0.0476, $CellContext`glx$$ = 
    15., $CellContext`gly$$ = 0., $CellContext`lastlocposth$$ = {
    11.677930746766794`, -0.09511889862328349}, $CellContext`laststartposth$$ \
= {10.677930746766792`, -0.7209011264080125}, $CellContext`lastth$$ = 
    32.037600804503974`, $CellContext`radiusth$$ = 
    1.1796624078994897`, \
$CellContext`staticpolygons11458120071219151445727591$$ = {
     GrayLevel[0], 
     AbsoluteThickness[0.5], 
     Line[CompressedData["
1:eJztlkFqw0AMAE2SQ/Gph0DApSEN/Yf3DYX0AYWe+63i5pAfWO/pE3xomsSS
zI4RzrGELpgwaNfRrHaFXz7ent6LopifnrvT83B6ZoUOWRbZkPvmPL6cS/Ai
n992l/je+fvChyIYdR//dO5yTvPjefw4l4j3+TXOyH/E8EnwSfCp4VNP+LTw
aeEj8BH4CHxG9VBOzwGrn3MJXuTzrV7O6mdsw9jq5dzlbPVyLhFXP2fkP2L4
JPgk+NTwqSd8Wvi08BH4CHwEPmF9lgGbn3EJXuTzvV7G5hece6+XcZez18u4
RNz8kHf4C58EnwSfGj71hE8LnxY+Ah+Bj8AnrA/Py3Z3Hq/Om97LeY35FeIr
rL+uL3nf0X3zPq375n1oqi9xBH136KPog5rPEJ/qu73vzrnC/MdLnY7OG8S3
WB/cX/7/zZ7HW+sX//crz++P3y/mEZyTJrpX5nf1OVE/5wrz1c95g/gW66e+
N/T84X1Dn1hjfoX4Cuuv60N77NcM+3nAfof3ljz6/lA/gZ/AT+An8Av70z3m
q5/AT+An8Iu+d8l2/vC+Bv9XIJ8G+Tahj54/7McwX88f9rPBfg/rJ74PfwFi
2+cg
      "]]}, $CellContext`staticpolygons12458120071219151445731868$$ = {
     GrayLevel[0], 
     AbsoluteThickness[0.5], 
     Line[{{{40., 15.}, {40., -15.}, {40., -15.}, {40., 15.}, {40., 15.}}, {{
      40., -15.}, {0., -15.}, {0., -15.}, {40., -15.}, {40., -15.}}, {{
      0., -15.}, {0., 15.}, {0., 15.}, {0., -15.}, {0., -15.}}, {{0., 15.}, {
      40., 15.}, {40., 15.}, {0., 15.}, {0., 15.}}, {{40., -15.}, {40., 
      15.}, {0., 15.}, {0., -15.}, {40., -15.}}, {{40., 15.}, {40., -15.}, {
      0., -15.}, {0., 15.}, {40., 15.}}}]}, $CellContext`th$$ = 
    32.037600804503974`, $CellContext`width$$ = 1.44, $CellContext`x$$ = 
    10.677930746766792`, $CellContext`xoffth$$ = 
    1.0000000000000018`, $CellContext`xpos$$ = 
    1.834376303712972, $CellContext`xth$$ = 
    11.677930746766794`, $CellContext`y$$ = -0.7209011264080125, \
$CellContext`yoffth$$ = 
    0.6257822277847289, $CellContext`ypos$$ = -0.052148518982061985`, \
$CellContext`yth$$ = -0.09511889862328349, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`th$$], 0.}, {-180., 180.}}, {{
       Hold[$CellContext`width$$], 4.}, {0, 10}}, {{
       Hold[$CellContext`x$$], 10.}, {0.1, 20}}, {{
       Hold[$CellContext`y$$], 1.}, {0.1, 1.5}}, {{
       Hold[$CellContext`glx$$], 15.}, {0.15, 30}}, {{
       Hold[$CellContext`gly$$], 0.}, {-10, 10}}, {{
       Hold[$CellContext`baseIndex$$], 2.5}, {2.5, 10}}, {{
       Hold[$CellContext`factorX$$], 0.001}, {0, 0.1}}, {{
       Hold[$CellContext`factorY$$], 0.001}, {0, 0.1}}, {{
       Hold[$CellContext`xpos$$], 1.}, {0.1, 1.5}}, {{
       Hold[$CellContext`ypos$$], 0.}, {-10, 10}}, {
      Hold[
       Style[
        Grid[{{"Horizontal Quadratic Index Factor", 
           Manipulator[
            Dynamic[$CellContext`factorX$$], {0, 0.1}], 
           Dynamic[$CellContext`factorX$$]}}]]], 
      Manipulate`Dump`ThisIsNotAControl}, {
      Hold[
       Style[
        Grid[{{"Vertical Quadratic Index Factor", 
           Manipulator[
            Dynamic[$CellContext`factorY$$], {0, 0.1}], 
           Dynamic[$CellContext`factorY$$]}}]]], 
      Manipulate`Dump`ThisIsNotAControl}, {
      Hold[
       Style[
        Grid[{{"Refractive Index Constant", 
           Manipulator[
            Dynamic[$CellContext`baseIndex$$], {2.5, 10}], 
           Dynamic[$CellContext`baseIndex$$]}}]]], 
      Manipulate`Dump`ThisIsNotAControl}, {
      Hold[
       Style[
        Grid[{{"Beam Width", 
           Manipulator[
            Dynamic[$CellContext`width$$], {0, 10}], 
           Dynamic[$CellContext`width$$]}}]]], 
      Manipulate`Dump`ThisIsNotAControl}, {{
       Hold[$CellContext`xth$$], 11.}}, {{
       Hold[$CellContext`yth$$], 1.}}, {{
       Hold[$CellContext`radiusth$$], 1.}}, {{
       Hold[$CellContext`xoffth$$], 1.}}, {{
       Hold[$CellContext`yoffth$$], 0.}}, {{
       Hold[$CellContext`laststartposth$$], {10., 1.}}}, {{
       Hold[$CellContext`lastlocposth$$], {11., 1.}}}, {{
       Hold[$CellContext`lastth$$], 0}}, {{
       Hold[$CellContext`staticpolygons11458120071219151445727591$$], {
        GrayLevel[0], 
        AbsoluteThickness[0.5], 
        Line[CompressedData["
1:eJztlkFqw0AMAE2SQ/Gph0DApSEN/Yf3DYX0AYWe+63i5pAfWO/pE3xomsSS
zI4RzrGELpgwaNfRrHaFXz7ent6LopifnrvT83B6ZoUOWRbZkPvmPL6cS/Ai
n992l/je+fvChyIYdR//dO5yTvPjefw4l4j3+TXOyH/E8EnwSfCp4VNP+LTw
aeEj8BH4CHxG9VBOzwGrn3MJXuTzrV7O6mdsw9jq5dzlbPVyLhFXP2fkP2L4
JPgk+NTwqSd8Wvi08BH4CHwEPmF9lgGbn3EJXuTzvV7G5hece6+XcZez18u4
RNz8kHf4C58EnwSfGj71hE8LnxY+Ah+Bj8AnrA/Py3Z3Hq/Om97LeY35FeIr
rL+uL3nf0X3zPq375n1oqi9xBH136KPog5rPEJ/qu73vzrnC/MdLnY7OG8S3
WB/cX/7/zZ7HW+sX//crz++P3y/mEZyTJrpX5nf1OVE/5wrz1c95g/gW66e+
N/T84X1Dn1hjfoX4Cuuv60N77NcM+3nAfof3ljz6/lA/gZ/AT+An8Av70z3m
q5/AT+An8Iu+d8l2/vC+Bv9XIJ8G+Tahj54/7McwX88f9rPBfg/rJ74PfwFi
2+cg
         "]]}}}, {{
       Hold[$CellContext`staticpolygons12458120071219151445731868$$], {
        GrayLevel[0], 
        AbsoluteThickness[0.5], 
        Line[{{{40., 15.}, {40., -15.}, {40., -15.}, {40., 15.}, {40., 
         15.}}, {{40., -15.}, {0., -15.}, {0., -15.}, {40., -15.}, {
         40., -15.}}, {{0., -15.}, {0., 15.}, {0., 15.}, {0., -15.}, {
         0., -15.}}, {{0., 15.}, {40., 15.}, {40., 15.}, {0., 15.}, {0., 
         15.}}, {{40., -15.}, {40., 15.}, {0., 15.}, {0., -15.}, {
         40., -15.}}, {{40., 15.}, {40., -15.}, {0., -15.}, {0., 15.}, {40., 
         15.}}}]}}}}, Typeset`size$$ = {1200., {317.375, 322.625}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    False, $CellContext`th$273280$$ = False, $CellContext`width$273281$$ = 
    False, $CellContext`x$273282$$ = False, $CellContext`y$273283$$ = 
    False, $CellContext`glx$273284$$ = False, $CellContext`gly$273285$$ = 
    False, $CellContext`baseIndex$273286$$ = 
    False, $CellContext`factorX$273287$$ = 
    False, $CellContext`factorY$273288$$ = False, $CellContext`xpos$273289$$ =
     False, $CellContext`ypos$273290$$ = False}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`baseIndex$$ = 2.5, $CellContext`factorX$$ = 
        0.001, $CellContext`factorY$$ = 0.001, $CellContext`glx$$ = 
        15., $CellContext`gly$$ = 
        0., $CellContext`lastlocposth$$ = {11., 
         1.}, $CellContext`laststartposth$$ = {10., 
         1.}, $CellContext`lastth$$ = 0, $CellContext`radiusth$$ = 
        1., $CellContext`staticpolygons11458120071219151445727591$$ = {
          GrayLevel[0], 
          AbsoluteThickness[0.5], 
          Line[CompressedData["
1:eJztlkFqw0AMAE2SQ/Gph0DApSEN/Yf3DYX0AYWe+63i5pAfWO/pE3xomsSS
zI4RzrGELpgwaNfRrHaFXz7ent6LopifnrvT83B6ZoUOWRbZkPvmPL6cS/Ai
n992l/je+fvChyIYdR//dO5yTvPjefw4l4j3+TXOyH/E8EnwSfCp4VNP+LTw
aeEj8BH4CHxG9VBOzwGrn3MJXuTzrV7O6mdsw9jq5dzlbPVyLhFXP2fkP2L4
JPgk+NTwqSd8Wvi08BH4CHwEPmF9lgGbn3EJXuTzvV7G5hece6+XcZez18u4
RNz8kHf4C58EnwSfGj71hE8LnxY+Ah+Bj8AnrA/Py3Z3Hq/Om97LeY35FeIr
rL+uL3nf0X3zPq375n1oqi9xBH136KPog5rPEJ/qu73vzrnC/MdLnY7OG8S3
WB/cX/7/zZ7HW+sX//crz++P3y/mEZyTJrpX5nf1OVE/5wrz1c95g/gW66e+
N/T84X1Dn1hjfoX4Cuuv60N77NcM+3nAfof3ljz6/lA/gZ/AT+An8Av70z3m
q5/AT+An8Iu+d8l2/vC+Bv9XIJ8G+Tahj54/7McwX88f9rPBfg/rJ74PfwFi
2+cg
           
           "]]}, $CellContext`staticpolygons12458120071219151445731868$$ = {
          GrayLevel[0], 
          AbsoluteThickness[0.5], 
          
          Line[{{{40., 15.}, {40., -15.}, {40., -15.}, {40., 15.}, {40., 
           15.}}, {{40., -15.}, {0., -15.}, {0., -15.}, {40., -15.}, {
           40., -15.}}, {{0., -15.}, {0., 15.}, {0., 15.}, {0., -15.}, {
           0., -15.}}, {{0., 15.}, {40., 15.}, {40., 15.}, {0., 15.}, {0., 
           15.}}, {{40., -15.}, {40., 15.}, {0., 15.}, {0., -15.}, {
           40., -15.}}, {{40., 15.}, {40., -15.}, {0., -15.}, {0., 15.}, {40.,
            15.}}}]}, $CellContext`th$$ = 0., $CellContext`width$$ = 
        4., $CellContext`x$$ = 10., $CellContext`xoffth$$ = 
        1., $CellContext`xpos$$ = 1., $CellContext`xth$$ = 
        11., $CellContext`y$$ = 1., $CellContext`yoffth$$ = 
        0., $CellContext`ypos$$ = 0., $CellContext`yth$$ = 1.}, 
      "ControllerVariables" :> {
        Hold[$CellContext`th$$, $CellContext`th$273280$$, False], 
        Hold[$CellContext`width$$, $CellContext`width$273281$$, False], 
        Hold[$CellContext`x$$, $CellContext`x$273282$$, False], 
        Hold[$CellContext`y$$, $CellContext`y$273283$$, False], 
        Hold[$CellContext`glx$$, $CellContext`glx$273284$$, False], 
        Hold[$CellContext`gly$$, $CellContext`gly$273285$$, False], 
        Hold[$CellContext`baseIndex$$, $CellContext`baseIndex$273286$$, 
         False], 
        Hold[$CellContext`factorX$$, $CellContext`factorX$273287$$, False], 
        Hold[$CellContext`factorY$$, $CellContext`factorY$273288$$, False], 
        Hold[$CellContext`xpos$$, $CellContext`xpos$273289$$, False], 
        Hold[$CellContext`ypos$$, $CellContext`ypos$273290$$, False]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Column[{
         Row[{
           Show[{
             Graphics[
              Dynamic[
               GeometricTransformation[
                Part[
                 
                 ContourPlot[$CellContext`baseIndex$$ - \
$CellContext`factorX$$ ($CellContext`rsx - $CellContext`xpos$$)^2 - \
$CellContext`factorY$$ ($CellContext`rsy - $CellContext`ypos$$)^2, \
{$CellContext`rsx, -5, 5}, {$CellContext`rsy, -5, 5}], 1], {{{1, 0}, {0, 
                 1}}, {$CellContext`glx$$ + 5, $CellContext`gly$$}}]]], 
             Graphics[{{
                Opacity[0.8], 
                
                GeometricTransformation[$CellContext`\
staticpolygons11458120071219151445727591$$, 
                 
                 Dynamic[{{{1, 0}, {0, 
                   1}}, {$CellContext`glx$$, $CellContext`gly$$}}]], \
$CellContext`staticpolygons12458120071219151445731868$$, 
                Opacity[1], 
                RGBColor[
                0.038747429704798886`, 0.9161617552424038, 
                 0.039847212269181365`], 
                AbsoluteThickness[Medium], 
                Line[
                 Dynamic[
                  Map[{
                    Part[#, {1, 2}], 
                    Part[#, {4, 5}]}& , 
                   Select[
                    $CellContext`raytracefunction1458120071219151445741744[$\
CellContext`th$$, $CellContext`width$$, $CellContext`x$$, $CellContext`y$$, \
$CellContext`glx$$, $CellContext`gly$$, $CellContext`baseIndex$$, \
$CellContext`factorX$$, $CellContext`factorY$$, $CellContext`xpos$$, \
$CellContext`ypos$$], Part[#, 1] > -9.87654321*^8& ]]]], 
                Arrowheads[Large], 
                Thickness[Large], 
                Dashing[{Small, Small}], 
                RGBColor[1, 1, 0], 
                Arrow[
                 Dynamic[If[
                    
                    Or[$CellContext`laststartposth$$ != {$CellContext`x$$, \
$CellContext`y$$}, $CellContext`lastth$$ =!= $CellContext`th$$], \
$CellContext`laststartposth$$ = {$CellContext`x$$, $CellContext`y$$}; \
$CellContext`lastth$$ = $CellContext`th$$; {$CellContext`xth$$, \
$CellContext`yth$$} = $CellContext`laststartposth$$ + $CellContext`radiusth$$ \
{
                    Cos[$CellContext`th$$ Degree], 
                    
                    Sin[$CellContext`th$$ 
                    Degree]}]; {$CellContext`laststartposth$$, \
{$CellContext`xth$$, $CellContext`yth$$}}, ({$CellContext`laststartposth$$, \
{$CellContext`xth$$, $CellContext`yth$$}} = #)& ]], 
                Tooltip[
                 Locator[
                  Dynamic[If[
                    
                    Or[{$CellContext`xth$$, $CellContext`yth$$} != \
$CellContext`lastlocposth$$, $CellContext`lastth$$ != $CellContext`th$$], \
$CellContext`lastlocposth$$ = {$CellContext`xth$$, $CellContext`yth$$}; \
$CellContext`lastth$$ = $CellContext`th$$; {$CellContext`xth$$, \
$CellContext`yth$$} = $CellContext`laststartposth$$ + $CellContext`radiusth$$ \
{
                    Cos[$CellContext`th$$ Degree], 
                    
                    Sin[$CellContext`th$$ 
                    Degree]}]; {$CellContext`xth$$, $CellContext`yth$$}, \
({$CellContext`xth$$, $CellContext`yth$$} = #; $CellContext`xoffth$$ = \
$CellContext`xth$$ - $CellContext`x$$; $CellContext`yoffth$$ = \
$CellContext`yth$$ - $CellContext`y$$; $CellContext`radiusth$$ = 
                    Sqrt[$CellContext`xoffth$$^2 + $CellContext`yoffth$$^2]; \
$CellContext`th$$ = Chop[
                    ArcTan[$CellContext`xoffth$$, $CellContext`yoffth$$]/
                    Degree]; {$CellContext`xth$$, $CellContext`yth$$})& ], 
                  Graphics[{
                    RGBColor[1/3, 1/3, 1], 
                    Disk[{0, 0}, 0.5]}, ImageSize -> 10]], 
                 Dynamic[
                  StringJoin["th = ", 
                   ToString[$CellContext`th$$]]]], 
                Tooltip[
                 Locator[
                  
                  Dynamic[{$CellContext`x$$, $CellContext`y$$}, \
({$CellContext`x$$, $CellContext`y$$} = Chop[#])& ], 
                  Graphics[{
                    RGBColor[1, 1/3, 1/3], 
                    Disk[{0, 0}, 0.8]}, ImageSize -> 10]], 
                 Dynamic[
                  StringJoin["{x, y} = ", 
                   ToString[
                    Chop[{$CellContext`x$$, $CellContext`y$$}]]]]], 
                Tooltip[
                 Locator[
                  
                  Dynamic[{$CellContext`glx$$, $CellContext`gly$$}, \
({$CellContext`glx$$, $CellContext`gly$$} = Chop[#])& ], 
                  Graphics[{
                    RGBColor[1, 1/3, 1/3], 
                    Disk[{0, 0}, 0.8]}, ImageSize -> 10]], 
                 Dynamic[
                  StringJoin["{glx, gly} = ", 
                   ToString[
                    Chop[{$CellContext`glx$$, $CellContext`gly$$}]]]]]}}], 
             Graphics[
              GeometricTransformation[
               Locator[
                Dynamic[{$CellContext`xpos$$, $CellContext`ypos$$}], 
                Graphics[{
                  Lighter[Red], 
                  Disk[{0, 0}, 0.8]}, ImageSize -> 10]], {{{1, 0}, {0, 
                1}}, {$CellContext`glx$$ + 5, $CellContext`gly$$}}]]}, {
            PlotLabel -> 
             "Graded Refraction Through A Transparent Cubical Block", 
             ImageSize -> 800, AspectRatio -> Automatic}], Null, 
           Dynamic[
            
            Plot3D[$CellContext`baseIndex$$ - $CellContext`factorX$$ \
($CellContext`rsx - $CellContext`xpos$$)^2 - $CellContext`factorY$$ \
($CellContext`rsy - $CellContext`ypos$$)^2, {$CellContext`rsx, -5, 
              5}, {$CellContext`rsy, -5, 5}, PlotLabel -> 
             "Graded Index Profile", ImageSize -> 400]]}], 
         Tooltip[
          Row[{
            Style["", Italic, 10], 
            Hyperlink[
             Style["<< Crafted with Optica\[Trademark] >>", Italic, 10], 
             "http://www.opticasoftware.com"], 
            Style["", Italic, 10]}], 
          "Click here to visit www.opticasoftware.com"]}, Center], 
      "Specifications" :> {{{$CellContext`th$$, 0.}, {-180., 180.}, 
         ControlType -> None}, {{$CellContext`width$$, 4.}, {0, 10}, 
         ControlType -> None}, {{$CellContext`x$$, 10.}, {0.1, 20}, 
         ControlType -> None}, {{$CellContext`y$$, 1.}, {0.1, 1.5}, 
         ControlType -> None}, {{$CellContext`glx$$, 15.}, {0.15, 30}, 
         ControlType -> None}, {{$CellContext`gly$$, 0.}, {-10, 10}, 
         ControlType -> None}, {{$CellContext`baseIndex$$, 2.5}, {2.5, 10}, 
         ControlType -> None}, {{$CellContext`factorX$$, 0.001}, {0, 0.1}, 
         ControlType -> None}, {{$CellContext`factorY$$, 0.001}, {0, 0.1}, 
         ControlType -> None}, {{$CellContext`xpos$$, 1.}, {0.1, 1.5}, 
         ControlType -> None}, {{$CellContext`ypos$$, 0.}, {-10, 10}, 
         ControlType -> None}, 
        Style[
         Grid[{{"Horizontal Quadratic Index Factor", 
            Manipulator[
             Dynamic[$CellContext`factorX$$], {0, 0.1}], 
            Dynamic[$CellContext`factorX$$]}}]], 
        Style[
         Grid[{{"Vertical Quadratic Index Factor", 
            Manipulator[
             Dynamic[$CellContext`factorY$$], {0, 0.1}], 
            Dynamic[$CellContext`factorY$$]}}]], 
        Style[
         Grid[{{"Refractive Index Constant", 
            Manipulator[
             Dynamic[$CellContext`baseIndex$$], {2.5, 10}], 
            Dynamic[$CellContext`baseIndex$$]}}]], 
        Style[
         Grid[{{"Beam Width", 
            Manipulator[
             Dynamic[$CellContext`width$$], {0, 10}], 
            Dynamic[$CellContext`width$$]}}]], {{$CellContext`xth$$, 11.}, 
         ControlType -> None}, {{$CellContext`yth$$, 1.}, ControlType -> 
         None}, {{$CellContext`radiusth$$, 1.}, ControlType -> 
         None}, {{$CellContext`xoffth$$, 1.}, ControlType -> 
         None}, {{$CellContext`yoffth$$, 0.}, ControlType -> 
         None}, {{$CellContext`laststartposth$$, {10., 1.}}, ControlType -> 
         None}, {{$CellContext`lastlocposth$$, {11., 1.}}, ControlType -> 
         None}, {{$CellContext`lastth$$, 0}, ControlType -> 
         None}, {{$CellContext`staticpolygons11458120071219151445727591$$, {
           GrayLevel[0], 
           AbsoluteThickness[0.5], 
           Line[CompressedData["
1:eJztlkFqw0AMAE2SQ/Gph0DApSEN/Yf3DYX0AYWe+63i5pAfWO/pE3xomsSS
zI4RzrGELpgwaNfRrHaFXz7ent6LopifnrvT83B6ZoUOWRbZkPvmPL6cS/Ai
n992l/je+fvChyIYdR//dO5yTvPjefw4l4j3+TXOyH/E8EnwSfCp4VNP+LTw
aeEj8BH4CHxG9VBOzwGrn3MJXuTzrV7O6mdsw9jq5dzlbPVyLhFXP2fkP2L4
JPgk+NTwqSd8Wvi08BH4CHwEPmF9lgGbn3EJXuTzvV7G5hece6+XcZez18u4
RNz8kHf4C58EnwSfGj71hE8LnxY+Ah+Bj8AnrA/Py3Z3Hq/Om97LeY35FeIr
rL+uL3nf0X3zPq375n1oqi9xBH136KPog5rPEJ/qu73vzrnC/MdLnY7OG8S3
WB/cX/7/zZ7HW+sX//crz++P3y/mEZyTJrpX5nf1OVE/5wrz1c95g/gW66e+
N/T84X1Dn1hjfoX4Cuuv60N77NcM+3nAfof3ljz6/lA/gZ/AT+An8Av70z3m
q5/AT+An8Iu+d8l2/vC+Bv9XIJ8G+Tahj54/7McwX88f9rPBfg/rJ74PfwFi
2+cg
            "]]}}, ControlType -> 
         None}, {{$CellContext`staticpolygons12458120071219151445731868$$, {
           GrayLevel[0], 
           AbsoluteThickness[0.5], 
           
           Line[{{{40., 15.}, {40., -15.}, {40., -15.}, {40., 15.}, {40., 
            15.}}, {{40., -15.}, {0., -15.}, {0., -15.}, {40., -15.}, {
            40., -15.}}, {{0., -15.}, {0., 15.}, {0., 15.}, {0., -15.}, {
            0., -15.}}, {{0., 15.}, {40., 15.}, {40., 15.}, {0., 15.}, {0., 
            15.}}, {{40., -15.}, {40., 15.}, {0., 15.}, {0., -15.}, {
            40., -15.}}, {{40., 15.}, {40., -15.}, {0., -15.}, {0., 15.}, {
            40., 15.}}}]}}, ControlType -> None}}, 
      "Options" :> {
       Deployed -> False, 
        AutorunSequencing -> {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11}, 
        SynchronousInitialization -> True, SynchronousUpdating -> True}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{1242., {407.375, 412.625}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    Initialization:>($CellContext`raytracefunction1458120071219151445741744 = 
      Compile[{{$CellContext`th$$, 
          Blank[Real]}, {$CellContext`width$$, 
          Blank[Real]}, {$CellContext`x$$, 
          Blank[Real]}, {$CellContext`y$$, 
          Blank[Real]}, {$CellContext`glx$$, 
          Blank[Real]}, {$CellContext`gly$$, 
          Blank[Real]}, {$CellContext`baseIndex$$, 
          Blank[Real]}, {$CellContext`factorX$$, 
          Blank[Real]}, {$CellContext`factorY$$, 
          Blank[Real]}, {$CellContext`xpos$$, 
          Blank[Real]}, {$CellContext`ypos$$, 
          Blank[Real]}}, 
        Module[{$CellContext`activeregion$, $CellContext`Aelement$, \
$CellContext`allcreatedamplitudes$, $CellContext`allcreatedrays$, \
$CellContext`allowzeroraylength$, $CellContext`alternateindex$, \
$CellContext`amplitude$, $CellContext`axismagnitude$, \
$CellContext`axismatrix$, $CellContext`Belement$, $CellContext`Celement$, \
$CellContext`clonedata$, $CellContext`clonegenerationnumber$, \
$CellContext`cloneinput$, $CellContext`clonenumber$, \
$CellContext`cloneposition$, $CellContext`clonereportedrays$, \
$CellContext`clonerotation$, $CellContext`clonescale$, \
$CellContext`clonescalevector$, $CellContext`clonesorthistogram$, \
$CellContext`clonetraceinput$, $CellContext`clonetraceoutput$, \
$CellContext`closestdistances$, $CellContext`closestposition$, \
$CellContext`closestpositions$, $CellContext`closestraylength$, \
$CellContext`completedray$, $CellContext`componentnumber$, \
$CellContext`cosangle$, $CellContext`crossmatrix$, \
$CellContext`deflecteddummyrayspresent$, $CellContext`deflectedlocalrays$, \
$CellContext`deflectedrays$, $CellContext`deflectedrayspresent$, \
$CellContext`dummymatrix$, $CellContext`dummymatrixlist$, \
$CellContext`dummyvector$, $CellContext`frontid$, \
$CellContext`generationlimit$, $CellContext`generationnumber$, \
$CellContext`holeintersections$, $CellContext`holeQ$, \
$CellContext`holeQlist$, $CellContext`hor$, $CellContext`index$, \
$CellContext`index1$, $CellContext`index2$, $CellContext`indexpoints$, \
$CellContext`inrays$, $CellContext`integratedrefractiveindex$, \
$CellContext`intensity$, $CellContext`intensityscale$, \
$CellContext`intersectionnumber$, $CellContext`intersections$, \
$CellContext`intersectionslist$, $CellContext`intersectionspresent$, \
$CellContext`listofpositions$, $CellContext`listoftilts$, \
$CellContext`localdummyoutrayspresent$, $CellContext`localindex$, \
$CellContext`localopticallength$, $CellContext`localoutrays$, \
$CellContext`localoutrayspresent$, $CellContext`localpos$, \
$CellContext`localraylength$, $CellContext`localrotation$, \
$CellContext`localtilt$, $CellContext`localtranslation$, \
$CellContext`magnitude$, $CellContext`maxclonegenerationnumber$, \
$CellContext`maximumposition$, $CellContext`minimumraylength$, \
$CellContext`minresonateraylength$, $CellContext`n12$, \
$CellContext`newcomponentnumber$, $CellContext`newdeflectedrays$, \
$CellContext`newdistance$, $CellContext`newpos$, $CellContext`newsurfaceid$, \
$CellContext`newsurfacenumber$, $CellContext`newtilt$, $CellContext`Nfinal$, \
$CellContext`Ninitial$, $CellContext`ninteger$, \
$CellContext`nonintersectingrays$, $CellContext`normalizedpolarization$, \
$CellContext`oldgenerationnumber$, $CellContext`opticallength$, \
$CellContext`opticallengths$, $CellContext`originalopticallength$, \
$CellContext`originalray$, $CellContext`originalraytilt$, \
$CellContext`originalrotation$, $CellContext`originalsurfnorm$, \
$CellContext`outrays$, $CellContext`parallelamplitude$, $CellContext`PAxis$, \
$CellContext`perpendicularamplitude$, $CellContext`phaseshift$, \
$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$, \
$CellContext`previoustilt$, $CellContext`propagate$, \
$CellContext`propagatedrays$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, $CellContext`ray1$, \
$CellContext`ray2$, $CellContext`ray3$, $CellContext`LocRayL$, \
$CellContext`rayslot$, $CellContext`raysreported$, $CellContext`raytiltx$, \
$CellContext`raytiltz$, $CellContext`reporteddummyrayspresent$, \
$CellContext`reportedlocalrays$, $CellContext`reportedrays$, \
$CellContext`reportedrayspresent$, $CellContext`resonateintersections$, \
$CellContext`resonatenumber$, $CellContext`resonateraylength$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`rotationaxis$, $CellContext`rsx$, $CellContext`LocRSx$, \
$CellContext`rSxOffset$, $CellContext`rsy$, $CellContext`LocRSy$, \
$CellContext`rsz$, $CellContext`LocRSz$, 
          Optica`Optica`RTx$, $CellContext`LocRTy$, $CellContext`LocRTz$, \
$CellContext`rx$, $CellContext`rxhlp$, $CellContext`ry$, $CellContext`ryhlp$, \
$CellContext`rz$, $CellContext`rzhlp$, $CellContext`LocSCx$, \
$CellContext`LocSCy$, $CellContext`Sfinal$, $CellContext`sid$, \
$CellContext`sinangle$, $CellContext`Sinitial$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`surfaceid$, $CellContext`surfacenumber$, \
$CellContext`surfacerotationmatrix$, $CellContext`surfacetranslationvector$, \
$CellContext`surfnorm$, $CellContext`surfrot$, $CellContext`surftrans$, \
$CellContext`symr1$, $CellContext`symr2$, $CellContext`symr3$, \
$CellContext`symr4$, $CellContext`symr5$, $CellContext`symr6$, \
$CellContext`symr7$, $CellContext`symr8$, $CellContext`symr9$, \
$CellContext`tempclonedata$, $CellContext`terminatedeflection$, \
$CellContext`thresholdintensity$, $CellContext`tiltmagnitude$, \
$CellContext`transmatrix$, $CellContext`LocTV1$, $CellContext`LocTV10$, \
$CellContext`LocTV2$, $CellContext`LocTV3$, $CellContext`LocTV4$, \
$CellContext`LocTV5$, $CellContext`LocTV6$, $CellContext`LocTV7$, \
$CellContext`LocTV8$, $CellContext`LocTV9$, $CellContext`u$, \
$CellContext`unfilteredintersections$, $CellContext`unit$, $CellContext`uu$, \
$CellContext`ver$, $CellContext`wavelength$, $CellContext`XAxis$, \
$CellContext`xunit$, $CellContext`YAxis$, $CellContext`yunit$, \
$CellContext`ZAxis$, $CellContext`zunit$}, $CellContext`activeregion$ = 
          1.; $CellContext`Aelement$ = {0., 0., 
           0.}; $CellContext`allcreatedamplitudes$ = {{
            0. + 0. I, 0. + 0. I, 0. + 
             0. I}}; $CellContext`allcreatedrays$ = {{
           1.}}; $CellContext`allowzeroraylength$ = 
          True; $CellContext`alternateindex$ = 
          1.; $CellContext`amplitude$ = {
           1. + 0. I, 0. + 0. I, 0. + 0. I}; $CellContext`axismagnitude$ = 
          1.; $CellContext`axismatrix$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 0.,
            1.}}; $CellContext`Belement$ = {0., 0., 
           0.}; $CellContext`Celement$ = {0., 0., 
           0.}; $CellContext`clonedata$ = {{
           1.}}; $CellContext`clonegenerationnumber$ = 
          1.; $CellContext`cloneinput$ = {1.}; $CellContext`clonenumber$ = 
          1; $CellContext`cloneposition$ = {0., 0., 
           0.}; $CellContext`clonereportedrays$ = {{
           1.}}; $CellContext`clonerotation$ = {{
           1.}}; $CellContext`clonescale$ = 
          1.; $CellContext`clonescalevector$ = {
           1.}; $CellContext`clonesorthistogram$ = {
           1}; $CellContext`clonetraceinput$ = {{
           1.}}; $CellContext`clonetraceoutput$ = {{
           1.}}; $CellContext`closestdistances$ = {
           1.}; $CellContext`closestposition$ = 
          0; $CellContext`closestpositions$ = {
           0}; $CellContext`closestraylength$ = 
          1.; $CellContext`completedray$ = {
           1.}; $CellContext`componentnumber$ = -1.; $CellContext`cosangle$ = 
          1.; $CellContext`crossmatrix$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 
           0., 1.}}; $CellContext`deflecteddummyrayspresent$ = 
          False; $CellContext`deflectedlocalrays$ = {{
           1.}}; $CellContext`deflectedrays$ = {{
           1.}}; $CellContext`deflectedrayspresent$ = 
          False; $CellContext`dummymatrix$ = {{
           1.}}; $CellContext`dummymatrixlist$ = {{{
           1.}}}; $CellContext`dummyvector$ = {1.}; $CellContext`frontid$ = 
          1.; $CellContext`generationlimit$ = 
          200.; $CellContext`generationnumber$ = 
          1.; $CellContext`holeintersections$ = {{-1., 0., 
           0.}}; $CellContext`holeQ$ = 
          False; $CellContext`holeQlist$ = {0}; $CellContext`hor$ = 
          1. + 0. I; $CellContext`index$ = 1.; $CellContext`index1$ = 
          1.; $CellContext`index2$ = 
          1.; $CellContext`indexpoints$ = {1.}; $CellContext`inrays$ = {{
           1.}}; $CellContext`integratedrefractiveindex$ = 
          0.; $CellContext`intensity$ = 1.; $CellContext`intensityscale$ = 
          1.; $CellContext`intersectionnumber$ = 
          1.; $CellContext`intersections$ = {{-1., 0., 
           0.}}; $CellContext`intersectionslist$ = {{{-1., 0., 
           0.}}}; $CellContext`intersectionspresent$ = 
          False; $CellContext`listofpositions$ = {{
           1.}}; $CellContext`listoftilts$ = {{
           1.}}; $CellContext`localdummyoutrayspresent$ = 
          False; $CellContext`localindex$ = 
          1.; $CellContext`localopticallength$ = 
          0.; $CellContext`localoutrays$ = {{
           1.}}; $CellContext`localoutrayspresent$ = 
          False; $CellContext`localpos$ = {0., 0., 
           0.}; $CellContext`localraylength$ = 
          0.; $CellContext`localrotation$ = {{
           1.}}; $CellContext`localtilt$ = {1., 0., 
           0.}; $CellContext`localtranslation$ = {1., 0., 
           0.}; $CellContext`magnitude$ = 
          1.; $CellContext`maxclonegenerationnumber$ = 
          1.; $CellContext`maximumposition$ = 
          1; $CellContext`minimumraylength$ = 
          0.0001; $CellContext`minresonateraylength$ = 1.; $CellContext`n12$ = 
          1.; $CellContext`newcomponentnumber$ = -1.; \
$CellContext`newdeflectedrays$ = {{1.}}; $CellContext`newdistance$ = 
          1.; $CellContext`newpos$ = {0., 0., 
           0.}; $CellContext`newsurfaceid$ = -1.; \
$CellContext`newsurfacenumber$ = -1.; $CellContext`newtilt$ = {1., 0., 
           0.}; $CellContext`Nfinal$ = 0.; $CellContext`Ninitial$ = 
          0.; $CellContext`ninteger$ = 
          1; $CellContext`nonintersectingrays$ = {{
           1.}}; $CellContext`normalizedpolarization$ = {1., 
           1.}; $CellContext`oldgenerationnumber$ = 
          1.; $CellContext`opticallength$ = 
          1.; $CellContext`opticallengths$ = {
           1.}; $CellContext`originalray$ = {
           1.}; $CellContext`originalraytilt$ = {
           1.}; $CellContext`originalrotation$ = {{1., 0., 0.}, {0., 1., 
           0.}, {0., 0., 1.}}; $CellContext`originalsurfnorm$ = {{
           1.}}; $CellContext`outrays$ = {{
           1.}}; $CellContext`parallelamplitude$ = 
          1. + 0. I; $CellContext`PAxis$ = {1., 0., 
           0.}; $CellContext`perpendicularamplitude$ = 
          1. + 0. I; $CellContext`phaseshift$ = 0.; $CellContext`pol1$ = 
          1.; $CellContext`pol2$ = 1.; $CellContext`pol3$ = 
          1.; $CellContext`previoustilt$ = {1., 0., 
           0.}; $CellContext`propagate$ = 
          True; $CellContext`propagatedrays$ = {{1.}}; $CellContext`r1$ = 
          1.; $CellContext`r2$ = 1.; $CellContext`r3$ = 1.; $CellContext`r4$ = 
          1.; $CellContext`r5$ = 1.; $CellContext`r6$ = 1.; $CellContext`r7$ = 
          1.; $CellContext`r8$ = 1.; $CellContext`r9$ = 
          1.; $CellContext`ray1$ = 1.; $CellContext`ray2$ = 
          1.; $CellContext`ray3$ = 1.; $CellContext`LocRayL$ = 
          1.; $CellContext`rayslot$ = 1.; $CellContext`raysreported$ = 
          False; $CellContext`raytiltx$ = 1.; $CellContext`raytiltz$ = 
          1.; $CellContext`reporteddummyrayspresent$ = 
          False; $CellContext`reportedlocalrays$ = {{
           1.}}; $CellContext`reportedrays$ = {{
           1.}}; $CellContext`reportedrayspresent$ = 
          False; $CellContext`resonateintersections$ = {{-1., 0., 
           0.}}; $CellContext`resonatenumber$ = 
          0; $CellContext`resonateraylength$ = 1.; $CellContext`rex$ = 
          1.; $CellContext`rey$ = 1.; $CellContext`rez$ = 
          1.; $CellContext`rsx$ = 1.; $CellContext`LocRSx$ = 
          1.; $CellContext`rSxOffset$ = 1.; $CellContext`rsy$ = 
          1.; $CellContext`LocRSy$ = 1.; $CellContext`rsz$ = 
          1.; $CellContext`LocRSz$ = 1.; 
         Optica`Optica`RTx$ = 1.; $CellContext`LocRTy$ = 
          1.; $CellContext`LocRTz$ = 1.; $CellContext`rx$ = 
          1.; $CellContext`rxhlp$ = 1.; $CellContext`ry$ = 
          1.; $CellContext`ryhlp$ = 1.; $CellContext`rz$ = 
          1.; $CellContext`rzhlp$ = 1.; $CellContext`LocSCx$ = 
          1.; $CellContext`LocSCy$ = 1.; $CellContext`Sfinal$ = 
          0.; $CellContext`sid$ = 1.; $CellContext`sinangle$ = 
          1.; $CellContext`Sinitial$ = 0.; $CellContext`sno1$ = 
          1.; $CellContext`sno2$ = 1.; $CellContext`sno3$ = 
          1.; $CellContext`sno4$ = 
          1.; $CellContext`surfaceid$ = -1.; $CellContext`surfacenumber$ = \
-1.; $CellContext`surfacerotationmatrix$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 
           0., 1.}}; $CellContext`surfacetranslationvector$ = {0., 0., 
           0.}; $CellContext`surfnorm$ = {{1.}}; $CellContext`surfrot$ = {{
           1.}}; $CellContext`surftrans$ = {1., 0., 0.}; $CellContext`symr1$ = 
          1.; $CellContext`symr2$ = 1.; $CellContext`symr3$ = 
          1.; $CellContext`symr4$ = 1.; $CellContext`symr5$ = 
          1.; $CellContext`symr6$ = 1.; $CellContext`symr7$ = 
          1.; $CellContext`symr8$ = 1.; $CellContext`symr9$ = 
          1.; $CellContext`tempclonedata$ = {{
           1.}}; $CellContext`terminatedeflection$ = 
          False; $CellContext`thresholdintensity$ = 
          1.; $CellContext`tiltmagnitude$ = 
          1.; $CellContext`transmatrix$ = {{{1., 0., 0.}, {0., 1., 0.}, {0., 
           0., 1.}}}; $CellContext`LocTV1$ = 1.; $CellContext`LocTV10$ = 
          1.; $CellContext`LocTV2$ = 1.; $CellContext`LocTV3$ = 
          1.; $CellContext`LocTV4$ = 1.; $CellContext`LocTV5$ = 
          1.; $CellContext`LocTV6$ = 1.; $CellContext`LocTV7$ = 
          1.; $CellContext`LocTV8$ = 1.; $CellContext`LocTV9$ = 
          1.; $CellContext`u$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
           1.}}; $CellContext`unfilteredintersections$ = {{-1., 0., 
           0.}}; $CellContext`unit$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
           1.}}; $CellContext`uu$ = {{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
           1.}}; $CellContext`ver$ = 0. + 0. I; $CellContext`wavelength$ = 
          1.; $CellContext`XAxis$ = {1., 0., 0.}; $CellContext`xunit$ = 
          1.; $CellContext`YAxis$ = {1., 0., 0.}; $CellContext`yunit$ = 
          1.; $CellContext`ZAxis$ = {1., 0., 0.}; $CellContext`zunit$ = 
          1.; $CellContext`propagatedrays$ = 
          Join[{$CellContext`symr1$, $CellContext`symr2$, \
$CellContext`symr3$, $CellContext`symr4$, $CellContext`symr5$, \
$CellContext`symr6$, $CellContext`symr7$, $CellContext`symr8$, \
$CellContext`symr9$} = {
               Cos[Degree $CellContext`th$$], 
               Sin[Degree $CellContext`th$$], 0, -
               Sin[Degree $CellContext`th$$], 
               Cos[Degree $CellContext`th$$], 0, 0, 0, 1}; 
            Map[({$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {$CellContext`LocTV1$, $CellContext`LocTV2$, \
$CellContext`LocTV3$} = {$CellContext`rsx$ $CellContext`symr1$ + \
$CellContext`rsy$ $CellContext`symr4$ + $CellContext`rsz$ $CellContext`symr7$ + \
$CellContext`x$$ + (0.5 $CellContext`width$$) 
                  Sin[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr2$ + $CellContext`rsy$ $CellContext`symr5$ + \
$CellContext`rsz$ $CellContext`symr8$ + $CellContext`y$$ - (
                  0.5 $CellContext`width$$) 
                 Cos[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr3$ + $CellContext`rsy$ $CellContext`symr6$ + \
$CellContext`rsz$ $CellContext`symr9$}; {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`rex$ \
$CellContext`symr1$ + $CellContext`rey$ $CellContext`symr4$ + \
$CellContext`rez$ $CellContext`symr7$ + $CellContext`x$$ + (
                   0.5 $CellContext`width$$) 
                  Sin[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr2$ + $CellContext`rey$ $CellContext`symr5$ + \
$CellContext`rez$ $CellContext`symr8$ + $CellContext`y$$ - (
                  0.5 $CellContext`width$$) 
                 Cos[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr3$ + $CellContext`rey$ $CellContext`symr6$ + \
$CellContext`rez$ $CellContext`symr9$}; {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`r1$ \
$CellContext`symr1$ + $CellContext`r2$ $CellContext`symr4$ + $CellContext`r3$ \
$CellContext`symr7$, $CellContext`r1$ $CellContext`symr2$ + $CellContext`r2$ \
$CellContext`symr5$ + $CellContext`r3$ $CellContext`symr8$, $CellContext`r1$ \
$CellContext`symr3$ + $CellContext`r2$ $CellContext`symr6$ + $CellContext`r3$ \
$CellContext`symr9$}; {$CellContext`LocTV4$, $CellContext`LocTV5$, \
$CellContext`LocTV6$} = {$CellContext`r4$ $CellContext`symr1$ + \
$CellContext`r5$ $CellContext`symr4$ + $CellContext`r6$ $CellContext`symr7$, \
$CellContext`r4$ $CellContext`symr2$ + $CellContext`r5$ $CellContext`symr5$ + \
$CellContext`r6$ $CellContext`symr8$, $CellContext`r4$ $CellContext`symr3$ + \
$CellContext`r5$ $CellContext`symr6$ + $CellContext`r6$ $CellContext`symr9$}; \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$} = \
{$CellContext`r7$ $CellContext`symr1$ + $CellContext`r8$ $CellContext`symr4$ + \
$CellContext`r9$ $CellContext`symr7$, $CellContext`r7$ $CellContext`symr2$ + \
$CellContext`r8$ $CellContext`symr5$ + $CellContext`r9$ $CellContext`symr8$, \
$CellContext`r7$ $CellContext`symr3$ + $CellContext`r8$ $CellContext`symr6$ + \
$CellContext`r9$ $CellContext`symr9$}; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
{{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$}, \
{$CellContext`LocTV4$, $CellContext`LocTV5$, $CellContext`LocTV6$}, \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$}}; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 
              0., 1., 0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 
              0., 0., 0., 273039., 273039., 1., 1., 0., 0., 1., 0., 0., 0., 
              1., 0.}}], {$CellContext`symr1$, $CellContext`symr2$, \
$CellContext`symr3$, $CellContext`symr4$, $CellContext`symr5$, \
$CellContext`symr6$, $CellContext`symr7$, $CellContext`symr8$, \
$CellContext`symr9$} = {
               Cos[Degree $CellContext`th$$], 
               Sin[Degree $CellContext`th$$], 0, -
               Sin[Degree $CellContext`th$$], 
               Cos[Degree $CellContext`th$$], 0, 0, 0, 1}; 
            Map[({$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {$CellContext`LocTV1$, $CellContext`LocTV2$, \
$CellContext`LocTV3$} = {$CellContext`rsx$ $CellContext`symr1$ + \
$CellContext`rsy$ $CellContext`symr4$ + $CellContext`rsz$ $CellContext`symr7$ + \
$CellContext`x$$ + (0.4 $CellContext`width$$) 
                  Sin[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr2$ + $CellContext`rsy$ $CellContext`symr5$ + \
$CellContext`rsz$ $CellContext`symr8$ + $CellContext`y$$ - (
                  0.4 $CellContext`width$$) 
                 Cos[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr3$ + $CellContext`rsy$ $CellContext`symr6$ + \
$CellContext`rsz$ $CellContext`symr9$}; {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`rex$ \
$CellContext`symr1$ + $CellContext`rey$ $CellContext`symr4$ + \
$CellContext`rez$ $CellContext`symr7$ + $CellContext`x$$ + (
                   0.4 $CellContext`width$$) 
                  Sin[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr2$ + $CellContext`rey$ $CellContext`symr5$ + \
$CellContext`rez$ $CellContext`symr8$ + $CellContext`y$$ - (
                  0.4 $CellContext`width$$) 
                 Cos[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr3$ + $CellContext`rey$ $CellContext`symr6$ + \
$CellContext`rez$ $CellContext`symr9$}; {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`r1$ \
$CellContext`symr1$ + $CellContext`r2$ $CellContext`symr4$ + $CellContext`r3$ \
$CellContext`symr7$, $CellContext`r1$ $CellContext`symr2$ + $CellContext`r2$ \
$CellContext`symr5$ + $CellContext`r3$ $CellContext`symr8$, $CellContext`r1$ \
$CellContext`symr3$ + $CellContext`r2$ $CellContext`symr6$ + $CellContext`r3$ \
$CellContext`symr9$}; {$CellContext`LocTV4$, $CellContext`LocTV5$, \
$CellContext`LocTV6$} = {$CellContext`r4$ $CellContext`symr1$ + \
$CellContext`r5$ $CellContext`symr4$ + $CellContext`r6$ $CellContext`symr7$, \
$CellContext`r4$ $CellContext`symr2$ + $CellContext`r5$ $CellContext`symr5$ + \
$CellContext`r6$ $CellContext`symr8$, $CellContext`r4$ $CellContext`symr3$ + \
$CellContext`r5$ $CellContext`symr6$ + $CellContext`r6$ $CellContext`symr9$}; \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$} = \
{$CellContext`r7$ $CellContext`symr1$ + $CellContext`r8$ $CellContext`symr4$ + \
$CellContext`r9$ $CellContext`symr7$, $CellContext`r7$ $CellContext`symr2$ + \
$CellContext`r8$ $CellContext`symr5$ + $CellContext`r9$ $CellContext`symr8$, \
$CellContext`r7$ $CellContext`symr3$ + $CellContext`r8$ $CellContext`symr6$ + \
$CellContext`r9$ $CellContext`symr9$}; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
{{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$}, \
{$CellContext`LocTV4$, $CellContext`LocTV5$, $CellContext`LocTV6$}, \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$}}; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 
              0., 1., 0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 
              0., 0., 0., 273042., 273042., 1., 1., 0., 0., 1., 0., 0., 0., 
              1., 0.}}], {$CellContext`symr1$, $CellContext`symr2$, \
$CellContext`symr3$, $CellContext`symr4$, $CellContext`symr5$, \
$CellContext`symr6$, $CellContext`symr7$, $CellContext`symr8$, \
$CellContext`symr9$} = {
               Cos[Degree $CellContext`th$$], 
               Sin[Degree $CellContext`th$$], 0, -
               Sin[Degree $CellContext`th$$], 
               Cos[Degree $CellContext`th$$], 0, 0, 0, 1}; 
            Map[({$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {$CellContext`LocTV1$, $CellContext`LocTV2$, \
$CellContext`LocTV3$} = {$CellContext`rsx$ $CellContext`symr1$ + \
$CellContext`rsy$ $CellContext`symr4$ + $CellContext`rsz$ $CellContext`symr7$ + \
$CellContext`x$$ + (0.3 $CellContext`width$$) 
                  Sin[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr2$ + $CellContext`rsy$ $CellContext`symr5$ + \
$CellContext`rsz$ $CellContext`symr8$ + $CellContext`y$$ - (
                  0.3 $CellContext`width$$) 
                 Cos[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr3$ + $CellContext`rsy$ $CellContext`symr6$ + \
$CellContext`rsz$ $CellContext`symr9$}; {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`rex$ \
$CellContext`symr1$ + $CellContext`rey$ $CellContext`symr4$ + \
$CellContext`rez$ $CellContext`symr7$ + $CellContext`x$$ + (
                   0.3 $CellContext`width$$) 
                  Sin[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr2$ + $CellContext`rey$ $CellContext`symr5$ + \
$CellContext`rez$ $CellContext`symr8$ + $CellContext`y$$ - (
                  0.3 $CellContext`width$$) 
                 Cos[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr3$ + $CellContext`rey$ $CellContext`symr6$ + \
$CellContext`rez$ $CellContext`symr9$}; {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`r1$ \
$CellContext`symr1$ + $CellContext`r2$ $CellContext`symr4$ + $CellContext`r3$ \
$CellContext`symr7$, $CellContext`r1$ $CellContext`symr2$ + $CellContext`r2$ \
$CellContext`symr5$ + $CellContext`r3$ $CellContext`symr8$, $CellContext`r1$ \
$CellContext`symr3$ + $CellContext`r2$ $CellContext`symr6$ + $CellContext`r3$ \
$CellContext`symr9$}; {$CellContext`LocTV4$, $CellContext`LocTV5$, \
$CellContext`LocTV6$} = {$CellContext`r4$ $CellContext`symr1$ + \
$CellContext`r5$ $CellContext`symr4$ + $CellContext`r6$ $CellContext`symr7$, \
$CellContext`r4$ $CellContext`symr2$ + $CellContext`r5$ $CellContext`symr5$ + \
$CellContext`r6$ $CellContext`symr8$, $CellContext`r4$ $CellContext`symr3$ + \
$CellContext`r5$ $CellContext`symr6$ + $CellContext`r6$ $CellContext`symr9$}; \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$} = \
{$CellContext`r7$ $CellContext`symr1$ + $CellContext`r8$ $CellContext`symr4$ + \
$CellContext`r9$ $CellContext`symr7$, $CellContext`r7$ $CellContext`symr2$ + \
$CellContext`r8$ $CellContext`symr5$ + $CellContext`r9$ $CellContext`symr8$, \
$CellContext`r7$ $CellContext`symr3$ + $CellContext`r8$ $CellContext`symr6$ + \
$CellContext`r9$ $CellContext`symr9$}; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
{{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$}, \
{$CellContext`LocTV4$, $CellContext`LocTV5$, $CellContext`LocTV6$}, \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$}}; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 
              0., 1., 0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 
              0., 0., 0., 273045., 273045., 1., 1., 0., 0., 1., 0., 0., 0., 
              1., 0.}}], {$CellContext`symr1$, $CellContext`symr2$, \
$CellContext`symr3$, $CellContext`symr4$, $CellContext`symr5$, \
$CellContext`symr6$, $CellContext`symr7$, $CellContext`symr8$, \
$CellContext`symr9$} = {
               Cos[Degree $CellContext`th$$], 
               Sin[Degree $CellContext`th$$], 0, -
               Sin[Degree $CellContext`th$$], 
               Cos[Degree $CellContext`th$$], 0, 0, 0, 1}; 
            Map[({$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {$CellContext`LocTV1$, $CellContext`LocTV2$, \
$CellContext`LocTV3$} = {$CellContext`rsx$ $CellContext`symr1$ + \
$CellContext`rsy$ $CellContext`symr4$ + $CellContext`rsz$ $CellContext`symr7$ + \
$CellContext`x$$ + (0.19999999999999998` $CellContext`width$$) 
                  Sin[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr2$ + $CellContext`rsy$ $CellContext`symr5$ + \
$CellContext`rsz$ $CellContext`symr8$ + $CellContext`y$$ - (
                  0.19999999999999998` $CellContext`width$$) 
                 Cos[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr3$ + $CellContext`rsy$ $CellContext`symr6$ + \
$CellContext`rsz$ $CellContext`symr9$}; {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`rex$ \
$CellContext`symr1$ + $CellContext`rey$ $CellContext`symr4$ + \
$CellContext`rez$ $CellContext`symr7$ + $CellContext`x$$ + (
                   0.19999999999999998` $CellContext`width$$) 
                  Sin[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr2$ + $CellContext`rey$ $CellContext`symr5$ + \
$CellContext`rez$ $CellContext`symr8$ + $CellContext`y$$ - (
                  0.19999999999999998` $CellContext`width$$) 
                 Cos[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr3$ + $CellContext`rey$ $CellContext`symr6$ + \
$CellContext`rez$ $CellContext`symr9$}; {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`r1$ \
$CellContext`symr1$ + $CellContext`r2$ $CellContext`symr4$ + $CellContext`r3$ \
$CellContext`symr7$, $CellContext`r1$ $CellContext`symr2$ + $CellContext`r2$ \
$CellContext`symr5$ + $CellContext`r3$ $CellContext`symr8$, $CellContext`r1$ \
$CellContext`symr3$ + $CellContext`r2$ $CellContext`symr6$ + $CellContext`r3$ \
$CellContext`symr9$}; {$CellContext`LocTV4$, $CellContext`LocTV5$, \
$CellContext`LocTV6$} = {$CellContext`r4$ $CellContext`symr1$ + \
$CellContext`r5$ $CellContext`symr4$ + $CellContext`r6$ $CellContext`symr7$, \
$CellContext`r4$ $CellContext`symr2$ + $CellContext`r5$ $CellContext`symr5$ + \
$CellContext`r6$ $CellContext`symr8$, $CellContext`r4$ $CellContext`symr3$ + \
$CellContext`r5$ $CellContext`symr6$ + $CellContext`r6$ $CellContext`symr9$}; \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$} = \
{$CellContext`r7$ $CellContext`symr1$ + $CellContext`r8$ $CellContext`symr4$ + \
$CellContext`r9$ $CellContext`symr7$, $CellContext`r7$ $CellContext`symr2$ + \
$CellContext`r8$ $CellContext`symr5$ + $CellContext`r9$ $CellContext`symr8$, \
$CellContext`r7$ $CellContext`symr3$ + $CellContext`r8$ $CellContext`symr6$ + \
$CellContext`r9$ $CellContext`symr9$}; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
{{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$}, \
{$CellContext`LocTV4$, $CellContext`LocTV5$, $CellContext`LocTV6$}, \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$}}; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 
              0., 1., 0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 
              0., 0., 0., 273048., 273048., 1., 1., 0., 0., 1., 0., 0., 0., 
              1., 0.}}], {$CellContext`symr1$, $CellContext`symr2$, \
$CellContext`symr3$, $CellContext`symr4$, $CellContext`symr5$, \
$CellContext`symr6$, $CellContext`symr7$, $CellContext`symr8$, \
$CellContext`symr9$} = {
               Cos[Degree $CellContext`th$$], 
               Sin[Degree $CellContext`th$$], 0, -
               Sin[Degree $CellContext`th$$], 
               Cos[Degree $CellContext`th$$], 0, 0, 0, 1}; 
            Map[({$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {$CellContext`LocTV1$, $CellContext`LocTV2$, \
$CellContext`LocTV3$} = {$CellContext`rsx$ $CellContext`symr1$ + \
$CellContext`rsy$ $CellContext`symr4$ + $CellContext`rsz$ $CellContext`symr7$ + \
$CellContext`x$$ + (0.09999999999999998 $CellContext`width$$) 
                  Sin[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr2$ + $CellContext`rsy$ $CellContext`symr5$ + \
$CellContext`rsz$ $CellContext`symr8$ + $CellContext`y$$ - (
                  0.09999999999999998 $CellContext`width$$) 
                 Cos[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr3$ + $CellContext`rsy$ $CellContext`symr6$ + \
$CellContext`rsz$ $CellContext`symr9$}; {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`rex$ \
$CellContext`symr1$ + $CellContext`rey$ $CellContext`symr4$ + \
$CellContext`rez$ $CellContext`symr7$ + $CellContext`x$$ + (
                   0.09999999999999998 $CellContext`width$$) 
                  Sin[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr2$ + $CellContext`rey$ $CellContext`symr5$ + \
$CellContext`rez$ $CellContext`symr8$ + $CellContext`y$$ - (
                  0.09999999999999998 $CellContext`width$$) 
                 Cos[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr3$ + $CellContext`rey$ $CellContext`symr6$ + \
$CellContext`rez$ $CellContext`symr9$}; {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`r1$ \
$CellContext`symr1$ + $CellContext`r2$ $CellContext`symr4$ + $CellContext`r3$ \
$CellContext`symr7$, $CellContext`r1$ $CellContext`symr2$ + $CellContext`r2$ \
$CellContext`symr5$ + $CellContext`r3$ $CellContext`symr8$, $CellContext`r1$ \
$CellContext`symr3$ + $CellContext`r2$ $CellContext`symr6$ + $CellContext`r3$ \
$CellContext`symr9$}; {$CellContext`LocTV4$, $CellContext`LocTV5$, \
$CellContext`LocTV6$} = {$CellContext`r4$ $CellContext`symr1$ + \
$CellContext`r5$ $CellContext`symr4$ + $CellContext`r6$ $CellContext`symr7$, \
$CellContext`r4$ $CellContext`symr2$ + $CellContext`r5$ $CellContext`symr5$ + \
$CellContext`r6$ $CellContext`symr8$, $CellContext`r4$ $CellContext`symr3$ + \
$CellContext`r5$ $CellContext`symr6$ + $CellContext`r6$ $CellContext`symr9$}; \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$} = \
{$CellContext`r7$ $CellContext`symr1$ + $CellContext`r8$ $CellContext`symr4$ + \
$CellContext`r9$ $CellContext`symr7$, $CellContext`r7$ $CellContext`symr2$ + \
$CellContext`r8$ $CellContext`symr5$ + $CellContext`r9$ $CellContext`symr8$, \
$CellContext`r7$ $CellContext`symr3$ + $CellContext`r8$ $CellContext`symr6$ + \
$CellContext`r9$ $CellContext`symr9$}; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
{{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$}, \
{$CellContext`LocTV4$, $CellContext`LocTV5$, $CellContext`LocTV6$}, \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$}}; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 
              0., 1., 0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 
              0., 0., 0., 273051., 273051., 1., 1., 0., 0., 1., 0., 0., 0., 
              1., 0.}}], {$CellContext`symr1$, $CellContext`symr2$, \
$CellContext`symr3$, $CellContext`symr4$, $CellContext`symr5$, \
$CellContext`symr6$, $CellContext`symr7$, $CellContext`symr8$, \
$CellContext`symr9$} = {
               Cos[Degree $CellContext`th$$], 
               Sin[Degree $CellContext`th$$], 0, -
               Sin[Degree $CellContext`th$$], 
               Cos[Degree $CellContext`th$$], 0, 0, 0, 1}; 
            Map[({$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {$CellContext`LocTV1$, $CellContext`LocTV2$, \
$CellContext`LocTV3$} = {$CellContext`rsx$ $CellContext`symr1$ + \
$CellContext`rsy$ $CellContext`symr4$ + $CellContext`rsz$ $CellContext`symr7$ + \
$CellContext`x$$, $CellContext`rsx$ $CellContext`symr2$ + $CellContext`rsy$ \
$CellContext`symr5$ + $CellContext`rsz$ $CellContext`symr8$ + \
$CellContext`y$$, $CellContext`rsx$ $CellContext`symr3$ + $CellContext`rsy$ \
$CellContext`symr6$ + $CellContext`rsz$ $CellContext`symr9$}; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$} = \
{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$}; \
{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$} = \
{$CellContext`rex$ $CellContext`symr1$ + $CellContext`rey$ \
$CellContext`symr4$ + $CellContext`rez$ $CellContext`symr7$ + \
$CellContext`x$$, $CellContext`rex$ $CellContext`symr2$ + $CellContext`rey$ \
$CellContext`symr5$ + $CellContext`rez$ $CellContext`symr8$ + \
$CellContext`y$$, $CellContext`rex$ $CellContext`symr3$ + $CellContext`rey$ \
$CellContext`symr6$ + $CellContext`rez$ $CellContext`symr9$}; \
{$CellContext`rex$, $CellContext`rey$, $CellContext`rez$} = \
{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$}; \
{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$} = \
{$CellContext`r1$ $CellContext`symr1$ + $CellContext`r2$ $CellContext`symr4$ + \
$CellContext`r3$ $CellContext`symr7$, $CellContext`r1$ $CellContext`symr2$ + \
$CellContext`r2$ $CellContext`symr5$ + $CellContext`r3$ $CellContext`symr8$, \
$CellContext`r1$ $CellContext`symr3$ + $CellContext`r2$ $CellContext`symr6$ + \
$CellContext`r3$ $CellContext`symr9$}; {$CellContext`LocTV4$, \
$CellContext`LocTV5$, $CellContext`LocTV6$} = {$CellContext`r4$ \
$CellContext`symr1$ + $CellContext`r5$ $CellContext`symr4$ + $CellContext`r6$ \
$CellContext`symr7$, $CellContext`r4$ $CellContext`symr2$ + $CellContext`r5$ \
$CellContext`symr5$ + $CellContext`r6$ $CellContext`symr8$, $CellContext`r4$ \
$CellContext`symr3$ + $CellContext`r5$ $CellContext`symr6$ + $CellContext`r6$ \
$CellContext`symr9$}; {$CellContext`LocTV7$, $CellContext`LocTV8$, \
$CellContext`LocTV9$} = {$CellContext`r7$ $CellContext`symr1$ + \
$CellContext`r8$ $CellContext`symr4$ + $CellContext`r9$ $CellContext`symr7$, \
$CellContext`r7$ $CellContext`symr2$ + $CellContext`r8$ $CellContext`symr5$ + \
$CellContext`r9$ $CellContext`symr8$, $CellContext`r7$ $CellContext`symr3$ + \
$CellContext`r8$ $CellContext`symr6$ + $CellContext`r9$ $CellContext`symr9$}; \
{{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}} = {{$CellContext`LocTV1$, $CellContext`LocTV2$, \
$CellContext`LocTV3$}, {$CellContext`LocTV4$, $CellContext`LocTV5$, \
$CellContext`LocTV6$}, {$CellContext`LocTV7$, $CellContext`LocTV8$, \
$CellContext`LocTV9$}}; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 
              0., 1., 0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 
              0., 0., 0., 273054., 273054., 1., 1., 0., 0., 1., 0., 0., 0., 
              1., 0.}}], {$CellContext`symr1$, $CellContext`symr2$, \
$CellContext`symr3$, $CellContext`symr4$, $CellContext`symr5$, \
$CellContext`symr6$, $CellContext`symr7$, $CellContext`symr8$, \
$CellContext`symr9$} = {
               Cos[Degree $CellContext`th$$], 
               Sin[Degree $CellContext`th$$], 0, -
               Sin[Degree $CellContext`th$$], 
               Cos[Degree $CellContext`th$$], 0, 0, 0, 1}; 
            Map[({$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {$CellContext`LocTV1$, $CellContext`LocTV2$, \
$CellContext`LocTV3$} = {$CellContext`rsx$ $CellContext`symr1$ + \
$CellContext`rsy$ $CellContext`symr4$ + $CellContext`rsz$ $CellContext`symr7$ + \
$CellContext`x$$ - (0.10000000000000003` $CellContext`width$$) 
                 Sin[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr2$ + $CellContext`rsy$ $CellContext`symr5$ + \
$CellContext`rsz$ $CellContext`symr8$ + $CellContext`y$$ + (
                   0.10000000000000003` $CellContext`width$$) 
                  Cos[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr3$ + $CellContext`rsy$ $CellContext`symr6$ + \
$CellContext`rsz$ $CellContext`symr9$}; {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`rex$ \
$CellContext`symr1$ + $CellContext`rey$ $CellContext`symr4$ + \
$CellContext`rez$ $CellContext`symr7$ + $CellContext`x$$ - (
                  0.10000000000000003` $CellContext`width$$) 
                 Sin[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr2$ + $CellContext`rey$ $CellContext`symr5$ + \
$CellContext`rez$ $CellContext`symr8$ + $CellContext`y$$ + (
                   0.10000000000000003` $CellContext`width$$) 
                  Cos[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr3$ + $CellContext`rey$ $CellContext`symr6$ + \
$CellContext`rez$ $CellContext`symr9$}; {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`r1$ \
$CellContext`symr1$ + $CellContext`r2$ $CellContext`symr4$ + $CellContext`r3$ \
$CellContext`symr7$, $CellContext`r1$ $CellContext`symr2$ + $CellContext`r2$ \
$CellContext`symr5$ + $CellContext`r3$ $CellContext`symr8$, $CellContext`r1$ \
$CellContext`symr3$ + $CellContext`r2$ $CellContext`symr6$ + $CellContext`r3$ \
$CellContext`symr9$}; {$CellContext`LocTV4$, $CellContext`LocTV5$, \
$CellContext`LocTV6$} = {$CellContext`r4$ $CellContext`symr1$ + \
$CellContext`r5$ $CellContext`symr4$ + $CellContext`r6$ $CellContext`symr7$, \
$CellContext`r4$ $CellContext`symr2$ + $CellContext`r5$ $CellContext`symr5$ + \
$CellContext`r6$ $CellContext`symr8$, $CellContext`r4$ $CellContext`symr3$ + \
$CellContext`r5$ $CellContext`symr6$ + $CellContext`r6$ $CellContext`symr9$}; \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$} = \
{$CellContext`r7$ $CellContext`symr1$ + $CellContext`r8$ $CellContext`symr4$ + \
$CellContext`r9$ $CellContext`symr7$, $CellContext`r7$ $CellContext`symr2$ + \
$CellContext`r8$ $CellContext`symr5$ + $CellContext`r9$ $CellContext`symr8$, \
$CellContext`r7$ $CellContext`symr3$ + $CellContext`r8$ $CellContext`symr6$ + \
$CellContext`r9$ $CellContext`symr9$}; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
{{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$}, \
{$CellContext`LocTV4$, $CellContext`LocTV5$, $CellContext`LocTV6$}, \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$}}; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 
              0., 1., 0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 
              0., 0., 0., 273057., 273057., 1., 1., 0., 0., 1., 0., 0., 0., 
              1., 0.}}], {$CellContext`symr1$, $CellContext`symr2$, \
$CellContext`symr3$, $CellContext`symr4$, $CellContext`symr5$, \
$CellContext`symr6$, $CellContext`symr7$, $CellContext`symr8$, \
$CellContext`symr9$} = {
               Cos[Degree $CellContext`th$$], 
               Sin[Degree $CellContext`th$$], 0, -
               Sin[Degree $CellContext`th$$], 
               Cos[Degree $CellContext`th$$], 0, 0, 0, 1}; 
            Map[({$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {$CellContext`LocTV1$, $CellContext`LocTV2$, \
$CellContext`LocTV3$} = {$CellContext`rsx$ $CellContext`symr1$ + \
$CellContext`rsy$ $CellContext`symr4$ + $CellContext`rsz$ $CellContext`symr7$ + \
$CellContext`x$$ - (0.20000000000000004` $CellContext`width$$) 
                 Sin[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr2$ + $CellContext`rsy$ $CellContext`symr5$ + \
$CellContext`rsz$ $CellContext`symr8$ + $CellContext`y$$ + (
                   0.20000000000000004` $CellContext`width$$) 
                  Cos[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr3$ + $CellContext`rsy$ $CellContext`symr6$ + \
$CellContext`rsz$ $CellContext`symr9$}; {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`rex$ \
$CellContext`symr1$ + $CellContext`rey$ $CellContext`symr4$ + \
$CellContext`rez$ $CellContext`symr7$ + $CellContext`x$$ - (
                  0.20000000000000004` $CellContext`width$$) 
                 Sin[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr2$ + $CellContext`rey$ $CellContext`symr5$ + \
$CellContext`rez$ $CellContext`symr8$ + $CellContext`y$$ + (
                   0.20000000000000004` $CellContext`width$$) 
                  Cos[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr3$ + $CellContext`rey$ $CellContext`symr6$ + \
$CellContext`rez$ $CellContext`symr9$}; {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`r1$ \
$CellContext`symr1$ + $CellContext`r2$ $CellContext`symr4$ + $CellContext`r3$ \
$CellContext`symr7$, $CellContext`r1$ $CellContext`symr2$ + $CellContext`r2$ \
$CellContext`symr5$ + $CellContext`r3$ $CellContext`symr8$, $CellContext`r1$ \
$CellContext`symr3$ + $CellContext`r2$ $CellContext`symr6$ + $CellContext`r3$ \
$CellContext`symr9$}; {$CellContext`LocTV4$, $CellContext`LocTV5$, \
$CellContext`LocTV6$} = {$CellContext`r4$ $CellContext`symr1$ + \
$CellContext`r5$ $CellContext`symr4$ + $CellContext`r6$ $CellContext`symr7$, \
$CellContext`r4$ $CellContext`symr2$ + $CellContext`r5$ $CellContext`symr5$ + \
$CellContext`r6$ $CellContext`symr8$, $CellContext`r4$ $CellContext`symr3$ + \
$CellContext`r5$ $CellContext`symr6$ + $CellContext`r6$ $CellContext`symr9$}; \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$} = \
{$CellContext`r7$ $CellContext`symr1$ + $CellContext`r8$ $CellContext`symr4$ + \
$CellContext`r9$ $CellContext`symr7$, $CellContext`r7$ $CellContext`symr2$ + \
$CellContext`r8$ $CellContext`symr5$ + $CellContext`r9$ $CellContext`symr8$, \
$CellContext`r7$ $CellContext`symr3$ + $CellContext`r8$ $CellContext`symr6$ + \
$CellContext`r9$ $CellContext`symr9$}; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
{{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$}, \
{$CellContext`LocTV4$, $CellContext`LocTV5$, $CellContext`LocTV6$}, \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$}}; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 
              0., 1., 0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 
              0., 0., 0., 273060., 273060., 1., 1., 0., 0., 1., 0., 0., 0., 
              1., 0.}}], {$CellContext`symr1$, $CellContext`symr2$, \
$CellContext`symr3$, $CellContext`symr4$, $CellContext`symr5$, \
$CellContext`symr6$, $CellContext`symr7$, $CellContext`symr8$, \
$CellContext`symr9$} = {
               Cos[Degree $CellContext`th$$], 
               Sin[Degree $CellContext`th$$], 0, -
               Sin[Degree $CellContext`th$$], 
               Cos[Degree $CellContext`th$$], 0, 0, 0, 1}; 
            Map[({$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {$CellContext`LocTV1$, $CellContext`LocTV2$, \
$CellContext`LocTV3$} = {$CellContext`rsx$ $CellContext`symr1$ + \
$CellContext`rsy$ $CellContext`symr4$ + $CellContext`rsz$ $CellContext`symr7$ + \
$CellContext`x$$ - (0.30000000000000004` $CellContext`width$$) 
                 Sin[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr2$ + $CellContext`rsy$ $CellContext`symr5$ + \
$CellContext`rsz$ $CellContext`symr8$ + $CellContext`y$$ + (
                   0.30000000000000004` $CellContext`width$$) 
                  Cos[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr3$ + $CellContext`rsy$ $CellContext`symr6$ + \
$CellContext`rsz$ $CellContext`symr9$}; {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`rex$ \
$CellContext`symr1$ + $CellContext`rey$ $CellContext`symr4$ + \
$CellContext`rez$ $CellContext`symr7$ + $CellContext`x$$ - (
                  0.30000000000000004` $CellContext`width$$) 
                 Sin[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr2$ + $CellContext`rey$ $CellContext`symr5$ + \
$CellContext`rez$ $CellContext`symr8$ + $CellContext`y$$ + (
                   0.30000000000000004` $CellContext`width$$) 
                  Cos[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr3$ + $CellContext`rey$ $CellContext`symr6$ + \
$CellContext`rez$ $CellContext`symr9$}; {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`r1$ \
$CellContext`symr1$ + $CellContext`r2$ $CellContext`symr4$ + $CellContext`r3$ \
$CellContext`symr7$, $CellContext`r1$ $CellContext`symr2$ + $CellContext`r2$ \
$CellContext`symr5$ + $CellContext`r3$ $CellContext`symr8$, $CellContext`r1$ \
$CellContext`symr3$ + $CellContext`r2$ $CellContext`symr6$ + $CellContext`r3$ \
$CellContext`symr9$}; {$CellContext`LocTV4$, $CellContext`LocTV5$, \
$CellContext`LocTV6$} = {$CellContext`r4$ $CellContext`symr1$ + \
$CellContext`r5$ $CellContext`symr4$ + $CellContext`r6$ $CellContext`symr7$, \
$CellContext`r4$ $CellContext`symr2$ + $CellContext`r5$ $CellContext`symr5$ + \
$CellContext`r6$ $CellContext`symr8$, $CellContext`r4$ $CellContext`symr3$ + \
$CellContext`r5$ $CellContext`symr6$ + $CellContext`r6$ $CellContext`symr9$}; \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$} = \
{$CellContext`r7$ $CellContext`symr1$ + $CellContext`r8$ $CellContext`symr4$ + \
$CellContext`r9$ $CellContext`symr7$, $CellContext`r7$ $CellContext`symr2$ + \
$CellContext`r8$ $CellContext`symr5$ + $CellContext`r9$ $CellContext`symr8$, \
$CellContext`r7$ $CellContext`symr3$ + $CellContext`r8$ $CellContext`symr6$ + \
$CellContext`r9$ $CellContext`symr9$}; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
{{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$}, \
{$CellContext`LocTV4$, $CellContext`LocTV5$, $CellContext`LocTV6$}, \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$}}; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 
              0., 1., 0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 
              0., 0., 0., 273063., 273063., 1., 1., 0., 0., 1., 0., 0., 0., 
              1., 0.}}], {$CellContext`symr1$, $CellContext`symr2$, \
$CellContext`symr3$, $CellContext`symr4$, $CellContext`symr5$, \
$CellContext`symr6$, $CellContext`symr7$, $CellContext`symr8$, \
$CellContext`symr9$} = {
               Cos[Degree $CellContext`th$$], 
               Sin[Degree $CellContext`th$$], 0, -
               Sin[Degree $CellContext`th$$], 
               Cos[Degree $CellContext`th$$], 0, 0, 0, 1}; 
            Map[({$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {$CellContext`LocTV1$, $CellContext`LocTV2$, \
$CellContext`LocTV3$} = {$CellContext`rsx$ $CellContext`symr1$ + \
$CellContext`rsy$ $CellContext`symr4$ + $CellContext`rsz$ $CellContext`symr7$ + \
$CellContext`x$$ - (0.4 $CellContext`width$$) 
                 Sin[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr2$ + $CellContext`rsy$ $CellContext`symr5$ + \
$CellContext`rsz$ $CellContext`symr8$ + $CellContext`y$$ + (
                   0.4 $CellContext`width$$) 
                  Cos[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr3$ + $CellContext`rsy$ $CellContext`symr6$ + \
$CellContext`rsz$ $CellContext`symr9$}; {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`rex$ \
$CellContext`symr1$ + $CellContext`rey$ $CellContext`symr4$ + \
$CellContext`rez$ $CellContext`symr7$ + $CellContext`x$$ - (
                  0.4 $CellContext`width$$) 
                 Sin[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr2$ + $CellContext`rey$ $CellContext`symr5$ + \
$CellContext`rez$ $CellContext`symr8$ + $CellContext`y$$ + (
                   0.4 $CellContext`width$$) 
                  Cos[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr3$ + $CellContext`rey$ $CellContext`symr6$ + \
$CellContext`rez$ $CellContext`symr9$}; {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`r1$ \
$CellContext`symr1$ + $CellContext`r2$ $CellContext`symr4$ + $CellContext`r3$ \
$CellContext`symr7$, $CellContext`r1$ $CellContext`symr2$ + $CellContext`r2$ \
$CellContext`symr5$ + $CellContext`r3$ $CellContext`symr8$, $CellContext`r1$ \
$CellContext`symr3$ + $CellContext`r2$ $CellContext`symr6$ + $CellContext`r3$ \
$CellContext`symr9$}; {$CellContext`LocTV4$, $CellContext`LocTV5$, \
$CellContext`LocTV6$} = {$CellContext`r4$ $CellContext`symr1$ + \
$CellContext`r5$ $CellContext`symr4$ + $CellContext`r6$ $CellContext`symr7$, \
$CellContext`r4$ $CellContext`symr2$ + $CellContext`r5$ $CellContext`symr5$ + \
$CellContext`r6$ $CellContext`symr8$, $CellContext`r4$ $CellContext`symr3$ + \
$CellContext`r5$ $CellContext`symr6$ + $CellContext`r6$ $CellContext`symr9$}; \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$} = \
{$CellContext`r7$ $CellContext`symr1$ + $CellContext`r8$ $CellContext`symr4$ + \
$CellContext`r9$ $CellContext`symr7$, $CellContext`r7$ $CellContext`symr2$ + \
$CellContext`r8$ $CellContext`symr5$ + $CellContext`r9$ $CellContext`symr8$, \
$CellContext`r7$ $CellContext`symr3$ + $CellContext`r8$ $CellContext`symr6$ + \
$CellContext`r9$ $CellContext`symr9$}; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
{{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$}, \
{$CellContext`LocTV4$, $CellContext`LocTV5$, $CellContext`LocTV6$}, \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$}}; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 
              0., 1., 0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 
              0., 0., 0., 273066., 273066., 1., 1., 0., 0., 1., 0., 0., 0., 
              1., 0.}}], {$CellContext`symr1$, $CellContext`symr2$, \
$CellContext`symr3$, $CellContext`symr4$, $CellContext`symr5$, \
$CellContext`symr6$, $CellContext`symr7$, $CellContext`symr8$, \
$CellContext`symr9$} = {
               Cos[Degree $CellContext`th$$], 
               Sin[Degree $CellContext`th$$], 0, -
               Sin[Degree $CellContext`th$$], 
               Cos[Degree $CellContext`th$$], 0, 0, 0, 1}; 
            Map[({$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {$CellContext`LocTV1$, $CellContext`LocTV2$, \
$CellContext`LocTV3$} = {$CellContext`rsx$ $CellContext`symr1$ + \
$CellContext`rsy$ $CellContext`symr4$ + $CellContext`rsz$ $CellContext`symr7$ + \
$CellContext`x$$ - (0.5 $CellContext`width$$) 
                 Sin[Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr2$ + $CellContext`rsy$ $CellContext`symr5$ + \
$CellContext`rsz$ $CellContext`symr8$ + $CellContext`y$$ + (
                   0.5 $CellContext`width$$) 
                  Cos[
                   Degree $CellContext`th$$], $CellContext`rsx$ \
$CellContext`symr3$ + $CellContext`rsy$ $CellContext`symr6$ + \
$CellContext`rsz$ $CellContext`symr9$}; {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`rex$ \
$CellContext`symr1$ + $CellContext`rey$ $CellContext`symr4$ + \
$CellContext`rez$ $CellContext`symr7$ + $CellContext`x$$ - (
                  0.5 $CellContext`width$$) 
                 Sin[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr2$ + $CellContext`rey$ $CellContext`symr5$ + \
$CellContext`rez$ $CellContext`symr8$ + $CellContext`y$$ + (
                   0.5 $CellContext`width$$) 
                  Cos[Degree $CellContext`th$$], $CellContext`rex$ \
$CellContext`symr3$ + $CellContext`rey$ $CellContext`symr6$ + \
$CellContext`rez$ $CellContext`symr9$}; {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} = {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$}; {$CellContext`LocTV1$, \
$CellContext`LocTV2$, $CellContext`LocTV3$} = {$CellContext`r1$ \
$CellContext`symr1$ + $CellContext`r2$ $CellContext`symr4$ + $CellContext`r3$ \
$CellContext`symr7$, $CellContext`r1$ $CellContext`symr2$ + $CellContext`r2$ \
$CellContext`symr5$ + $CellContext`r3$ $CellContext`symr8$, $CellContext`r1$ \
$CellContext`symr3$ + $CellContext`r2$ $CellContext`symr6$ + $CellContext`r3$ \
$CellContext`symr9$}; {$CellContext`LocTV4$, $CellContext`LocTV5$, \
$CellContext`LocTV6$} = {$CellContext`r4$ $CellContext`symr1$ + \
$CellContext`r5$ $CellContext`symr4$ + $CellContext`r6$ $CellContext`symr7$, \
$CellContext`r4$ $CellContext`symr2$ + $CellContext`r5$ $CellContext`symr5$ + \
$CellContext`r6$ $CellContext`symr8$, $CellContext`r4$ $CellContext`symr3$ + \
$CellContext`r5$ $CellContext`symr6$ + $CellContext`r6$ $CellContext`symr9$}; \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$} = \
{$CellContext`r7$ $CellContext`symr1$ + $CellContext`r8$ $CellContext`symr4$ + \
$CellContext`r9$ $CellContext`symr7$, $CellContext`r7$ $CellContext`symr2$ + \
$CellContext`r8$ $CellContext`symr5$ + $CellContext`r9$ $CellContext`symr8$, \
$CellContext`r7$ $CellContext`symr3$ + $CellContext`r8$ $CellContext`symr6$ + \
$CellContext`r9$ $CellContext`symr9$}; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
{{$CellContext`LocTV1$, $CellContext`LocTV2$, $CellContext`LocTV3$}, \
{$CellContext`LocTV4$, $CellContext`LocTV5$, $CellContext`LocTV6$}, \
{$CellContext`LocTV7$, $CellContext`LocTV8$, $CellContext`LocTV9$}}; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , {{0., 0., 0., 0., 0., 0., 1., 0., 0., 0., 1., 0., 0., 
              0., 1., 0.532, 100., 1., 0., 1.00026945145708, 0., 0., 0., 0., 
              0., 0., 0., 273069., 273069., 1., 1., 0., 0., 1., 0., 0., 0., 
              1., 0.}}]]; $CellContext`propagatedrays$ = 
          Map[({$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`componentnumber$ = 
             1.; $CellContext`frontid$ = 
             1.; {$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, \
$CellContext`rex$, $CellContext`rey$, $CellContext`rez$, $CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$, $CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$, $CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`propagatedrays$]; \
$CellContext`thresholdintensity$ = 1.; $CellContext`generationlimit$ = 
          200.; $CellContext`reportedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`generationnumber$ = 
          0.; ($CellContext`inrays$ = $CellContext`propagatedrays$; \
$CellContext`outrays$ = {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
            1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1.,
             1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
            1.}}; $CellContext`deflectedrayspresent$ = 
           True; $CellContext`reportedrayspresent$ = 
           False; $CellContext`propagate$ = True; While[
            And[$CellContext`deflectedrayspresent$, $CellContext`propagate$], 
            AddTo[$CellContext`generationnumber$, 
              1.]; ($CellContext`deflecteddummyrayspresent$ = 
              False; $CellContext`deflectedrayspresent$ = 
              False; $CellContext`reportedrayspresent$ = 
              False; $CellContext`reporteddummyrayspresent$ = 
              True; $CellContext`localdummyoutrayspresent$ = 
              False; $CellContext`localoutrayspresent$ = 
              False; {$CellContext`deflectedlocalrays$, \
$CellContext`localoutrays$, $CellContext`reportedlocalrays$} = 
              Map[Flatten[#, 1]& , 
                Transpose[
                 
                 Map[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; If[
                    
                    And[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`generationnumber$ < \
$CellContext`generationlimit$], ($CellContext`resonatenumber$ = 
                    0; $CellContext`resonateraylength$ = 
                    9.87654321*^8; $CellContext`resonateintersections$ = \
{{-1., 0., 0.}}; MapIndexed[If[
                    And[
                    Part[#, 1, 1] > -1., 
                    Part[#, 1, 
                    1] < $CellContext`resonateraylength$], \
$CellContext`resonateraylength$ = 
                    Part[#, 1, 
                    1]; $CellContext`resonateintersections$ = #; \
$CellContext`resonatenumber$ = 
                    First[#2], $CellContext`resonatenumber$]& , \
$CellContext`intersectionslist$ = {{{-1., 0., 
                    0.}}}; $CellContext`holeQlist$ = {
                    0}; ({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                    Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = \
$CellContext`rex$ - 1. 
                    Re[$CellContext`glx$$]; $CellContext`ry$ = \
$CellContext`rey$ - 1. 
                    Re[$CellContext`gly$$]; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., 
                    And[
                    Part[#, 2] <= 5., Part[#, 2] >= -5., Part[#, 3] >= -5., 
                    Part[#, 3] <= 5.]], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 272713.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                    If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; 
                    AppendTo[$CellContext`intersectionslist$, \
$CellContext`intersections$]; If[$CellContext`holeQ$, 
                    AppendTo[$CellContext`holeQlist$, 1], 
                    
                    AppendTo[$CellContext`holeQlist$, 
                    0]]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                    Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -10. + \
$CellContext`rex$ - 1. 
                    Re[$CellContext`glx$$]; $CellContext`ry$ = \
$CellContext`rey$ - 1. 
                    Re[$CellContext`gly$$]; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., 
                    And[
                    Part[#, 2] <= 5., Part[#, 2] >= -5., Part[#, 3] >= -5., 
                    Part[#, 3] <= 5.]], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 272778.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                    If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; 
                    AppendTo[$CellContext`intersectionslist$, \
$CellContext`intersections$]; If[$CellContext`holeQ$, 
                    AppendTo[$CellContext`holeQlist$, 1], 
                    
                    AppendTo[$CellContext`holeQlist$, 
                    0]]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r3$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = -$CellContext`r1$; \
$CellContext`xunit$ = Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -5. + \
$CellContext`rez$; $CellContext`ry$ = $CellContext`rey$ - 1. 
                    Re[$CellContext`gly$$]; $CellContext`rz$ = -(-5. + \
$CellContext`rex$ - 1. Re[$CellContext`glx$$]); $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., 
                    And[
                    Part[#, 2] <= 5., Part[#, 2] >= -5., Part[#, 3] >= -5., 
                    Part[#, 3] <= 5.]], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 272521.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                    If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; 
                    AppendTo[$CellContext`intersectionslist$, \
$CellContext`intersections$]; If[$CellContext`holeQ$, 
                    AppendTo[$CellContext`holeQlist$, 1], 
                    AppendTo[$CellContext`holeQlist$, 
                    0]]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = -$CellContext`r3$; $CellContext`yunit$ = \
-$CellContext`r2$; $CellContext`zunit$ = -$CellContext`r1$; \
$CellContext`xunit$ = Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -(
                    5. + $CellContext`rez$); $CellContext`ry$ = \
-($CellContext`rey$ - 1. 
                    Re[$CellContext`gly$$]); $CellContext`rz$ = -(-5. + \
$CellContext`rex$ - 1. Re[$CellContext`glx$$]); $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., 
                    And[
                    Part[#, 2] <= 5., Part[#, 2] >= -5., Part[#, 3] >= -5., 
                    Part[#, 3] <= 5.]], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 272551.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                    If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; 
                    AppendTo[$CellContext`intersectionslist$, \
$CellContext`intersections$]; If[$CellContext`holeQ$, 
                    AppendTo[$CellContext`holeQlist$, 1], 
                    
                    AppendTo[$CellContext`holeQlist$, 
                    0]]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = -$CellContext`r2$; $CellContext`yunit$ = \
$CellContext`r1$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                    Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -(-5. + \
$CellContext`rey$ - 1. 
                    Re[$CellContext`gly$$]); $CellContext`ry$ = -5. + \
$CellContext`rex$ - 1. 
                    Re[$CellContext`glx$$]; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., 
                    And[
                    Part[#, 2] <= 5., Part[#, 2] >= -5., Part[#, 3] >= -5., 
                    Part[#, 3] <= 5.]], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 272617.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                    If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; 
                    AppendTo[$CellContext`intersectionslist$, \
$CellContext`intersections$]; If[$CellContext`holeQ$, 
                    AppendTo[$CellContext`holeQlist$, 1], 
                    
                    AppendTo[$CellContext`holeQlist$, 
                    0]]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r2$; $CellContext`yunit$ = \
-$CellContext`r1$; $CellContext`zunit$ = $CellContext`r3$; \
$CellContext`xunit$ = Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                    5. + $CellContext`rey$ - 1. 
                    Re[$CellContext`gly$$]; $CellContext`ry$ = -(-5. + \
$CellContext`rex$ - 1. 
                    Re[$CellContext`glx$$]); $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., 
                    And[
                    Part[#, 2] <= 5., Part[#, 2] >= -5., Part[#, 3] >= -5., 
                    Part[#, 3] <= 5.]], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 272683.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                    If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; 
                    AppendTo[$CellContext`intersectionslist$, \
$CellContext`intersections$]; If[$CellContext`holeQ$, 
                    AppendTo[$CellContext`holeQlist$, 1], 
                    
                    AppendTo[$CellContext`holeQlist$, 
                    0]]); $CellContext`holeQlist$ = 
                    Drop[$CellContext`holeQlist$, 1]; 
                    Drop[$CellContext`intersectionslist$, 1]]); 
                    Which[$CellContext`resonatenumber$ == 
                    1, {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                    Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = \
$CellContext`rex$ - 1. 
                    Re[$CellContext`glx$$]; $CellContext`ry$ = \
$CellContext`rey$ - 1. 
                    Re[$CellContext`gly$$]; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = \
$CellContext`resonateintersections$; $CellContext`holeQ$ = 
                    Part[$CellContext`holeQlist$, \
$CellContext`resonatenumber$] == 
                    1; {$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 1., 
                    272713.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 1., 
                    272713.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
$CellContext`rxhlp$ + 
                    Re[$CellContext`glx$$]; $CellContext`rey$ = \
$CellContext`ryhlp$ + 
                    Re[$CellContext`gly$$]; $CellContext`rez$ = \
$CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`reportedrayspresent$ = 
                    True; $CellContext`intersectionspresent$ = 
                    True; $CellContext`deflectedrayspresent$ = 
                    True; $CellContext`localdummyoutrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = {
                    Re[$CellContext`glx$$], 
                    Re[$CellContext`gly$$], 0.}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; \
$CellContext`surftrans$ = $CellContext`surfacetranslationvector$; \
$CellContext`surfrot$ = $CellContext`surfacerotationmatrix$; 
                    Which[$CellContext`surfaceid$ == 
                    272713, $CellContext`localtranslation$ = {0, 0, 
                    0}; $CellContext`localrotation$ = {{1, 0, 0}, {0, 1, 0}, {
                    0, 0, 1}}, $CellContext`surfaceid$ == 
                    272778, $CellContext`localtranslation$ = {10., 0., 
                    0.}; $CellContext`localrotation$ = {{1., 0., 0.}, {0., 1.,
                     0.}, {0., 0., 1.}}, $CellContext`surfaceid$ == 
                    272521, $CellContext`localtranslation$ = {5., 0., 
                    5.}; $CellContext`localrotation$ = {{0., 0., 1.}, {0., 1.,
                     0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272551, $CellContext`localtranslation$ = {5., 
                    0., -5.}; $CellContext`localrotation$ = {{0., 0., -1.}, {
                    0., -1., 0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272617, $CellContext`localtranslation$ = {5., 5., 
                    0.}; $CellContext`localrotation$ = {{0., -1., 0.}, {1., 
                    0., 0.}, {0., 0., 1.}}, 
                    True, $CellContext`localtranslation$ = {5., -5., 
                    0.}; $CellContext`localrotation$ = {{0., 1., 0.}, {-1., 
                    0., 0.}, {0., 0., 1.}}]; $CellContext`localpos$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} - $CellContext`surftrans$]; \
$CellContext`localtilt$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`localpos$ = 
                    Dot[$CellContext`localpos$, $CellContext`localrotation$] + \
$CellContext`localtranslation$; $CellContext`localtilt$ = 
                    
                    Dot[$CellContext`localtilt$, $CellContext`localrotation$]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; $CellContext`allcreatedrays$ = \
{{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]; \
($CellContext`originalray$ = 
                    First[$CellContext`allcreatedrays$]; \
$CellContext`completedray$ = $CellContext`originalray$); \
$CellContext`deflectedrays$ = $CellContext`allcreatedrays$; \
$CellContext`newdeflectedrays$ = {$CellContext`originalray$}; 
                    Scan[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; ($CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; If[
                    Abs[$CellContext`raytiltx$] < 1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = $CellContext`baseIndex$$ - \
$CellContext`factorX$$ ($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - \
$CellContext`factorY$$ ($CellContext`LocRSy$ - $CellContext`ypos$$)^2; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]], \
$CellContext`index2$ = Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = \
$CellContext`baseIndex$$ - $CellContext`factorX$$ ($CellContext`LocRSx$ - \
$CellContext`xpos$$)^2 - $CellContext`factorY$$ ($CellContext`LocRSy$ - \
$CellContext`ypos$$)^2; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = \
$CellContext`baseIndex$$ - $CellContext`factorX$$ ($CellContext`LocRSx$ - \
$CellContext`xpos$$)^2 - $CellContext`factorY$$ ($CellContext`LocRSy$ - \
$CellContext`ypos$$)^2]]; $CellContext`n12$ = \
$CellContext`index1$/$CellContext`index2$; $CellContext`index$ = \
$CellContext`index2$; If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 
                    1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]); \
$CellContext`newdeflectedrays$ = 
                    Join[$CellContext`newdeflectedrays$, \
$CellContext`allcreatedrays$])& , $CellContext`deflectedrays$]; \
$CellContext`allcreatedrays$ = 
                    Drop[$CellContext`newdeflectedrays$, 
                    1]; $CellContext`deflectedrays$ = \
$CellContext`allcreatedrays$; $CellContext`newdeflectedrays$ = \
{$CellContext`originalray$}; 
                    Scan[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; ($CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; If[
                    Abs[$CellContext`raytiltx$] < 1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; \
$CellContext`surftrans$ = $CellContext`surfacetranslationvector$; \
$CellContext`surfrot$ = $CellContext`surfacerotationmatrix$; 
                    Which[$CellContext`surfaceid$ == 
                    272713, $CellContext`localtranslation$ = {0, 0, 
                    0}; $CellContext`localrotation$ = {{1, 0, 0}, {0, 1, 0}, {
                    0, 0, 1}}, $CellContext`surfaceid$ == 
                    272778, $CellContext`localtranslation$ = {10., 0., 
                    0.}; $CellContext`localrotation$ = {{1., 0., 0.}, {0., 1.,
                     0.}, {0., 0., 1.}}, $CellContext`surfaceid$ == 
                    272521, $CellContext`localtranslation$ = {5., 0., 
                    5.}; $CellContext`localrotation$ = {{0., 0., 1.}, {0., 1.,
                     0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272551, $CellContext`localtranslation$ = {5., 
                    0., -5.}; $CellContext`localrotation$ = {{0., 0., -1.}, {
                    0., -1., 0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272617, $CellContext`localtranslation$ = {5., 5., 
                    0.}; $CellContext`localrotation$ = {{0., -1., 0.}, {1., 
                    0., 0.}, {0., 0., 1.}}, 
                    True, $CellContext`localtranslation$ = {5., -5., 
                    0.}; $CellContext`localrotation$ = {{0., 1., 0.}, {-1., 
                    0., 0.}, {0., 0., 1.}}]; $CellContext`localopticallength$ = 
                    0.; $CellContext`localraylength$ = 
                    0.; $CellContext`integratedrefractiveindex$ = 
                    0.; $CellContext`localpos$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} - $CellContext`surftrans$]; \
$CellContext`localtilt$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[$CellContext`activeregion$ 
                    Part[$CellContext`localtilt$, 1] > 
                    0, {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$; $CellContext`localpos$ = 
                    Dot[$CellContext`localpos$, $CellContext`localrotation$] + \
$CellContext`localtranslation$; $CellContext`localtilt$ = 
                    Dot[$CellContext`localtilt$, $CellContext`localrotation$]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; $CellContext`localindex$ = $CellContext`index$; \
$CellContext`localindex$ = $CellContext`baseIndex$$ - $CellContext`factorX$$ \
($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - $CellContext`factorY$$ \
($CellContext`LocRSy$ - $CellContext`ypos$$)^2; $CellContext`listofpositions$ = \
{{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}}; \
$CellContext`listoftilts$ = {{
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}}; $CellContext`indexpoints$ = \
{$CellContext`localindex$}; $CellContext`opticallengths$ = \
{$CellContext`opticallength$}; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; $CellContext`localtilt$ = \
$CellContext`localindex$ $CellContext`localtilt$; $CellContext`Ninitial$ = \
$CellContext`localindex$^2; $CellContext`Sinitial$ = 
                    0.1^2 Dot[{(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}, $CellContext`localtilt$]; $CellContext`rSxOffset$ = 
                    0.; While[
                    And[
                    Plus[10.] - ($CellContext`LocRSx$ - \
$CellContext`rSxOffset$) >= (-0.01) 0.1, 
                    Plus[$CellContext`LocRSx$ - $CellContext`rSxOffset$] >= \
(-0.01) 0.1, 
                    And[
                    0.99999 $CellContext`LocRSy$ <= 5., 
                    0.99999 $CellContext`LocRSy$ >= -5., 
                    0.99999 $CellContext`LocRSz$ >= -5., 
                    0.99999 $CellContext`LocRSz$ <= 
                    5.]], $CellContext`localraylength$ = \
($CellContext`localraylength$ + Sqrt[
                    
                    Dot[#, #]]& )[$CellContext`localpos$ - \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}]; \
$CellContext`localpos$ = {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$}; 
                    AppendTo[$CellContext`listofpositions$, \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}]; 
                    AppendTo[$CellContext`listoftilts$, {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}]; $CellContext`localindex$ = $CellContext`baseIndex$$ - \
$CellContext`factorX$$ ($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - \
$CellContext`factorY$$ ($CellContext`LocRSy$ - $CellContext`ypos$$)^2; 
                    AppendTo[$CellContext`indexpoints$, \
$CellContext`localindex$]; $CellContext`opticallengths$ = 
                    Append[$CellContext`opticallengths$, 
                    Last[$CellContext`opticallengths$] + \
$CellContext`localindex$ 
                    0.1]; $CellContext`integratedrefractiveindex$ = \
$CellContext`integratedrefractiveindex$ + $CellContext`localindex$^2; \
$CellContext`localtilt$ = $CellContext`localindex$ {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}; $CellContext`Aelement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$ + (
                    0.1 $CellContext`localtilt$)/
                    2. + (0.1 $CellContext`Aelement$)/
                    8.; $CellContext`Belement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$ + 
                    0.1 $CellContext`localtilt$ + (
                    0.1 $CellContext`Belement$)/2; $CellContext`Celement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; $CellContext`newpos$ = $CellContext`localpos$ + 
                    0.1 ($CellContext`localtilt$ + ($CellContext`Aelement$ + 
                    2 $CellContext`Belement$)/
                    6); $CellContext`newtilt$ = $CellContext`localtilt$ + \
($CellContext`Aelement$ + 4. $CellContext`Aelement$ + $CellContext`Celement$)/
                    6.; $CellContext`newtilt$ = $CellContext`newtilt$/Sqrt[
                    
                    Dot[$CellContext`newtilt$, $CellContext`newtilt$]]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`newpos$; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`newtilt$; 
                    1.]; $CellContext`integratedrefractiveindex$ = \
$CellContext`integratedrefractiveindex$ - $CellContext`localindex$^2; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; $CellContext`Sfinal$ = 
                    0.1 Dot[$CellContext`Aelement$, $CellContext`localtilt$]; \
$CellContext`Nfinal$ = $CellContext`localindex$^2; $CellContext`localtilt$ = \
$CellContext`localtilt$/Sqrt[
                    Dot[$CellContext`localtilt$, $CellContext`localtilt$]]; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; \
$CellContext`localopticallength$ = 
                    0.1 $CellContext`integratedrefractiveindex$ - \
($CellContext`Sfinal$ - $CellContext`Sinitial$)/
                    6 + (0.1 ($CellContext`Nfinal$ - $CellContext`Ninitial$))/
                    2; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`localopticallength$; \
$CellContext`ray1$ = $CellContext`localraylength$; $CellContext`localpos$ = 
                    Dot[$CellContext`localrotation$, $CellContext`localpos$ - \
$CellContext`localtranslation$]; {$CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$} = 
                    Dot[$CellContext`localpos$, $CellContext`surfrot$] + \
$CellContext`surftrans$; $CellContext`localtilt$ = 
                    Dot[$CellContext`localrotation$, $CellContext`localtilt$]; \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = 
                    Dot[$CellContext`localtilt$, $CellContext`surfrot$]; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$} = \
{$CellContext`rex$, $CellContext`rey$, $CellContext`rez$}; \
$CellContext`index$ = $CellContext`baseIndex$$ - $CellContext`factorX$$ \
($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - $CellContext`factorY$$ \
($CellContext`LocRSy$ - $CellContext`ypos$$)^2; $CellContext`allcreatedrays$ = \
{{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`listofpositions$ = 
                    Map[Dot[$CellContext`localrotation$, # - \
$CellContext`localtranslation$]& , $CellContext`listofpositions$]; \
$CellContext`listofpositions$ = 
                    Map[Dot[#, $CellContext`surfrot$] + \
$CellContext`surftrans$& , $CellContext`listofpositions$]; \
$CellContext`listoftilts$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`listoftilts$]; \
$CellContext`listoftilts$ = Map[
                    Dot[#, $CellContext`surfrot$]& , \
$CellContext`listoftilts$]; If[
                    
                    And[$CellContext`reportedrayspresent$, 
                    Length[$CellContext`indexpoints$] > 
                    1], $CellContext`reportedrays$ = 
                    Join[$CellContext`reportedrays$, 
                    
                    Table[{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$} = 
                    Part[$CellContext`listofpositions$, \
$CellContext`ninteger$]; {$CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$} = 
                    Part[$CellContext`listofpositions$, \
$CellContext`ninteger$ + 
                    1]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = 
                    Part[$CellContext`listoftilts$, $CellContext`ninteger$]; \
$CellContext`ray1$ = 0.1; $CellContext`index$ = 
                    Part[$CellContext`indexpoints$, $CellContext`ninteger$]; \
$CellContext`opticallength$ = 
                    Part[$CellContext`opticallengths$, \
$CellContext`ninteger$]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`ninteger$, 1, 
                    Length[$CellContext`indexpoints$] - 1}]]; 1., 
                    1.]; $CellContext`allcreatedrays$, \
$CellContext`allcreatedrays$ = {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}]; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]); \
$CellContext`newdeflectedrays$ = 
                    Join[$CellContext`newdeflectedrays$, \
$CellContext`allcreatedrays$])& , $CellContext`deflectedrays$]; \
$CellContext`allcreatedrays$ = 
                    Drop[$CellContext`newdeflectedrays$, 
                    1]; $CellContext`deflectedrays$ = \
$CellContext`allcreatedrays$; $CellContext`deflectedrays$ = 
                    MapIndexed[ReplacePart[#, 
                    First[#2], 
                    34]& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = $CellContext`deflectedrays$); \
{$CellContext`allcreatedrays$, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 
                    0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,
                     1., 1., 1., 
                    1.}}, {$CellContext`completedray$}}, \
$CellContext`resonatenumber$ == 
                    2, {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                    Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -10. + \
$CellContext`rex$ - 1. 
                    Re[$CellContext`glx$$]; $CellContext`ry$ = \
$CellContext`rey$ - 1. 
                    Re[$CellContext`gly$$]; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    
                    0.}}; $CellContext`intersections$ = \
$CellContext`resonateintersections$; $CellContext`holeQ$ = 
                    Part[$CellContext`holeQlist$, \
$CellContext`resonatenumber$] == 
                    1; {$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 2., 
                    272778.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 2., 
                    272778.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = 
                    10. + $CellContext`rxhlp$ + 
                    Re[$CellContext`glx$$]; $CellContext`rey$ = \
$CellContext`ryhlp$ + 
                    Re[$CellContext`gly$$]; $CellContext`rez$ = \
$CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`reportedrayspresent$ = 
                    True; $CellContext`intersectionspresent$ = 
                    True; $CellContext`deflectedrayspresent$ = 
                    True; $CellContext`localdummyoutrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1., 0, 0}, {0, 1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = {
                    10. + Re[$CellContext`glx$$], 
                    Re[$CellContext`gly$$], 
                    0.}; $CellContext`activeregion$ = -1.; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; \
$CellContext`surftrans$ = $CellContext`surfacetranslationvector$; \
$CellContext`surfrot$ = $CellContext`surfacerotationmatrix$; 
                    Which[$CellContext`surfaceid$ == 
                    272713, $CellContext`localtranslation$ = {0, 0, 
                    0}; $CellContext`localrotation$ = {{1, 0, 0}, {0, 1, 0}, {
                    0, 0, 1}}, $CellContext`surfaceid$ == 
                    272778, $CellContext`localtranslation$ = {10., 0., 
                    0.}; $CellContext`localrotation$ = {{1., 0., 0.}, {0., 1.,
                     0.}, {0., 0., 1.}}, $CellContext`surfaceid$ == 
                    272521, $CellContext`localtranslation$ = {5., 0., 
                    5.}; $CellContext`localrotation$ = {{0., 0., 1.}, {0., 1.,
                     0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272551, $CellContext`localtranslation$ = {5., 
                    0., -5.}; $CellContext`localrotation$ = {{0., 0., -1.}, {
                    0., -1., 0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272617, $CellContext`localtranslation$ = {5., 5., 
                    0.}; $CellContext`localrotation$ = {{0., -1., 0.}, {1., 
                    0., 0.}, {0., 0., 1.}}, 
                    True, $CellContext`localtranslation$ = {5., -5., 
                    0.}; $CellContext`localrotation$ = {{0., 1., 0.}, {-1., 
                    0., 0.}, {0., 0., 1.}}]; $CellContext`localpos$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} - $CellContext`surftrans$]; \
$CellContext`localtilt$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`localpos$ = 
                    Dot[$CellContext`localpos$, $CellContext`localrotation$] + \
$CellContext`localtranslation$; $CellContext`localtilt$ = 
                    Dot[$CellContext`localtilt$, $CellContext`localrotation$]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; $CellContext`allcreatedrays$ = \
{{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]; \
($CellContext`originalray$ = 
                    First[$CellContext`allcreatedrays$]; \
$CellContext`completedray$ = $CellContext`originalray$); \
$CellContext`deflectedrays$ = $CellContext`allcreatedrays$; \
$CellContext`newdeflectedrays$ = {$CellContext`originalray$}; 
                    Scan[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; ($CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; If[
                    Abs[$CellContext`raytiltx$] < 1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = $CellContext`baseIndex$$ - \
$CellContext`factorX$$ ($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - \
$CellContext`factorY$$ ($CellContext`LocRSy$ - $CellContext`ypos$$)^2; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]], \
$CellContext`index2$ = Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = \
$CellContext`baseIndex$$ - $CellContext`factorX$$ ($CellContext`LocRSx$ - \
$CellContext`xpos$$)^2 - $CellContext`factorY$$ ($CellContext`LocRSy$ - \
$CellContext`ypos$$)^2; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = \
$CellContext`baseIndex$$ - $CellContext`factorX$$ ($CellContext`LocRSx$ - \
$CellContext`xpos$$)^2 - $CellContext`factorY$$ ($CellContext`LocRSy$ - \
$CellContext`ypos$$)^2]]; $CellContext`n12$ = \
$CellContext`index1$/$CellContext`index2$; $CellContext`index$ = \
$CellContext`index2$; If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]); \
$CellContext`newdeflectedrays$ = 
                    Join[$CellContext`newdeflectedrays$, \
$CellContext`allcreatedrays$])& , $CellContext`deflectedrays$]; \
$CellContext`allcreatedrays$ = 
                    Drop[$CellContext`newdeflectedrays$, 
                    1]; $CellContext`deflectedrays$ = \
$CellContext`allcreatedrays$; $CellContext`newdeflectedrays$ = \
{$CellContext`originalray$}; 
                    Scan[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; ($CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; If[
                    Abs[$CellContext`raytiltx$] < 1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; \
$CellContext`surftrans$ = $CellContext`surfacetranslationvector$; \
$CellContext`surfrot$ = $CellContext`surfacerotationmatrix$; 
                    Which[$CellContext`surfaceid$ == 
                    272713, $CellContext`localtranslation$ = {0, 0, 
                    0}; $CellContext`localrotation$ = {{1, 0, 0}, {0, 1, 0}, {
                    0, 0, 1}}, $CellContext`surfaceid$ == 
                    272778, $CellContext`localtranslation$ = {10., 0., 
                    0.}; $CellContext`localrotation$ = {{1., 0., 0.}, {0., 1.,
                     0.}, {0., 0., 1.}}, $CellContext`surfaceid$ == 
                    272521, $CellContext`localtranslation$ = {5., 0., 
                    5.}; $CellContext`localrotation$ = {{0., 0., 1.}, {0., 1.,
                     0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272551, $CellContext`localtranslation$ = {5., 
                    0., -5.}; $CellContext`localrotation$ = {{0., 0., -1.}, {
                    0., -1., 0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272617, $CellContext`localtranslation$ = {5., 5., 
                    0.}; $CellContext`localrotation$ = {{0., -1., 0.}, {1., 
                    0., 0.}, {0., 0., 1.}}, 
                    True, $CellContext`localtranslation$ = {5., -5., 
                    0.}; $CellContext`localrotation$ = {{0., 1., 0.}, {-1., 
                    0., 0.}, {0., 0., 1.}}]; $CellContext`localopticallength$ = 
                    0.; $CellContext`localraylength$ = 
                    0.; $CellContext`integratedrefractiveindex$ = 
                    0.; $CellContext`localpos$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} - $CellContext`surftrans$]; \
$CellContext`localtilt$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[$CellContext`activeregion$ 
                    Part[$CellContext`localtilt$, 1] > 
                    0, {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$; $CellContext`localpos$ = 
                    
                    Dot[$CellContext`localpos$, $CellContext`localrotation$] + \
$CellContext`localtranslation$; $CellContext`localtilt$ = 
                    Dot[$CellContext`localtilt$, $CellContext`localrotation$]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; $CellContext`localindex$ = $CellContext`index$; \
$CellContext`localindex$ = $CellContext`baseIndex$$ - $CellContext`factorX$$ \
($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - $CellContext`factorY$$ \
($CellContext`LocRSy$ - $CellContext`ypos$$)^2; $CellContext`listofpositions$ = \
{{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}}; \
$CellContext`listoftilts$ = {{
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}}; $CellContext`indexpoints$ = \
{$CellContext`localindex$}; $CellContext`opticallengths$ = \
{$CellContext`opticallength$}; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; $CellContext`localtilt$ = \
$CellContext`localindex$ $CellContext`localtilt$; $CellContext`Ninitial$ = \
$CellContext`localindex$^2; $CellContext`Sinitial$ = 
                    0.1^2 Dot[{(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}, $CellContext`localtilt$]; $CellContext`rSxOffset$ = 
                    0.; While[
                    And[
                    Plus[10.] - ($CellContext`LocRSx$ - \
$CellContext`rSxOffset$) >= (-0.01) 0.1, 
                    Plus[$CellContext`LocRSx$ - $CellContext`rSxOffset$] >= \
(-0.01) 0.1, 
                    And[
                    0.99999 $CellContext`LocRSy$ <= 5., 
                    0.99999 $CellContext`LocRSy$ >= -5., 
                    0.99999 $CellContext`LocRSz$ >= -5., 
                    0.99999 $CellContext`LocRSz$ <= 
                    5.]], $CellContext`localraylength$ = \
($CellContext`localraylength$ + Sqrt[
                    
                    Dot[#, #]]& )[$CellContext`localpos$ - \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}]; \
$CellContext`localpos$ = {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$}; 
                    AppendTo[$CellContext`listofpositions$, \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}]; 
                    AppendTo[$CellContext`listoftilts$, {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}]; $CellContext`localindex$ = $CellContext`baseIndex$$ - \
$CellContext`factorX$$ ($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - \
$CellContext`factorY$$ ($CellContext`LocRSy$ - $CellContext`ypos$$)^2; 
                    AppendTo[$CellContext`indexpoints$, \
$CellContext`localindex$]; $CellContext`opticallengths$ = 
                    Append[$CellContext`opticallengths$, 
                    Last[$CellContext`opticallengths$] + \
$CellContext`localindex$ 
                    0.1]; $CellContext`integratedrefractiveindex$ = \
$CellContext`integratedrefractiveindex$ + $CellContext`localindex$^2; \
$CellContext`localtilt$ = $CellContext`localindex$ {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}; $CellContext`Aelement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$ + (
                    0.1 $CellContext`localtilt$)/
                    2. + (0.1 $CellContext`Aelement$)/
                    8.; $CellContext`Belement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$ + 
                    0.1 $CellContext`localtilt$ + (
                    0.1 $CellContext`Belement$)/2; $CellContext`Celement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; $CellContext`newpos$ = $CellContext`localpos$ + 
                    0.1 ($CellContext`localtilt$ + ($CellContext`Aelement$ + 
                    2 $CellContext`Belement$)/
                    6); $CellContext`newtilt$ = $CellContext`localtilt$ + \
($CellContext`Aelement$ + 4. $CellContext`Aelement$ + $CellContext`Celement$)/
                    6.; $CellContext`newtilt$ = $CellContext`newtilt$/Sqrt[
                    
                    Dot[$CellContext`newtilt$, $CellContext`newtilt$]]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`newpos$; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`newtilt$; 
                    1.]; $CellContext`integratedrefractiveindex$ = \
$CellContext`integratedrefractiveindex$ - $CellContext`localindex$^2; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; $CellContext`Sfinal$ = 
                    0.1 Dot[$CellContext`Aelement$, $CellContext`localtilt$]; \
$CellContext`Nfinal$ = $CellContext`localindex$^2; $CellContext`localtilt$ = \
$CellContext`localtilt$/Sqrt[
                    Dot[$CellContext`localtilt$, $CellContext`localtilt$]]; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; \
$CellContext`localopticallength$ = 
                    0.1 $CellContext`integratedrefractiveindex$ - \
($CellContext`Sfinal$ - $CellContext`Sinitial$)/
                    6 + (0.1 ($CellContext`Nfinal$ - $CellContext`Ninitial$))/
                    2; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`localopticallength$; \
$CellContext`ray1$ = $CellContext`localraylength$; $CellContext`localpos$ = 
                    Dot[$CellContext`localrotation$, $CellContext`localpos$ - \
$CellContext`localtranslation$]; {$CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$} = 
                    Dot[$CellContext`localpos$, $CellContext`surfrot$] + \
$CellContext`surftrans$; $CellContext`localtilt$ = 
                    Dot[$CellContext`localrotation$, $CellContext`localtilt$]; \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = 
                    Dot[$CellContext`localtilt$, $CellContext`surfrot$]; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$} = \
{$CellContext`rex$, $CellContext`rey$, $CellContext`rez$}; \
$CellContext`index$ = $CellContext`baseIndex$$ - $CellContext`factorX$$ \
($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - $CellContext`factorY$$ \
($CellContext`LocRSy$ - $CellContext`ypos$$)^2; $CellContext`allcreatedrays$ = \
{{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`listofpositions$ = 
                    Map[Dot[$CellContext`localrotation$, # - \
$CellContext`localtranslation$]& , $CellContext`listofpositions$]; \
$CellContext`listofpositions$ = 
                    Map[Dot[#, $CellContext`surfrot$] + \
$CellContext`surftrans$& , $CellContext`listofpositions$]; \
$CellContext`listoftilts$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`listoftilts$]; \
$CellContext`listoftilts$ = Map[
                    Dot[#, $CellContext`surfrot$]& , \
$CellContext`listoftilts$]; If[
                    
                    And[$CellContext`reportedrayspresent$, 
                    Length[$CellContext`indexpoints$] > 
                    1], $CellContext`reportedrays$ = 
                    Join[$CellContext`reportedrays$, 
                    
                    Table[{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$} = 
                    Part[$CellContext`listofpositions$, \
$CellContext`ninteger$]; {$CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$} = 
                    Part[$CellContext`listofpositions$, \
$CellContext`ninteger$ + 
                    1]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = 
                    Part[$CellContext`listoftilts$, $CellContext`ninteger$]; \
$CellContext`ray1$ = 0.1; $CellContext`index$ = 
                    Part[$CellContext`indexpoints$, $CellContext`ninteger$]; \
$CellContext`opticallength$ = 
                    Part[$CellContext`opticallengths$, \
$CellContext`ninteger$]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`ninteger$, 1, 
                    Length[$CellContext`indexpoints$] - 1}]]; 1., 
                    1.]; $CellContext`allcreatedrays$, \
$CellContext`allcreatedrays$ = {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}]; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]); \
$CellContext`newdeflectedrays$ = 
                    Join[$CellContext`newdeflectedrays$, \
$CellContext`allcreatedrays$])& , $CellContext`deflectedrays$]; \
$CellContext`allcreatedrays$ = 
                    Drop[$CellContext`newdeflectedrays$, 
                    1]; $CellContext`deflectedrays$ = \
$CellContext`allcreatedrays$; $CellContext`deflectedrays$ = 
                    MapIndexed[ReplacePart[#, 
                    First[#2], 
                    34]& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = $CellContext`deflectedrays$); \
{$CellContext`allcreatedrays$, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 
                    0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,
                     1., 1., 1., 
                    1.}}, {$CellContext`completedray$}}, \
$CellContext`resonatenumber$ == 
                    3, {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r3$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = -$CellContext`r1$; \
$CellContext`xunit$ = Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -5. + \
$CellContext`rez$; $CellContext`ry$ = $CellContext`rey$ - 1. 
                    Re[$CellContext`gly$$]; $CellContext`rz$ = -(-5. + \
$CellContext`rex$ - 1. Re[$CellContext`glx$$]); $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = \
$CellContext`resonateintersections$; $CellContext`holeQ$ = 
                    Part[$CellContext`holeQlist$, \
$CellContext`resonatenumber$] == 
                    1; {$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 3., 
                    272521.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 3., 
                    272521.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = 
                    5. - 1. $CellContext`rzhlp$ + 
                    Re[$CellContext`glx$$]; $CellContext`rey$ = \
$CellContext`ryhlp$ + Re[$CellContext`gly$$]; $CellContext`rez$ = 
                    5. + $CellContext`rxhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`reportedrayspresent$ = 
                    True; $CellContext`intersectionspresent$ = 
                    True; $CellContext`deflectedrayspresent$ = 
                    True; $CellContext`localdummyoutrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[Dot[{{0., 0., -1.}, {0., 1., 0.}, {1., 0., 
                    0.}}, #]& , $CellContext`surfnorm$]; \
$CellContext`surfnorm$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{0, 0, 1.}, {
                    0, 1., 0}, {-1., 0, 
                    0}}; $CellContext`surfacetranslationvector$ = {
                    5. + Re[$CellContext`glx$$], 
                    Re[$CellContext`gly$$], 5.}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; \
$CellContext`surftrans$ = $CellContext`surfacetranslationvector$; \
$CellContext`surfrot$ = $CellContext`surfacerotationmatrix$; 
                    Which[$CellContext`surfaceid$ == 
                    272713, $CellContext`localtranslation$ = {0, 0, 
                    0}; $CellContext`localrotation$ = {{1, 0, 0}, {0, 1, 0}, {
                    0, 0, 1}}, $CellContext`surfaceid$ == 
                    272778, $CellContext`localtranslation$ = {10., 0., 
                    0.}; $CellContext`localrotation$ = {{1., 0., 0.}, {0., 1.,
                     0.}, {0., 0., 1.}}, $CellContext`surfaceid$ == 
                    272521, $CellContext`localtranslation$ = {5., 0., 
                    5.}; $CellContext`localrotation$ = {{0., 0., 1.}, {0., 1.,
                     0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272551, $CellContext`localtranslation$ = {5., 
                    0., -5.}; $CellContext`localrotation$ = {{0., 0., -1.}, {
                    0., -1., 0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272617, $CellContext`localtranslation$ = {5., 5., 
                    0.}; $CellContext`localrotation$ = {{0., -1., 0.}, {1., 
                    0., 0.}, {0., 0., 1.}}, 
                    True, $CellContext`localtranslation$ = {5., -5., 
                    0.}; $CellContext`localrotation$ = {{0., 1., 0.}, {-1., 
                    0., 0.}, {0., 0., 1.}}]; $CellContext`localpos$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} - $CellContext`surftrans$]; \
$CellContext`localtilt$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`localpos$ = 
                    Dot[$CellContext`localpos$, $CellContext`localrotation$] + \
$CellContext`localtranslation$; $CellContext`localtilt$ = 
                    Dot[$CellContext`localtilt$, $CellContext`localrotation$]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; $CellContext`allcreatedrays$ = \
{{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]; \
($CellContext`originalray$ = 
                    First[$CellContext`allcreatedrays$]; \
$CellContext`completedray$ = $CellContext`originalray$); \
$CellContext`deflectedrays$ = $CellContext`allcreatedrays$; \
$CellContext`newdeflectedrays$ = {$CellContext`originalray$}; 
                    Scan[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; ($CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; If[
                    Abs[$CellContext`raytiltx$] < 1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = $CellContext`baseIndex$$ - \
$CellContext`factorX$$ ($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - \
$CellContext`factorY$$ ($CellContext`LocRSy$ - $CellContext`ypos$$)^2; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]], \
$CellContext`index2$ = Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = \
$CellContext`baseIndex$$ - $CellContext`factorX$$ ($CellContext`LocRSx$ - \
$CellContext`xpos$$)^2 - $CellContext`factorY$$ ($CellContext`LocRSy$ - \
$CellContext`ypos$$)^2; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = \
$CellContext`baseIndex$$ - $CellContext`factorX$$ ($CellContext`LocRSx$ - \
$CellContext`xpos$$)^2 - $CellContext`factorY$$ ($CellContext`LocRSy$ - \
$CellContext`ypos$$)^2]]; $CellContext`n12$ = \
$CellContext`index1$/$CellContext`index2$; $CellContext`index$ = \
$CellContext`index2$; If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]); \
$CellContext`newdeflectedrays$ = 
                    Join[$CellContext`newdeflectedrays$, \
$CellContext`allcreatedrays$])& , $CellContext`deflectedrays$]; \
$CellContext`allcreatedrays$ = 
                    Drop[$CellContext`newdeflectedrays$, 
                    1]; $CellContext`deflectedrays$ = \
$CellContext`allcreatedrays$; $CellContext`newdeflectedrays$ = \
{$CellContext`originalray$}; 
                    Scan[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; ($CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; If[
                    Abs[$CellContext`raytiltx$] < 1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; \
$CellContext`surftrans$ = $CellContext`surfacetranslationvector$; \
$CellContext`surfrot$ = $CellContext`surfacerotationmatrix$; 
                    Which[$CellContext`surfaceid$ == 
                    272713, $CellContext`localtranslation$ = {0, 0, 
                    0}; $CellContext`localrotation$ = {{1, 0, 0}, {0, 1, 0}, {
                    0, 0, 1}}, $CellContext`surfaceid$ == 
                    272778, $CellContext`localtranslation$ = {10., 0., 
                    0.}; $CellContext`localrotation$ = {{1., 0., 0.}, {0., 1.,
                     0.}, {0., 0., 1.}}, $CellContext`surfaceid$ == 
                    272521, $CellContext`localtranslation$ = {5., 0., 
                    5.}; $CellContext`localrotation$ = {{0., 0., 1.}, {0., 1.,
                     0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272551, $CellContext`localtranslation$ = {5., 
                    0., -5.}; $CellContext`localrotation$ = {{0., 0., -1.}, {
                    0., -1., 0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272617, $CellContext`localtranslation$ = {5., 5., 
                    0.}; $CellContext`localrotation$ = {{0., -1., 0.}, {1., 
                    0., 0.}, {0., 0., 1.}}, 
                    True, $CellContext`localtranslation$ = {5., -5., 
                    0.}; $CellContext`localrotation$ = {{0., 1., 0.}, {-1., 
                    0., 0.}, {0., 0., 1.}}]; $CellContext`localopticallength$ = 
                    0.; $CellContext`localraylength$ = 
                    0.; $CellContext`integratedrefractiveindex$ = 
                    0.; $CellContext`localpos$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} - $CellContext`surftrans$]; \
$CellContext`localtilt$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[$CellContext`activeregion$ 
                    Part[$CellContext`localtilt$, 1] > 
                    0, {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$; $CellContext`localpos$ = 
                    Dot[$CellContext`localpos$, $CellContext`localrotation$] + \
$CellContext`localtranslation$; $CellContext`localtilt$ = 
                    Dot[$CellContext`localtilt$, $CellContext`localrotation$]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; $CellContext`localindex$ = $CellContext`index$; \
$CellContext`localindex$ = $CellContext`baseIndex$$ - $CellContext`factorX$$ \
($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - $CellContext`factorY$$ \
($CellContext`LocRSy$ - $CellContext`ypos$$)^2; $CellContext`listofpositions$ = \
{{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}}; \
$CellContext`listoftilts$ = {{
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}}; $CellContext`indexpoints$ = \
{$CellContext`localindex$}; $CellContext`opticallengths$ = \
{$CellContext`opticallength$}; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; $CellContext`localtilt$ = \
$CellContext`localindex$ $CellContext`localtilt$; $CellContext`Ninitial$ = \
$CellContext`localindex$^2; $CellContext`Sinitial$ = 
                    0.1^2 Dot[{(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}, $CellContext`localtilt$]; $CellContext`rSxOffset$ = 
                    0.; While[
                    And[
                    Plus[10.] - ($CellContext`LocRSx$ - \
$CellContext`rSxOffset$) >= (-0.01) 0.1, 
                    Plus[$CellContext`LocRSx$ - $CellContext`rSxOffset$] >= \
(-0.01) 0.1, 
                    And[
                    0.99999 $CellContext`LocRSy$ <= 5., 
                    0.99999 $CellContext`LocRSy$ >= -5., 
                    0.99999 $CellContext`LocRSz$ >= -5., 
                    0.99999 $CellContext`LocRSz$ <= 
                    5.]], $CellContext`localraylength$ = \
($CellContext`localraylength$ + Sqrt[
                    
                    Dot[#, #]]& )[$CellContext`localpos$ - \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}]; \
$CellContext`localpos$ = {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$}; 
                    AppendTo[$CellContext`listofpositions$, \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}]; 
                    AppendTo[$CellContext`listoftilts$, {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}]; $CellContext`localindex$ = $CellContext`baseIndex$$ - \
$CellContext`factorX$$ ($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - \
$CellContext`factorY$$ ($CellContext`LocRSy$ - $CellContext`ypos$$)^2; 
                    AppendTo[$CellContext`indexpoints$, \
$CellContext`localindex$]; $CellContext`opticallengths$ = 
                    Append[$CellContext`opticallengths$, 
                    Last[$CellContext`opticallengths$] + \
$CellContext`localindex$ 
                    0.1]; $CellContext`integratedrefractiveindex$ = \
$CellContext`integratedrefractiveindex$ + $CellContext`localindex$^2; \
$CellContext`localtilt$ = $CellContext`localindex$ {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}; $CellContext`Aelement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$ + (
                    0.1 $CellContext`localtilt$)/
                    2. + (0.1 $CellContext`Aelement$)/
                    8.; $CellContext`Belement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$ + 
                    0.1 $CellContext`localtilt$ + (
                    0.1 $CellContext`Belement$)/2; $CellContext`Celement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; $CellContext`newpos$ = $CellContext`localpos$ + 
                    0.1 ($CellContext`localtilt$ + ($CellContext`Aelement$ + 
                    2 $CellContext`Belement$)/
                    6); $CellContext`newtilt$ = $CellContext`localtilt$ + \
($CellContext`Aelement$ + 4. $CellContext`Aelement$ + $CellContext`Celement$)/
                    6.; $CellContext`newtilt$ = $CellContext`newtilt$/Sqrt[
                    
                    Dot[$CellContext`newtilt$, $CellContext`newtilt$]]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`newpos$; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`newtilt$; 
                    1.]; $CellContext`integratedrefractiveindex$ = \
$CellContext`integratedrefractiveindex$ - $CellContext`localindex$^2; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; $CellContext`Sfinal$ = 
                    0.1 Dot[$CellContext`Aelement$, $CellContext`localtilt$]; \
$CellContext`Nfinal$ = $CellContext`localindex$^2; $CellContext`localtilt$ = \
$CellContext`localtilt$/Sqrt[
                    Dot[$CellContext`localtilt$, $CellContext`localtilt$]]; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; \
$CellContext`localopticallength$ = 
                    0.1 $CellContext`integratedrefractiveindex$ - \
($CellContext`Sfinal$ - $CellContext`Sinitial$)/
                    6 + (0.1 ($CellContext`Nfinal$ - $CellContext`Ninitial$))/
                    2; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`localopticallength$; \
$CellContext`ray1$ = $CellContext`localraylength$; $CellContext`localpos$ = 
                    Dot[$CellContext`localrotation$, $CellContext`localpos$ - \
$CellContext`localtranslation$]; {$CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$} = 
                    Dot[$CellContext`localpos$, $CellContext`surfrot$] + \
$CellContext`surftrans$; $CellContext`localtilt$ = 
                    Dot[$CellContext`localrotation$, $CellContext`localtilt$]; \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = 
                    Dot[$CellContext`localtilt$, $CellContext`surfrot$]; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$} = \
{$CellContext`rex$, $CellContext`rey$, $CellContext`rez$}; \
$CellContext`index$ = $CellContext`baseIndex$$ - $CellContext`factorX$$ \
($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - $CellContext`factorY$$ \
($CellContext`LocRSy$ - $CellContext`ypos$$)^2; $CellContext`allcreatedrays$ = \
{{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`listofpositions$ = 
                    Map[Dot[$CellContext`localrotation$, # - \
$CellContext`localtranslation$]& , $CellContext`listofpositions$]; \
$CellContext`listofpositions$ = 
                    Map[Dot[#, $CellContext`surfrot$] + \
$CellContext`surftrans$& , $CellContext`listofpositions$]; \
$CellContext`listoftilts$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`listoftilts$]; \
$CellContext`listoftilts$ = Map[
                    Dot[#, $CellContext`surfrot$]& , \
$CellContext`listoftilts$]; If[
                    
                    And[$CellContext`reportedrayspresent$, 
                    Length[$CellContext`indexpoints$] > 
                    1], $CellContext`reportedrays$ = 
                    Join[$CellContext`reportedrays$, 
                    
                    Table[{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$} = 
                    Part[$CellContext`listofpositions$, \
$CellContext`ninteger$]; {$CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$} = 
                    Part[$CellContext`listofpositions$, \
$CellContext`ninteger$ + 
                    1]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = 
                    Part[$CellContext`listoftilts$, $CellContext`ninteger$]; \
$CellContext`ray1$ = 0.1; $CellContext`index$ = 
                    Part[$CellContext`indexpoints$, $CellContext`ninteger$]; \
$CellContext`opticallength$ = 
                    Part[$CellContext`opticallengths$, \
$CellContext`ninteger$]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`ninteger$, 1, 
                    Length[$CellContext`indexpoints$] - 1}]]; 1., 
                    1.]; $CellContext`allcreatedrays$, \
$CellContext`allcreatedrays$ = {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}]; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]); \
$CellContext`newdeflectedrays$ = 
                    Join[$CellContext`newdeflectedrays$, \
$CellContext`allcreatedrays$])& , $CellContext`deflectedrays$]; \
$CellContext`allcreatedrays$ = 
                    Drop[$CellContext`newdeflectedrays$, 
                    1]; $CellContext`deflectedrays$ = \
$CellContext`allcreatedrays$; $CellContext`deflectedrays$ = 
                    MapIndexed[ReplacePart[#, 
                    First[#2], 
                    34]& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = $CellContext`deflectedrays$); \
{$CellContext`allcreatedrays$, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 
                    0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,
                     1., 1., 1., 
                    1.}}, {$CellContext`completedray$}}, \
$CellContext`resonatenumber$ == 
                    4, {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = -$CellContext`r3$; $CellContext`yunit$ = \
-$CellContext`r2$; $CellContext`zunit$ = -$CellContext`r1$; \
$CellContext`xunit$ = Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -(
                    5. + $CellContext`rez$); $CellContext`ry$ = \
-($CellContext`rey$ - 1. 
                    Re[$CellContext`gly$$]); $CellContext`rz$ = -(-5. + \
$CellContext`rex$ - 1. Re[$CellContext`glx$$]); $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = \
$CellContext`resonateintersections$; $CellContext`holeQ$ = 
                    Part[$CellContext`holeQlist$, \
$CellContext`resonatenumber$] == 
                    1; {$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 4., 
                    272551.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 4., 
                    272551.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = 
                    5. - 1. $CellContext`rzhlp$ + 
                    Re[$CellContext`glx$$]; $CellContext`rey$ = \
-$CellContext`ryhlp$ + Re[$CellContext`gly$$]; $CellContext`rez$ = -5. - 
                    1. $CellContext`rxhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`reportedrayspresent$ = 
                    True; $CellContext`intersectionspresent$ = 
                    True; $CellContext`deflectedrayspresent$ = 
                    True; $CellContext`localdummyoutrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[Dot[{{0., 0., -1.}, {0., -1., 0.}, {-1., 0., 
                    0.}}, #]& , $CellContext`surfnorm$]; \
$CellContext`surfnorm$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{0, 0, -1.}, {
                    0, -1., 0}, {-1., 0, 
                    0}}; $CellContext`surfacetranslationvector$ = {
                    5. + Re[$CellContext`glx$$], 
                    Re[$CellContext`gly$$], -5.}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; \
$CellContext`surftrans$ = $CellContext`surfacetranslationvector$; \
$CellContext`surfrot$ = $CellContext`surfacerotationmatrix$; 
                    Which[$CellContext`surfaceid$ == 
                    272713, $CellContext`localtranslation$ = {0, 0, 
                    0}; $CellContext`localrotation$ = {{1, 0, 0}, {0, 1, 0}, {
                    0, 0, 1}}, $CellContext`surfaceid$ == 
                    272778, $CellContext`localtranslation$ = {10., 0., 
                    0.}; $CellContext`localrotation$ = {{1., 0., 0.}, {0., 1.,
                     0.}, {0., 0., 1.}}, $CellContext`surfaceid$ == 
                    272521, $CellContext`localtranslation$ = {5., 0., 
                    5.}; $CellContext`localrotation$ = {{0., 0., 1.}, {0., 1.,
                     0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272551, $CellContext`localtranslation$ = {5., 
                    0., -5.}; $CellContext`localrotation$ = {{0., 0., -1.}, {
                    0., -1., 0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272617, $CellContext`localtranslation$ = {5., 5., 
                    0.}; $CellContext`localrotation$ = {{0., -1., 0.}, {1., 
                    0., 0.}, {0., 0., 1.}}, 
                    True, $CellContext`localtranslation$ = {5., -5., 
                    0.}; $CellContext`localrotation$ = {{0., 1., 0.}, {-1., 
                    0., 0.}, {0., 0., 1.}}]; $CellContext`localpos$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} - $CellContext`surftrans$]; \
$CellContext`localtilt$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`localpos$ = 
                    Dot[$CellContext`localpos$, $CellContext`localrotation$] + \
$CellContext`localtranslation$; $CellContext`localtilt$ = 
                    
                    Dot[$CellContext`localtilt$, $CellContext`localrotation$]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; $CellContext`allcreatedrays$ = \
{{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]; \
($CellContext`originalray$ = 
                    First[$CellContext`allcreatedrays$]; \
$CellContext`completedray$ = $CellContext`originalray$); \
$CellContext`deflectedrays$ = $CellContext`allcreatedrays$; \
$CellContext`newdeflectedrays$ = {$CellContext`originalray$}; 
                    Scan[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; ($CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; If[
                    Abs[$CellContext`raytiltx$] < 1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = $CellContext`baseIndex$$ - \
$CellContext`factorX$$ ($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - \
$CellContext`factorY$$ ($CellContext`LocRSy$ - $CellContext`ypos$$)^2; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]], \
$CellContext`index2$ = Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = \
$CellContext`baseIndex$$ - $CellContext`factorX$$ ($CellContext`LocRSx$ - \
$CellContext`xpos$$)^2 - $CellContext`factorY$$ ($CellContext`LocRSy$ - \
$CellContext`ypos$$)^2; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = \
$CellContext`baseIndex$$ - $CellContext`factorX$$ ($CellContext`LocRSx$ - \
$CellContext`xpos$$)^2 - $CellContext`factorY$$ ($CellContext`LocRSy$ - \
$CellContext`ypos$$)^2]]; $CellContext`n12$ = \
$CellContext`index1$/$CellContext`index2$; $CellContext`index$ = \
$CellContext`index2$; If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 
                    1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]); \
$CellContext`newdeflectedrays$ = 
                    Join[$CellContext`newdeflectedrays$, \
$CellContext`allcreatedrays$])& , $CellContext`deflectedrays$]; \
$CellContext`allcreatedrays$ = 
                    Drop[$CellContext`newdeflectedrays$, 
                    1]; $CellContext`deflectedrays$ = \
$CellContext`allcreatedrays$; $CellContext`newdeflectedrays$ = \
{$CellContext`originalray$}; 
                    Scan[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; ($CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; If[
                    Abs[$CellContext`raytiltx$] < 1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; \
$CellContext`surftrans$ = $CellContext`surfacetranslationvector$; \
$CellContext`surfrot$ = $CellContext`surfacerotationmatrix$; 
                    Which[$CellContext`surfaceid$ == 
                    272713, $CellContext`localtranslation$ = {0, 0, 
                    0}; $CellContext`localrotation$ = {{1, 0, 0}, {0, 1, 0}, {
                    0, 0, 1}}, $CellContext`surfaceid$ == 
                    272778, $CellContext`localtranslation$ = {10., 0., 
                    0.}; $CellContext`localrotation$ = {{1., 0., 0.}, {0., 1.,
                     0.}, {0., 0., 1.}}, $CellContext`surfaceid$ == 
                    272521, $CellContext`localtranslation$ = {5., 0., 
                    5.}; $CellContext`localrotation$ = {{0., 0., 1.}, {0., 1.,
                     0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272551, $CellContext`localtranslation$ = {5., 
                    0., -5.}; $CellContext`localrotation$ = {{0., 0., -1.}, {
                    0., -1., 0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272617, $CellContext`localtranslation$ = {5., 5., 
                    0.}; $CellContext`localrotation$ = {{0., -1., 0.}, {1., 
                    0., 0.}, {0., 0., 1.}}, 
                    True, $CellContext`localtranslation$ = {5., -5., 
                    0.}; $CellContext`localrotation$ = {{0., 1., 0.}, {-1., 
                    0., 0.}, {0., 0., 1.}}]; $CellContext`localopticallength$ = 
                    0.; $CellContext`localraylength$ = 
                    0.; $CellContext`integratedrefractiveindex$ = 
                    0.; $CellContext`localpos$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} - $CellContext`surftrans$]; \
$CellContext`localtilt$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[$CellContext`activeregion$ 
                    Part[$CellContext`localtilt$, 1] > 
                    0, {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$; $CellContext`localpos$ = 
                    Dot[$CellContext`localpos$, $CellContext`localrotation$] + \
$CellContext`localtranslation$; $CellContext`localtilt$ = 
                    Dot[$CellContext`localtilt$, $CellContext`localrotation$]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; $CellContext`localindex$ = $CellContext`index$; \
$CellContext`localindex$ = $CellContext`baseIndex$$ - $CellContext`factorX$$ \
($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - $CellContext`factorY$$ \
($CellContext`LocRSy$ - $CellContext`ypos$$)^2; $CellContext`listofpositions$ = \
{{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}}; \
$CellContext`listoftilts$ = {{
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}}; $CellContext`indexpoints$ = \
{$CellContext`localindex$}; $CellContext`opticallengths$ = \
{$CellContext`opticallength$}; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; $CellContext`localtilt$ = \
$CellContext`localindex$ $CellContext`localtilt$; $CellContext`Ninitial$ = \
$CellContext`localindex$^2; $CellContext`Sinitial$ = 
                    0.1^2 Dot[{(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}, $CellContext`localtilt$]; $CellContext`rSxOffset$ = 
                    0.; While[
                    And[
                    Plus[10.] - ($CellContext`LocRSx$ - \
$CellContext`rSxOffset$) >= (-0.01) 0.1, 
                    Plus[$CellContext`LocRSx$ - $CellContext`rSxOffset$] >= \
(-0.01) 0.1, 
                    And[
                    0.99999 $CellContext`LocRSy$ <= 5., 
                    0.99999 $CellContext`LocRSy$ >= -5., 
                    0.99999 $CellContext`LocRSz$ >= -5., 
                    0.99999 $CellContext`LocRSz$ <= 
                    5.]], $CellContext`localraylength$ = \
($CellContext`localraylength$ + Sqrt[
                    
                    Dot[#, #]]& )[$CellContext`localpos$ - \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}]; \
$CellContext`localpos$ = {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$}; 
                    AppendTo[$CellContext`listofpositions$, \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}]; 
                    AppendTo[$CellContext`listoftilts$, {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}]; $CellContext`localindex$ = $CellContext`baseIndex$$ - \
$CellContext`factorX$$ ($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - \
$CellContext`factorY$$ ($CellContext`LocRSy$ - $CellContext`ypos$$)^2; 
                    AppendTo[$CellContext`indexpoints$, \
$CellContext`localindex$]; $CellContext`opticallengths$ = 
                    Append[$CellContext`opticallengths$, 
                    Last[$CellContext`opticallengths$] + \
$CellContext`localindex$ 
                    0.1]; $CellContext`integratedrefractiveindex$ = \
$CellContext`integratedrefractiveindex$ + $CellContext`localindex$^2; \
$CellContext`localtilt$ = $CellContext`localindex$ {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}; $CellContext`Aelement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$ + (
                    0.1 $CellContext`localtilt$)/
                    2. + (0.1 $CellContext`Aelement$)/
                    8.; $CellContext`Belement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$ + 
                    0.1 $CellContext`localtilt$ + (
                    0.1 $CellContext`Belement$)/2; $CellContext`Celement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; $CellContext`newpos$ = $CellContext`localpos$ + 
                    0.1 ($CellContext`localtilt$ + ($CellContext`Aelement$ + 
                    2 $CellContext`Belement$)/
                    6); $CellContext`newtilt$ = $CellContext`localtilt$ + \
($CellContext`Aelement$ + 4. $CellContext`Aelement$ + $CellContext`Celement$)/
                    6.; $CellContext`newtilt$ = $CellContext`newtilt$/Sqrt[
                    
                    Dot[$CellContext`newtilt$, $CellContext`newtilt$]]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`newpos$; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`newtilt$; 
                    1.]; $CellContext`integratedrefractiveindex$ = \
$CellContext`integratedrefractiveindex$ - $CellContext`localindex$^2; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; $CellContext`Sfinal$ = 
                    0.1 Dot[$CellContext`Aelement$, $CellContext`localtilt$]; \
$CellContext`Nfinal$ = $CellContext`localindex$^2; $CellContext`localtilt$ = \
$CellContext`localtilt$/Sqrt[
                    Dot[$CellContext`localtilt$, $CellContext`localtilt$]]; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; \
$CellContext`localopticallength$ = 
                    0.1 $CellContext`integratedrefractiveindex$ - \
($CellContext`Sfinal$ - $CellContext`Sinitial$)/
                    6 + (0.1 ($CellContext`Nfinal$ - $CellContext`Ninitial$))/
                    2; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`localopticallength$; \
$CellContext`ray1$ = $CellContext`localraylength$; $CellContext`localpos$ = 
                    Dot[$CellContext`localrotation$, $CellContext`localpos$ - \
$CellContext`localtranslation$]; {$CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$} = 
                    Dot[$CellContext`localpos$, $CellContext`surfrot$] + \
$CellContext`surftrans$; $CellContext`localtilt$ = 
                    Dot[$CellContext`localrotation$, $CellContext`localtilt$]; \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = 
                    Dot[$CellContext`localtilt$, $CellContext`surfrot$]; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$} = \
{$CellContext`rex$, $CellContext`rey$, $CellContext`rez$}; \
$CellContext`index$ = $CellContext`baseIndex$$ - $CellContext`factorX$$ \
($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - $CellContext`factorY$$ \
($CellContext`LocRSy$ - $CellContext`ypos$$)^2; $CellContext`allcreatedrays$ = \
{{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`listofpositions$ = 
                    Map[Dot[$CellContext`localrotation$, # - \
$CellContext`localtranslation$]& , $CellContext`listofpositions$]; \
$CellContext`listofpositions$ = 
                    Map[Dot[#, $CellContext`surfrot$] + \
$CellContext`surftrans$& , $CellContext`listofpositions$]; \
$CellContext`listoftilts$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`listoftilts$]; \
$CellContext`listoftilts$ = Map[
                    Dot[#, $CellContext`surfrot$]& , \
$CellContext`listoftilts$]; If[
                    
                    And[$CellContext`reportedrayspresent$, 
                    Length[$CellContext`indexpoints$] > 
                    1], $CellContext`reportedrays$ = 
                    Join[$CellContext`reportedrays$, 
                    
                    Table[{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$} = 
                    Part[$CellContext`listofpositions$, \
$CellContext`ninteger$]; {$CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$} = 
                    Part[$CellContext`listofpositions$, \
$CellContext`ninteger$ + 
                    1]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = 
                    Part[$CellContext`listoftilts$, $CellContext`ninteger$]; \
$CellContext`ray1$ = 0.1; $CellContext`index$ = 
                    Part[$CellContext`indexpoints$, $CellContext`ninteger$]; \
$CellContext`opticallength$ = 
                    Part[$CellContext`opticallengths$, \
$CellContext`ninteger$]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`ninteger$, 1, 
                    Length[$CellContext`indexpoints$] - 1}]]; 1., 
                    1.]; $CellContext`allcreatedrays$, \
$CellContext`allcreatedrays$ = {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}]; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]); \
$CellContext`newdeflectedrays$ = 
                    Join[$CellContext`newdeflectedrays$, \
$CellContext`allcreatedrays$])& , $CellContext`deflectedrays$]; \
$CellContext`allcreatedrays$ = 
                    Drop[$CellContext`newdeflectedrays$, 
                    1]; $CellContext`deflectedrays$ = \
$CellContext`allcreatedrays$; $CellContext`deflectedrays$ = 
                    MapIndexed[ReplacePart[#, 
                    First[#2], 
                    34]& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = $CellContext`deflectedrays$); \
{$CellContext`allcreatedrays$, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 
                    0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,
                     1., 1., 1., 
                    1.}}, {$CellContext`completedray$}}, \
$CellContext`resonatenumber$ == 
                    5, {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = -$CellContext`r2$; $CellContext`yunit$ = \
$CellContext`r1$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                    Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -(-5. + \
$CellContext`rey$ - 1. 
                    Re[$CellContext`gly$$]); $CellContext`ry$ = -5. + \
$CellContext`rex$ - 1. 
                    Re[$CellContext`glx$$]; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    
                    0.}}; $CellContext`intersections$ = \
$CellContext`resonateintersections$; $CellContext`holeQ$ = 
                    Part[$CellContext`holeQlist$, \
$CellContext`resonatenumber$] == 
                    1; {$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 5., 
                    272617.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 5., 
                    272617.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = 
                    5. + $CellContext`ryhlp$ + 
                    Re[$CellContext`glx$$]; $CellContext`rey$ = 
                    5. - 1. $CellContext`rxhlp$ + 
                    Re[$CellContext`gly$$]; $CellContext`rez$ = \
$CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`reportedrayspresent$ = 
                    True; $CellContext`intersectionspresent$ = 
                    True; $CellContext`deflectedrayspresent$ = 
                    True; $CellContext`localdummyoutrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[Dot[{{0., 1., 0.}, {-1., 0., 0.}, {0., 0., 
                    1.}}, #]& , $CellContext`surfnorm$]; \
$CellContext`surfnorm$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{0, -1., 0}, {1., 0, 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = {
                    5. + Re[$CellContext`glx$$], 5. + Re[$CellContext`gly$$], 
                    0.}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; \
$CellContext`surftrans$ = $CellContext`surfacetranslationvector$; \
$CellContext`surfrot$ = $CellContext`surfacerotationmatrix$; 
                    Which[$CellContext`surfaceid$ == 
                    272713, $CellContext`localtranslation$ = {0, 0, 
                    0}; $CellContext`localrotation$ = {{1, 0, 0}, {0, 1, 0}, {
                    0, 0, 1}}, $CellContext`surfaceid$ == 
                    272778, $CellContext`localtranslation$ = {10., 0., 
                    0.}; $CellContext`localrotation$ = {{1., 0., 0.}, {0., 1.,
                     0.}, {0., 0., 1.}}, $CellContext`surfaceid$ == 
                    272521, $CellContext`localtranslation$ = {5., 0., 
                    5.}; $CellContext`localrotation$ = {{0., 0., 1.}, {0., 1.,
                     0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272551, $CellContext`localtranslation$ = {5., 
                    0., -5.}; $CellContext`localrotation$ = {{0., 0., -1.}, {
                    0., -1., 0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272617, $CellContext`localtranslation$ = {5., 5., 
                    0.}; $CellContext`localrotation$ = {{0., -1., 0.}, {1., 
                    0., 0.}, {0., 0., 1.}}, 
                    True, $CellContext`localtranslation$ = {5., -5., 
                    0.}; $CellContext`localrotation$ = {{0., 1., 0.}, {-1., 
                    0., 0.}, {0., 0., 1.}}]; $CellContext`localpos$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} - $CellContext`surftrans$]; \
$CellContext`localtilt$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`localpos$ = 
                    Dot[$CellContext`localpos$, $CellContext`localrotation$] + \
$CellContext`localtranslation$; $CellContext`localtilt$ = 
                    Dot[$CellContext`localtilt$, $CellContext`localrotation$]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; $CellContext`allcreatedrays$ = \
{{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]; \
($CellContext`originalray$ = 
                    First[$CellContext`allcreatedrays$]; \
$CellContext`completedray$ = $CellContext`originalray$); \
$CellContext`deflectedrays$ = $CellContext`allcreatedrays$; \
$CellContext`newdeflectedrays$ = {$CellContext`originalray$}; 
                    Scan[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; ($CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; If[
                    Abs[$CellContext`raytiltx$] < 1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = $CellContext`baseIndex$$ - \
$CellContext`factorX$$ ($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - \
$CellContext`factorY$$ ($CellContext`LocRSy$ - $CellContext`ypos$$)^2; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]], \
$CellContext`index2$ = Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = \
$CellContext`baseIndex$$ - $CellContext`factorX$$ ($CellContext`LocRSx$ - \
$CellContext`xpos$$)^2 - $CellContext`factorY$$ ($CellContext`LocRSy$ - \
$CellContext`ypos$$)^2; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = \
$CellContext`baseIndex$$ - $CellContext`factorX$$ ($CellContext`LocRSx$ - \
$CellContext`xpos$$)^2 - $CellContext`factorY$$ ($CellContext`LocRSy$ - \
$CellContext`ypos$$)^2]]; $CellContext`n12$ = \
$CellContext`index1$/$CellContext`index2$; $CellContext`index$ = \
$CellContext`index2$; If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]); \
$CellContext`newdeflectedrays$ = 
                    Join[$CellContext`newdeflectedrays$, \
$CellContext`allcreatedrays$])& , $CellContext`deflectedrays$]; \
$CellContext`allcreatedrays$ = 
                    Drop[$CellContext`newdeflectedrays$, 
                    1]; $CellContext`deflectedrays$ = \
$CellContext`allcreatedrays$; $CellContext`newdeflectedrays$ = \
{$CellContext`originalray$}; 
                    Scan[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; ($CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; If[
                    Abs[$CellContext`raytiltx$] < 1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; \
$CellContext`surftrans$ = $CellContext`surfacetranslationvector$; \
$CellContext`surfrot$ = $CellContext`surfacerotationmatrix$; 
                    Which[$CellContext`surfaceid$ == 
                    272713, $CellContext`localtranslation$ = {0, 0, 
                    0}; $CellContext`localrotation$ = {{1, 0, 0}, {0, 1, 0}, {
                    0, 0, 1}}, $CellContext`surfaceid$ == 
                    272778, $CellContext`localtranslation$ = {10., 0., 
                    0.}; $CellContext`localrotation$ = {{1., 0., 0.}, {0., 1.,
                     0.}, {0., 0., 1.}}, $CellContext`surfaceid$ == 
                    272521, $CellContext`localtranslation$ = {5., 0., 
                    5.}; $CellContext`localrotation$ = {{0., 0., 1.}, {0., 1.,
                     0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272551, $CellContext`localtranslation$ = {5., 
                    0., -5.}; $CellContext`localrotation$ = {{0., 0., -1.}, {
                    0., -1., 0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272617, $CellContext`localtranslation$ = {5., 5., 
                    0.}; $CellContext`localrotation$ = {{0., -1., 0.}, {1., 
                    0., 0.}, {0., 0., 1.}}, 
                    True, $CellContext`localtranslation$ = {5., -5., 
                    0.}; $CellContext`localrotation$ = {{0., 1., 0.}, {-1., 
                    0., 0.}, {0., 0., 1.}}]; $CellContext`localopticallength$ = 
                    0.; $CellContext`localraylength$ = 
                    0.; $CellContext`integratedrefractiveindex$ = 
                    0.; $CellContext`localpos$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} - $CellContext`surftrans$]; \
$CellContext`localtilt$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[$CellContext`activeregion$ 
                    Part[$CellContext`localtilt$, 1] > 
                    0, {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$; $CellContext`localpos$ = 
                    
                    Dot[$CellContext`localpos$, $CellContext`localrotation$] + \
$CellContext`localtranslation$; $CellContext`localtilt$ = 
                    Dot[$CellContext`localtilt$, $CellContext`localrotation$]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; $CellContext`localindex$ = $CellContext`index$; \
$CellContext`localindex$ = $CellContext`baseIndex$$ - $CellContext`factorX$$ \
($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - $CellContext`factorY$$ \
($CellContext`LocRSy$ - $CellContext`ypos$$)^2; $CellContext`listofpositions$ = \
{{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}}; \
$CellContext`listoftilts$ = {{
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}}; $CellContext`indexpoints$ = \
{$CellContext`localindex$}; $CellContext`opticallengths$ = \
{$CellContext`opticallength$}; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; $CellContext`localtilt$ = \
$CellContext`localindex$ $CellContext`localtilt$; $CellContext`Ninitial$ = \
$CellContext`localindex$^2; $CellContext`Sinitial$ = 
                    0.1^2 Dot[{(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}, $CellContext`localtilt$]; $CellContext`rSxOffset$ = 
                    0.; While[
                    And[
                    Plus[10.] - ($CellContext`LocRSx$ - \
$CellContext`rSxOffset$) >= (-0.01) 0.1, 
                    Plus[$CellContext`LocRSx$ - $CellContext`rSxOffset$] >= \
(-0.01) 0.1, 
                    And[
                    0.99999 $CellContext`LocRSy$ <= 5., 
                    0.99999 $CellContext`LocRSy$ >= -5., 
                    0.99999 $CellContext`LocRSz$ >= -5., 
                    0.99999 $CellContext`LocRSz$ <= 
                    5.]], $CellContext`localraylength$ = \
($CellContext`localraylength$ + Sqrt[
                    
                    Dot[#, #]]& )[$CellContext`localpos$ - \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}]; \
$CellContext`localpos$ = {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$}; 
                    AppendTo[$CellContext`listofpositions$, \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}]; 
                    AppendTo[$CellContext`listoftilts$, {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}]; $CellContext`localindex$ = $CellContext`baseIndex$$ - \
$CellContext`factorX$$ ($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - \
$CellContext`factorY$$ ($CellContext`LocRSy$ - $CellContext`ypos$$)^2; 
                    AppendTo[$CellContext`indexpoints$, \
$CellContext`localindex$]; $CellContext`opticallengths$ = 
                    Append[$CellContext`opticallengths$, 
                    Last[$CellContext`opticallengths$] + \
$CellContext`localindex$ 
                    0.1]; $CellContext`integratedrefractiveindex$ = \
$CellContext`integratedrefractiveindex$ + $CellContext`localindex$^2; \
$CellContext`localtilt$ = $CellContext`localindex$ {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}; $CellContext`Aelement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$ + (
                    0.1 $CellContext`localtilt$)/
                    2. + (0.1 $CellContext`Aelement$)/
                    8.; $CellContext`Belement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$ + 
                    0.1 $CellContext`localtilt$ + (
                    0.1 $CellContext`Belement$)/2; $CellContext`Celement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; $CellContext`newpos$ = $CellContext`localpos$ + 
                    0.1 ($CellContext`localtilt$ + ($CellContext`Aelement$ + 
                    2 $CellContext`Belement$)/
                    6); $CellContext`newtilt$ = $CellContext`localtilt$ + \
($CellContext`Aelement$ + 4. $CellContext`Aelement$ + $CellContext`Celement$)/
                    6.; $CellContext`newtilt$ = $CellContext`newtilt$/Sqrt[
                    
                    Dot[$CellContext`newtilt$, $CellContext`newtilt$]]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`newpos$; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`newtilt$; 
                    1.]; $CellContext`integratedrefractiveindex$ = \
$CellContext`integratedrefractiveindex$ - $CellContext`localindex$^2; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; $CellContext`Sfinal$ = 
                    0.1 Dot[$CellContext`Aelement$, $CellContext`localtilt$]; \
$CellContext`Nfinal$ = $CellContext`localindex$^2; $CellContext`localtilt$ = \
$CellContext`localtilt$/Sqrt[
                    Dot[$CellContext`localtilt$, $CellContext`localtilt$]]; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; \
$CellContext`localopticallength$ = 
                    0.1 $CellContext`integratedrefractiveindex$ - \
($CellContext`Sfinal$ - $CellContext`Sinitial$)/
                    6 + (0.1 ($CellContext`Nfinal$ - $CellContext`Ninitial$))/
                    2; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`localopticallength$; \
$CellContext`ray1$ = $CellContext`localraylength$; $CellContext`localpos$ = 
                    Dot[$CellContext`localrotation$, $CellContext`localpos$ - \
$CellContext`localtranslation$]; {$CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$} = 
                    Dot[$CellContext`localpos$, $CellContext`surfrot$] + \
$CellContext`surftrans$; $CellContext`localtilt$ = 
                    Dot[$CellContext`localrotation$, $CellContext`localtilt$]; \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = 
                    Dot[$CellContext`localtilt$, $CellContext`surfrot$]; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$} = \
{$CellContext`rex$, $CellContext`rey$, $CellContext`rez$}; \
$CellContext`index$ = $CellContext`baseIndex$$ - $CellContext`factorX$$ \
($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - $CellContext`factorY$$ \
($CellContext`LocRSy$ - $CellContext`ypos$$)^2; $CellContext`allcreatedrays$ = \
{{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`listofpositions$ = 
                    Map[Dot[$CellContext`localrotation$, # - \
$CellContext`localtranslation$]& , $CellContext`listofpositions$]; \
$CellContext`listofpositions$ = 
                    Map[Dot[#, $CellContext`surfrot$] + \
$CellContext`surftrans$& , $CellContext`listofpositions$]; \
$CellContext`listoftilts$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`listoftilts$]; \
$CellContext`listoftilts$ = Map[
                    Dot[#, $CellContext`surfrot$]& , \
$CellContext`listoftilts$]; If[
                    
                    And[$CellContext`reportedrayspresent$, 
                    Length[$CellContext`indexpoints$] > 
                    1], $CellContext`reportedrays$ = 
                    Join[$CellContext`reportedrays$, 
                    
                    Table[{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$} = 
                    Part[$CellContext`listofpositions$, \
$CellContext`ninteger$]; {$CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$} = 
                    Part[$CellContext`listofpositions$, \
$CellContext`ninteger$ + 
                    1]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = 
                    Part[$CellContext`listoftilts$, $CellContext`ninteger$]; \
$CellContext`ray1$ = 0.1; $CellContext`index$ = 
                    Part[$CellContext`indexpoints$, $CellContext`ninteger$]; \
$CellContext`opticallength$ = 
                    Part[$CellContext`opticallengths$, \
$CellContext`ninteger$]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`ninteger$, 1, 
                    Length[$CellContext`indexpoints$] - 1}]]; 1., 
                    1.]; $CellContext`allcreatedrays$, \
$CellContext`allcreatedrays$ = {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}]; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]); \
$CellContext`newdeflectedrays$ = 
                    Join[$CellContext`newdeflectedrays$, \
$CellContext`allcreatedrays$])& , $CellContext`deflectedrays$]; \
$CellContext`allcreatedrays$ = 
                    Drop[$CellContext`newdeflectedrays$, 
                    1]; $CellContext`deflectedrays$ = \
$CellContext`allcreatedrays$; $CellContext`deflectedrays$ = 
                    MapIndexed[ReplacePart[#, 
                    First[#2], 
                    34]& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = $CellContext`deflectedrays$); \
{$CellContext`allcreatedrays$, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 
                    0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,
                     1., 1., 1., 
                    1.}}, {$CellContext`completedray$}}, \
$CellContext`resonatenumber$ == 
                    6, {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r2$; $CellContext`yunit$ = \
-$CellContext`r1$; $CellContext`zunit$ = $CellContext`r3$; \
$CellContext`xunit$ = Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                    5. + $CellContext`rey$ - 1. 
                    Re[$CellContext`gly$$]; $CellContext`ry$ = -(-5. + \
$CellContext`rex$ - 1. 
                    Re[$CellContext`glx$$]); $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = \
$CellContext`resonateintersections$; $CellContext`holeQ$ = 
                    Part[$CellContext`holeQlist$, \
$CellContext`resonatenumber$] == 
                    1; {$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {1., 6., 
                    272683.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {1., 6., 
                    272683.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = 
                    5. - 1. $CellContext`ryhlp$ + 
                    Re[$CellContext`glx$$]; $CellContext`rey$ = -5. + \
$CellContext`rxhlp$ + 
                    Re[$CellContext`gly$$]; $CellContext`rez$ = \
$CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`reportedrayspresent$ = 
                    True; $CellContext`intersectionspresent$ = 
                    True; $CellContext`deflectedrayspresent$ = 
                    True; $CellContext`localdummyoutrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[Dot[{{0., -1., 0.}, {1., 0., 0.}, {0., 0., 
                    1.}}, #]& , $CellContext`surfnorm$]; \
$CellContext`surfnorm$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{0, 1., 0}, {-1., 0, 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = {
                    5. + Re[$CellContext`glx$$], -5. + Re[$CellContext`gly$$],
                     0.}; $CellContext`activeregion$ = 
                    1.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; 
                    If[Abs[$CellContext`raytiltx$] < 
                    1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; \
$CellContext`surftrans$ = $CellContext`surfacetranslationvector$; \
$CellContext`surfrot$ = $CellContext`surfacerotationmatrix$; 
                    Which[$CellContext`surfaceid$ == 
                    272713, $CellContext`localtranslation$ = {0, 0, 
                    0}; $CellContext`localrotation$ = {{1, 0, 0}, {0, 1, 0}, {
                    0, 0, 1}}, $CellContext`surfaceid$ == 
                    272778, $CellContext`localtranslation$ = {10., 0., 
                    0.}; $CellContext`localrotation$ = {{1., 0., 0.}, {0., 1.,
                     0.}, {0., 0., 1.}}, $CellContext`surfaceid$ == 
                    272521, $CellContext`localtranslation$ = {5., 0., 
                    5.}; $CellContext`localrotation$ = {{0., 0., 1.}, {0., 1.,
                     0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272551, $CellContext`localtranslation$ = {5., 
                    0., -5.}; $CellContext`localrotation$ = {{0., 0., -1.}, {
                    0., -1., 0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272617, $CellContext`localtranslation$ = {5., 5., 
                    0.}; $CellContext`localrotation$ = {{0., -1., 0.}, {1., 
                    0., 0.}, {0., 0., 1.}}, 
                    True, $CellContext`localtranslation$ = {5., -5., 
                    0.}; $CellContext`localrotation$ = {{0., 1., 0.}, {-1., 
                    0., 0.}, {0., 0., 1.}}]; $CellContext`localpos$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} - $CellContext`surftrans$]; \
$CellContext`localtilt$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`localpos$ = 
                    Dot[$CellContext`localpos$, $CellContext`localrotation$] + \
$CellContext`localtranslation$; $CellContext`localtilt$ = 
                    Dot[$CellContext`localtilt$, $CellContext`localrotation$]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; $CellContext`allcreatedrays$ = \
{{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]; \
($CellContext`originalray$ = 
                    First[$CellContext`allcreatedrays$]; \
$CellContext`completedray$ = $CellContext`originalray$); \
$CellContext`deflectedrays$ = $CellContext`allcreatedrays$; \
$CellContext`newdeflectedrays$ = {$CellContext`originalray$}; 
                    Scan[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; ($CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; If[
                    Abs[$CellContext`raytiltx$] < 1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; 
                    If[$CellContext`activeregion$ Part[
                    
                    Dot[$CellContext`surfacerotationmatrix$, \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}], 1] > 
                    0, $CellContext`index2$ = $CellContext`baseIndex$$ - \
$CellContext`factorX$$ ($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - \
$CellContext`factorY$$ ($CellContext`LocRSy$ - $CellContext`ypos$$)^2; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = 
                    Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]], \
$CellContext`index2$ = Sqrt[1.0005281111748805` - 
                    2.364805676582992*^-10 $CellContext`wavelength$^2 + 
                    2.9781670902982902`*^-6/$CellContext`wavelength$^2 + 
                    2.6004099469477187`*^-8/$CellContext`wavelength$^4 + 
                    3.7787839314048715`*^-10/$CellContext`wavelength$^6 + 
                    2.830549017940716*^-12/$CellContext`wavelength$^8]; \
$CellContext`index1$ = $CellContext`index$; 
                    If[Abs[$CellContext`index2$ - $CellContext`index1$] < 
                    0.01, $CellContext`alternateindex$ = \
$CellContext`baseIndex$$ - $CellContext`factorX$$ ($CellContext`LocRSx$ - \
$CellContext`xpos$$)^2 - $CellContext`factorY$$ ($CellContext`LocRSy$ - \
$CellContext`ypos$$)^2; 
                    If[Abs[$CellContext`alternateindex$ - \
$CellContext`index1$] > 
                    Abs[$CellContext`index2$ - $CellContext`index1$], \
$CellContext`index1$ = $CellContext`index2$; $CellContext`index2$ = \
$CellContext`alternateindex$, $CellContext`index1$ = \
$CellContext`alternateindex$], $CellContext`index1$ = \
$CellContext`baseIndex$$ - $CellContext`factorX$$ ($CellContext`LocRSx$ - \
$CellContext`xpos$$)^2 - $CellContext`factorY$$ ($CellContext`LocRSy$ - \
$CellContext`ypos$$)^2]]; $CellContext`n12$ = \
$CellContext`index1$/$CellContext`index2$; $CellContext`index$ = \
$CellContext`index2$; If[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2 >= 
                    0., $CellContext`dummyvector$ = $CellContext`n12$ \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} + $CellContext`ZAxis$ \
(-($CellContext`n12$ $CellContext`raytiltz$) + 
                    Sqrt[1 - $CellContext`n12$^2 $CellContext`raytiltx$^2]); \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = \
$CellContext`dummyvector$; 1., 
                    If[Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, 
                    Part[$CellContext`surfnorm$, 1]] > 
                    0, $CellContext`phaseshift$ = $CellContext`phaseshift$ + 
                    0.5, 1.]; $CellContext`index2$ = $CellContext`index1$; \
$CellContext`index$ = $CellContext`index1$; $CellContext`dummyvector$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - (
                    2 $CellContext`ZAxis$) 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = \
{$CellContext`pol1$, $CellContext`pol2$, $CellContext`pol3$} + {0, 
                    0, -180}; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; 
                    1.]; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[
                    Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]); \
$CellContext`newdeflectedrays$ = 
                    Join[$CellContext`newdeflectedrays$, \
$CellContext`allcreatedrays$])& , $CellContext`deflectedrays$]; \
$CellContext`allcreatedrays$ = 
                    Drop[$CellContext`newdeflectedrays$, 
                    1]; $CellContext`deflectedrays$ = \
$CellContext`allcreatedrays$; $CellContext`newdeflectedrays$ = \
{$CellContext`originalray$}; 
                    Scan[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; ($CellContext`ZAxis$ = 
                    First[$CellContext`surfnorm$] Sign[
                    Dot[
                    
                    First[$CellContext`surfnorm$], {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]]; $CellContext`raytiltz$ = 
                    Dot[$CellContext`ZAxis$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`raytiltx$ = 
                    1 - $CellContext`raytiltz$^2; 
                    If[$CellContext`raytiltx$ < 
                    2.220446049250313*^-16, $CellContext`raytiltx$ = 
                    0., $CellContext`raytiltx$ = 
                    Sqrt[$CellContext`raytiltx$]]; $CellContext`XAxis$ = \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} - $CellContext`ZAxis$ \
$CellContext`raytiltz$; If[
                    Abs[$CellContext`raytiltx$] < 1.*^-7, $CellContext`XAxis$ = 
                    Part[$CellContext`surfnorm$, 
                    2], $CellContext`XAxis$ = \
$CellContext`XAxis$/$CellContext`raytiltx$]; $CellContext`YAxis$ = {-(
                    Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 2]) + 
                    Part[$CellContext`ZAxis$, 2] Part[$CellContext`XAxis$, 3],
                     Part[$CellContext`ZAxis$, 3] 
                    Part[$CellContext`XAxis$, 1] - 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 3], -(
                    Part[$CellContext`ZAxis$, 2] 
                    Part[$CellContext`XAxis$, 1]) + 
                    Part[$CellContext`ZAxis$, 1] 
                    Part[$CellContext`XAxis$, 
                    2]}; $CellContext`YAxis$ = $CellContext`YAxis$/Sqrt[
                    
                    Dot[$CellContext`YAxis$, $CellContext`YAxis$]]; \
$CellContext`PAxis$ = $CellContext`ZAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`XAxis$] - $CellContext`XAxis$ 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, $CellContext`ZAxis$]; $CellContext`PAxis$ = \
$CellContext`PAxis$/Sqrt[
                    
                    Dot[$CellContext`PAxis$, $CellContext`PAxis$]]; \
$CellContext`normalizedpolarization$ = 
                    Part[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {1, 
                    2}]; $CellContext`normalizedpolarization$ = \
$CellContext`normalizedpolarization$/Sqrt[
                    
                    Dot[$CellContext`normalizedpolarization$, \
$CellContext`normalizedpolarization$]]; $CellContext`allcreatedamplitudes$ = \
{{I 0., I 0., I 0.}}; $CellContext`amplitude$ = 
                    Sqrt[$CellContext`intensity$] (
                    Part[$CellContext`normalizedpolarization$, 
                    1] {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$} + \
(Part[$CellContext`normalizedpolarization$, 
                    2] {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$})
                     Exp[(I $CellContext`pol3$) 
                    0.017453292519943295`]); \
$CellContext`perpendicularamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`YAxis$]; \
$CellContext`parallelamplitude$ = 
                    Dot[$CellContext`amplitude$, $CellContext`PAxis$]; \
$CellContext`surftrans$ = $CellContext`surfacetranslationvector$; \
$CellContext`surfrot$ = $CellContext`surfacerotationmatrix$; 
                    Which[$CellContext`surfaceid$ == 
                    272713, $CellContext`localtranslation$ = {0, 0, 
                    0}; $CellContext`localrotation$ = {{1, 0, 0}, {0, 1, 0}, {
                    0, 0, 1}}, $CellContext`surfaceid$ == 
                    272778, $CellContext`localtranslation$ = {10., 0., 
                    0.}; $CellContext`localrotation$ = {{1., 0., 0.}, {0., 1.,
                     0.}, {0., 0., 1.}}, $CellContext`surfaceid$ == 
                    272521, $CellContext`localtranslation$ = {5., 0., 
                    5.}; $CellContext`localrotation$ = {{0., 0., 1.}, {0., 1.,
                     0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272551, $CellContext`localtranslation$ = {5., 
                    0., -5.}; $CellContext`localrotation$ = {{0., 0., -1.}, {
                    0., -1., 0.}, {-1., 0., 0.}}, $CellContext`surfaceid$ == 
                    272617, $CellContext`localtranslation$ = {5., 5., 
                    0.}; $CellContext`localrotation$ = {{0., -1., 0.}, {1., 
                    0., 0.}, {0., 0., 1.}}, 
                    True, $CellContext`localtranslation$ = {5., -5., 
                    0.}; $CellContext`localrotation$ = {{0., 1., 0.}, {-1., 
                    0., 0.}, {0., 0., 1.}}]; $CellContext`localopticallength$ = 
                    0.; $CellContext`localraylength$ = 
                    0.; $CellContext`integratedrefractiveindex$ = 
                    0.; $CellContext`localpos$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$} - $CellContext`surftrans$]; \
$CellContext`localtilt$ = 
                    Dot[$CellContext`surfrot$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[$CellContext`activeregion$ 
                    Part[$CellContext`localtilt$, 1] > 
                    0, {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$; $CellContext`localpos$ = 
                    Dot[$CellContext`localpos$, $CellContext`localrotation$] + \
$CellContext`localtranslation$; $CellContext`localtilt$ = 
                    Dot[$CellContext`localtilt$, $CellContext`localrotation$]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; $CellContext`localindex$ = $CellContext`index$; \
$CellContext`localindex$ = $CellContext`baseIndex$$ - $CellContext`factorX$$ \
($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - $CellContext`factorY$$ \
($CellContext`LocRSy$ - $CellContext`ypos$$)^2; $CellContext`listofpositions$ = \
{{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}}; \
$CellContext`listoftilts$ = {{
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}}; $CellContext`indexpoints$ = \
{$CellContext`localindex$}; $CellContext`opticallengths$ = \
{$CellContext`opticallength$}; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; $CellContext`localtilt$ = \
$CellContext`localindex$ $CellContext`localtilt$; $CellContext`Ninitial$ = \
$CellContext`localindex$^2; $CellContext`Sinitial$ = 
                    0.1^2 Dot[{(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}, $CellContext`localtilt$]; $CellContext`rSxOffset$ = 
                    0.; While[
                    And[
                    Plus[10.] - ($CellContext`LocRSx$ - \
$CellContext`rSxOffset$) >= (-0.01) 0.1, 
                    Plus[$CellContext`LocRSx$ - $CellContext`rSxOffset$] >= \
(-0.01) 0.1, 
                    And[
                    0.99999 $CellContext`LocRSy$ <= 5., 
                    0.99999 $CellContext`LocRSy$ >= -5., 
                    0.99999 $CellContext`LocRSz$ >= -5., 
                    0.99999 $CellContext`LocRSz$ <= 
                    5.]], $CellContext`localraylength$ = \
($CellContext`localraylength$ + Sqrt[
                    
                    Dot[#, #]]& )[$CellContext`localpos$ - \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}]; \
$CellContext`localpos$ = {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$}; 
                    AppendTo[$CellContext`listofpositions$, \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$}]; 
                    AppendTo[$CellContext`listoftilts$, {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}]; $CellContext`localindex$ = $CellContext`baseIndex$$ - \
$CellContext`factorX$$ ($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - \
$CellContext`factorY$$ ($CellContext`LocRSy$ - $CellContext`ypos$$)^2; 
                    AppendTo[$CellContext`indexpoints$, \
$CellContext`localindex$]; $CellContext`opticallengths$ = 
                    Append[$CellContext`opticallengths$, 
                    Last[$CellContext`opticallengths$] + \
$CellContext`localindex$ 
                    0.1]; $CellContext`integratedrefractiveindex$ = \
$CellContext`integratedrefractiveindex$ + $CellContext`localindex$^2; \
$CellContext`localtilt$ = $CellContext`localindex$ {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$}; $CellContext`Aelement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$ + (
                    0.1 $CellContext`localtilt$)/
                    2. + (0.1 $CellContext`Aelement$)/
                    8.; $CellContext`Belement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; {$CellContext`LocRSx$, $CellContext`LocRSy$, \
$CellContext`LocRSz$} = $CellContext`localpos$ + 
                    0.1 $CellContext`localtilt$ + (
                    0.1 $CellContext`Belement$)/2; $CellContext`Celement$ = 
                    0.1 {(((-2) $CellContext`baseIndex$$) \
$CellContext`factorX$$) $CellContext`LocRSx$ + (
                    2 $CellContext`factorX$$^2) $CellContext`LocRSx$^3 + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorX$$) \
$CellContext`xpos$$ - ((
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$^2) \
$CellContext`xpos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$^2) $CellContext`xpos$$ + ((
                    
                    6 $CellContext`factorX$$^2) $CellContext`LocRSx$) \
$CellContext`xpos$$^2 - (
                    2 $CellContext`factorX$$^2) $CellContext`xpos$$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$) $CellContext`ypos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`ypos$$^2 - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$) $CellContext`ypos$$^2, (((-2) $CellContext`baseIndex$$) \
$CellContext`factorY$$) $CellContext`LocRSy$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`LocRSy$ + (
                    2 $CellContext`factorY$$^2) $CellContext`LocRSy$^3 - ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`LocRSy$) $CellContext`xpos$$ + (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSy$) $CellContext`xpos$$^2 + ((
                    2 $CellContext`baseIndex$$) $CellContext`factorY$$) \
$CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$^2) $CellContext`ypos$$ - ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$^2) \
$CellContext`ypos$$ + ((((
                    4 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`LocRSx$) $CellContext`xpos$$) $CellContext`ypos$$ - (((
                    2 $CellContext`factorX$$) $CellContext`factorY$$) \
$CellContext`xpos$$^2) $CellContext`ypos$$ + ((
                    6 $CellContext`factorY$$^2) $CellContext`LocRSy$) \
$CellContext`ypos$$^2 - (2 $CellContext`factorY$$^2) $CellContext`ypos$$^3, 
                    0}; $CellContext`newpos$ = $CellContext`localpos$ + 
                    0.1 ($CellContext`localtilt$ + ($CellContext`Aelement$ + 
                    2 $CellContext`Belement$)/
                    6); $CellContext`newtilt$ = $CellContext`localtilt$ + \
($CellContext`Aelement$ + 4. $CellContext`Aelement$ + $CellContext`Celement$)/
                    6.; $CellContext`newtilt$ = $CellContext`newtilt$/Sqrt[
                    
                    Dot[$CellContext`newtilt$, $CellContext`newtilt$]]; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`newpos$; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`newtilt$; 
                    1.]; $CellContext`integratedrefractiveindex$ = \
$CellContext`integratedrefractiveindex$ - $CellContext`localindex$^2; \
{$CellContext`LocRSx$, $CellContext`LocRSy$, $CellContext`LocRSz$} = \
$CellContext`localpos$; $CellContext`Sfinal$ = 
                    0.1 Dot[$CellContext`Aelement$, $CellContext`localtilt$]; \
$CellContext`Nfinal$ = $CellContext`localindex$^2; $CellContext`localtilt$ = \
$CellContext`localtilt$/Sqrt[
                    Dot[$CellContext`localtilt$, $CellContext`localtilt$]]; {
                    Optica`Optica`RTx$, $CellContext`LocRTy$, \
$CellContext`LocRTz$} = $CellContext`localtilt$; \
$CellContext`localopticallength$ = 
                    0.1 $CellContext`integratedrefractiveindex$ - \
($CellContext`Sfinal$ - $CellContext`Sinitial$)/
                    6 + (0.1 ($CellContext`Nfinal$ - $CellContext`Ninitial$))/
                    2; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`localopticallength$; \
$CellContext`ray1$ = $CellContext`localraylength$; $CellContext`localpos$ = 
                    Dot[$CellContext`localrotation$, $CellContext`localpos$ - \
$CellContext`localtranslation$]; {$CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$} = 
                    Dot[$CellContext`localpos$, $CellContext`surfrot$] + \
$CellContext`surftrans$; $CellContext`localtilt$ = 
                    Dot[$CellContext`localrotation$, $CellContext`localtilt$]; \
{$CellContext`r1$, $CellContext`r2$, $CellContext`r3$} = 
                    Dot[$CellContext`localtilt$, $CellContext`surfrot$]; \
{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$} = \
{$CellContext`rex$, $CellContext`rey$, $CellContext`rez$}; \
$CellContext`index$ = $CellContext`baseIndex$$ - $CellContext`factorX$$ \
($CellContext`LocRSx$ - $CellContext`xpos$$)^2 - $CellContext`factorY$$ \
($CellContext`LocRSy$ - $CellContext`ypos$$)^2; $CellContext`allcreatedrays$ = \
{{$CellContext`rsx$, $CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, \
$CellContext`rey$, $CellContext`rez$, $CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$, $CellContext`r4$, $CellContext`r5$, $CellContext`r6$, \
$CellContext`r7$, $CellContext`r8$, $CellContext`r9$, \
$CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}; $CellContext`listofpositions$ = 
                    Map[Dot[$CellContext`localrotation$, # - \
$CellContext`localtranslation$]& , $CellContext`listofpositions$]; \
$CellContext`listofpositions$ = 
                    Map[Dot[#, $CellContext`surfrot$] + \
$CellContext`surftrans$& , $CellContext`listofpositions$]; \
$CellContext`listoftilts$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`listoftilts$]; \
$CellContext`listoftilts$ = Map[
                    Dot[#, $CellContext`surfrot$]& , \
$CellContext`listoftilts$]; If[
                    
                    And[$CellContext`reportedrayspresent$, 
                    Length[$CellContext`indexpoints$] > 
                    1], $CellContext`reportedrays$ = 
                    Join[$CellContext`reportedrays$, 
                    
                    Table[{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$} = 
                    Part[$CellContext`listofpositions$, \
$CellContext`ninteger$]; {$CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$} = 
                    Part[$CellContext`listofpositions$, \
$CellContext`ninteger$ + 
                    1]; {$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$} = 
                    Part[$CellContext`listoftilts$, $CellContext`ninteger$]; \
$CellContext`ray1$ = 0.1; $CellContext`index$ = 
                    Part[$CellContext`indexpoints$, $CellContext`ninteger$]; \
$CellContext`opticallength$ = 
                    Part[$CellContext`opticallengths$, \
$CellContext`ninteger$]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`ninteger$, 1, 
                    Length[$CellContext`indexpoints$] - 1}]]; 1., 
                    1.]; $CellContext`allcreatedrays$, \
$CellContext`allcreatedrays$ = {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}]; $CellContext`originalrotation$ = Partition[
                    Take[$CellContext`originalray$, {7, 15}], 
                    3]; $CellContext`previoustilt$ = 
                    Part[$CellContext`originalrotation$, 
                    1]; $CellContext`transmatrix$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`rotationaxis$ = 
                    Cross[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; $CellContext`axismagnitude$ = Sqrt[
                    
                    Dot[$CellContext`rotationaxis$, \
$CellContext`rotationaxis$]]; 
                    If[Chop[$CellContext`axismagnitude$] != 
                    0., $CellContext`rotationaxis$ = \
$CellContext`rotationaxis$/$CellContext`axismagnitude$; \
$CellContext`axismatrix$ = 
                    Map[# $CellContext`rotationaxis$& , \
$CellContext`rotationaxis$]; $CellContext`crossmatrix$ = {{
                    0., -Part[$CellContext`rotationaxis$, 3], 
                    Part[$CellContext`rotationaxis$, 2]}, {
                    Part[$CellContext`rotationaxis$, 3], 0., -
                    Part[$CellContext`rotationaxis$, 1]}, {-
                    Part[$CellContext`rotationaxis$, 2], 
                    Part[$CellContext`rotationaxis$, 1], 
                    0.}}; $CellContext`cosangle$ = 
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]; 
                    If[1. - $CellContext`cosangle$ < 
                    2.220446049250313*^-16, $CellContext`cosangle$ = 
                    1.]; $CellContext`sinangle$ = 
                    1 - $CellContext`cosangle$^2; 
                    If[$CellContext`sinangle$ < 
                    2.220446049250313*^-16, $CellContext`sinangle$ = 
                    0., $CellContext`sinangle$ = 
                    Sqrt[$CellContext`sinangle$]]; $CellContext`axismatrix$ + \
({{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}} - $CellContext`axismatrix$) $CellContext`cosangle$ + \
$CellContext`crossmatrix$ $CellContext`sinangle$, {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    If[Sign[
                    
                    Dot[$CellContext`previoustilt$, {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}]] === 1, {{1., 0., 0.}, {0., 1., 0.}, {0.,
                     0., 1.}}, {{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}]])& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = 
                    MapIndexed[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = 
                    Function[$CellContext`mm$, 
                    Map[
                    Dot[$CellContext`mm$, #]& , \
$CellContext`originalrotation$]][
                    Part[$CellContext`transmatrix$, 
                    First[#2]]]; $CellContext`tiltmagnitude$ = 
                    Dot[{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r1$, $CellContext`r2$, $CellContext`r3$}]; 
                    If[Abs[$CellContext`tiltmagnitude$ - 1.] > 
                    1.*^-6, $CellContext`dummyvector$ = {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}/
                    Sqrt[$CellContext`tiltmagnitude$]; {$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$} = $CellContext`dummyvector$; \
$CellContext`dummymatrix$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , {{$CellContext`r1$, $CellContext`r2$, \
$CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, $CellContext`r6$}, \
{$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}}]; {{$CellContext`r1$, \
$CellContext`r2$, $CellContext`r3$}, {$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, {$CellContext`r7$, $CellContext`r8$, $CellContext`r9$}} = \
$CellContext`dummymatrix$; 1., 1.]; 
                    If[$CellContext`allcreatedamplitudes$ != {{
                    I 0., I 0., I 0.}}, $CellContext`amplitude$ = 
                    Part[$CellContext`allcreatedamplitudes$, 
                    First[#2]]; $CellContext`hor$ = 
                    Dot[{$CellContext`r4$, $CellContext`r5$, \
$CellContext`r6$}, $CellContext`amplitude$]; $CellContext`ver$ = 
                    Dot[{$CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$}, $CellContext`amplitude$]; If[
                    Or[Abs[$CellContext`hor$] > 0., Abs[$CellContext`ver$] > 
                    0.], {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = {
                    Abs[$CellContext`hor$], 
                    Abs[$CellContext`ver$], 
                    0.}; $CellContext`dummyvector$ = {$CellContext`pol1$, \
$CellContext`pol2$, $CellContext`pol3$}/Sqrt[
                    
                    Dot[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}]]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$; $CellContext`dummyvector$ = 
                    ReplacePart[{$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}, (If[$CellContext`ver$ == 0., 0., 
                    Arg[$CellContext`ver$]] - 
                    If[$CellContext`hor$ == 0., 0., 
                    Arg[$CellContext`hor$]])/Degree, 
                    3]; {$CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = $CellContext`dummyvector$]; 1., 
                    1.]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$})& , $CellContext`allcreatedrays$]); \
$CellContext`newdeflectedrays$ = 
                    Join[$CellContext`newdeflectedrays$, \
$CellContext`allcreatedrays$])& , $CellContext`deflectedrays$]; \
$CellContext`allcreatedrays$ = 
                    Drop[$CellContext`newdeflectedrays$, 
                    1]; $CellContext`deflectedrays$ = \
$CellContext`allcreatedrays$; $CellContext`deflectedrays$ = 
                    MapIndexed[ReplacePart[#, 
                    First[#2], 
                    34]& , $CellContext`allcreatedrays$]; \
$CellContext`allcreatedrays$ = $CellContext`deflectedrays$); \
{$CellContext`allcreatedrays$, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 
                    0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,
                     1., 1., 1., 1.}}, {$CellContext`completedray$}}, 
                    True, $CellContext`deflecteddummyrayspresent$ = 
                    True; $CellContext`reporteddummyrayspresent$ = 
                    True; $CellContext`localoutrayspresent$ = 
                    True; {{{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 
                    0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,
                     1., 1., 1., 
                    1.}}, {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 
                    0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,
                     1., 1., 1., 
                    1.}}}], $CellContext`deflecteddummyrayspresent$ = 
                    True; $CellContext`reporteddummyrayspresent$ = 
                    True; $CellContext`localdummyoutrayspresent$ = True; {{{
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 
                    0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,
                     1., 1., 1., 1.}}, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 
                    1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,
                     1., 1., 1., 1., 1.}}}])& , $CellContext`inrays$]]]; If[
               
               And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ] 
                1., 1.]; 
             If[$CellContext`localoutrayspresent$, 
               If[$CellContext`localdummyoutrayspresent$, \
$CellContext`localoutrays$ = 
                  Select[$CellContext`localoutrays$, Part[#, 23] > 0.& ]; 1., 
                 1.]; $CellContext`outrays$ = 
                Join[$CellContext`outrays$, $CellContext`localoutrays$]; 1., 
               1.]; If[
               
               And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
                Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
               1., 1.]); 
            If[$CellContext`reportedrayspresent$, $CellContext`raysreported$ = 
               True; $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`inrays$ = $CellContext`deflectedlocalrays$; \
$CellContext`propagate$ = $CellContext`generationnumber$ < \
$CellContext`generationlimit$]; $CellContext`propagatedrays$ = 
           If[Length[$CellContext`outrays$] > 1, 
             Drop[$CellContext`outrays$, 1], $CellContext`outrays$]; If[
            
            And[$CellContext`generationnumber$ >= \
$CellContext`generationlimit$, $CellContext`deflectedrayspresent$], \
$CellContext`propagatedrays$ = 
             Join[$CellContext`propagatedrays$, \
$CellContext`deflectedlocalrays$]; 1., 
            1.]); ($CellContext`inrays$ = $CellContext`propagatedrays$; \
$CellContext`outrays$ = {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
            1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1.,
             1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
            1.}}; $CellContext`deflectedrayspresent$ = 
           True; $CellContext`reportedrayspresent$ = 
           False; $CellContext`propagate$ = True; While[
            And[$CellContext`deflectedrayspresent$, $CellContext`propagate$], 
            AddTo[$CellContext`generationnumber$, 
              1.]; ($CellContext`deflecteddummyrayspresent$ = 
              False; $CellContext`deflectedrayspresent$ = 
              False; $CellContext`reportedrayspresent$ = 
              False; $CellContext`reporteddummyrayspresent$ = 
              True; $CellContext`localdummyoutrayspresent$ = 
              False; $CellContext`localoutrayspresent$ = 
              False; {$CellContext`deflectedlocalrays$, \
$CellContext`localoutrays$, $CellContext`reportedlocalrays$} = 
              Map[Flatten[#, 1]& , 
                Transpose[
                 
                 Map[({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; If[
                    
                    And[$CellContext`intensity$ > \
$CellContext`thresholdintensity$, $CellContext`generationnumber$ < \
$CellContext`generationlimit$], ($CellContext`resonatenumber$ = 
                    0; $CellContext`resonateraylength$ = 
                    9.87654321*^8; $CellContext`resonateintersections$ = \
{{-1., 0., 0.}}; MapIndexed[If[
                    And[
                    Part[#, 1, 1] > -1., 
                    Part[#, 1, 
                    1] < $CellContext`resonateraylength$], \
$CellContext`resonateraylength$ = 
                    Part[#, 1, 
                    1]; $CellContext`resonateintersections$ = #; \
$CellContext`resonatenumber$ = 
                    First[#2], $CellContext`resonatenumber$]& , \
$CellContext`intersectionslist$ = {{{-1., 0., 
                    0.}}}; $CellContext`holeQlist$ = {
                    0}; ({$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = -$CellContext`r1$; $CellContext`yunit$ = \
-$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; \
$CellContext`xunit$ = Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -(-40. + \
$CellContext`rex$); $CellContext`ry$ = -$CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., 
                    And[
                    Part[#, 2] <= 15., Part[#, 2] >= -15., Part[#, 3] >= -15.,
                     Part[#, 3] <= 15.]], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 273031.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                    If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; 
                    AppendTo[$CellContext`intersectionslist$, \
$CellContext`intersections$]; If[$CellContext`holeQ$, 
                    AppendTo[$CellContext`holeQlist$, 1], 
                    
                    AppendTo[$CellContext`holeQlist$, 
                    0]]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r2$; $CellContext`yunit$ = \
-$CellContext`r1$; $CellContext`zunit$ = $CellContext`r3$; \
$CellContext`xunit$ = Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                    15. + $CellContext`rey$; $CellContext`ry$ = -(-20. + \
$CellContext`rex$); $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., 
                    And[
                    Part[#, 2] <= 20., Part[#, 2] >= -20., Part[#, 3] >= -15.,
                     Part[#, 3] <= 15.]], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 273032.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                    If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; 
                    AppendTo[$CellContext`intersectionslist$, \
$CellContext`intersections$]; If[$CellContext`holeQ$, 
                    AppendTo[$CellContext`holeQlist$, 1], 
                    
                    AppendTo[$CellContext`holeQlist$, 
                    0]]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                    Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = \
$CellContext`rex$; $CellContext`ry$ = $CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., 
                    And[Part[#, 2] <= 15., Part[#, 2] >= -15., 
                    Part[#, 3] >= -15., Part[#, 3] <= 15.]], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 273033.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                    If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; 
                    AppendTo[$CellContext`intersectionslist$, \
$CellContext`intersections$]; If[$CellContext`holeQ$, 
                    AppendTo[$CellContext`holeQlist$, 1], 
                    
                    AppendTo[$CellContext`holeQlist$, 
                    0]]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = -$CellContext`r2$; $CellContext`yunit$ = \
$CellContext`r1$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                    Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -(-15. + \
$CellContext`rey$); $CellContext`ry$ = -20. + $CellContext`rex$; \
$CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., 
                    And[
                    Part[#, 2] <= 20., Part[#, 2] >= -20., Part[#, 3] >= -15.,
                     Part[#, 3] <= 15.]], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 273034.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                    If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; 
                    AppendTo[$CellContext`intersectionslist$, \
$CellContext`intersections$]; If[$CellContext`holeQ$, 
                    AppendTo[$CellContext`holeQlist$, 1], 
                    AppendTo[$CellContext`holeQlist$, 
                    0]]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r3$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = -$CellContext`r1$; \
$CellContext`xunit$ = Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                    15. + $CellContext`rez$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = -(-20. + $CellContext`rex$); \
$CellContext`rx$ = Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., 
                    And[
                    Part[#, 2] <= 15., Part[#, 2] >= -15., Part[#, 3] >= -20.,
                     Part[#, 3] <= 20.]], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 273035.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                    If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; 
                    AppendTo[$CellContext`intersectionslist$, \
$CellContext`intersections$]; If[$CellContext`holeQ$, 
                    AppendTo[$CellContext`holeQlist$, 1], 
                    
                    AppendTo[$CellContext`holeQlist$, 
                    0]]; {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = -$CellContext`r3$; $CellContext`yunit$ = \
-$CellContext`r2$; $CellContext`zunit$ = -$CellContext`r1$; \
$CellContext`xunit$ = Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -(-15. + \
$CellContext`rez$); $CellContext`ry$ = -$CellContext`rey$; $CellContext`rz$ = \
-(-20. + $CellContext`rex$); $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = 
                    If[Chop[$CellContext`xunit$] != 0, {
                    (If[
                    And[N[
                    Chop[
                    Part[#, 1]]] >= 0., 
                    And[
                    Part[#, 2] <= 15., Part[#, 2] >= -15., Part[#, 3] >= -20.,
                     Part[#, 3] <= 20.]], {
                    Part[#, 1], 
                    Part[#, 2], 
                    Part[#, 3]}, {-1., 0., 
                    0.}]& )[{-($CellContext`rx$/$CellContext`xunit$), \
$CellContext`ry$ - ($CellContext`rx$ \
$CellContext`yunit$)/$CellContext`xunit$, $CellContext`rz$ - \
($CellContext`rx$ $CellContext`zunit$)/$CellContext`xunit$}]}, {{-1., 0., 
                    0.}}]; AppendTo[$CellContext`intersections$, {-1., 0., 
                    0.}]; $CellContext`holeQ$ = False; If[
                    Or[
                    Not[
                    Or[Chop[$CellContext`surfaceid$ - 273036.] == 0., N[
                    Chop[$CellContext`ray1$]] < 
                    0.0001]], $CellContext`generationnumber$ == 
                    1.], $CellContext`minresonateraylength$ = 
                    0., $CellContext`minresonateraylength$ = 0.0001]; 
                    Block[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$}, $CellContext`LocRayL$ = 1.; $CellContext`LocSCx$ = 
                    1.; $CellContext`LocSCy$ = 1.; $CellContext`dummymatrix$ = 
                    Union[
                    
                    Select[$CellContext`intersections$, \
({$CellContext`LocRayL$, $CellContext`LocSCx$, $CellContext`LocSCy$} = #; 
                    Or[{$CellContext`LocRayL$, $CellContext`LocSCx$, \
$CellContext`LocSCy$} == {-1., 0., 0.}, N[
                    
                    Chop[$CellContext`LocRayL$]] >= \
$CellContext`minresonateraylength$])& ]]; $CellContext`intersections$ = \
$CellContext`dummymatrix$]; $CellContext`unfilteredintersections$ = \
$CellContext`intersections$; 
                    If[Length[$CellContext`intersections$] > 
                    1, $CellContext`dummymatrix$ = 
                    Take[$CellContext`intersections$, {
                    
                    2}]; $CellContext`intersections$ = \
$CellContext`dummymatrix$; 1., 1.]; 
                    AppendTo[$CellContext`intersectionslist$, \
$CellContext`intersections$]; If[$CellContext`holeQ$, 
                    AppendTo[$CellContext`holeQlist$, 1], 
                    
                    AppendTo[$CellContext`holeQlist$, 
                    0]]); $CellContext`holeQlist$ = 
                    Drop[$CellContext`holeQlist$, 1]; 
                    Drop[$CellContext`intersectionslist$, 1]]); 
                    Which[$CellContext`resonatenumber$ == 
                    1, {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = -$CellContext`r1$; $CellContext`yunit$ = \
-$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; \
$CellContext`xunit$ = Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -(-40. + \
$CellContext`rex$); $CellContext`ry$ = -$CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = \
$CellContext`resonateintersections$; $CellContext`holeQ$ = 
                    Part[$CellContext`holeQlist$, \
$CellContext`resonatenumber$] == 
                    1; {$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {2., 1., 
                    273031.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {2., 1., 
                    273031.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = 
                    40. - 1. $CellContext`rxhlp$; $CellContext`rey$ = \
-$CellContext`ryhlp$; $CellContext`rez$ = $CellContext`rzhlp$; \
$CellContext`rex$ = Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`reportedrayspresent$ = 
                    True; $CellContext`intersectionspresent$ = 
                    True; $CellContext`deflectedrayspresent$ = 
                    True; $CellContext`localdummyoutrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[Dot[{{-1., 0., 0.}, {0., -1., 0.}, {0., 0., 
                    1.}}, #]& , $CellContext`surfnorm$]; \
$CellContext`surfnorm$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{-1., 0, 0}, {0, -1., 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = {
                    40., 0, 0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`intensity$ = 
                    0.; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}); {$CellContext`allcreatedrays$, {{1., 1., 1., 1., 1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}, {$CellContext`completedray$}}, \
$CellContext`resonatenumber$ == 
                    2, {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r2$; $CellContext`yunit$ = \
-$CellContext`r1$; $CellContext`zunit$ = $CellContext`r3$; \
$CellContext`xunit$ = Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                    15. + $CellContext`rey$; $CellContext`ry$ = -(-20. + \
$CellContext`rex$); $CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = \
$CellContext`resonateintersections$; $CellContext`holeQ$ = 
                    Part[$CellContext`holeQlist$, \
$CellContext`resonatenumber$] == 
                    1; {$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {2., 2., 
                    273032.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {2., 2., 
                    273032.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = 
                    20. - 1. $CellContext`ryhlp$; $CellContext`rey$ = -15. + \
$CellContext`rxhlp$; $CellContext`rez$ = $CellContext`rzhlp$; \
$CellContext`rex$ = Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`reportedrayspresent$ = 
                    True; $CellContext`intersectionspresent$ = 
                    True; $CellContext`deflectedrayspresent$ = 
                    True; $CellContext`localdummyoutrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[Dot[{{0., -1., 0.}, {1., 0., 0.}, {0., 0., 
                    1.}}, #]& , $CellContext`surfnorm$]; \
$CellContext`surfnorm$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{0, 1., 0}, {-1., 0, 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = {
                    20., -15., 0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`intensity$ = 
                    0.; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}); {$CellContext`allcreatedrays$, {{1., 1., 1., 1., 1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}, {$CellContext`completedray$}}, \
$CellContext`resonatenumber$ == 
                    3, {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r1$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                    Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = \
$CellContext`rex$; $CellContext`ry$ = $CellContext`rey$; $CellContext`rz$ = \
$CellContext`rez$; $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = \
$CellContext`resonateintersections$; $CellContext`holeQ$ = 
                    Part[$CellContext`holeQlist$, \
$CellContext`resonatenumber$] == 
                    1; {$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {2., 3., 
                    273033.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {2., 3., 
                    273033.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = \
$CellContext`rxhlp$; $CellContext`rey$ = $CellContext`ryhlp$; \
$CellContext`rez$ = $CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`reportedrayspresent$ = 
                    True; $CellContext`intersectionspresent$ = 
                    True; $CellContext`deflectedrayspresent$ = 
                    True; $CellContext`localdummyoutrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[#& , $CellContext`surfnorm$]; $CellContext`surfnorm$ = 
                    Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{1, 0, 0}, {0, 1, 0}, {0, 0, 
                    1}}; $CellContext`surfacetranslationvector$ = {0, 0, 
                    0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`intensity$ = 
                    0.; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}); {$CellContext`allcreatedrays$, {{1., 1., 1., 1., 1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}, {$CellContext`completedray$}}, \
$CellContext`resonatenumber$ == 
                    4, {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = -$CellContext`r2$; $CellContext`yunit$ = \
$CellContext`r1$; $CellContext`zunit$ = $CellContext`r3$; $CellContext`xunit$ = 
                    Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -(-15. + \
$CellContext`rey$); $CellContext`ry$ = -20. + $CellContext`rex$; \
$CellContext`rz$ = $CellContext`rez$; $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = \
$CellContext`resonateintersections$; $CellContext`holeQ$ = 
                    Part[$CellContext`holeQlist$, \
$CellContext`resonatenumber$] == 
                    1; {$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {2., 4., 
                    273034.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {2., 4., 
                    273034.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = 
                    20. + $CellContext`ryhlp$; $CellContext`rey$ = 
                    15. - 1. $CellContext`rxhlp$; $CellContext`rez$ = \
$CellContext`rzhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`reportedrayspresent$ = 
                    True; $CellContext`intersectionspresent$ = 
                    True; $CellContext`deflectedrayspresent$ = 
                    True; $CellContext`localdummyoutrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[Dot[{{0., 1., 0.}, {-1., 0., 0.}, {0., 0., 
                    1.}}, #]& , $CellContext`surfnorm$]; \
$CellContext`surfnorm$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{0, -1., 0}, {1., 0, 0}, {
                    0, 0, 1.}}; $CellContext`surfacetranslationvector$ = {
                    20., 15., 0}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`intensity$ = 
                    0.; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}); {$CellContext`allcreatedrays$, {{1., 1., 1., 1., 1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}, {$CellContext`completedray$}}, \
$CellContext`resonatenumber$ == 
                    5, {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = $CellContext`r3$; $CellContext`yunit$ = \
$CellContext`r2$; $CellContext`zunit$ = -$CellContext`r1$; \
$CellContext`xunit$ = Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = 
                    15. + $CellContext`rez$; $CellContext`ry$ = \
$CellContext`rey$; $CellContext`rz$ = -(-20. + $CellContext`rex$); \
$CellContext`rx$ = Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = \
$CellContext`resonateintersections$; $CellContext`holeQ$ = 
                    Part[$CellContext`holeQlist$, \
$CellContext`resonatenumber$] == 
                    1; {$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {2., 5., 
                    273035.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {2., 5., 
                    273035.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = 
                    20. - 1. $CellContext`rzhlp$; $CellContext`rey$ = \
$CellContext`ryhlp$; $CellContext`rez$ = -15. + $CellContext`rxhlp$; \
$CellContext`rex$ = Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`reportedrayspresent$ = 
                    True; $CellContext`intersectionspresent$ = 
                    True; $CellContext`deflectedrayspresent$ = 
                    True; $CellContext`localdummyoutrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[Dot[{{0., 0., -1.}, {0., 1., 0.}, {1., 0., 
                    0.}}, #]& , $CellContext`surfnorm$]; \
$CellContext`surfnorm$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{0, 0, 1.}, {
                    0, 1., 0}, {-1., 0, 
                    0}}; $CellContext`surfacetranslationvector$ = {
                    20., 0, -15.}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`intensity$ = 
                    0.; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}); {$CellContext`allcreatedrays$, {{1., 1., 1., 1., 1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}, {$CellContext`completedray$}}, \
$CellContext`resonatenumber$ == 
                    6, {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`oldgenerationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$} = #; $CellContext`index1$ = $CellContext`index$; \
$CellContext`xunit$ = -$CellContext`r3$; $CellContext`yunit$ = \
-$CellContext`r2$; $CellContext`zunit$ = -$CellContext`r1$; \
$CellContext`xunit$ = Chop[$CellContext`xunit$]; $CellContext`yunit$ = 
                    Chop[$CellContext`yunit$]; $CellContext`zunit$ = 
                    Chop[$CellContext`zunit$]; $CellContext`magnitude$ = \
($CellContext`xunit$^2 + $CellContext`yunit$^2 + $CellContext`zunit$^2)^(
                    2^(-1)); $CellContext`xunit$ = \
$CellContext`xunit$/$CellContext`magnitude$; $CellContext`yunit$ = \
$CellContext`yunit$/$CellContext`magnitude$; $CellContext`zunit$ = \
$CellContext`zunit$/$CellContext`magnitude$; $CellContext`rx$ = -(-15. + \
$CellContext`rez$); $CellContext`ry$ = -$CellContext`rey$; $CellContext`rz$ = \
-(-20. + $CellContext`rex$); $CellContext`rx$ = 
                    Chop[$CellContext`rx$]; $CellContext`ry$ = 
                    Chop[$CellContext`ry$]; $CellContext`rz$ = 
                    Chop[$CellContext`rz$]; $CellContext`terminatedeflection$ = 
                    False; $CellContext`intersections$ = {{-1., 0., 
                    0.}}; $CellContext`intersections$ = \
$CellContext`resonateintersections$; $CellContext`holeQ$ = 
                    Part[$CellContext`holeQlist$, \
$CellContext`resonatenumber$] == 
                    1; {$CellContext`newcomponentnumber$, \
$CellContext`newsurfacenumber$, $CellContext`newsurfaceid$} = {2., 6., 
                    273036.}; {$CellContext`componentnumber$, \
$CellContext`surfacenumber$, $CellContext`surfaceid$} = {2., 6., 
                    273036.}; {$CellContext`ray1$, $CellContext`ray2$, \
$CellContext`ray3$} = Part[$CellContext`intersections$, 
                    1]; $CellContext`rsx$ = $CellContext`rex$; \
$CellContext`rsy$ = $CellContext`rey$; $CellContext`rsz$ = $CellContext`rez$; \
$CellContext`rxhlp$ = $CellContext`rx$ + $CellContext`ray1$ \
$CellContext`xunit$; $CellContext`ryhlp$ = $CellContext`ry$ + \
$CellContext`ray1$ $CellContext`yunit$; $CellContext`rzhlp$ = \
$CellContext`rz$ + $CellContext`ray1$ $CellContext`zunit$; $CellContext`rex$ = 
                    20. - 1. $CellContext`rzhlp$; $CellContext`rey$ = \
-$CellContext`ryhlp$; $CellContext`rez$ = 
                    15. - 1. $CellContext`rxhlp$; $CellContext`rex$ = 
                    Chop[$CellContext`rex$]; $CellContext`rey$ = 
                    Chop[$CellContext`rey$]; $CellContext`rez$ = 
                    Chop[$CellContext`rez$]; $CellContext`intersectionnumber$ = \
$CellContext`intersectionnumber$ + 
                    1.; $CellContext`opticallength$ = \
$CellContext`opticallength$ + $CellContext`ray1$ $CellContext`index1$; \
$CellContext`completedray$ = {$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`reportedrayspresent$ = 
                    True; $CellContext`intersectionspresent$ = 
                    True; $CellContext`deflectedrayspresent$ = 
                    True; $CellContext`localdummyoutrayspresent$ = 
                    True; ($CellContext`surfnorm$ = 
                    1. Re[{{1., 0., 0.}, {0., 1., 0.}, {0., 0., 
                    1.}}]; $CellContext`dummymatrix$ = 
                    Map[Dot[{{0., 0., -1.}, {0., -1., 0.}, {-1., 0., 
                    0.}}, #]& , $CellContext`surfnorm$]; \
$CellContext`surfnorm$ = Map[#/Sqrt[
                    
                    Dot[#, #]]& , $CellContext`dummymatrix$]; \
$CellContext`surfacerotationmatrix$ = {{0, 0, -1.}, {
                    0, -1., 0}, {-1., 0, 
                    0}}; $CellContext`surfacetranslationvector$ = {
                    20., 0, 15.}; $CellContext`activeregion$ = 
                    0.; $CellContext`completedray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`componentnumber$ = \
$CellContext`newcomponentnumber$; $CellContext`surfacenumber$ = \
$CellContext`newsurfacenumber$; $CellContext`surfaceid$ = \
$CellContext`newsurfaceid$; $CellContext`originalray$ = {$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}; $CellContext`intensity$ = 
                    0.; $CellContext`allcreatedrays$ = {{$CellContext`rsx$, \
$CellContext`rsy$, $CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, \
$CellContext`rez$, $CellContext`r1$, $CellContext`r2$, $CellContext`r3$, \
$CellContext`r4$, $CellContext`r5$, $CellContext`r6$, $CellContext`r7$, \
$CellContext`r8$, $CellContext`r9$, $CellContext`wavelength$, \
$CellContext`intensity$, $CellContext`intensityscale$, $CellContext`ray1$, \
$CellContext`index$, $CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}); {$CellContext`allcreatedrays$, {{1., 1., 1., 1., 1., 
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1., 1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}, {$CellContext`completedray$}}, 
                    True, $CellContext`deflecteddummyrayspresent$ = 
                    True; $CellContext`reporteddummyrayspresent$ = 
                    True; $CellContext`localoutrayspresent$ = 
                    True; {{{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 
                    0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,
                     1., 1., 1., 
                    1.}}, {{$CellContext`rsx$, $CellContext`rsy$, \
$CellContext`rsz$, $CellContext`rex$, $CellContext`rey$, $CellContext`rez$, \
$CellContext`r1$, $CellContext`r2$, $CellContext`r3$, $CellContext`r4$, \
$CellContext`r5$, $CellContext`r6$, $CellContext`r7$, $CellContext`r8$, \
$CellContext`r9$, $CellContext`wavelength$, $CellContext`intensity$, \
$CellContext`intensityscale$, $CellContext`ray1$, $CellContext`index$, \
$CellContext`opticallength$, $CellContext`phaseshift$, \
$CellContext`componentnumber$, $CellContext`surfacenumber$, \
$CellContext`surfaceid$, $CellContext`ray2$, $CellContext`ray3$, \
$CellContext`sid$, $CellContext`frontid$, $CellContext`sno1$, \
$CellContext`sno2$, $CellContext`sno3$, $CellContext`sno4$, \
$CellContext`rayslot$, $CellContext`generationnumber$, \
$CellContext`intersectionnumber$, $CellContext`pol1$, $CellContext`pol2$, \
$CellContext`pol3$}}, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 
                    0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,
                     1., 1., 1., 
                    1.}}}], $CellContext`deflecteddummyrayspresent$ = 
                    True; $CellContext`reporteddummyrayspresent$ = 
                    True; $CellContext`localdummyoutrayspresent$ = True; {{{
                    1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., -9.87654321*^8, 1., 1., 1., 1., 0., -1., -1., -1.,
                     1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1.}}, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 1., 
                    0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,
                     1., 1., 1., 1.}}, {{1., 1., 1., 1., 1., 1., 1., 1., 1., 
                    1., 1., 1., 1., 1., 1., 1., -9.87654321*^8, 1., 1., 1., 
                    1., 0., -1., -1., -1., 1., 1., 1., 1., 1., 1., 1., 1., 1.,
                     1., 1., 1., 1., 1.}}}])& , $CellContext`inrays$]]]; If[
               
               And[$CellContext`deflectedrayspresent$, \
$CellContext`deflecteddummyrayspresent$], $CellContext`deflectedlocalrays$ = 
               Select[$CellContext`deflectedlocalrays$, Part[#, 23] > 0.& ] 
                1., 1.]; 
             If[$CellContext`localoutrayspresent$, 
               If[$CellContext`localdummyoutrayspresent$, \
$CellContext`localoutrays$ = 
                  Select[$CellContext`localoutrays$, Part[#, 23] > 0.& ]; 1., 
                 1.]; $CellContext`outrays$ = 
                Join[$CellContext`outrays$, $CellContext`localoutrays$]; 1., 
               1.]; If[
               
               And[$CellContext`reportedrayspresent$, \
$CellContext`reporteddummyrayspresent$], $CellContext`reportedlocalrays$ = 
                Select[$CellContext`reportedlocalrays$, Part[#, 23] > 0.& ]; 
               1., 1.]); 
            If[$CellContext`reportedrayspresent$, $CellContext`raysreported$ = 
               True; $CellContext`reportedrays$ = 
               Join[$CellContext`reportedrays$, {{-9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8, -9.87654321*^8, -9.87654321*^8, \
-9.87654321*^8, -9.87654321*^8}}, $CellContext`reportedlocalrays$]; 1., 
              1.]; $CellContext`inrays$ = $CellContext`deflectedlocalrays$; \
$CellContext`propagate$ = $CellContext`generationnumber$ < \
$CellContext`generationlimit$]; $CellContext`propagatedrays$ = 
           If[Length[$CellContext`outrays$] > 1, 
             Drop[$CellContext`outrays$, 1], $CellContext`outrays$]; If[
            
            And[$CellContext`generationnumber$ >= \
$CellContext`generationlimit$, $CellContext`deflectedrayspresent$], \
$CellContext`propagatedrays$ = 
             Join[$CellContext`propagatedrays$, \
$CellContext`deflectedlocalrays$]; 1., 1.]); 
         If[Length[$CellContext`reportedrays$] > 
           2, $CellContext`reportedrays$ = 
           Drop[$CellContext`reportedrays$, 2], $CellContext`reportedrays$]; 
         Map[{
            Part[#, 1], 
            Part[#, 2], 
            Part[#, 3], 
            Part[#, 4], 
            Part[#, 5], 
            Part[#, 6]}& , $CellContext`reportedrays$]]]; 
     Typeset`initDone$$ = True),
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output"]
}, {2}]]
},
WindowSize->{1689, 1117},
WindowMargins->{{17, Automatic}, {Automatic, 55}},
DockedCells->FEPrivate`If[
  FEPrivate`SameQ[FEPrivate`$ProductIDName, "MathematicaPlayer"], {
   Cell[
    BoxData[
     Cell[
      GraphicsData[
      "CompressedBitmap", 
       "eJzdXWdgVEeSnlUiYzA2mdUCygFEkhDKRAkMAhsWE8wZe8FgwHjB9p7DLuwa\n\
7CUJY6IIAgmUESighAQSCiihnBMCRDz7wu/7sd91v9f9pt/Mm5EE+M/9mNSv\n\
Q1V1d31V1WGWbvxiy6YdG7/Y+vHGPyzatfHzLVs/3v2HhTt3kSTL3+l0Flt0\n\
Op3zH3T0O8hX9vYWOjs7dVaozsvHleB3kB8ZhfbWVmspeQAa6upxLzAE3ePd\n\
UeYyBc0Bvnj0b6F4+NkaVK1fjXuXL+sspbz90NnRgerr15C/YzsKZs1B8UhH\n\
JE7zQsWVKzrQPNLbHCm37m3Wbtb3+3B1nANiN21DVXGxlZQ8Ah2krvp31+KR\n\
w3Tct5+JlsWBaN8Qgifb3sPDD0LR9OFK1EWcQW3qNVSeO4u87Z+icI4vaqe6\n\
ocjVFedGT8a15e+ivbHRVNs2qKuqQoLbLMQPnICL07xRfOwE6nNuWUiP30R7\n\
czPaVq7AIy9vtE2bjZo5nmhauwAPdq/Cs+/X4fE6QtPSeWgJDULzqvmo8JuO\n\
8hnuqJjmgRhbJ4RTGla8q2/eR25+pPQxBimE9fQRk5Azwg7J5DPDcSru7Pgc\n\
ZSdPo2TdWjz18sTDQH80+vqi1c4DDX4z8eD7lXj69/fQ+UUo2jYFo2nRTDRv\n\
mYe7gTNREDQFCVPccMHWHhedXHDz8z/rTDQ+DjXFRUhycEfsyMnkZYfccXZI\n\
H2+POHsHFDk44anbTDwO8EfnwkB0zZiDDnc33N+5AI/Prcej42vR/mUwyjYG\n\
oHSdN26tmo3kebMQ7uCMw2PG45SLGyoTE6WmyaDQ9ZfatERdVhbqb92SfukJ\n\
myISNhYdbW3IWPFHXBn2eyT6euPu3z9CxT+3oOTAFlQe2oKGI5+i8acdaDix\n\
Ew0/f4a6w1tQd2o7GmO/RMOVr9AY/RVqLvwZVSe3o/LUDpQf/wylhz5F5vaV\n\
OOExBTe/+RaFBw9ZszHQ0daKisuXUXo2HFlr1yLjvVW4Fx+vJ2+qTN4o6WMy\n\
7pLOSXBzQdWFr9B87QhqY4+hKeE4HqefxYP0cDxIO4OutHDcz7iArszz6Lz6\n\
MzpjjqKTPGvPOYfW3HNoJN9rk06iNv446pJ+RlPqSeR+8QmuOLgh87OdKCP0\n\
lNNXZCRKzpzB9XXrkRi6HElkgOeQwXCT0NmYny/I0EMkchIKDochLsQPDVf3\n\
415kOCqvROJpWiy60qPxXzU5+J97OfglPxVP8zPxrCAdL1Kj8cuNWDxLicGT\n\
tBh0p8ahLTkO7dFRaIm+hKpzhOiLkWgnBJ2d4oIfJtkizMkJh13dcH46Ge2e\n\
0xHnPAV3p3qhaLY/sjd/gra6+iaJHGu0Xk9DlYsvKoe5oCZ0Pf2tG8/GRHFx\n\
sTxOyK8XLG3btm1IT0+XfgWytFOnTknpERERpNckbt9gj6je4VVYMQm0Nbci\n\
ccVyxCz2QV38D2RknEf31Sj8WpCCC37+SAkJQWt6JP6z4Ta689Px+HYyXhQn\n\
43l2LLqTiLQSL+FJdATuX7qAzvPn8fBSBJrPhKMhOhqdN1Jx0GsqDnhMQpj7\n\
ZJx1d0Y20REl84JQExCEXO8A0p1fUgk0Mwl0VFajynMRKn8/Q5ICkQaZgzL5\n\
lZWVEnf0138IEkhKShIkYIVbZObQNPqMfLcWheCIwiNhyP7oIyL6zbi54zPk\n\
/3gAVak3UH0zGwVbNyOPKIXUd/xRH/8jHqdexLPMaLyozkKSTwDKdBNwY4IL\n\
cndtQVv+VTyvzMZTIownt+LwKOUyEcglPCICuU8E0nrxPBojzxOlexqt8bF4\n\
lJ2G5IW+yA/xQePS+WgNWohm/2CUBwUhPSAQd/b/oGtnHLTl3ZG4p6/mn8PH\n\
9lIAc1najz/+iKNHjwr9rBsofRBtU1SEqsiLaDwXjurLUSiNjkFh5GUUbN+O\n\
uqnT0PXmRNwfPgntQyaizckZT6a54ZmdK24vCUBV/H4ycy/iQcYVdN9LR5x/\n\
EMoHOKB2qDNu6yYi0W06bv/wDbrKUvGkMAldqZHoTIxAx9WLaI2LQPWlsygN\n\
P4l7Z47jflIcOm/eQNm7S9Cycinayef9NaGoXTgfGZ5zcGM9Gf01NR2Mo5q5\n\
yyVh1K3/RNdXadDfu3btMpaGK+oqylFI9NnNd1fgnpMbSkdNQuwIW8SMnYw8\n\
e0dkjrZFzaCJePiWHTrdXNHuNwsPPDyQuzwIpVF/J1P/HDoyL+N+WQqiyYDO\n\
H+yA4lFuKBnthuKhDkgeSuoLnIvik/vRfjMGLQnn0RB/gaiZ8yi9cBoFP4fh\n\
7vEwMsES0XozDRWfrMaDbzfg0ZYVBFAXICfAD5nrN9AJohvMGGiOjFXGBpkl\n\
EkeW9BdhlT7jE9yCGRt0RtVt3a3oFfpJf5N02SCxYIUb/rJHKEzTrMQ0+l1K\n\
tmKAQAcpVVKMEKlSkiblsdBXrF2JBesc+oxxQw0jXshGZEXJRHpfoHiQkoez\n\
yJUGpYpSJykSOoUiY5ntZY3GfYf1oiDPe+LWktl3VDWT9tViJL9pOsuv0xcw\n\
LdNBSlpvqLbg4EvyirKmXCjNjFARTl+UKJpdZJTm6U2TNuZ7pm/0W/L5y2in\n\
6txaGJi0Lp5fkKjOwpQQ+2lMfp4moiFvuLGxUZr85JkyBKIJNH399ddSfvpJ\n\
fjPF0E9BT1qGlqXt0jr37t1LiKK1DKDfJYyhz3ibVN3ychR5rXpsS/sZnxe0\n\
Tpqun8mWCqaRTyZEdT4bM/VaasjIhvHM6+Avyh/hgcqYtaOuk/NooVGn6TQb\n\
MU16UYuGQJUsVhsJtQQjh2fnvSZwKklf3yODjIrSvKzXORzw6pgkhkkjiJbj\n\
HNGep/XS32LPm6iHM8WYUITHSDEnG7HPTPdjP4kKPq7oi35n+XqUM+0vgzHZ\n\
87Cz4YJVmqRCIWTIj4dIMqO1cpnQ4nSkUEop4zydtUjT2eyUuaHViXlY9Zqj\n\
k5Mk9rvRsNALjlDO0V1GSie0khZLiXd1b9sOdDt6oNveCUV2LshzJHbQ9Klo\n\
meiC+65T0DbbG/fnByDng2AUXNiDuoSzxPO4hJbCBJzzD8C1YXbIGOOK9DEu\n\
5OWK7NGuuDZ0MsKJR3g5dCkKTx1CRRzxQC6Fo/DEURQePYjK2DNouJ2Kxtw0\n\
NOzZgF9/+hBPvlyBqiVBSPH1I17U2SGsPwRFK70oMFuwZ1SRi88oyvAJoZjK\n\
7BmxkRQko+n0ORPay0I8xw+q4qkJxizz3wDiBRBQASjPQw0/Vivl00pBHYY0\n\
fLSIAqPUM4jvmc6B1NAWDSs9w7Lcja0C01LVp/WWbgXc5Y7k5bXoJnRasmSJ\n\
RGbPkZbMNdQDrPeeYol1bnBy60c/YfsZjklRhi+P69yo59OeKjGmpJSGeRrV\n\
PDQ//WS6kOXpr2h4mpfmoVqJqxCi2SwkcB0oKTmahSscqqxoGi1C05mC633L\n\
A83lkZph6M5nDSdU78brDQA9cPSmabUAbZggBGNC4YqjAvltyTLz6mmf8GwS\n\
ZhvXbDrNRgWgtIup/KRqqLhtFOygj7jIFSKsRb6lziLE6OSigyS0Eo01ygOt\n\
jpbhJgE3mjiF3CiUTQj6xFKEL5ZvkLm6DDnR9YoVrS5Up3Hs5yjLx6mAuqYF\n\
LZtD1kYjVT8WJvQ4DJl8VeXZhFTkxqwGJQ/tA/qcfvJ0Wi8ry5gaIJWnZUXG\n\
eBs0nZoC5kaROA40ZMvtHb39zYI+w9F0pxDNYQfQNX822p3d0eo9EzWLvNGy\n\
aA4eTJ+NR3OCkLE6GLfO/Q2lMWdQFncWNblxCPP1Rdgbtjg92oGG1kY5kLrI\n\
d5wZaY/Dg8fj+/F2iFi3FnlnjiIr7CBunTiI8qRzqL2Tgrr8VLQc+Dc827MS\n\
nWsCcGeuN64vWYKWe5U6jv2i2lf7fLKnKj6jiplPS9Fm4DqYfPYGkXrCfrkJ\n\
KxWSSlV3qjw5WsGrmgCWogev08YUmmat5ONYpGAJa9gIUdXJUliil7TyJhRx\n\
W9Di8oASK+3BBLBW0npLMyeO+sCcOCW5n4pmMQhBiePVUpNPaM5Eaz2YAn2n\n\
nHaQaDypDFWhCKlO3xPqPnk5a4ATJSh0EUO5nhF1CNc3XJRMp1gKRajqEvUz\n\
d+vMVcOasuzN4wGqx6JS44BCNJnCrxZi9IYxJietajizXPdT30lLZqIAekZ5\n\
axU20m4jOl0JdlD9znGE47EWKHLXg3apGDBQ6fp+qqY4bDHPXVGS3C3XhIvX\n\
Q61pCNfuJLMkvcRIsxQfK7ITi9A+Ztg6QKMIZ4DbFzTmw6sWR+MrwDJHd2pt\n\
MVgeLn0MQ2daMvG8F+BBiBfuL/dG68ZgtK5fhO7FgchcF4ys8L+i8MJRFEX8\n\
jHs3orDfazZ2DxmL7962xTcjba3w7du2uqH4buREfDN8AnYOHoVvHF1w/qMP\n\
cfdaOMpTzqGm+Dpqcq6h5eBG/PrP99H60SLkBPrhemjoUCYBMUqqVnd651zx\n\
Tz0X6YOabFGCuklaaSbVW1/hl6h1Ln9Bz74y/PZTYJWbGlwSBq6aMf4SMtSg\n\
Y4gI6kYte6JUHocqFKEmgRZS9Rl3e6JViy6NJmTTjJkthE59s50qu8FMc30G\n\
3h7FbC1ZC8xcMRqgfNDWbd2t7et39hlr+yvaQ5z11Dmi30kdXPnS6mgS95sM\n\
3FuhhNLLWrpFrKaHVowe91c95vRyJ4ToWb7dwhh/1ASa4skMxHJVTC0S2pqB\n\
lEyz3DOysqCrglVcw/cWWXlkQVzC6COymtX4r4dac8j6EiDU57FlKT5WqOcB\n\
7E7m7VLOBrL8wjNlFPE6aD6+kYZbXZoRApOM8JHAe493i3586t6UPoaio/gu\n\
2tYvR1fgTDzeRtB01xI8WD8XmcsCkUcc3KrIY6hOjUB9XiIOzPHBd2+Mx/7R\n\
djbYN2oyKb5v9GT6DX8dPA573xyPqNAQFMT8hJaKNNQTn7b95Gb89+kNeLB1\n\
EQoX+CF5MfFpq6oGM/pFPcUVHXEaFf+RAaTWeqm1oQ7W53opLFXC2EwPsi01\n\
XJ2/ljB2PzFErWKaamKhdn28W1o0ZTYF0fAqCgyWvQ0lZAI9jZxTKULQZ5/V\n\
Rh8ENkmi4SaDXmGn0o0kTViWULCtt81Zme+L3tCvXnbgQCvETtT0yWk8Ii97\n\
tdyz7huaDjbSrNxr5aEwPuvZd770KhZjjzSXhK3Yu+gxEW1hxSTHlYaqditV\n\
DFhJ7meYLHklPERnDjaN09QMcGJNY6a1uKSnMGzNmDMRVu0JM/Uykp+J4jaH\n\
QnyAUnjg4UVpmcBUs9q9zAPJlCMeqDYwiH4rDn4DHGWGgxLf0RxZg4wEQYtx\n\
/1fkikaIrdmg4N1LhSSuSNCFe0NOKC5zTOXwbSCtXmIqnag8hs1MW46pI6SP\n\
IWi7lYuuD0PwaIMP2j8MwqN9f0TO9hUoOvs3NMadQktGJNqKk3DK1x/nh09G\n\
9FhX0u6VsS4EUC+PdETMaEfcmOmF7E3rkPbPL4lrehpdpcloLcpAx+lN+J/z\n\
69C9aS6aVvogMygAN9Z9wAFV2fBFdBX3Cole4x3GfTbpEfcbVK7NbwOrltJm\n\
HwZ6pI3XgKUDjPxMcT8R/a4nzVqMHcsV/n6GTMZLw6iliJd0NGpBa6/9T2O6\n\
Xg07+fjvqV4tkLRgQQraXSyvTnOEGFeu7xTFOyedQ39zU65x32G5sv5mh1Rf\n\
oNFUgPQloFFGj218/xfXYDoRF40A0ESypZjMdh9ZKo6UyORvg41WikPBbAZp\n\
ZVVG/t8WFvsb6VC+U44qTrNNaqcJ269kaf8/AUIztpQoNbZNTG5NysKapHXy\n\
LVI0sxAs4I4jtcE48PEwOVuz6CPw8YVc+oiaN3QhmwHfW2xmth7bh/ZV/mjZ\n\
EYyOf6xCzu73UHqemMJRJ9GcFIGO21dx3i8AqUPtcXOMmxXdHUU80eyRLrg5\n\
wgmFTtNQ/P5yXP96J3LjzqKlNBUdhYnounsN7bdT0HFyE/770HK8+GIRHm4P\n\
QXmgN1J9/VB8NAyttbUDmWQVR5KoHEW99Fc0Fvc3Ra2kttJfNwbyOUpRl+pH\n\
rdpeAQMFnFfhD9v3qw9EGm34lmGZpusDlq/mVgrr0DzAI67oqWTZ631R5gl+\n\
NaDs38t6tYDSiuWjDuTL0T7AyM+nYQexE8lvpbxRxF2kh2DwS6DpEJXCEZ1M\n\
ASal772JcRq4KcIOWZ24PUc7pKevjpZ7PfFbqqeYJ2roiMoNy+BA+e5FWJoV\n\
M73Yaq1oYi3WBRQwAp+egKz3kVG1Hud0kLTeLtDyJrhQaBUMTX7zsDNHQcEe\n\
k158S52Cgq8/sNuLQSeEU7k6EEDRqJ+5Iy+GQTikdyoGhX7MGAtniCmGVDPS\n\
YPYZgnJzUiLaAmehZpUPKrctROZny1EV9Q+0XDqJ9pgL6MxJQLRfIIoG2qPi\n\
bTcLlL3tqnsbZSNcUDbUCTUT3FG7eCHy93yOa0cP4vqhQ2jIjEf7retoy0pA\n\
V0Ea7t8hwPb1Mjz7cgEeffUOHr0fhI5Fs1Ho5YVkzzlIXfVHtFZX6wYwvvm+\n\
IK44GQxbsDMlAnibiwq/1qVUnXqhjptRJpdQxY03Qh08IKjgixFac4Y47xy9\n\
meI3Az59Xz3VJFJePRVPDSqHaIQlQkH+CknMqVaR2RP2mSP9FRdT+2lXbcM6\n\
UNx81MlsP77vmTDKmeFZKKM2bMoY1CjlE8CXU8WBl/eDsLyqaCkF1w0HJrfW\n\
zOOzWq0yT9ekuuthY1GS8fYl9Z4Ta/E0KHc9dGJ1DNN601ovtzEJEG3kzMra\n\
TPb6OHL20CpD/d5gtGDtKBI1PNTDZCBuBmYtKEV4GieQbQ8ytTtIL1FrFfH8\n\
sE5Pq738rK5Ikn4CyiTx/bSaMNi3zUx6crX2Ag0SzSnpxQOxNJ/hlmpzjiZh\n\
q6eNTSbHnrYgub3DOFQNc2GdWgniDhDy9wTReqkM0ByBXLqsI3SG40e/iY7B\n\
tD1arsahaYUXKld6oWCTP9I2B6Puyj48iDmHhynR6L6djATfIFTa2KN2hCtq\n\
3nRF9RBnNLztgjYfP5T9+U/IuXgcxWkJqElJwO0TJ9GQHofHZel4mHcdj4uy\n\
yGcWqt8LQMOKaahb4YOWBd7oeMcXLZ6eKPaYiTTP2UhethzFP/1EHOoaNh/1\n\
YWPmUXKlZsGUJtN5slpkgEmK8L4TFfFr3n9M467shKuwVitl1Z+MMmkdWClh\n\
cul4FKVYxgbOjLDZS3S7ZRdZOLpquK1HT7a1yptmp16NnTcO3KbB3MaQVrWU\n\
B4qhDAXuOD283wRDhbMo4jtvQY7RMvL1gNsz+WYB3cSuZPnwmbJ4xmGZtWUy\n\
AGIUs5YnqmjWqOMf6qCOmhVrI2NBNolkxoz3mA/Uh7mF9RZu+wmWglQ936tO\n\
26T5xc1q5hDfGJ/eMFKdvT2hITtvippT6uGnN7jS41FKU6dD9Ed5f5ODTOLK\n\
8asdZJIDrNwFI+laIV0rRqVhYFQ4C6MELBQrYJjKI6WP+TEefsJVTOOAZXSQ\n\
6Q3N0z9aZ8cMT9ToTxBNlPKIAQ/enyL0CkJQIJ//NujbHuviwGZ8mmlQX/jR\n\
7FzRoGJ1G1svwzStB0MWTTWtHMPr+WwTp0Ksgpt4nHu2nKFUzy1nvrtLlDCF\n\
fD4GjYPzgzSD86akpxVyobRQs5TjCP3NNcvvRFPDEY3f/jvKF89BxQfEbPjY\n\
Fzf+tAgNsT/gfmwEniRF42l+GmJ9glA6wF5SZBXDndAwZRaqP16DrEN7cCsm\n\
Em0FN9GZn4mGzOu4G3UJVdEX8aIkBU8Lr+GXiix03yGmxoa5aJ7rjOoZDqhz\n\
cUbT9KmodvRAqeNUlLt7IN9tOjJnzEbGu6tQcuoMjeErdytouWB8sdVC8rCs\n\
VHCnGBRWih5mZ565+ucAaYQ6otFBLRv92ehBki6nBSkGCHu19PdYMDdZ76Na\n\
KwdtBRwydv30wFWp7BoyTBOtIGuxAjEqwfubO5/yNmDjGAJbTxAEIkYHGM08\n\
l3yYt1Nwj6XbY2i5ISocFTcSULYMYN3IxDBm3UbVMQKW6kUmUK2PaVB0JyV5\n\
Mu8o1WUn1lq0Kgal1C5pq0E4Pi00ZSkKSJm6JmweYTu2EE/QZEEveB4boEQZ\n\
BrLoNmwOtMKFKKoLUAxGsJVKksIWcnNGBlcr4nFKY6Vs/v4Rni4bGfRdvzmH\n\
wycvl6QcrX2puyd6vpfCePGZXzhB8xGyTK/tmqvWWuXnM4o114l5aFiIFrM6\n\
3lSkzR15bh2IB5j4tifaPq1DvHuEpVkya9DEfSKqKgVyVddoiPFv8WoTdppd\n\
sp9IE5Rirao4DBre0iGYULINRt5FVFZuQ3k16rXsBx4M4MeThCZ1XGLiBSGm\n\
2OId0ZdrenjblH5+Jwotp+98Y0mr7kuxVoI2vFrz29gGqbax9a6z9bOer2ro\n\
RWOpsCUYDPKGNuIR1daidN5clHi5o2DJbGSFeiN5zUI0xfyArovn8DghGo9v\n\
peK8TwCSB0xEkcM0lK1aiuw9u5F+6hhKoiJRGX0Z1QmxaM5KRmtOCqqvxuJe\n\
VAQe5ybgaU4cXhTdQHdeBurX+OPhInfUudmj1sEOdU72aBpnj/Kxdihxn4IK\n\
x2modPBAleMUlMz0Qv77a1B58RKa75ZwfSTceqYIn6dRFcnVpDoOPVDlqisX\n\
TgmnZ1lYwWjdmtXH1oOtVWF+ZjzoREzldSvwJeOi3l9V6pcv0BKvIaPYQctT\n\
E8AgTX1sRwnkh65XupivzivXdhgwzTBVvFCRMy0RZaOHPUHAclRBwjD1aoAs\n\
eel+MQ5M9Oo3mVr58RCV5y3eXEbbpkyysL2YpoTezNCrWB7WZvBZrmeosjlR\n\
uU6T1MkDH2baMBeIMDzZoJhgpDnRKOmJBeE4gmGESLbXZCGbuF9NFZVRhiXJ\n\
Y9Y6sFKQ2eD8qKhtB5pJE2PXo3pZVisfh1Ku0qgqm6rRxjCNtHEa9Rle/kB/\n\
eQtiYP6XkZ9G9zxo8TZAVJN2qP/qC9Q5uCFv+hSkOrvjirMzEkMD0CipybPo\n\
IH5TY1I8TnrOQeIsT2R/sQWpR35Aaewl1F+Lwb0rF1F8Lhy3T51EfvgZVMZH\n\
oSI2ErdOnUBj3AW0J1zA45vX8CjnBsqW+qNzsSdqpriiaMYM5AQEIv+jjcjb\n\
uhU1sXGoTUiwIG/x1GJOiEP9lSjUxpD+v33LMKSmHAKU1JehHUqnyWBDhaef\n\
4sZp9mJmcccKr5nPDMXdMHBUBhrQZ2Bpq1tzMvVgvEYtWsE+FtzTZMWphxki\n\
XCdjboaI17W97hlieMURtUU8XmGGiAsVPL7jI8wac8e+B5meIfJps4mo/8f3\n\
uDdtCjLsXBEz3hHR4+0RYTsJMSF+qL78PZpOH0fJyRMoOXMKl0OXIXXvlyi5\n\
GoGugmt4Up+Dpw3ZeFCeIW08qE+ORknEaWQdDUN62GFkHjmEguNHiTFwGm3J\n\
sejIvoHCBYEo85uN3LlzUfTPA6gm3sdgPsIZ0OgB0kp1HRX5rvjW+s1ZPU8G\n\
EQPtlXmlM1w+l4ei2CAzSRQC+zoBelxIp/lHaswBdvGWPhbB9qD1eV7wTc7c\n\
4BdHlDjK+EgRN0Pz5be+zgz9Pi71tdfytQHad1dxC53o92lMUJWVw5Vv4kIk\n\
529kL6oj7PgwXnpze5GZ+TKMz5fiu6he+yFKxjngwihbRA21RdJbtrg4wRZH\n\
xk5AuK8nyi/uw60fD6Do6BGUnjiK8sjTaMpNROfdZHRWpOI+fZVcQ3tBAppS\n\
o9GcEYP2zEjURp9CHt3Q8/0+pJHyBWdOkCF6E48qypDj74lcr1koJNN/KCPT\n\
WJdbKYaZGQtFmC/qAaqst8lgw4IiBEY79UsmtE3eoUb7STWmDMUWyaLic9rc\n\
8JVu6SWTlcbnTGYeqYkjeqNdb9v10JqpI/M8+MJtHREtRgn5ejMnhMtZ5VIG\n\
c3E4a13rEldKG3UvF5sc/MbleLyAxrb9WB5zV3cO1uCHjfghvPPp312kpiF3\n\
336kEBsq194d16Z4ISF4MeJ95yNj1RpELwrGURc3XBo2Adl/+QwNyQQd7pXh\n\
eXMtXnQ04vmDFjx/0olfXnThxfMu/NLdghcPGvG0rQFPW+vwrJ28mqrwuKYC\n\
XffK0VxSioctzfjff/0L98KOINXFGal+fii/dMlF363GwUR5b65+CHMxzzM1\n\
FqbID+QZJNo8f+jL6HESpMgvQB1lMALoryca+VTS7of2pibE+wfh+uIlKPru\n\
W9QmJ6OpqpL+XQRT3ONQX1qKhPnBuDJ0DA7a2SHhkw9Rf+wA6k+GoSHyJNqu\n\
R6Aj/QraUiPRlhIl/QFA6/WzaLl0DA3hP6HhzCE0njyIhhNHyPejqAo7hEp6\n\
O+3mT3BmsiNibe1w1dsH5REXdf/SYFf6KwYvkW4yz9vbUUEGdkdrMwsFjUNF\n\
Zjay9v2A88uXYY/tWJyeMRn1871Qs2Y+2veuxrP9a/DrpW34NX4Xfo3YjF8S\n\
P8HzCx+ge9McdITOQss77mgOdEJ90DQ0zJuOkhnuyCQWfDyh75ytI85NoP/j\n\
4YbiY8dUdPINOSKdo6WPMYhasRz7x41BjvdUNPrOQdvGZXj+40Y8/XIlnn6/\n\
Bs//thq/hq3Drz+vxvO9y/BwexC65ruie90s3A/xQHWgJxrnTEOd73TcneqO\n\
PCc3xBPb6cTvHRA5xhbpa9cJ/1chuzJsLIxDc0MjjgUE4MTbY1A30wst7wbj\n\
0ZbleLrjPbz46yp0bQ7B412hePJREF78JRhPvluGzp0haJnvhqZZ9mj3Iuou\n\
0BuV7tNQM88PZZ4zUeLshqIpU5E82Rkxb01CwsLF0mDREzFbTURJYiLO2k5E\n\
rq0TGmcGoHvVMjzasBgPPghB658WozYkAA3Lg9AW4oknOxbi8RdL0b7CD60B\n\
09Hg7oAqRzuU+/uhZO/fURUVhbzdu5GxYiVuE2nedXNHylhHhA2fgJt79poi\n\
4k2UXo5C4mQ7VPqQBwsX4KGnPxpDl6Jowzrc+frfcffIYeRsWI+8QD/UB/vg\n\
4ao5uP9+ANpme6DRwxllzq6oPHuG33rRWluDsrNncYtOLA+im0bbIXyWD/0X\n\
FoEGL5GGfohbvRoZpPu6/PzRvTwYLZ/tRF1ykvRXLhZsbrZUVODGH99HDmGu\n\
KcQbD5YFoH2GB1odHXH7ncWoy85WdrHRqVtMhl7yHH/ETHJG9nd/NW5cVtw2\n\
qL99S5rnNa6ziGQXoy09DR2NjdbMqKHtpq9di4Jp09E0w5M4sVNQN2yi5EwS\n\
+rjPU020Q9bHmxDn7UtqzNO35im2ZoWcnZ8j02MmKvwXofFmbn9GRG1GhnSd\n\
ceWsaah2ckXZZBeUnTo1gJWiDGV/uh03v/qLNL+V2mfJtfP/NpL+yuadJcib\n\
uwA1t28PZPIoOnQYucSpbrJzQlXoe9J+Y25h1RBA6Wht1U9T6W2mWK8lSo4f\n\
R0ZIMOrulrKCVqRHc5HiE4B6W2eUvv+Bvuw8uexb3DIhqJW6Zi0qU1KU/16g\n\
aVlbP0UxQbDCzVuMyvJ2O5qbFXXPAbLqejLSZsym/z2iMypoxzLRXkte/A5S\n\
V682zmTPMmX+aROuL1thwPpcOZPud/8HKWwI5g=="], Evaluatable -> False, 
      ImageSize -> {616, 41}, ImageMargins -> {{0, 0}, {0, 0}}, 
      ImageRegion -> {{0, 1}, {0, 1}}]], "DockedCell", Background -> 
    GrayLevel[0.866682], CellFrame -> {{0, 0}, {0, 4}}, CellFrameColor -> 
    RGBColor[0.690074, 0.12871, 0.194598], CellMargins -> {{0, 0}, {-3, 0}}, 
    CellFrameMargins -> 0], 
   Cell[
    BoxData[
     GridBox[{{
        Cell[
         GraphicsData[
         "CompressedBitmap", 
          "eJzVV0tIVFEYvs4dx9FkFtZCAh+LyhLMDDNNXJio+UILKqOVqOHbUtEEH5BR\n\
ahmC2MuQHhNFJpJIUFRChK4qNwWuWrSsdfjI/s5/zn/unHvnTpoMRBfunfP4\n\
H9/3/+f850xJRVtNdWNFW21lRXx+S8XZmtrK1vi85hY2pIdomjbP3th4DdvA\n\
mvSZh56eHja5/k8W/9HB6/XC7Owsvto5/hVjbJZLbDWLo+hSezS+TBy/Yux/\n\
E9f5NxJWZmoAHxzHZ/l+AW+vvD5v7gs5B3ac2NLchg7OYXvt+2f4uTgl9bis\n\
FgGrC3f4lDSDbXzWvr71M625TBbx/fXjG6rIaRWwAkAnVoq24CjAhv+RIP1q\n\
DlKTiFHTwb9ibKk3Bo0LN+y7fCsT6CG5UAOfZIjyWzaTG5d/bibKEYLw5BRd\n\
a/wiueTq3CAHh68pS/07DdKYKUbKgYMsSxhmjIl0im1uws6L05QlnmuBCR34\n\
SZuzYjcmGLsDYjcx13mX4GsCf7iBX8UuVQkNk2Wj6IzlkVzRmBJsxsCIwUxN\n\
RJC2FaHAFWEQ2kicXAYhjAs3ycAzdaeMxXAyX6vMMsafqXgC7RHeRjMoz+NF\n\
Y5vKlp1cqB1ZDLHE6+Z4/ZajL0e6ylqpAhaImH2qKWJvBydFGBSjINikSG58\n\
dE96tPEjjDG5uHABYt5k6aMFt5EcybXM65BdlQzzi49EzbyJZSCgelSo9hTt\n\
4Qp1p9W9bo2Cb2tR6ZSrNHiJQQhqEG33TpSMr6gdbJHZ1j1S5cUDNwIWaEZa\n\
nl6sv15+jLpCtZHL+GqGQ6lkan4kCUIhuEYHBB2Isx1w7kqteCy7NrtJdRPs\n\
3aSr4aIdkWCAlgTQu1wfvLpTVmyzphBSzhm+fLk+ydodV4H8oCwdEbhee2NY\n\
miU2tfxLvwYuSjO2KVS6Uu4s8Im+x49+IAoWug5+ZfCYFp9SP6w5DMqBFeq/\n\
6VgdUWs/lQy6+viOS/mYyoZLVB1WWWRBpEucTrcHyzVQnA2hKg15mTQOFlzx\n\
SsHhQXKSN3nx5BH27QKlZDtNu0m5TkpuFqAmVUnGvwYK16Yrn+j/5Y3vn/01\n\
iCfx8YIi6G9q4r3tmzNxLy8fBmtrTSY2+OcqjsQvtrfDo+wcGCsp1R6qU064\n\
0tAAk4eywJuTC30dHV7z7EBjIzxOTYfpjCwYqK/3kL2e7m7D1YjQiOE/Lj41\n\
erIchhjiuwl74d3+DBg/eiySNK8yg7dPnYberi5tVGjGkuaD3HzwVp+BqT1J\n\
8CElDV4UF8JwVWUEaV5jmpOHc2Gkqkq7rmqGwQSj9jEtHV4lJ8JcUip8Kj0C\n\
02VlcKGzk50YgslQfT08O5AJT7Ky0TlZ2EbGL7e2wmBTs+TAvm641NcHLwtL\n\
YDFqBzzdvQvepxyEL8VFsFBUDDfr6sIUw2/2ZcDzuEQYO37ihjCshfwGPGMf\nPw=="], 
         Evaluatable -> False, ImageSize -> {199, 30}, 
         ImageMargins -> {{0, 0}, {0, 0}}, ImageRegion -> {{0, 1}, {0, 1}}], 
        ButtonBox[
         Cell[
          GraphicsData[
          "CompressedBitmap", 
           "eJylVb1uAjEMDuSAUqTr1J234A3aqQ9xQpVgqFpRZkZWNkZWRkZmRkZmVkZ2\n\
xtSfY0e+9MrSSLkY27E//4W3aj55/6jm03E1fJ1VX5Pp+Hv48jkjlm8550a0\n\
y6EDHYiUzygsFgsS1o42Hw9hs9mE6/UasHCu12tI+KTVYbUy7Ha7pIZ1uVys\n\
GtPL5ZJpmLzdbrgTvXgrol+0XBHO5zOr4irtyO7zTWHx3u/3CRTo1Wol4FMM\n\
WBBB5Xg8MlDQsE6rYLUnjkFVIdputwm7qCYvigLmCCi5AvSSZapnbUFPY89l\n\
hN4zhE44HA4J3el0EtMcjHusAUHG8gTX4ikZIwxqpmwM1gwcqh7xC8k//CtU\n\
YrcFIthaXS1Z7IJuKiMyqcBI3pIIvHUtcRU5rDYLe4zKZgvVkLS4qJObw3eA\n\
+qeIkQG9Z20obm0/U2lpP5/CB09jRxW18mhPyoO7F9xzY87zNrTIgF56ovEO\n\
PGri8BsoRSeyB7U2w7ZtbNsOg1JIYCioBixtczewwZ+BWW9IEcrVES8NerUu\n\
gGcZqMju/womz5vtPnWNHOqMUkf+v0AohmIDDT19T/I7pBc90Rd3ZBycrY5W\n\
AEOn49JUHW+qowMKm6STXgVvX4GUTfsqEB1no8uXbTZBk3EdJ9RLbsgY9FJj\n\
6kaXyMMRvelzjWRpIInt01MRX+KGPxo5XOsHSMiAwg=="], Evaluatable -> False, 
          ImageSize -> {55, 14}, ImageMargins -> {{0, 0}, {0, 0}}, 
          ImageRegion -> {{0, 1}, {0, 1}}], ButtonData -> {
           URL["http://store.wolfram.com/view/app/playerpro/"], None}, 
         ButtonNote -> "http://store.wolfram.com/view/app/playerpro/"], 
        Cell[
         GraphicsData[
         "CompressedBitmap", 
          "eJzzTSzJSM1NLMlMTlRwL0osyMhMLlZwyy8CCjEzMjAwMAExnwIDiP0fyIQS\n\
jP9bWloY/8+ZPZuBgfF/V2cn4//VK1cOFnZ7ezvj/+XLlgFdyggAJaVbgQ==\n"], Evaluatable -> 
         False, ImageSize -> {2, 14}, ImageMargins -> {{0, 0}, {0, 0}}, 
         ImageRegion -> {{0, 1}, {0, 1}}], 
        ButtonBox[
         Cell[
          GraphicsData[
          "CompressedBitmap", 
           "eJyVVj1vIjEQ9bIBRKKjyClFOn5NUvEjUBQpKU6JctSUtHSUtJSU1JSU1LSU\n\
9JTOPHued0x2SWJpWXvGOx/Pb8YMR+OX53+j8evTaPD4MXp/eX36P3h4+xBR\n\
WTjnhvL0Bw5zL1P9GfrJZCLK7NUKr9LP53OPgVWQlVi5O386nbC0G/x0Og3z\n\
xWKRybHGgN7KMYcdjPV67TrBzZXfbreeQ+aMBQOfYMWty+UybZV5S5XH4zGJ\n\
xTK9xeB7/nA4BBEfbFHLYT6bzVyRA8EcEhDuPllnvjZXmiJOVs78VqtVJocN\n\
yJgUwrgKvnrBFrISWXhgd7PZhO8Uc9dVUBQM2onhdlOocKHm6V5SgoFekFlk\n\
4AJuMd/tdn6/33+PTJlYUMn6GQtgktFbBJAVdOKG8lJNGnIlULCVx3seLfd2\n\
lBLWjdFH8+2MuwSlc6YDcMpfAQHGm0GIVCsDaJplxMVdJ5D5EWuCbz03Zg4T\n\
yErC0My7aRuzIWUS/PJLgKtDaEShpZlCDVcEsYq6zlysVDJczqxAZV1ixt+s\n\
Zs5xYG2wPCmHZzACMuiwjqSNfqDT2pAcILu5BFAWQwVqvwmcVMsYOAzwwcTX\n\
UpgotgAhXFJAgCoQ+29L5zYLzCZCOZIHORko25/dI+B0GsqGn3wtm95FTBRH\n\
V9ak09Zf08vYD6V2gLoTNrDrEV3Lip8wxXRXASvylMcANlBmbqrY6kgTUAlG\n\
2FYtNGcBpK7zHSQSmCMnTNCNPZaUZgMEpNpj1YJekikdFkidTNLUkm2nAmBj\n\
QfcutYNgv82ClxIquO4ilghrG1vF0z/Z5U40eDEiFl72X2PN7cWLzNX+M3HF\nJ/Rd8Mk="], 
          Evaluatable -> False, ImageSize -> {77, 14}, 
          ImageMargins -> {{0, 0}, {0, 0}}, ImageRegion -> {{0, 1}, {0, 1}}], 
         ButtonData -> {
           URL[
           "http://www.wolfram.com/solutions/interactivedeployment/\
licensingterms.html"], None}, ButtonNote -> 
         "http://www.wolfram.com/solutions/interactivedeployment/\
licensingterms.html"]}}, ColumnsEqual -> False, 
      GridBoxAlignment -> {"Columns" -> {{Center}}, "Rows" -> {{Center}}}]], 
    "DockedCell", Background -> GrayLevel[0.494118], 
    CellFrame -> {{0, 0}, {4, 0}}, CellFrameColor -> 
    RGBColor[0.690074, 0.12871, 0.194598], CellMargins -> 0, 
    CellFrameMargins -> {{0, 0}, {0, -1}}, 
    ButtonBoxOptions -> {ButtonFunction :> (FrontEndExecute[{
         NotebookLocate[#2]}]& ), Appearance -> None, ButtonFrame -> None, 
      Evaluator -> None, Method -> "Queued"}]}, {}],
FrontEndVersion->"6.0 for Microsoft Windows (32-bit) (June 19, 2007)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[590, 23, 145, 2, 27, "Input"],
Cell[CellGroupData[{
Cell[760, 29, 257, 3, 20, "Print"],
Cell[1020, 34, 1182, 21, 170, "Print"]
}, Open  ]]
}, Open  ]],
Cell[2229, 59, 11265, 258, 268, "Input"],
Cell[CellGroupData[{
Cell[13519, 321, 314019, 4717, 70, "Input"],
Cell[327541, 5040, 692243, 11352, 838, "Output"]
}, {2}]]
}
]
*)

(* End of internal cache information *)
(* NotebookSignature WxpSmTIBpTlYmCKKI#HtJGdL *)
